#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// two chirp signals at 16kHz one from 0 to 3kHz, the second from 500 to 4500 Hz

main(int argc, char **argv)
{
  FILE *f;
  int i, n, Fsms;
  double Fs, F1, F2;
  short x;

  if (argc != 5) {
    fprintf(stderr,"genAsignal <filename> <SamplingRate> <InitialFrequency> <FinalFrequency>\n");
    exit(0);
  }
  f = fopen(argv[1], "wb");
  Fs = atof(argv[2]);
  Fsms = (int) Fs / 1000;
  F1 = atof(argv[3]);
  F2 = atof(argv[4]);

   // 100 ms silence
  for (i = 0, x = 0; i < 100 * Fsms; i++) fwrite(&x, sizeof(short), 1, f);
 
  for (n = 0; n < 500 * Fsms; n++) {
    double r, Finst, xx;
    if (n < 100 * Fsms)
    	r = n / (100. * Fsms);
    else if (n > 400 * Fsms)
    	r = (500. * Fsms - n) / (100. * Fsms);
    else r = 1.;

    if (fabs(F2 - F1) < 1.e-04) Finst = F2;
    else Finst = F1 + (F2 - F1) * n / (500. * 2 * Fsms);
//    Finst = F2 * (1. - exp(-n / 500.));
    xx = (r * 2000. * sin(2. * M_PI * n / Fs * Finst));
    x = (short) xx;

    fwrite(&x, sizeof(short), 1, f);
  }

  // 100 ms silence
  for (i = 0, x = 0; i < 100 * Fsms; i++) fwrite(&x, sizeof(short), 1, f);

}
