#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define __int64 long long int

char *zeroPadStr(char *s)
{
	int i;
   for (i = 0; i < strlen(s); i++) if (s[i] == ' ') s[i] = '0';
   return(s);
}

//
// Affiche la cle avec les zeros necessaires
//
char *strWith0(unsigned __int64 x)
{
  unsigned int *y;
  char s1[100],s0[100];
  y = (unsigned int *) &x;
  sprintf(s1,"%8lx",y[1]);
  zeroPadStr(s1);
  sprintf(s0,"%8lx",y[0]);
  zeroPadStr(s0);
  return(strdup(strcat(s1,s0)));
}

//
//  Generateur de nombre aleatoires
//
unsigned __int64 aleat(
  unsigned __int64 r)
{
  int i;
  unsigned __int64  x,
					a = 2147483659ULL,
					c = 549755813911ULL;

  for (i = 0, x = r; i < 10; i++)
    x = c+a*x;

  return x;
}

//
// Calcul de la cle de depart
//
unsigned __int64 xdep(
  const char *s)
{
  char tmp[1000];
  char *ptr;
  int i, l = strlen(s) / 4 + 1;
  unsigned __int64 c = 0;

  strcpy(tmp, s);
  strcat(tmp, s);
  for (i = 0, ptr = tmp; i < l; i++, ptr += 4) {
    unsigned __int64 y;
    unsigned int *x = (unsigned int *) ptr;
    y = *x;
    c += y;
  }
  return c;
}

//
// Verification de l'enregistrement (la premiere fois).
//
bool verLic(
  const char *organization,
  const char *cle,
  unsigned int lpVolumeSerialNumber,
  unsigned __int64 *cleFinale)
{
  unsigned __int64 yal, yab, ysn, cleNum;
  unsigned int *xx;
  yal = xdep(organization);
  xx = (unsigned int *) &cleNum;
  sscanf(cle,"%8lx%8lx",&xx[1],&xx[0]);

  yab = aleat(yal);
  ysn = aleat((unsigned __int64) lpVolumeSerialNumber);
  if (yab == cleNum) *cleFinale = cleNum ^ ysn;
  return (yab == cleNum);
}

//
// Verification de l'enregistrement (avec la cle stockee dans wsno.ini).
//
bool verLicMach(
 const char *organization,
 const char *cleMach,
 unsigned long int lpVolumeSerialNumber)
{
  unsigned __int64 yal, ysn, yab, cleMachNum;
  unsigned int *xx = (unsigned int *) &cleMachNum;

  sscanf(cleMach,"%8lx%8lx",&xx[1],&xx[0]);
  yal = xdep(organization);
  yab = aleat(yal);
  ysn = aleat((unsigned __int64) lpVolumeSerialNumber);
  ysn = ysn ^ cleMachNum;
  return(ysn == yab);
}
