// Exemple d'utilisation pour gnrer le forme de l'excitation LF
// t=0:0.01:T0
// y=0:0.01:T0
// y = LFestimation(5000, 8, 0.04, 0.3, 1.8);
// plot2d(t,y);

function [y] = LFsource(a, eps, w, te, ta, tc, Ee, EE0, t, y)
s=size(t)
for i=1:s(2) if t(i) < te  then
  y(i) = EE0 * exp(a * t(i)) * sin(w * t(i))
elseif t(i) < tc then
  y(i) = - Ee/(eps * ta) *(exp(-eps * (t(i) - te)) - exp(-eps * (tc - te)))
else y(i) = 0
end
end
endfunction


function [y] = LFestimation(Ee, T0, Ra, Rk, Rg, t)
tc = T0
Fg = Rg / T0
w = 2 * %pi * Fg
tp = 1 / (2 * Fg)
te = tp + Rk * tp
ta = Ra * (tc - te)
tcmte = tc - te

// Determination of epsilon 
eps = 1/ta
for i=0:4
 err = eps * ta - 1 + exp(-eps * tcmte)

 der = ta - tcmte * exp(-eps * tcmte)
 disp(err,eps)
 eps = eps - err / der
end

disp("epsilon vaut")
disp(eps)
disp("---")

// Integral of the return
UeRight = -Ee / eps * (1 + (eps  * ta - 1) / Ra)

// Fisrt iteration to initialize variables
err = 1e100
a = 0
// Integral of the first part
den = a^2 + w^2
num = a - w / tan(w * te) + w * exp(-a * te) / sin (w * te)
UeLeft = -Ee * num / den
err_ = err
err = UeLeft + UeRight
der = -Ee * ((1. - w * te / sin(w * te) * exp(-a * te)) * den - 2. * a * num) / den^2
//   fprintf(stdout, "err = %9.6f a = %9.6f\n", err, a);

a_ = a
a = a - err / der

 
while abs(err) < abs(err_) & a_ < a 
  // Integral of the first part
  den = a^2 + w^2
  num = a - w / tan(w * te) + w * exp(-a * te) / sin (w * te)
  UeLeft = -Ee * num / den
  err_ = err
  err = UeLeft + UeRight
  der = -Ee * ((1. - w * te / sin(w * te) * exp(-a * te)) * den - 2. * a * num) / den^2
  //   fprintf(stdout, "err = %9.6f a = %9.6f\n", err, a)
  a_ = a
  a = a - err / der
  disp(a, err)
end

E0 = -Ee * exp(-a * te) /sin(w* te)
param(1,1) = eps
param(1,2) = a

y = LFsource(a, eps, w, te, ta, tc, Ee, E0, t, y)


endfunction

//t=0:0.01:T0
//y=0:0.01:T0
//plot2d(t,y);
