/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include <math.h>
#include "SuiviSnake/snake.h"


/* Inversion d'une matrice  bande ( a bande reguliere) stockee lineairement.
 * Les bande successives   sont stockees a la queue leu leu.
 * La matrice de depart n'est pas conservee.
 * dbande est la demi largeur  de bande
 * la fonction position determine la place de l'element a(i,j)
 * dans le tableau lineaire.
 */
  
  
/* a est stockee dans un tableau lineaire */

/*triangulation de la matrice bande a.(bande est la largeur de bande) */
/*Les memes operations etant effectuees sur Id et stockees dans b */


void trianguler1(
  double a[],
  double **b,
  int dbande,
  int n)
{
  double x,*p,*q,kk;
  int k,l,ll,i,j,numero,numero1,num1,num2,bande,i1;


  bande=2*dbande+1;

/* initialisation de b */

  for (i=0;i<n ;i++)
    {p=b[i];
    for(j=0;j<n;j++)
      (*(p+j))=0.;
    (*(p+i))=1.;
    }
	

  for(j=0;j<n;j++)


    /* travail sur les colonnes de la matrice  */
    /* recherche du coeff max de la colonne j */
    { 
      numero=position(j,j,dbande,n);
      x =a[numero];
      k=j;
      for(l=j;l<n;l++) numero=position(l,j,dbande,n);
      if (abs(a[numero])>x) {x=a[numero];
      k=l;}


      if (x==0) printf(" matrice non inversible ");
      else {k=l;
/* if (k!=l) {echanger(a,k,j,n);
 *           echanger(b,k,j,n);}*/

      numero1=position(j,j,dbande,n);

      for(i=j+1;i<=j+dbande;i++) if (i<n) {
	     numero=position(i,j,dbande,n);
	     kk=a[numero]/a[numero1];
 
	     for(ll = j-dbande;ll <= j+dbande; ll++) if (ll >= 0 && ll < n) {
          /* (*(p+ll))=(*(p+ll))-a[j][ll]*kk;*/
		    /* (*(q+ll))=(*(q+ll))-b[j][ll]*kk;*/
		    num1=position(i,ll,dbande,n);
		    num2=position(j,ll,dbande,n);

		    a[num1]=a[num1]-(a[num2]*kk);
        }
       
        for (ll=0;ll<n;ll++)
	      b[i][ll]=b[i][ll]-(b[j][ll]*kk); 
	    }
     }
   }
}



void resolution1(
  double a[],
  double **b,
  int dbande,
  int n)
{
  double x;
  int i,j ,k,numero,num;


  for(k=0;k<n;k++)
    {numero=position(n-1,n-1,dbande,n);
    b[n-1][k]=b[n-1][k]/a[numero];}
 
  for (i=n-2;i>=0;i--)
    {numero=position(i,i,dbande,n);
    for (k=0;k<n;k++)
      { x=0.0;
      for (j=i+1;j<=i+dbande;j++)
	 
	if (j<n)
	  {num=position(i,j,dbande,n);
	  x=x+a[num]*b[j][k];}

	 
      
      b[i][k]=(b[i][k]-x)/a[numero];}
      
    }
}





/* inversion de la matrice a .resultat dans b */ 
void  inverser1(
  double *a,
  double **b,
  int dbande,
  int n)
{
  int i,j,longueur;

  /* longueur du tableau a */
  longueur=(n)*(2*dbande+1) - dbande*(dbande+1);

  trianguler1(a,b,dbande,n);
  resolution1(a,b,dbande,n);
}




/* Determination de la place de l'element a[i][j] si la matrice a est une
 * matrice bande stockee lineairement
 * n est la taille de la matrice
 * dbande est la demie largeur de bande
 * bande est la largeur complete de la bande
 * position renvoie le numero de l'e'lement dans la liste line'aire
 *
 * si les lignes ont toutes bande elements,le numero de l'element (i,j)
 * serait i*bande (numero de l'element en tete de ligne i )
 *        +j-(i-dbande)
 * Les elements manquants des nbande premieres et derniere lignes
 * sont a retirer.On retire une somme d'entiers consecutifs.
 * si nbande<=i<n-nbande on retire la somme des entiers de 1 a nbande.
 * si n-nbbande<i on retire la somme des entiers de 1 a dbande-(n-i)
 */

int position(
  int i,
  int j,
  int dbande,
  int n)	/* dbande est la demi largeur de bande */
{
  int bande,k,numero,ajust;   

  bande = 2*dbande + 1;
  numero=0.;

  if (i<dbande)
    if (i==0)
      numero=j;
	else
    for (k=0;k<i;k++)
      numero=numero +(i>k)*(dbande+1-k)*(dbande-k>0)+j;
  else
    if (i<=(n-dbande))
      numero=i*bande -dbande*(dbande + 1)/2 +j-(i-dbande);
    else
      {ajust=( dbande-(n-(i)))*(dbande-(n-(i))+1)/2;
      numero =i*bande -dbande*(dbande + 1)/2 +j-(i-dbande)-ajust ;}
  return numero;
}
        
  
