/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include <math.h>
#include <string.h>
#include <malloc.h>
#include "SuiviSnake/snake.h"


/*------------------------------------------------------------
  Interpolation de tab[m] en utilisant les quatre voisins
  ponderes par l'inverse de la distance au point m
  ------------------------------------------------------------*/
double interpol(
  type_coord_float m,
  int tab [][DIM_Y])
{
  type_coord n[4];
  double poids, somme ,d[4],x;
  int i; 

  n[0].x = (int) m.x; n[0].y = (int) m.y;
  d[0] = sqrt((m.x-n[0].x)*(m.x-n[0].x)+(m.y-n[0].y)*(m.y-n[0].y));
  n[1].x=n[0].x+1;n[1].y=n[0].y;
  d[1] = sqrt((m.x-n[1].x)*(m.x-n[1].x)+(m.y-n[1].y)*(m.y-n[1].y));
  n[2].x=n[1].x;n[2].y=n[1].y+1;
  d[2] = sqrt((m.x-n[2].x)*(m.x-n[2].x)+(m.y-n[2].y)*(m.y-n[2].y));
  n[3].x=n[0].x;n[3].y=n[2].y;
  d[3] = sqrt((m.x-n[3].x)*(m.x-n[3].x)+(m.y-n[3].y)*(m.y-n[3].y));

  if (d[0]<.001)
    return (double) (tab[(int) m.x][(int) m.y]);
  else
    if (d[1]<.001)
      return ((double)(tab[(int) n[1].x][(int) n[1].y]));
    else
      if (d[2]<.001)
	return (double) (tab[(int) n[2].x][(int) n[2].y]);
      else
	if( d[3]<.001)
	  return ((double)(tab[(int) n[3].x][(int) n[3].y]));
	else
	  { poids = somme = 0;
	  for(i=0;i<4;i++)
	    { poids += 1/d[i];
	    /*	printf(" disnace %g tab %d \n",d[i],tab[n[i].x][n[i].y]);*/
	    somme += tab[n[i].x][n[i].y]/d[i];}
	  return (somme/poids);
	  }
}

