/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

/*===========================================================================*/
/*                                                                           */
/*        PROCEDURES ET FONCTIONS AUXILLIAIRES utilisees dans SNAKE          */
/*                                                                           */
/*===========================================================================*/
#include "SuiviSnake/snake.h"


/*--------------------------------------------------------------------------*/
/* Calcul du produit Scalaire de deux vecteurs.                             */
/*--------------------------------------------------------------------------*/
float scalaire(
  type_coord_float U, 
  type_coord_float V)
{
  return  (U.x * V.x + U.y * V.y);
}

/*--------------------------------------------------------------------------*/
/* Calcul du produit Vectoriel de deux vecteurs.                             */
/*--------------------------------------------------------------------------*/
float vectoriel(
  type_coord_float U, 
  type_coord_float V)
{
  return  (U.x * V.y - U.y * V.x);
}




/*--------------------------------------------------------------------------*/
/* Calcul de la Distance entre deux points.                                 */
/*--------------------------------------------------------------------------*/

double distance(
  type_coord_float A, 
  type_coord_float B)
{
  return (sqrt ( (A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y) ) );
}



/*--------------------------------------------------------------------------*/
/* Calcul de t a la puissance n.                                            */
/*--------------------------------------------------------------------------*/
float puissance(
  float t,
  int n)
{
  float     res = 1.;

  for (int i = 1; i <= n; i++) res *= t;
  return res;
}



