/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier annoter.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <math.h>

#include "notetiq.h"
#include "cnotetiq.h"
#include "signal.h"
#include "snoori.h"
#include "outils.h"
#include "format_f.h"
#include "files.h"
#include "add_files/htmlhelp.h"

////////////////////////////////////////////
// fonctions de la souris
//
static int yaUnChangerTexteAnnot = FAUX;
static int yaUnAjouterLimiteAnnot = FAUX;
static int yaUnEffacerLimiteAnnot = FAUX;
static int yaUnChangerLimiteAnnot = FAUX;

static void AjouterLimiteAnnot(long echt)
{ notes.add_mt(echt);
  yaUnAjouterLimiteAnnot=FAUX;
  Set_yaDesModifsEtiquetages();
  aff_notes();
}

static void EffacerLimiteAnnot(long echt)
{ notes.detach(echt);
  yaUnEffacerLimiteAnnot=FAUX;
  Set_yaDesModifsEtiquetages();
  aff_notes();
}

static void ChangerLimiteAnnot(long echt)
{ notes.shift(echt);
  Set_yaDesModifsEtiquetages();
  aff_notes();
}

static void ChangerTexteAnnot(long echt)
{ int i,j;
  char ch[80]; 

  if (debug==6) Wmsg->wr("ChangerTexteAnnot()");
  i=notes.search(echt);
  if ((i>=0)&&(i<notes.nb-1))
  { strcpy(ch,notes.e[i]->Text());
    if (MyInputDialog(
	  ml(2502,"texte de l'annotation")
	 ,ml(2503,"entrez le nouveau texte")
		    ,ch,50))
    { j=strlen(ch);
      while ((j!=0)&&(ch[j-1]==' ')) { ch[j-1]=0; j--; }
      
      notes.e[i]->SetText(ch);
      aff_notes();
    }
  }
  else
    MessageBox(PTWtop->HWindow
,ml(2504,"entre de texte impossible ici\n\
vous n'tes pas entre deux limites")
,ml(2505,"warning"),MB_OK);

  yaUnChangerTexteAnnot=FAUX;
  Set_yaDesModifsEtiquetages();
}

////////////////////////////////////////
// traitement de la souris
//
void drawDownAnnot(int event_x)
{ long echt;
  BOOL ctrl,maj;

  if (!yaUnSignal) return;
  if (!isNoteModifiable)
  { affiche_warning(
ml(2506,"Modification impossible,\nVous \
n'avez pas le droit de toucher  ce fichier"));
    wannotations->LButtonDown=FALSE;
    return;
  }
  echt=wannotations->DXtoLX(event_x);
  ctrl=GetKeyState(VK_CONTROL)<0;
  maj=GetKeyState(VK_SHIFT)<0;
  yaUnEffacerLimiteAnnot=ctrl&&maj;
  yaUnAjouterLimiteAnnot=ctrl&&(!maj);
  yaUnChangerLimiteAnnot=(!ctrl)&&maj;
  ct.posBarre=-1;
  wsignal->wsig->MoveBarre(echt);
  SetCapture(wannotations->HWindow);
}
void drawDblclkAnnot(int event_x)
{ long echt;

  if (!yaUnSignal) return;
  if (!isNoteModifiable) 
  { affiche_warning(
ml(2506,"Modification impossible,\nVous \
n'avez pas le droit de toucher  ce fichier"));
    wannotations->LButtonDown=FALSE;
    return;
  }
  echt=wannotations->DXtoLX(event_x);
  yaUnChangerTexteAnnot=TRUE;
  ct.posBarre=-1;
  wsignal->wsig->MoveBarre(echt);
  SetCapture(wannotations->HWindow);
}
void drawMotionAnnot(int event_x)
{ long echt;

  if (!yaUnSignal) return;
  if (!isNoteModifiable) return;
  echt=wannotations->DXtoLX(event_x);
  if (yaUnChangerLimiteAnnot)
    ChangerLimiteAnnot(echt);
  wsignal->wsig->MoveBarre(echt);
}
void drawUpAnnot(int event_x)
{ long echt;

  if (!yaUnSignal) return;
  if (!isNoteModifiable) return;
  echt=wannotations->DXtoLX(event_x);
  if (yaUnAjouterLimiteAnnot) AjouterLimiteAnnot(echt);
  if (yaUnEffacerLimiteAnnot) EffacerLimiteAnnot(echt);
  if (yaUnChangerLimiteAnnot) ChangerLimiteAnnot(echt);
  if (yaUnChangerTexteAnnot) ChangerTexteAnnot(echt);
  yaUnChangerLimiteAnnot=FALSE;
  wsignal->wsig->MoveBarre(-1);
  ReleaseCapture();
}

//////////////////////////////////////////////////
// commandes du menu principal
//
typedef HWND WINAPI (*HtmlHelpFunc)( HWND hwndCaller, LPCSTR pszFile,UINT uCommand, DWORD dwData );

const char pszHelpOCXCtrl [] = "hhctrl.ocx";
void Wtop::CMHelpAnnot()
{
  HINSTANCE hHelpOCX = ::LoadLibrary(pszHelpOCXCtrl);
  if (!hHelpOCX) {
    ::MessageBox(HWindow, "Cannot use the html help!", "Error", MB_OK);
   return;
  }

   HtmlHelpFunc HTMLHelp = (HtmlHelpFunc)::GetProcAddress(hHelpOCX, ATOM_HTMLHELP_API_ANSI);

  // Now call HTMLHelp functions:

  HTMLHelp(HWindow, helpfile, HH_DISPLAY_TOPIC, (DWORD) "mouseWord.htm");
}


void Wtop::CMlectFichAnnot()
{ if (!yaUnSignal) return;

  if (get_format(this,en_cours)!=IDOK) return;
  notes.clear();
  if (en_cours.fmt_word!=0)
  { souris(XC_watch);
    lireAnnotations(&notes, en_cours);
    isNoteModifiable=droit_ecrire(en_cours.nomAnnot);
    //:: en_cours.isOpenWord=TRUE;
    aff_notes();
    souris(XC_top_left_arrow);
  }
}

void Wtop::CMsauverFichAnnot()
{ if (!yaUnSignal) return;

  if (get_format(this,en_cours)!=IDOK) return;
  if (en_cours.fmt_word!=0)
  { souris(XC_watch);
    if ((isNoteModifiable
	   =droit_ecrire_message(en_cours.nomAnnot)
          )==TRUE)
      sauveAnnotations(&notes,en_cours);
    souris(XC_top_left_arrow);
  }
}
