/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier axes.h
//
#ifndef _AXES_H
#define _AXES_H
// dans le fichier axes.cpp
extern void axe_x(
	float x_min,	// extremites de l'axe
	float x_max,
	float v_min,	// valeurs aux extremites	
	float v_max,
	float y_axe,	// ordonnee de l'axe
	COLORREF couleur,
	float increment, // difference entre deux graduations
			 // successives. Si cette valeur est
			 // nulle, elle est fixee par
			 // le programme.
	char *format,	 // format d'impression des graduations
   int charHeight,   // Height and width of characters
   int charWidth,
	d_planche *d);   // fenetre d'affichage

void axe_xUp(
	float x_min,	// extremites de l'axe		
	float x_max,    //     (en coordonnes de la fentre)
	float v_min,	// valeurs aux extremites	
	float v_max,    //     ( afficher) 
	float y_axeb,	// ordonnee de l'axe (en bas)
	float y_axeh,	// ordonnee de l'axe (en haut)
	COLORREF couleur,
   int graduationHeight,
   int textHeight,
   int textWidth,
   int lineWidth,
	float increment, // difference entre deux graduations
			 // successives. Si cette valeur est
			 // nulle, elle est fixee par
			 // le programme.				 
	d_planche *d);    // fenetre d'affichage

void axe_ySimple(
	float y_min,     // extremites de l'axe
	float y_max,
	float v_min,     // valeurs  afficher aux extremites
	float v_max,
	float x_axel,	 // axis abscissa at left
	float x_axer,	 // axis abscissa at right
   int charHeight,
   int charWidth,
	COLORREF couleur,
	d_planche *d);

extern float niceVertIncr(float vmin, float vmax, int charHeight, int *numberOfDigits, d_planche *d);
extern void axe_y(
	float y_min,     // extremites de l'axe
	float y_max,
	float v_min,     // valeurs aux extremites
	float v_max,
	float x_axe,	 // abscisse de l'axe
	COLORREF couleur,
	float increment, // difference entre deux graduations
			 // successives. Si cette valeur est
			 // nulle, elle est fixee par
                         // le programme.				 
   bool forceLast,  // Si true on affiche la dernire graduation en la dcalant au besoin.
   bool withoutLine,   // Si true on n'affiche pas la ligne verticale de l'axe
   int yprotect,	  // To disable text output above this limit.
   char *format,	 // format d'impression des graduations
   int charHeight,   // Height of characters in pixels
   int charWidth,    // Width of characters in pixels
	d_planche *d);   // fenetre d'affichage
#endif
