/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier babel.h
//

#ifndef _BABEL_H
#define _BABEL_H

//extern int Ligne;    /* numero de ligne (pour localiser les erreurs) */

typedef short 	I16;
typedef int 	I32;
typedef char 	I8;


#define ON_SWAP_PAS 	0
#define ON_SWAP		1
#define ON_1S1		2
#define ON_1S2		3


#define LCH		512	/* longueur maximale d'une
                                     ligne du descripteur */
#define SEP(X)	((X)=='=' || (X)==',' || (X)=='\000' || (X)=='\n')

#define MBLANC(X) { long *p=X, *l=X+NBVAR+1; for (;p<l;) *p++=0; }

struct champ_lu {
       int itere;	/* vrai si nb_phrase > 1 */
       char type_don;	/* type du champ lu dans le fichier */
       struct post_pile *adr,*tail; // adresse et longueur du
				    //   champ en caracteres
       int dd;		/* type du decodage (swap et caracteres) */
};

struct champ
{ char type;  // type des donnes stockes dans x
        	// 'c' -> caracteres 	
		// 'n' -> numerique	
		// 'l' -> lu ds fichier
		    // cas ci-dessus enlev
		    //   (shunt dans les sources)
		// ' ' -> non defini 	
  char type_res;  // type du rsultat  l'extraction
                  // 'n' -> nombre  'c' -> caracteres
                  // ne sert que si type=='c'
  union
  { char *libel;            // cas type=='c'
    struct post_pile *val;  // cas type=='n'
    struct champ_lu *lu;    // cas type=='l'
  } x;
}; 

struct entete
{ struct champ
    *frequence,    // nombre d'chantillons par seconde
    *nb_bits,      // nombre de bits dans un chantillon
    //*nb_phrase,    // (1)
    *debut,        // 1er octet du signal dans le fichier
    *longueur,     // longueur du signal en octets
    //*titre,        // (1)
    //*locuteur,     // (1)
    //*sexe,         // (1)
    //*age,          // (1)
    //*date,         // (1)
    *signal_swap;  // croisement ventuel des octets
    //*lg_bloc;      // (1)
};
// remarques
// - (1) non utiliss dans WinSnoori. Proviennent d'anciens
//     formats que l'on n'utilise plus. Ne pas remettre
//     en service (Voir remarque suivante sur nb_phrase).
// - signal_swap indique le sens des octets dans les
//   bits qui dcrivent un chantillon.
//       default is "non"
// - l'ancien format GRECO n'est plus utilis. C'est lui
//   qui utilisait le plus de champs avec (1).

#endif


