/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier buffers.h
//
#ifndef _BUFFERS_H
#define _BUFFERS_H
//#define BUFCONTROLS
extern void affiche_erreur(char *message);
    // lorsque les contrles sont valids par le define
    // ci-dessus, alors:
    //   - en lecture et criture on traite de manire
    //     spciale les accs qui dbordent du buffer,
    //     et on ouvre un panneau pour prvenir
    //     l'utilisateur
    //   - en lecture, on lit une valeur nulle.
    //   - en criture, on met la donne  crire
    //      un endroit non gnant. 

//////////////////////////////////////////////
class BUFbuf
{
    int sizeelt; // taille de l'lment en octets

  public:
    long ni; // nombre d'lments utilisables
    char *name;
    void huge *p;
  // revoir ci-dessous
  // probleme: tout ce qui prcde devrait tre
  //           priv pour les classes drives
  //public:
    BUFbuf(long ni,int sizeelt,char *name);
    ~BUFbuf();
    void newsize(long ni);
    long size() { return ni; }
};

//////////////////////////////////////////////
class SHORTbuf : public BUFbuf
{ public:
    SHORTbuf(long n,char *name)
        : BUFbuf(n,sizeof(short),name) {}
    SHORTbuf()
        : BUFbuf(0,sizeof(short),"") {}
    short & operator[](long i)
	#ifdef BUFCONTROLS
	;
        #else
	{ return ((short *)p)[i]; }
        #endif
};
#define SAMPLEbuf SHORTbuf

//////////////////////////////////////////////
class INTarray
{
  public:
    long ni; // nombre d'lments utilisables
    char *name;
    int *p;
  // revoir ci-dessous
  // probleme: tout ce qui prcde devrait tre
  //           priv pour les classes drives
  //public:
    INTarray(long ni, char *name);
    ~INTarray();
    void newsize(long ni);
    long size() { return ni; }
    int & operator[](long i) {
	  return p[i]; }
};

//////////////////////////////////////////////
class INTbuf : public BUFbuf
{

 public:
    INTbuf(long n,char *name)
        : BUFbuf(n,sizeof(int),name) {}
    INTbuf()
        : BUFbuf(0,sizeof(int),"") {}
    int & operator[](long i)
	#ifdef BUFCONTROLS
	;
        #else
	{ return ((int *)p)[i]; }
        #endif
};



//////////////////////////////////////////////
class FLOATbuf : public BUFbuf
{ public:
    FLOATbuf(long n,char *name)
        : BUFbuf(n,sizeof(float),name) {}
    float huge & operator[](long i)
        #ifdef BUFCONTROLS
	;
        #else
	{ return ((float huge *)p)[i]; }
        #endif
};

//////////////////////////////////////////////
class DOUBLEbuf : public BUFbuf
{ public:
    DOUBLEbuf(long n,char *name)
        : BUFbuf(n,sizeof(double),name) {}
    double huge & operator[](long i)
        #ifdef BUFCONTROLS
	;
        #else
	{ return ((double huge *)p)[i]; }
        #endif
};

//////////////////////////////////////////////
class CHARbuf : public BUFbuf
{ public:
    CHARbuf(long n,char *name)
        : BUFbuf(max(1,n),sizeof(char),name)
        { ((char *)p)[0]=0; }
    char *cpy(char *ch);
    char *cat(char *ch);
    unsigned int len();
    char huge & operator[](long i)
        #ifdef BUFCONTROLS
	;
        #else
	{ return ((char huge *)p)[i]; }
	#endif
};
#endif
