/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier cherchee.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "snoori.h"
#include "signal.h"
#include "notetiq.h"
#include "outils.h"
#include "menu.h"

static void chercherEtiquette(int num_phon)
	// chercher le phoneme num_phon
{ int i;
  char ch[80];

  logs.open1();
  //
  logs.puts1(ml(3006,"chercher le phonme : "));
  logs.puts1(TextOfPhon(num_phon));
  logs.rclf1();
  logs.puts1(ml(3005,"... dans le fichier courant : "));
  logs.puts1(en_cours.nom);
  logs.rclf1(); 
  logs.wr1(ml(3010,"Dbut\tFin"));
  logs.wr1(ml(3011,"[ms]\t[ms]"));
  for (i = 0; i < etiqs.nb-1; i++)
    if ( comp_phon(etiqs.e[i]->Text()
		 ,TextOfPhon( 
		       num_phon)) ) 
	 { sprintf(ch,"%ld\t%ld\t%s"
				  ,enMilli(etiqs.e[i]->limite)
				  ,enMilli(etiqs.e[i+1]->limite)
				  ,etiqs.e[i]->Text() );
		logs.wr1(ch);
    }
  logs.close1();
  return; 
}
  
void Wtop::CMchercheEtiq()
// fonction d'activation de la fentre dialogue
{ int ph;
  TPoint p(100,0);
  ph=GetPhonemeByMenu(p);
  if (ph!=-128)
  { chercherEtiquette(ph);
    logs.show1();
  }
}

