/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier common1.h
//
// fichier contenant toutes les constantes,
// structures et macros d'interet general.
//
#ifndef _COMMON1_H
#define _COMMON1_H
#define VRAI 1
#define FAUX 0

#define dans(X,A,B) ( (   ( ((float)(X)) >= ((float)(A)) ) \
                        &&( ((float)(X)) <= ((float)(B)) ) \
		      )? VRAI : FAUX)
	// dans(X,A,B) rpond TRUE si X est compris
        //             dans l'intervalle A,B bornes incluses
#define max(A,B) (((A)>(B)) ? (A) : (B))
#define min(A,B) (((A)>(B)) ? (B) : (A))
#define maxi(A,B) (((A)>(B)) ? (A) : (B))
#define mini(A,B) (((A)>(B)) ? (B) : (A))

#define log2(X) (log(X) / log(2.))

#define MAX_LIGNE 300
typedef char STRING[MAX_LIGNE];

//#define 	INDEF	-1

#define 	forever		while (1)

//#define BEEP 	'\007'

#define CHIFFRE(c) ((c) >= '0' && (c) <= '9')
#define MINUS(c) ((c) >= 'a' && (c) <= 'z')
#define MASJUS(c) ((c) >= 'A' && (c) <= 'Z')

#define NEW(T) ((T *) malloc ((unsigned int) sizeof(T)))

typedef	short	SAMPLE;
typedef int 	Position;

#define NOSIGNAL  0   // if there is no signal
#define ASIGNAL	1	 // if there is a real signal
#define ASHADOW	2	 // if there is a signal generated by the Klatt synthesizer.

#define 	NB_BITS	16	// nombre de bits par echantillon	

//#define	FREQ_STD	16000
//#define 	NB_BITS_STD	16

#define 	NB_SPECTRES_SUIVI  1000	/* nombre de spectres pour
                                             le suivi de formants */
#define 	TAILLE_MAX_HAMMING 4096	/* taille maximale de la
                                             fenetre de hamming */
//#define 	MAX_GOERT	1000 /* taille maximale d'une
//                                          fenetre de calcul de gortzel */
#define		TAILLE_FENETRE	256  /* nombre de prelevements par
                                          fenetre de Hamming	*/
#define NB_CANAUX	128
//#define	ORDRE_LISS	7    /* ordre du lissage sur les fft */
#define ORDRE_MAX_LPC	30   /* ordre maximal des lpc */
#define ORDRE_LPC_STD	18
#define NB_LPC		NB_SPECTRES_SUIVI /* nombre maximal de lpc */
//#define NB_COL_LPC	6    /* nombre de couleurs pour la LPC */
//#define COL_LPC		96   /* 1ere couleur lpc */


#define 	dBMIN		40.0
#define 	dBMAX 		115.0

#define		DYNA_SPECTRO	56.0		/* 32.0 + log10(256) */
#define		SILENCE_SPECTRO	60.0		/* 36.0 + log10(256) */
#define		MAX_SPECTRO	97.0		/* 73.0 + log10(256) */

// taille max du tampon mmoire
#define DUREE_BUF 12.0  // autrefois 4.0
#define	MAXECH (min(enEcht(DUREE_BUF * 1000), 576000))  // autrefois 64000
			/* nombre maximum d'echantillons */
// taille max du signal visualis  l'cran
#define DUREE_FEN  6.0  // duree du spectro affiche  autrefois 2.
                        //     sur 1 ecran (en secondes)
#define MAXECHTECR ((int)min(enEcht(DUREE_FEN * 1000), 288000))   //autrefois 32000
                   // nombre max d'chantillons sur l'cran

#define	MAXFFT256	(MAXECH / OFFSETFFT256)
#define OFFSETFFT256	128	/* recouvrement entre deux
                                     FFT a 256 points	*/
#define	FENFFT256	256	/* rien de surprenant,
                                     mais comme ca 
				     je sais ou apparait
				     cette constante */
#define	DECAL	   1.5	// decalage entre deux ecrans
			//     consecutifs (en seconde)


#define NB_SEG 1500		/* nombre maximal de phonemes
                                     dans la phrase	*/
#define	NB_CHOIX 3

#define AUTO 1
#define MANUEL 0

#define	_PI	3.14159265358979323846

#define IROUND(X) ((int)(((X) >= 0) ? (X) + 0.5 : (X) - 0.5))
#define LROUND(X) ((long)(((X) >= 0) ? (X) + 0.5 : (X) - 0.5))
#define	SQR(X)	((X) * (X))

#define	ALLOUER(TYPE)	( (TYPE *) malloc ((unsigned) sizeof(TYPE)) )
#define	ALLOUERM(TYPE, N)  ((TYPE *) malloc ((unsigned) \
                                 (sizeof(TYPE) * (N))))

				
#define	ON_LAISSE	0
#define ON_NETTOIE	1

#define EPSILON		1.0e-10

#define INFINI_D  1.0e+38
#define INFINI_F	1.0e+38
#define INFINI_L	2147483647L
#define INFINI_S	32767
#define INFINI_I	2147483647
#define INFINI_U	65535

/*
 * Declaration concernant les cepstres.
 */
//#define ORDRE_CEPNOR	256	/* ordre des fft pour le calcul
//                                     cepstral normal */
#define ORDRE_CEPSTRE 	256	/* ordre du lissage cepstral */
#define ORDRE_CEPMAX	512	/* ordre maximal du lissage cepstral */
#define SHIFT_CEPSTRE 	128	/* deplacement normal */
//#define DEP_FIN		32	/* deplacement fin */
//#define NB_COL_CEP	10	/* nombre de couleurs d'affichage
//                                     des pics de cepstres */
//#define COL_CEP		80	/* 1ere couleur pour les cepstres */
//#define NBCOUPCEP	35	/* filtrage des cepstres avec
//                                     coupure brutale */
//				/* filtrage des cepstres avec une
//				     coupure en cosinus */
//#define NB_CEP_STD1	20	/*  premier coef de coupure */
//#define NB_CEP_STD2	40	/*  deuxieme coef de coupure */
#define NB_CEP_STD1_SEC	0.00125	// premier coef de coupure (in s)
#define NB_CEP_STD2_SEC	0.0025	// deuxieme coef de coupure 

#define NB_CEPSTRE NB_SPECTRES_SUIVI

/*
 * LPC
 */
#define LARG_BAND_MAX	700.    // largeur maximale d'une
                                //   racine de lpc 

/* pour le champ modeMemoire */
#define TOUT		1  // tout le signal est affich
                           //   avec un maximum de 2 secondes
#define ZOOM		3  // seul une partie est affiche,
			   // dfinie par l'utilisateur
                           // avec la souris

struct ctrl_temps { // tous les indices temporels,
                    // appels d_* ou f_* 
                    // sont exprimes en echantillons 
  int modeMemoire; // type d'affichage du signal temporel
		   //   (tout ou partie du signal se
		   //   trouvant en memoire) 
  long tf   // taille du fichier (en echantillons) 
      ,d_e,f_e   // debut et fin de la zone d'etude
		 // typiquement la zone contenue en mmoire
		 // ( d_e correspond  space[0] )
      ,d_a,f_a   // debut et fin de la zone d'affichage
      ,d_es,f_es;// debut et fin de la zone de calcul du
		 // spectrogramme. En fait, on a toujours:
                 //   d_es=d_a et f_es=min(f_e,f_a)
  long debRegion, // premier et dernier echantillons
     finRegion,  // de la region mise en relief
     posBarre;          // chantillon de la barre
  Position xDebRegion, xFinRegion;  // Positions en entier sur la fenetre
  int xBarre;                       // du spectrogramme.
};

/////////////////////////////////////////////////
// la structure infoFile dsigne un son  lire
//   dans un fichier et est utilise pour
//   construire la structure de type infoFile qui
//   utilise ensuite.
// Le format du fichier son  lire:
//   est donn d'abord par l'extension du nom du fichier
//       .WAV or not .WAV
//   et est donn en dtail par:
//       cas .WAV
//           par le fichier .WAV lui-mme
//       cas not .WAV
//           par numfmt qui est le numro de format
//

struct infoFile {
	char nom[MAX_LIGNE];        // fichier signal
   char nom_man[MAX_LIGNE];    // fichier phonmes
	char nomAnnot[MAX_LIGNE];   // fichier mots
        // format des fichiers (cas non .WAV)
	int fmt_son; 
	int fmt_phon;
	int fmt_word;
	//
	bool isOpenSignal; // TRUE si fichier ouvert
	//:: bool isOpenPhon;   // TRUE si fichier ouvert
	//:: bool isOpenWord;   // TRUE si fichier ouvert
        //
	HMMIO hmmio;
	long depl,    // taille en octets de l'entte
	    	      // ou (c'est la mme chose) 
		      //   1er octet du signal dans
                      //       le fichier
	     longueur,   // nombre d'octets du signal
	     etiqdepl,   // depl et longueur de
	     etiqlongueur, // l'tiquetage (.WAV uniquement)
	     notedepl,   // depl et longueur des
	     notelongueur; // annotations (.WAV uniquement)
	int nb_bits;  // nombre de bit par echantillon  
	double frequence;
	int swap;  // ==SWAPINFILE : octets swaps
		   //     dans le fichier (voir
                   //     note ci-dessous) 
	int mode;   // type de spectre affich
};
#define SWAPINFILE 0
// note: les octets peuvent tre swaps ou non dans les
//   fichiers sons (selon la variable swap ci-dessus).
//   En mmoire, les octets sont toujours swaps.

// remarque sur le format .WAV en criture
//   les informations variables qui servent 
//   construire le fichier .WAV sont issues
//   de la structure ph_tude:
//       frequence :  la frquence (11025, 22050 ou 44100)
//       nb_bits :  le nombre de bits (8 ou 16)

#define LIMFOR 		3000.	/* frequence maximale (Hz)
                                     de notre interet */
#define LIMFORCAN	48	/* idem mais en canaux */
#define LIMFOR3		144	/* idem mais en tiers de canaux */
#endif
