/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier conver_t.cpp
//
// conversions temporelles diverses

#include "common.h"
#pragma hdrstop

#include "outils.h"
#include "signal.h"
#include "fmaxspec.h"

/*
 * Passage canaux --> Hz
 */
float canToHz (float x)
{
	return(x * fMaxSpectro / NB_CANAUX);
}

/*
 * Passage Hz --> canaux.
 */
float freqToEcr (float f)
{
  return(f / fMaxSpectro * NB_CANAUX);
}


/*
 * Conversion de frequence canal -> Hz.
 * attention ne pas oublier que les pics sont interpoles ==> d'ou le 3.
 */
float can3ToHz (float x)
{
  return(x / 3. * en_cours.frequence / 2. / NB_CANAUX);
}

/* 
 * Conversion de frequence Hz  -> canal.
 * attention ne pas oublier que les pics sont interpoles ==> d'ou le 3.
 */
int hzTocan3 (float x)
{
  return(IROUND(x * 3. / en_cours.frequence * 2. * NB_CANAUX));
}



