/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier couleur.h
//
#ifndef _COULEUR_H
#define _COULEUR_H
#define NB_COUL_SPEC 256	// nombre de couleurs
                        // toujours gal  16
          // les couleurs sont utilises
          // pour les spectrogrammes
          //      la place des griss
          //     lorsqu'on ne veut ou ne peut pas
          //     avoir de griss
          // les couleurs sont affiches
          // pour info sur la mire
          //

/////////////////////////////////////
// table des couleurs (pour info)
//     elles sont dfinies en type COLORREF

#define NOIR          0x000000L
#define ROUGEsombre   0x000080L
#define VERTsombre    0x008000L
#define JAUNEsombre   0x008080L
#define BLEUsombre    0x800000L
#define MAGENTAsombre 0x800080L
#define CYANsombre    0x808000L
#define GRISclair     0xC0C0C0L
#define GRISsombre    0x808080L
#define ROUGE         0x0000FFL
#define VERT          0x00FF00L
#define JAUNE         0x00FFFFL
#define BLEU          0xFF0000L
#define MAGENTA       0xFF00FFL
#define CYAN          0xFFFF00L
#define BLANC         0xFFFFFFL
#define DARKORANGE	 0x008cffL

#define	COULFOND  NOIR   // couleur du fond
#define COUL_SPEC PALETTEINDEX(0)  // couleur du fond
                                   //   du spectrogramme
				   // et aussi premier gris

//////////////////////////////////////////////
// variables
//
extern bool graymode;
extern COLORREF Pcolors[]; // table des couleurs
extern HPALETTE hpalGris; // palette des griss

//////////////////////////////////////////
// fonctions
//
extern void affGris(d_planche *fenetre
		     ,LPRECT lprect, int ngris);

extern COLORREF CoulFondSpec();

extern void grisSpectro( // Creation d'une palette de gris.
	double gamma);	// exposant de x, le niveau de gris
			//   etant (x/n) ^ gamma * 255.

extern bool colors16only();
extern void reinitgraymode();
extern void opencoul();
extern void closecoul();
#endif
