/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _CRITICALBANDS_H
#define _CRITICALBANDS_H
enum FrequencyScale{Bark, Mel, Mely};
enum MelStrategy{VariableMelWidth, ConstantMelWidth};
extern void freeCriticalBandFilters(float **filters, int nbFilters);
extern bool checkMelFilterWidth(FrequencyScale frequencyScale, int nbBands, int fftOrder, double samplingRate);
extern float **buildCriticalBandFilters(double samplingRate, int nbFilters, int FFTorder, int **centerFrequencies,
                                        bool ASRstrategy, FrequencyScale frequencyScale, MelStrategy melStrategy, bool nonLinearDisplayFrequency);
extern void applyCriticalBands(FLOATbuf& X, FLOATbuf& Y, int FFTorder, int cmax, float **filters, int indices[], int nbFilters, bool tobecompleted);
extern void applyCriticalBandsff(float *X, float *Y, int FFTorder, int cmax, float **filters, int indices[], int nbFilters);
extern void OLDapplyCriticalBandsff(float *X, float *Y, int FFTorder, int cmax, float **filters, int indices[], int nbFilters, bool tobecompleted);
extern void spectralCompletion(float *Y, int FFTorder, int cmax, int indices[], int nbFilters, bool ASRstrategy);
extern void rescalePerceptiveSpectrum(double perceptiveSpectrum[], int spectrumSize, bool freqScale, double samplingRate, float rescaledSpectrum[], int rescaleSpectrumSize);
extern float *dct(float *x, float *y, int n);
extern float *idct(float *x,float *y,int n, int nlifter, int nbFreqSamplesDisplayed, bool completionStrategy, double samplingRate, double (*hertz2percep)(double));
extern double bark2hertz(double fBark);
extern double hertz2bark(double hertz);
extern double hertz2mel(double hertz);
extern double mel2hertz(double mel);
extern double hertz2mely(double hertz);
extern double mely2hertz(double mel);
#endif
