function [mel] = hertz2mel(frq)
mel = log(1+frq/700)*1127.01048;
endfunction

function [mel] = hertz2mely(frq)
s=size(frq)
for i=1:s(2)
if frq(1,i) < 3000 then
mel(1,i) = frq(1,i) * (1 - frq(1,i) / 8000)
else 
a = 3000 * (1 - 3000 / 8000) - log(3000) * 500
mel(1,i) = log(frq(1,i))*500 + a
end
end
endfunction


function [frq] = mely2hertz(mel)
b = 3000 * (1 - 3000 / 8000)
a = 3000 * (1 - 3000 / 8000) - log(3000) * 500
s=size(mel)
for i=1:s(2)
if mel(1,i) < b then
frq(1,i) = 8000/2 * (1 - sqrt(1 - 4 * mel(1,i) / 8000))
else 
frq(1,i) = exp((mel(1,i) - a)/500)
end
end
endfunction

function [mel] = hertz2melyy(frq)
s=size(frq)
for i=1:s(2)
if frq(1,i) < 4000 then
mel(1,i) = frq(1,i) * (1 - frq(1,i) / 9000)
else 
a = 4000 * (1 - 4000 / 9000) - log(4000) * 500
mel(1,i) = log(frq(1,i))*500 + a
end
end
endfunction


function [frq] = melyy2hertz(mel)
b = 4000 * (1 - 4000 / 9000)
a = 4000 * (1 - 4000 / 9000) - log(4000) * 500
s=size(mel)
for i=1:s(2)
if mel(1,i) < b then
frq(1,i) = 9000/2 * (1 - sqrt(1 - 4 * mel(1,i) / 9000))
else 
frq(1,i) = exp((mel(1,i) - a)/500)
end
end
endfunction

function [frq] = mel2hertz(mel)
frq=700*(exp(mel/1127.01048)-1);
endfunction

function [y]= melfilter(w,mel,width)
s=size(w)
hertz=mel2hertz(mel)
widthLeft = hertz - mel2hertz(mel - width)
widthRight = -hertz + mel2hertz(mel + width);
for i=1:s(2) 
if w(i) < hertz - widthLeft then
  y(1,i) = 0
elseif w(i) < hertz  then
  y(1,i) = 1 - (hertz - w(i)) / widthLeft
elseif  w(i) < hertz + widthRight then
  y(1,i) = 1 - (w(i) -  hertz) / widthRight
else
  y(1,i) = 0
end
end
endfunction

function [y]= melyfilter(w,mel,width)
s=size(w)
hertz=mely2hertz(mel)
widthLeft = hertz - mely2hertz(mel - width)
widthRight = -hertz + mely2hertz(mel + width);
for i=1:s(2) 
if w(i) < hertz - widthLeft then
  y(1,i) = 0
elseif w(i) < hertz  then
  y(1,i) = 1 - (hertz - w(i)) / widthLeft
elseif  w(i) < hertz + widthRight then
  y(1,i) = 1 - (w(i) -  hertz) / widthRight
else
  y(1,i) = 0
end
end
endfunction

function [y]=bark2hertz(fBark)
 y = 600 * sinh(fBark / 6)
endfunction

function [y]=hertz2bark(hertz)
  y = 6.* log(hertz / 600. + sqrt((hertz / 600.)^2 +1.))
endfunction

function [y]= criticalband (w)
s=size(w)
for i=1:s(2) if w(i) < -1.3  then
  y(1,i) = 0
elseif w(i) < -0.5  then
  y(1,i) = exp(log(10) * 2.5 .* (w(i) + 0.5))
elseif  w(i) < 0.5 then
  y(1,i) = 1
elseif w(i) < 2.5
  y(1,i) = exp(log(10) * (0.5 - w(i)))
else
  y(1,i) = 0
end
end
endfunction

function [y]= criticalbandSym (w)
s=size(w)
for i=1:s(2) if w(i) < -2.5  then
  y(1,i) = 0
elseif w(i) < -0.5  then
  y(1,i) = exp(log(10) * (0.5 + w(i)))
elseif  w(i) < 0.5 then
  y(1,i) = 1
elseif w(i) < 1.3
  y(1,i) = exp(log(10) * 2.5 * (0.5 - w(i)))
else
  y(1,i) = 0
end
end
endfunction

function [y] = dct (x)
s = size(x)
for j=0:s(2)-1
  y(j+1) = 0.
  for k=0:s(2)-1 
    y(j+1) = y(j+1) + x(k+1) * cos(%pi / s(2) * j * (k + 1/2))
//    disp(y(j+1))
  end
end
endfunction

function [y] = idct(x)
s = size(x)
for j=0:s(2)-1
  y(j+1) = x(1) / 2
  for k=1:s(2)-1   
    y(j+1) = y(j+1) + x(k+1) * cos(%pi / s(2) * (j + 1 / 2) * k)
 end
  y(j+1) = y(j+1) * 2 / s(2);
 end
endfunction

function [y]= preemphasisPLP(x)
y = (x^2+56.810e06) .* x^4 ./((x^2+6.310e06)^2 .*(x^2+0.3810e09))
endfunction

function [y]=essai(x)
y = (x^2 .* (x+10)) ./(x^2 .* x)
endfunction

function [y]=preemphasis(f, Fs, alpha)
// y = 20 * log10(abs(1-alpha * exp(%i * 2 * %pi  * f / Fs)))
y = abs(1-alpha * exp(%i * 2 * %pi  * f / Fs))
endfunction

function drawCriticalBands(nbFilters)
Fs=16000
highestBarkFr = hertz2bark(Fs/2)
freq=(1:5:8000)
for i=1:nbFilters
  filterFreqBk = i * highestBarkFr / nbFilters
  filterFreqHz = bark2hertz(filterFreqBk)
  b=(1:5:8000)
  b = hertz2bark(b) - filterFreqBk
  if modulo(i,3) == 0 then 
    plot(freq, criticalband(b) * preemphasis(filterFreqHz, 16000,1), 'green')
  elseif modulo(i,3) == 1 then 
    plot(freq, criticalband(b) * preemphasis(filterFreqHz, 16000,1), 'blue')
  else
    plot(freq, criticalband(b) * preemphasis(filterFreqHz, 16000,1), 'red')
  end
end
endfunction

function drawMelFilters(nbFilters)
Fs=16000
highestMelFr = hertz2mel(Fs/2)
width = highestMelFr / (nbFilters + 1) 
freq=(1:5:8000)
for i=1:nbFilters
  filterFreqMel = width * i 
  filterFreqHz = mel2hertz(filterFreqMel)
  if modulo(i,3) == 0 then 
    plot(freq, melfilter(freq,filterFreqMel,width) * preemphasis(filterFreqHz, 16000,1), 'green')
  elseif modulo(i,3) == 1 then 
    plot(freq, melfilter(freq,filterFreqMel,width) * preemphasis(filterFreqHz, 16000,1), 'blue')
  else
    plot(freq, melfilter(freq,filterFreqMel,width) * preemphasis(filterFreqHz, 16000,1), 'red')
  end
end
endfunction

function drawMelyFilters(nbFilters)
Fs=16000
highestMelFr = hertz2mely(Fs/2)
width = highestMelFr / (nbFilters + 1) 
freq=(1:5:8000)
for i=1:nbFilters
  filterFreqMel = width * i 
  filterFreqHz = mely2hertz(filterFreqMel)
  if modulo(i,3) == 0 then 
    plot(freq, melyfilter(freq,filterFreqMel,width) * preemphasis(filterFreqHz, 16000,1), 'green')
  elseif modulo(i,3) == 1 then 
    plot(freq, melyfilter(freq,filterFreqMel,width) * preemphasis(filterFreqHz, 16000,1), 'blue')
  else
    plot(freq, melyfilter(freq,filterFreqMel,width) * preemphasis(filterFreqHz, 16000,1), 'red')
  end
end
endfunction
