/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier div.h
//
#ifndef _DIV_H
#define _DIV_H
#define DEBUG_PM 1

extern bool indtest;
extern bool Licensed;
extern char CountryFile[];
extern char LanguageFile[];
extern char PhoneticFont[];
extern char Organization[];
extern char SndRecorder[];
extern char Password[];

extern void init_choix_YESNO();

#define ml(n,s) mln(n)
// #define ml(n,s) (s)      pour supprimer l'utilisation de mln
#define mls(s) s
char *mln(int n);
bool ml_init();

extern int debug,subdebug;
extern int MyTextHeight;
extern int MyTextWidth; 
extern char tempdir[]; // directory temporaire
extern char helpfile[]; // fichier help
extern char logfile[]; // fichier log
extern char formatdir[];
extern char WinSnooriDirectory[];

extern unsigned long chtoul(char *ch);
extern void NotImplemented(PTWindowsObject AParent);

extern void *MyAlloc(HANDLE& h,long l);
extern void MyFree(HANDLE h);
extern void *MyReAlloc(HANDLE& h,long l);

extern int GetTicket();
extern HFONT queryFont(const char *name, int width, int height, int orientation);
extern void policeProp(const char *name, int width,int height,d_planche *fenetre);
extern void affiche_erreur(char *message);
extern void affiche_warning(char *message);
extern void affiche_bug(char *message);
extern void affiche_erreur_LigneFichier(char *ligne,char *fichier);
extern void fatal_error(char *message); // Arrete
                          // brutalement Snoori sur une
			  // erreur de l'utilisateur
extern char *My_itoa(int);                  /* int to ASCII */
extern char *My_ftoa(float);                  /* float to ASCII  */
extern void affstack();

extern void init_grafix(PTWindowsObject AParent);

////////////////////////////////////////////////
#define LOGFILE_MAXLEN 60000
class logfiles
{   FILE *fic1;
  public:
    logfiles();
    void open1();
    void open2(); // pour prosodie.cpp
    void puts1(char *ch);
    void rclf1();
    void wr1(char *ch);
    void date(long date);
    void close1();
    void clear();
    void appendLog1toLog();
    void show1();
    void show();
};
extern logfiles logs;

////////////////////////////////////////////////
// nombres ou textes  modifier par ScrollBar
#define HNUM  30   // hauteur de la fentre Wchange
// id : parametre id des constructeur
//    >=0 un bouton de modification est ajout
//    >0   chaque modification, un message WM_USER+id
//        sera envoy  la fentre mre
//        exemple de fonction traitant ce message:
//          virtual void clear_filtre(RTMessage MSG)
//                         =[WM_USER+2];
class TWchange : public TFrameWindow
{ public:
    char *afftext;
    int id; // pour message  renvoyer sur modif
    int ix,iy,iw; // parametres d'appel x y w
    int ixscreen,iyscreen; // ix et iy en coordonnes cran
    DWORD istyle; // style initial
    int scroll_visible;
    char ButtonChar;

    TWchange(PTWindowsObject AParent
	      ,int id,int x,int y,int w
	      ,char *afftext     // texte  afficher
	      ,char ButtonChar
	      ,int ticket
	      );
    void winit();
    void maj();
};
class TWfloat : public TWchange
{ public:
    float *var;
    float vdefaut; // valeur par dfaut (initiale)
    float vmin,vmax; // extrema
    float vminscroll,vmaxscroll; // extrema de la scrollbar
    TScrollBar *Tscrollbar;

    TWfloat(PTWindowsObject AParent
	      ,int id,int x,int y,int w
	      ,float *var     // variable  diter
	      ,char *afftext     // texte  afficher
	      ,float vmin, float vmax
	      ,float vminscroll, float vmaxscroll
	      ,int ticket
	      );
    void set(float f);
    virtual void SetupWindow();
    virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC,PAINTSTRUCT&);

	 // rponses aux vnements
	 /*
	 virtual void CMmore(RTMessage Msg)
		  = [ID_FIRST + 101];
	 virtual void CMscrollbar(RTMessage Msg)
		  = [ID_FIRST + 102];
	 */
	 void IDmore(WPARAM code);
	 void IDscrollbar(WPARAM code);
	 DECLARE_RESPONSE_TABLE(TWfloat);
};

class TWint : public TWchange
{ public:
    int *var;
    int vdefaut; // valeur par dfaut (initiale)
    int vmin,vmax; // extrema
    int vminscroll,vmaxscroll; // extrema de la scrollbar
    TScrollBar *Tscrollbar;

	 TWint(PTWindowsObject AParent
	      ,int id,int x,int y,int w
	      ,int *var     // variable  diter
	      ,char *afftext     // texte  afficher
	      ,int vmin, int vmax
	      ,int vminscroll, int vmaxscroll
	      ,int ticket
	      );
    void set(int i);
    virtual void SetupWindow();
    virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC,PAINTSTRUCT&);

	 // rponses aux vnements
	 /*
	 virtual void CMmore(RTMessage Msg)
        = [ID_FIRST + 101];
    virtual void CMscrollbar(RTMessage Msg)
	= [ID_FIRST + 102];
	 */
	 void IDmore(WPARAM code);
	 void IDscrollbar(WPARAM code);
	 DECLARE_RESPONSE_TABLE(TWint);
};

class TWtext : public TWchange
{ public:
	 char *var;
	 int maxlen;
	 TEdit *Tedit;

	 TWtext(PTWindowsObject AParent
			,int id,int x,int y,int w
			,char *var     // texte  diter
			,char *afftext     // texte  afficher
				  ,int maxlen
			,int ticket
			);
	 ~TWtext();
	 virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC,PAINTSTRUCT&);

	 // rponses aux vnements
	 /*
	 virtual void CMmore(RTMessage Msg)
		  = [ID_FIRST + 101];
	 */
	 void IDmore(WPARAM code);
	 DECLARE_RESPONSE_TABLE(TWtext);
};

struct choix { int n; char *text; };
class TWchoix : public TWchange
{ public:
	 bool *var;
	 int vdefaut; // valeur par dfaut (initiale)
	 choix *tchoix;

	 TWchoix(PTWindowsObject AParent
			,int id,int x,int y,int w
			,bool *var     // variable  diter
			,char *afftext     // texte  afficher
			,choix *tchoix
			,int ticket
			);
	 virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC,PAINTSTRUCT&);

	 // rponses aux vnements
	 /*
	 virtual void CMmore(RTMessage Msg)
		  = [ID_FIRST + 101];
	 */
	 void IDmore(WPARAM code);
	 DECLARE_RESPONSE_TABLE(TWchoix);
};

class TWchoixInt : public TWchange
{ public:
	 int *variable;
	 int vdefaut; // valeur par dfaut (initiale)
	 choix *tchoix;

	 TWchoixInt(PTWindowsObject AParent
			,int id,int x,int y,int w
			,int *var     // variable  diter
			,char *afftext     // texte  afficher
			,choix *tchoix
			,int ticket
			);
	 virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC,PAINTSTRUCT&);

	 // rponses aux vnements
	 /*
	 virtual void CMmore(RTMessage Msg)
		  = [ID_FIRST + 101];
	 */
	 void IDmore(WPARAM code);
	 DECLARE_RESPONSE_TABLE(TWchoixInt);
};

class TWWaveOutDevice : public TWchange
{ public:
	 TWWaveOutDevice(PTWindowsObject AParent
			,int x,int y,int w
			,int ticket
			);
	 virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC,PAINTSTRUCT&);

	 // rponses aux vnements
	 /*
	 virtual void CMmore(RTMessage Msg)
		  = [ID_FIRST + 101];
	 virtual void CMnext(RTMessage)
		  = [ID_FIRST + 102];
	 */
	 void IDmore(WPARAM code);
	 void IDnext(WPARAM code);
	 DECLARE_RESPONSE_TABLE(TWWaveOutDevice);
};

extern choix choix_YESNO[];

////////////////////////////////////////////
// activits
//
class TWact 
{   char text0[80],text1[80],text2[80];
    bool isRes;
  public:
    TWact();
    void paint();
    void wr_n(int n,char *text);
    void wr(char *text);
    void wr3(char *text1,char *text2,char *text3);
    void setXY(char *ch1,char *ch2);
    void f0(unsigned int f0);
    void duree(float duree);
    void showpourcent(char *text);
    void pourcent(long n,long nmax);
    void hidepourcent();
    void wrlog(bool b);
};
void initWact(PTWindowsObject AParent);
extern TWact *Wact;

///////////////////////////////////////////////////////
// fentre d'affichage d'un fichier texte
//
void ShowFileText(char *filename,char *title);

bool MyInputDialog(char *caption,char *prompt
		   ,char *text,int textmaxlen);

/////////////////////////////
// fentre message
//
class WindowMessage : public TEditWindow
{ int isVisible;
public:
  int nWmsg; // nombre de lignes entres
  WindowMessage(PTWindowsObject AParent);
  void wr(char *); // ajout d'une ligne de texte
  void show();
};
extern WindowMessage *Wmsg;
void initWmessage(PTWindowsObject AParent);
#endif


