/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

//----------------------------------------------------------------------------
// ObjectWindows
#include <owl/pch.h>
#include <owl/button.h>
#include <owl/dc.h>
#include "common1.h"
#include "drawbutton.h"
#include "menu.h"


//
// Function called when button needs to be drawn
//
void
TDrawableButton::ODADrawEntire(DRAWITEMSTRUCT far& drawInfo)
{
  HGDIOBJ oldHFont, hfont, fontPhon;
  int n;
  TDC drawDC(drawInfo.hDC);
  TRect itemRect(drawInfo.rcItem.left, drawInfo.rcItem.top,
                 drawInfo.rcItem.right, drawInfo.rcItem.bottom);
  drawDC.Rectangle(itemRect);
  //if (IsCurrentDefPB)
    drawDC.Rectangle(itemRect.InflatedBy(-1,-1));

  //itemRect.Inflate(-4,-6);
  n = max(0,min(drawInfo.CtlID - ID_PHON0, nPhonEntry -1));
  //oldHFont = SelectObject(drawInfo.hDC, fontPhon);
  drawDC.DrawText(phonEntries[idtext].text, -1, itemRect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
  //hfont = SelectObject(drawInfo.hDC, oldHFont);
  //  DeleteObject(hfont);
  if (drawInfo.itemState & ODS_FOCUS)
    drawDC.DrawFocusRect(itemRect);
}

//
// Function called when button gains or loses focus
//
void
TDrawableButton::ODAFocus(DRAWITEMSTRUCT far& drawInfo)
{
  TDC drawDC(drawInfo.hDC);
  TRect itemRect(drawInfo.rcItem.left+4, drawInfo.rcItem.top+6,
                 drawInfo.rcItem.right-4, drawInfo.rcItem.bottom-6);
  drawDC.DrawFocusRect(itemRect);
}

//
// Function called when button's selection status changes
//
void
TDrawableButton::ODASelect(DRAWITEMSTRUCT far& drawInfo)
{
  HGDIOBJ oldHFont;

  TDC drawDC(drawInfo.hDC);
  TRect itemRect(drawInfo.rcItem.left, drawInfo.rcItem.top,
                 drawInfo.rcItem.right, drawInfo.rcItem.bottom);
  drawDC.Rectangle(itemRect);
  if (IsCurrentDefPB)
    drawDC.Rectangle(itemRect.InflatedBy(-1,-1));

  itemRect.Inflate(-4,-6);
  //oldHFont = SelectObject(drawInfo.hDC, fontPhonetique());
  if (drawInfo.itemState & ODS_SELECTED)
    drawDC.DrawText(phonEntries[idtext].text, -1,
    					  itemRect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
  else
    drawDC.DrawText(phonEntries[idtext].text, -1,
    					  itemRect, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
  //SelectObject(drawInfo.hDC, oldHFont);
//  DeleteObject(la font phonetique);
  if (drawInfo.itemState & ODS_FOCUS)
    drawDC.DrawFocusRect(itemRect);
}


 

