/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// droit_ec.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <sys/stat.h>
#include <string.h>

#include "files.h"

////////////////////////////////////////////////
// teste le droit d'crire et affiche un
//   message si le fichier est protg
bool droit_ecrire_message(char *filename)
{ char ch[200];
  if (!droit_ecrire(filename))
  { strcpy(ch,filename);
    strcat(ch,ml(3601,"\nCe fichier est protg.\n\
L'criture n'est pas effectue."));
    affiche_warning(ch);
    return false;
  }
  return true;
}

////////////////////////////////////////////////
// droit d'criture dans un fichier
//
// en retour false criture interdite
//           true  criture autorise
bool droit_ecrire(char *fic)  
	/* fic est un fichier ou un rpertoire */
{ struct stat buf;
  char ch[_MAX_FNAME],fullpath[_MAX_PATH];

  if (strlen(fic)==0)  return false;
  _fullpath(fullpath,fic,_MAX_PATH);
  _splitpath(fullpath,NULL,NULL,ch,NULL);
  //
  if (strlen(ch)==0)
    return false; // fic est un chemin sans nom de fichier
  //
  if (!stat(fullpath, &buf))
  { // fic existe
    if ( (S_IFDIR & buf.st_mode)!=0 )
      return false; // fic est un rpertoire existant
    else
    { // fic est un fichier existant
      if ((S_IWRITE & buf.st_mode)==0) return false;
    }
  }
  else
  { // fic n'existe pas
    splitmakedir(fullpath);
    if (stat(fullpath, &buf)!=0)
      { int i=strlen(fullpath);
        fullpath[i-1]='\0';
        if (stat(fullpath, &buf)!=0)
        return false; // rpertoire de fic inexistant
      }
  }
  return true;
}




