/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef __ed_c0_h__
#define __ed_c0_h__
#include "end_detector.h"
#include "voca.h"
class TEDC0 : public TEndDetector {
	public :
		TEDC0();
		~TEDC0();

		virtual int Config(const char * basedir,TCfgFile &,int ver);
		int Config(double threshold,double threshold2,int minspeech,int maxspeechsil,int maxsilspeech,int keepstart,int keepend
				,double smoothing,int maxsize,int minsize,int maxsil);
		virtual int Init(TCepstreFactory *);

	protected :
		virtual int TestACepstre(const double *,int date);
	private :
		// param (duree en frames)
		double Threshold;	 // seuil parole
		double Threshold2;	 // seuil parole
		int MinSpeech;  // duree minimal de parole pour commencer
		int MaxSpeechSil; // duree maximale de parole dans silence de fin
		int MaxSilSpeech; // duree maximale de silence dans parole

		int KeepStart; // nombre de frame a garder avant le declenchement
		int KeepEnd;  // nombre de frame a garder apres la fin

		double Smoothing;  

		int MaxSize;  // duree maximale de la parole
		int MinSize;	// duree minimale de la parole

		int MaxSil;		// duree maximale de silence au debut


		// local var
		double OldValue;
		int State;
		int d1,d2,d3;
		int DateSil;
};

#endif
