/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef __ed_voca_h__
#define __ed_voca_h__

class TEDVoca {
	public :
		TEDVoca();
		~TEDVoca();
		int Config(int minspeech,int maxspeechsil,int maxsilspeech,
				int maxsize,int minsize,int maxsil,double minnrj, int stepms);
		virtual int Init();
      int getStartDate() { return startDate; }
      int getEndDate() { return endDate; }
		virtual int TestAFrame(float energy, int date);
	private :
		// param (duree en frames)
      void SetStartDate(int date) {startDate = date;}
      void SetEndDate(int date) {endDate = date;}
		int MinSpeech;  // duree minimal de parole pour commencer
		int MaxSpeechSil; // duree maximale de parole dans silence de fin
		int MaxSilSpeech; // duree maximale de silence dans parole

		int KeepStart; // nombre de frame a garder avant le declenchement
		int KeepEnd;  // nombre de frame a garder apres la fin

		int MaxSize;  // duree maximale de la parole
		int MinSize;	// duree minimale de la parole

		int MaxSil;		// duree maximale de silence au debut

      int StepMs;	// Step in ms between two cepstra calculations
		double TransCost; // cout de transition
		double MinNRJ; // C0 minimum pour etre de la parole

		double SilProb;
		double SpeechProb;

		// local var
		int State;
		int d1,d2,d3;
		int DateSil;
      int startDate, endDate;
};

#endif
