/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier editer.h
//

#ifndef _EDITER_H
#define _EDITER_H

#define PASDOP			0
#define COUPER			1
#define INSERER		2
#define SUBSTITUER	3
#define AMORTIRD		4
#define AMORTIRG		5
#define AMORTIRC     6
#define FILTRER		7
#define EFFACER      8
#define FILTEROLA		9
#define NOISE			10
#define ADDINGVOICING      11

struct editeur {
  struct infoFile insert;  // info sur le fichier a inserer
  struct infoFile substitute; // info sur le fichier qui remplace
  										// une partie du fichier original.
  struct infoFile cut;	   // info sur le fichier de couper 
  struct infoFile save;	   // info sur le fichier de sauvegarde 
  int derOp;		   // derniere operation effectuee 
  long debut, fin,	   // debut et fin de region a supprimer 
       derEchtFic;	   // le numero d'echantillon dans le
                           //     fichier auquel correspond ct.f_e 
  int yaDesModifsSignal;   // VRAI s'il y a eu des
                  // modifications dans le buffer signal
  int yaDesModifsEtiquetages;   // VRAI s'il y a eu des
		  // modifications dans les tiquetages
};
extern struct editeur infoEdit;	// structure de controle de l'editeur

extern void copieDansCutFile(struct editeur *infoEdit);
extern void insertFileIntoCurrentFile(struct editeur *infoEdit);
extern void substituteFileIntoCurrentFile(struct editeur *infoEdit);
extern void sauveRegion(struct editeur *infoEdit);
extern void insererUnFichierWAV(char *filename, int where);
extern void amortir(long deb, long fin, int cote, // AMORTIRG ou AMORTIRD ou AMORTIRC
                    float gain);
extern void annulerModif();
extern void fecoute(int n);

#endif
