/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier editeur.h
//
#ifndef _EDITEUR_H
#define _EDITEUR_H

////////////////////////////////////////
// fonctions
//
// dans le fichier delimite.cpp
extern void drawDown(int event_x);
extern void drawUp(int event_x);
extern void drawMotion(int event_x);
extern void MoveBarre(long echt);
extern void affRegion(d_planche *fenetre, struct ctrl_temps *pct);
extern void reinitSignalAndScreen();
extern void UpdateCurrentFile();
extern int UpdateCurrentFileBox();
extern void filtrage(
	struct profiltre *filt,
	long deb,
	long fin);
// extern void fecoute(int n);

extern void deplacement_ascenseur(long echt);
extern void allerA(	/* deplacement a une date
                                     specifiee en ms. */
	long echt); /* echantillon ou l'on veut aller. */
extern void rafraichirSpectro();
//\\// dans le fichier ecoute.cpp
//\\extern void ecoute(
//\\     long deb, 	// indices de debut et
//\\     long fin,   //     de fin d'ecoute
//\\     int n);	// nombre de repetitions
// dans le fichier edit.cpp
extern long copyBufToHFile(
		 SAMPLEbuf& bufsrc
		   ,long src_debut // en SAMPLEs
		,infoFile& dstinfo
		,long bcount); // en octets
extern long substituerFichier(long ou);
class writeSoundFile
{   int flushWAV();
    int flushNOTWAV();

  public:
    infoFile *dstinfo; // fichier destination
    // 1re partie, issue du fichier source
    infoFile *srcinfo; // fichier source
    long offset1;
    long length1;
    // 2me partie, issue du fichier insr
    //                   ou de la mmoire
    infoFile *insertinfo; // fichier  insrer
                          // si NULL, alors mmoire
    SAMPLEbuf *buf2; // buffer mmoire (si insertinfo==NULL)
    long offset2; // 1er octet dans le fichier insert
                   // ou dans le buffer p
    long length2; // nombre d'octets du buffer p
    // 3me partie, issue du fichier srcname
    long offset3;
    long length3;
    // buffer etiquetage
    char *petiqsbuf; // pointeur
    long netiqsbuf;  // longueur alloue
    long ietiqsbuf;  // indice courant en octets
    long previetiqsbuf; // avant-dernier ietiqsbuf
    // buffer annotations
    char *pnotesbuf; // pointeur
    long nnotesbuf;  // longueur alloue
    long inotesbuf;  // indice courant en octets
    long previnotesbuf; // avant-dernier inotesbuf

    writeSoundFile();
    ~writeSoundFile();
    void srcfile(infoFile *srcinfo
                , long offset1, long length1
		, long offset3, long length3);
    void addfiledata(infoFile *insertinfo, long offset2, long length2);
    void addmemdata(SAMPLEbuf& cnv, long offset2, long length2);
    void addetiq(long echt, char *text);
    void addnote(long echt, char *text);
    int flush();
};
extern void copyToCutFile(struct editeur *infoEdit);
extern long repercute_tf();
extern void repercuteModif(
	struct editeur *infoEdit);
	//\\,char *destinationFileName);
extern void Set_yaDesModifsSignal();
extern void Set_yaDesModifsEtiquetages();
extern void initEditSignal();
extern void initEditSignalSeul();
extern void insertFile(struct editeur *infoEdit);
extern void saveRegion(struct editeur *infoEdit);
extern long lireSignal(
	infoFile& srcinfo, // sound file
	long srcoffset,	 // expressed in # of char from
	                 //     the file beginning 
	SAMPLEbuf& dest, // destination
        long dest_debut, // dbut dans le buffer dest
	long nbSample);	 // number of sample to read
extern void initedit();
// dans le fichier spectrap.cpp
extern void ajtBoutSpectro(long d_, long f_, long d, long f);
extern void plusdeSpectroRapide();
extern void spectroRapide(d_planche *fenetre);
#endif
