/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

                             // fichier editMngmt.cpp
//

#include "common.h"
#include "signal.h"
#include "editer.h"
#include "editmngmt.h"
#include "filterOLA.h"
#include "noise.h"
#pragma hdrstop                                                         

bool yaUnEditManager = false;
TWEditManager *editManager;                                                        
int sortOfModif = 4;
static choix choix_type[] = { {0," stop band"}
                             ,{1," pass band"}
			  ,{0,""} };
static bool typeFiltre = false; // ==0 stop, !=0 pass
static bool typeStopOLA = true;

static int FIRorder = 41;
static float FIRattenuation = 30.;

float widthOLA = 300.,
      gainOLA = -48.,
      dampGain = -3.;

DEFINE_RESPONSE_TABLE1(TWEditManager,TDialog)
  EV_CHILD_NOTIFY_ALL_CODES(IDOK,IDOk),
  EV_CHILD_NOTIFY_ALL_CODES(IDCANCEL,IDCancel),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON4,EVremoveTrajOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON3,EVforgetPatternOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON8,EVapplyPatternOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON13,EVapplySelectedOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON2,EVreadPatternOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON7,EVsavePatternOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON5,EvLockHamonics),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON6,EvLockFormantLPC),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON9,EVapplyFIR),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON11,EVcancelModif),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON12,EVplay),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON10,EVapplyDamping),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON15,EVapplyNoise),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON14,EVapplyGetSpeechLevel),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_SCROLLBAR1,IDscrollFIRatt),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_SCROLLBAR2,IDscrollFIRorder),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON10,EVChModFIR),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON11,EVChModFIR),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON15,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON12,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON2,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON3,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON4,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON5,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON6,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON37,EVChModEdit),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON16,EVChModStopOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON17,EVChModStopOLA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON24,EVapplyAddvoicing),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_BUTTON25,EVforgetAddvoicing),
  EV_WM_CLOSE,
END_RESPONSE_TABLE;


TWEditManager::TWEditManager(PTWindowsObject AParent, LPSTR name)
	:TDialog(AParent,name)
{
  //new TGroupBox(this, 0, "FIR filter", 160, 4, 140, 80, 0);
  PTselect = new TRadioButton(this,IDC_RADIOBUTTON12,0);
  PTdampLeft = new TRadioButton(this,IDC_RADIOBUTTON3,0);
  PTdampMiddle = new TRadioButton(this,IDC_RADIOBUTTON4,0);
  PTdampRight = new TRadioButton(this,IDC_RADIOBUTTON2,0);
  PTFilterFIR = new TRadioButton(this,IDC_RADIOBUTTON6,0);
  PTFilterOLA = new TRadioButton(this,IDC_RADIOBUTTON5,0);
  PTAddNoise = new TRadioButton(this,IDC_RADIOBUTTON15,0);
  PTAddVoicing = new TRadioButton(this,IDC_RADIOBUTTON37,0);
  PTDefaultWidth = new TEdit(this, IDC_EDIT8);
  PTDefaultGain = new TEdit(this, IDC_EDIT11);
  PTWidth = new TEdit(this, IDC_EDIT18);
  PTGain = new TEdit(this, IDC_EDIT19);
  PTCancel = new TButton(this,IDCANCEL);
  PTRemove = new TButton(this, IDC_BUTTON4);
  PTPlay = new TButton(this, IDC_BUTTON12);
  PTCancelModif = new TButton(this, IDC_BUTTON11);
  PTApplySelectedOLA = new TButton(this, IDC_BUTTON13);
  PTApply = new TButton(this, IDC_BUTTON8);
  PTForget = new TButton(this, IDC_BUTTON3);
  PTRead = new TButton(this, IDC_BUTTON2);
  PTSave = new TButton(this, IDC_BUTTON7);
  PTLockFormant = new TButton(this, IDC_BUTTON6);
  PTLockHarmonics = new TButton(this, IDC_BUTTON5);
  PTgroup = new TGroupBox(this, IDC_GROUPBOX1);
  PTgroupOLA = new TGroupBox(this, IDC_GROUPBOX7);
  PTgroupPatternOLA = new TGroupBox(this, IDC_GROUPBOX8);
  PTStopOLA = new TRadioButton(this,IDC_RADIOBUTTON16);
  PTPassOLA = new TRadioButton(this,IDC_RADIOBUTTON17);
  PTgroupFIR = new TGroupBox(this, IDC_GROUPBOX9);
  PTFIRattenuation = new TScrollBar(this, IDC_SCROLLBAR1);
  PTFIRorder = new TScrollBar(this, IDC_SCROLLBAR2);
  PTTextFIRatt =  new TStatic(this, IDC_STATICTEXT23);
  PTTextFIRorder = new TStatic(this, IDC_STATICTEXT22);
  PTStopband = new TRadioButton(this,IDC_RADIOBUTTON10);
  PTPassband = new TRadioButton(this,IDC_RADIOBUTTON11);
  PTApplyFIR = new TButton(this, IDC_BUTTON9);
  PTgroupDamping = new TGroupBox(this, IDC_GROUPBOX10);
  PTApplyDamping = new TButton(this, IDC_BUTTON10);
  PTDampGain = new TEdit(this, IDC_EDIT20);
  PTgroupNoise = new TGroupBox(this, IDC_GROUPBOX13);
  PTNoiseDB = new TEdit(this, IDC_EDIT21);
  PTVoicingLevel = new TEdit(this, IDC_EDIT244);
  PTVoicingF0 = new TEdit(this, IDC_EDIT27);
  PTVoicingWidth = new TEdit(this, IDC_EDIT26);
  PTTextNoise = new TStatic(this, IDC_STATICTEXT31);
  PTApplyNoise = new TButton(this, IDC_BUTTON15);
  PTGetSpeechLevel = new TButton(this, IDC_BUTTON14);
  PTgroupVoicing = new TGroupBox(this, IDC_GROUPBOX11);
  PTForgetAddvoicing = new TButton(this, IDC_BUTTON25);
  PTApplyAddvoicing = new TButton(this, IDC_BUTTON24);
  // Creation de Static pour grer correctement l'invalidation d'options
  PTTextDamp1 = new TStatic(this, IDC_STATICTEXT27);
  PTTextDamp2 = new TStatic(this, IDC_STATICTEXT28);
  PTTextFIR1 = new TStatic(this, IDC_STATICTEXT20);
  PTTextFIR2 = new TStatic(this, IDC_STATICTEXT21);
  PTTextOLA1 = new TStatic(this, IDC_STATICTEXT4);
  PTTextOLA2 = new TStatic(this, IDC_STATICTEXT3);
  PTTextOLA3 = new TStatic(this, IDC_STATICTEXT9);
  PTTextOLA4 = new TStatic(this, IDC_STATICTEXT10);
  PTTextADDVOICINGW = new TStatic(this, IDC_STATICTEXT42);
  PTTextADDVOICINGF0 = new TStatic(this, IDC_STATICTEXT43);
  PTTextADDVOICING = new TStatic(this, IDC_STATICTEXT44);
}

bool TWEditManager::CanClose()
{
  STRING s;
  PTDefaultWidth->GetText(s,10);
  widthOLA = atof(s);
  PTDefaultGain->GetText(s,10);
  gainOLA = atof(s);
  PTDampGain->GetText(s,10);
  dampGain = atof(s);

  yaUnEditManager = false;
  return true;
}

float TWEditManager::GetWidth()
{
  STRING s;
  float width;

  PTDefaultWidth->GetText(s,10);
  width = atof(s);
  width = max(min(width, en_cours.frequence), 10.); // 10 Hz au minimum
  widthOLA = width;
  sprintf(s,"%.0f", width);
  PTDefaultWidth->SetText(s);
  return(width);
}

float TWEditManager::GetGain()
{
  STRING s;
  float gain;

  PTDefaultGain->GetText(s,10);
  gain = atof(s);
  gain = max(min(gain, 100.), -100.);
  gainOLA = gain;
  sprintf(s,"%.0f", gain);
  PTDefaultGain->SetText(s);
  return(gain);
}

float TWEditManager::GetDampGain()
{
  STRING s;
  float gain;

  PTDampGain->GetText(s,10);
  gain = atof(s);
  gain = max(min(gain, 100.), -100.);
  dampGain = gain;
  sprintf(s,"%.0f", gain);
  PTDampGain->SetText(s);
  return(gain);
}

double TWEditManager::GetSNRdB()
{
  STRING s;
  double SNR;

  PTNoiseDB->GetText(s,10);
  SNR = atof(s);
  sprintf(s,"%.1f", SNR);
  PTNoiseDB->SetText(s);
  return(SNR);
}

double TWEditManager::GetVoicingLevel()
{
  STRING s;
  double level;

  PTVoicingLevel->GetText(s,10);
  level = max(atof(s),0.);
  sprintf(s,"%.1f", level);
  PTVoicingLevel->SetText(s);
  return(level);
}

double TWEditManager::GetVoicingF0()
{
  STRING s;
  double f0;

  PTVoicingF0->GetText(s,10);
  f0 = max(atof(s),0.);
  sprintf(s,"%.1f", f0);
  PTVoicingF0->SetText(s);
  return(f0);
}

double TWEditManager::GetVoicingWidth()
{
  STRING s;
  double width;

  PTVoicingWidth->GetText(s,10);
  width = max(atof(s),0.);
  sprintf(s,"%.1f", width);
  PTVoicingWidth->SetText(s);
  return(width);
}


void TWEditManager::EvClose()
{
  TDialog::EvClose();
  yaUnEditManager = false;
}

TWEditManager::~TWEditManager() 
{
  delete PTdampLeft;
  delete PTdampMiddle;
  delete PTdampRight;
  delete PTFilterFIR;
  delete PTFilterOLA;
  delete PTAddNoise;
  delete PTAddVoicing;
  delete PTCancel;
  delete PTgroup;
  delete PTgroupOLA;
  delete PTApplySelectedOLA;
  delete PTApply;
  delete PTWidth;
  delete PTGain;
  delete PTDefaultWidth;
  delete PTDefaultGain;
  delete PTRemove;
  delete PTForget;
  delete PTForgetAddvoicing;
  delete PTSave;
  delete PTRead;
  delete PTLockFormant;
  delete PTLockHarmonics;
  delete PTFIRattenuation;
  delete PTFIRorder;
  delete PTTextFIRatt;
  delete PTTextFIRorder;
  delete PTgroupFIR;
  delete PTStopband;
  delete PTPassband;
  delete PTApplyFIR;
  delete PTApplyDamping;
  delete PTApplyAddvoicing;
  delete PTDampGain;
  delete PTgroupDamping;
  delete PTselect;
  delete PTPlay;
  delete PTCancelModif;
  delete PTgroupNoise;
  delete PTNoiseDB;
  delete PTTextNoise;
  delete PTGetSpeechLevel;
  delete PTApplyNoise;
  delete PTTextDamp1;
  delete PTTextDamp2;
  delete PTTextFIR1;
  delete PTTextFIR2;
  delete PTTextOLA1;
  delete PTTextOLA2;
  delete PTTextOLA3;
  delete PTTextOLA4;
  delete PTStopOLA;
  delete PTPassOLA;
  delete PTTextADDVOICING;
  delete PTTextADDVOICINGF0;
  delete PTTextADDVOICINGW;
  delete PTVoicingLevel;
  delete PTVoicingF0;
  delete PTVoicingWidth;
  delete PTgroupVoicing;
  yaUnEditManager = false;
}

void TWEditManager::SetupWindow()
{
	STRING s;
   TDialog::SetupWindow();
   PTselect->SetCheck(BF_CHECKED);
//   else PTonlyThisFile->SetCheck(BF_CHECKED);
   sprintf(s,"%.0f", widthOLA);
   PTDefaultWidth->SetText(s);
   PTWidth->SetText(s);
   sprintf(s,"%.0f", gainOLA);
   PTDefaultGain->SetText(s);
   PTGain->SetText(s);
   if (typeStopOLA) PTStopOLA->SetCheck(BF_CHECKED);
   else PTPassOLA->SetCheck(BF_CHECKED);
   
   sprintf(s,"%.0f", dampGain);
   PTDampGain->SetText(s);

   PTFIRattenuation->SetRange(1, 100, true);
   PTFIRattenuation->SetPosition((int)FIRattenuation);
   sprintf(s, "%d dB", (int) FIRattenuation);
   PTTextFIRatt->SetText(s);

   PTFIRorder->SetRange(4, 100, true);
   PTFIRorder->SetPosition(FIRorder);
   sprintf(s, "%d", FIRorder);
   PTTextFIRorder->SetText(s);

   if (!typeFiltre) PTStopband->SetCheck(BF_CHECKED);
   else PTPassband->SetCheck(BF_CHECKED);

   speechLeveldB = -INFINI_F;
   PTNoiseDB->SetText("0.0");

   voicingLevel = 0.7;
   PTVoicingLevel->SetText("0.7");
   voicingWidth = 100.;
   PTVoicingWidth->SetText("100.0");
   voicingF0 = 140.;
   PTVoicingF0->SetText("140.0");

   editMode = lastEditMode = SELECT;
   disableOLA();
   disableFIR();
   disableDamping();
   disableNoise();
   disableAddvoicing();
   yaUnEditManager = true;
}

void TWEditManager::IDOk(WPARAM)
{
  TDialog::CmOk();
  yaUnEditManager = false;
}

void TWEditManager::IDCancel(WPARAM)
{
 TDialog::CmCancel();
 yaUnEditManager = false;
}

void TWEditManager::IDscrollFIRatt(WPARAM)
{
  int pos;
  STRING s;
  pos = PTFIRattenuation->GetPosition();
  FIRattenuation = (float) pos;
  sprintf(s, "%d dB", (int) FIRattenuation);
  PTTextFIRatt->SetText(s);
}

void TWEditManager::IDscrollFIRorder(WPARAM)
{
  int pos;
  STRING s;
  pos = PTFIRorder->GetPosition();
  FIRorder = (float) pos;
  sprintf(s, "%d", FIRorder);
  PTTextFIRorder->SetText(s);
}

void TWEditManager::setCurrentPar(
  float gain,
  float width)
{
   STRING s;
   sprintf(s,"%.0f", width);
   PTWidth->SetText(s);
   sprintf(s,"%.0f", gain);
   PTGain->SetText(s);
}

void TWEditManager::getCurrentPar(
  float *gain,
  float *width)
{
  STRING s;
  PTWidth->GetText(s,10);
  *width = atof(s);
  *width = max(min(*width, en_cours.frequence), 10.); // 10 Hz au minimum
  sprintf(s,"%.0f", *width);
  PTWidth->SetText(s);

  PTGain->GetText(s,10);
  *gain = atof(s);
  *gain = max(min(*gain, 100.), -100.);
  sprintf(s,"%.0f", *gain);
  PTGain->SetText(s);
}

void TWEditManager::EVremoveTrajOLA(WPARAM)
{
  removeSelectTrajOLA();

  ::InvalidateRect(HWindow,NULL,TRUE);
  UpdateWindow();
}

void TWEditManager::EVcancelModif(WPARAM)
{
  annulerModif();
  if (editMode == OLA) affTrajOLA();
}

void TWEditManager::EVplay(WPARAM)
{
  fecoute(1);
}

void TWEditManager::EVforgetPatternOLA(WPARAM)
{
  forgetOLAPattern();
}

void TWEditManager::EVforgetAddvoicing(WPARAM)
{
  // forgetAddvoicing();   to be done
}

void TWEditManager::EVapplyPatternOLA(WPARAM)
{                                                                                                               
  applyOLAPattern(true, typeStopOLA);
}

void TWEditManager::EVapplySelectedOLA(WPARAM)
{
  applyOLAPattern(false, typeStopOLA);
}

void TWEditManager::EVsavePatternOLA(WPARAM)
{
  saveOLAPattern();
}

void TWEditManager::EVreadPatternOLA(WPARAM)
{
  readOLAPattern();
}

void TWEditManager::EvLockHamonics(WPARAM code)
{
  lockOLAPattern(HARMONICS);
}

void TWEditManager::EvLockFormantLPC(WPARAM code)
{
  lockOLAPattern(FORMANTLPC);
}

extern void applyFIR(int, float, bool);

void TWEditManager::EVapplyFIR(WPARAM code)
{
  applyFIR(FIRorder, FIRattenuation, typeFiltre);
}

void TWEditManager::EVapplyGetSpeechLevel(WPARAM)
{
  if (ct.debRegion >= ct.finRegion) speechLeveldB = getSignaldB(ct.d_e, ct.f_e);
  else speechLeveldB = getSignaldB(ct.debRegion, ct.finRegion);
}

extern void applyAddVoicing(int deb, int fin, double voicingLevel, double F0, double voicingWidth);
void TWEditManager::EVapplyAddvoicing(WPARAM)
{
  applyAddVoicing(ct.debRegion, ct.finRegion, GetVoicingLevel(), GetVoicingF0(), GetVoicingWidth());
}

void TWEditManager::EVapplyNoise(WPARAM)
{
  if (speechLeveldB < 0.) {
    affiche_erreur(ml(9103,"You must get the level of speech before"));
    return;
  }
  else addNoise(ct.debRegion, ct.finRegion, speechLeveldB, GetSNRdB());
}

void TWEditManager::EVapplyDamping(WPARAM code)
{
  if (isEditingDampLeft())
    amortir(ct.debRegion, ct.finRegion, AMORTIRG,1.);
  else if (isEditingDampRight())
    amortir(ct.debRegion, ct.finRegion, AMORTIRD,1.);
  else if (isEditingDampMiddle())
    amortir(ct.debRegion, ct.finRegion, AMORTIRC, exp(log(10.) * editManager->GetDampGain() / 20.));
}

void TWEditManager::EVChModFIR(WPARAM code)
{
  typeFiltre = PTPassband->GetCheck() == BF_CHECKED;
}

void TWEditManager::EVChModStopOLA(WPARAM code)
{
  typeStopOLA = PTStopOLA->GetCheck() == BF_CHECKED;
}

void TWEditManager::disableMode(int mode)
{
	switch (mode) {
     case OLA:
       disableOLA();
       break;
     case ADDVOICING:
       disableAddvoicing();
       break;
     case FIR:
       disableFIR();
       break;
     case DAMPLEFT:
     case DAMPMIDDLE:
     case DAMPRIGHT:
       disableDamping();
       break;
     case ADDNOISE:
       disableNoise();
       break;
   }
}

void TWEditManager::EVChModEdit(WPARAM code)
{
  if (PTselect->GetCheck() == BF_CHECKED) {
    disableMode(editMode);
    editMode = SELECT;
  }
  if (PTFilterFIR->GetCheck() == BF_CHECKED) {
     disableMode(editMode);
     editMode = FIR;
     disableFIR();
  }
  if (PTFilterOLA->GetCheck() == BF_CHECKED) {
     disableMode(editMode);
     editMode = OLA;
     disableOLA();
     // display existing OLA trajectories
     affTrajOLA();
  }
  if (PTdampLeft->GetCheck() == BF_CHECKED) {
    disableMode(editMode);
    editMode = DAMPLEFT;
    disableDamping();
  }
  if (PTdampMiddle->GetCheck() == BF_CHECKED) {
    disableMode(editMode);
    editMode = DAMPMIDDLE;
    disableDamping();
  }
  if (PTdampRight->GetCheck() == BF_CHECKED) {
    disableMode(editMode);
    editMode = DAMPRIGHT;
    disableDamping();
  }
  if (PTAddNoise->GetCheck() == BF_CHECKED) {
    disableMode(editMode);
    editMode = ADDNOISE;
    disableNoise();
  }
  if (PTAddVoicing->GetCheck() == BF_CHECKED) {
    disableMode(editMode);
    editMode = ADDVOICING;
    disableAddvoicing();
  }
}

#define INVERSE(X) oldStyle = X->GetStyle(); X->TWindow::SetWindowLong(GWL_STYLE, oldStyle ^= (WS_DISABLED));
void TWEditManager::disableAddvoicing()
{
  uint32 oldStyle;
  INVERSE(PTForgetAddvoicing);
  INVERSE(PTApplyAddvoicing);
  INVERSE(PTTextADDVOICING);
  INVERSE(PTTextADDVOICINGW);
  INVERSE(PTTextADDVOICINGF0);
  INVERSE(PTVoicingLevel);
  INVERSE(PTVoicingF0);
  INVERSE(PTVoicingWidth);
  INVERSE(PTgroupVoicing);
  ::InvalidateRect(HWindow,NULL,TRUE);
  UpdateWindow();
}

void TWEditManager::disableOLA()
{
  uint32 oldStyle;
  INVERSE(PTWidth);
  INVERSE(PTGain);
  INVERSE(PTDefaultWidth);
  INVERSE(PTDefaultGain);
  INVERSE(PTRemove);
  INVERSE(PTForget);
  INVERSE(PTApply);
  INVERSE(PTApplySelectedOLA);
  INVERSE(PTSave);
  INVERSE(PTRead);
  INVERSE(PTStopOLA);
  INVERSE(PTPassOLA);
  INVERSE(PTLockFormant);
  INVERSE(PTLockHarmonics);
  INVERSE(PTgroupPatternOLA);
  INVERSE(PTgroupOLA);
  INVERSE(PTTextOLA1);
  INVERSE(PTTextOLA2);
  INVERSE(PTTextOLA3);
  INVERSE(PTTextOLA4);
  ::InvalidateRect(HWindow,NULL,TRUE);
  UpdateWindow();
 }

void TWEditManager::disableFIR()
{
  uint32 oldStyle;
  INVERSE(PTFIRattenuation);
  INVERSE(PTTextFIRatt);
  INVERSE(PTFIRorder);
  INVERSE(PTTextFIRorder);
  INVERSE(PTStopband);
  INVERSE(PTPassband);
  INVERSE(PTApplyFIR);
  INVERSE(PTgroupFIR);
  INVERSE(PTTextFIR1);
  INVERSE(PTTextFIR2);
  ::InvalidateRect(HWindow,NULL,TRUE);
  UpdateWindow();
}

void TWEditManager::disableDamping()
{
  uint32 oldStyle;
  INVERSE(PTApplyDamping);
  INVERSE(PTDampGain);
  INVERSE(PTgroupDamping);
  INVERSE(PTTextDamp1);
  INVERSE(PTTextDamp2);
  ::InvalidateRect(HWindow,NULL,TRUE);
  UpdateWindow();
}

void TWEditManager::disableNoise()
{
  uint32 oldStyle;
  INVERSE(PTgroupNoise);
  INVERSE(PTNoiseDB);
  INVERSE(PTTextNoise);
  INVERSE(PTApplyNoise);
  INVERSE(PTGetSpeechLevel);
  ::InvalidateRect(HWindow,NULL,TRUE);
  UpdateWindow();
}

//////////////////////////////////////////////////
// commandes menu de la fentre principale
//
void Wtop::CMEditingTools()
// fonction d'activation de la fentre dialogue
{
  if (!yaUnEditManager) {
    editManager = new TWEditManager(PTWtop, "WEditionManager");
  	 editManager->Create();
    editManager->ShowWindow(SW_SHOW);
  }
}

bool isFilterFIR()
{
  return(yaUnEditManager && editManager->editMode == FIR);
}

bool isEditingAddvoicing()
{
  return (yaUnEditManager && editManager->editMode == ADDVOICING);
}

bool isFilterOLA()
{
  return (yaUnEditManager && editManager->editMode == OLA);
}

bool isEditingDampLeft()
{
  return(yaUnEditManager && editManager->editMode == DAMPLEFT);
}

bool isEditingDampRight()
{
  return (yaUnEditManager && editManager->editMode == DAMPRIGHT);
}

bool isEditingDampMiddle()
{
  return (yaUnEditManager && editManager->editMode == DAMPMIDDLE);
}
