/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#define SELECT 		0
#define DAMPLEFT 		1
#define DAMPMIDDLE 	2
#define DAMPRIGHT		3
#define FIR				4
#define OLA 			5
#define ADDNOISE		6
#define ADDVOICING   7

class TWEditManager : public TDialog
{
  public:
  TRadioButton *PTselect;
  TRadioButton *PTdampLeft;
  TRadioButton *PTdampMiddle;
  TRadioButton *PTdampRight;
  TRadioButton *PTFilterFIR;
  TRadioButton *PTFilterOLA;
  TRadioButton *PTAddNoise;
  TRadioButton *PTAddVoicing;
  TEdit *PTWidth;
  TEdit *PTGain;
  TEdit *PTDefaultWidth;
  TEdit *PTDefaultGain;
  TRadioButton *PTStopOLA, *PTPassOLA;
  TButton *PTCancel;
  TButton *PTRemove;
  TButton *PTApply;
  TButton *PTApplySelectedOLA;
  TButton *PTForget;
  TButton *PTPlay;
  TButton *PTCancelModif;
  TButton *PTRead;
  TButton *PTSave;
  TButton *PTLockFormant;
  TButton *PTLockHarmonics;
  TButton *PTForgetAddvoicing;
  TButton *PTApplyAddvoicing;
  TGroupBox *PTgroup;
  TGroupBox *PTgroupPatternOLA;
  TGroupBox *PTgroupOLA;
  TScrollBar *PTFIRattenuation;
  TScrollBar *PTFIRorder;
  TStatic *PTTextFIRatt;
  TStatic *PTTextFIRorder;
  TRadioButton *PTStopband;
  TRadioButton *PTPassband;
  TButton *PTApplyFIR;
  TButton *PTApplyDamping;
  TGroupBox *PTgroupDamping;
  TGroupBox *PTgroupFIR;
  TGroupBox *PTgroupNoise;
  TEdit *PTNoiseDB;
  TStatic *PTTextNoise;
  TButton *PTGetSpeechLevel;
  TButton *PTApplyNoise;
  TEdit *PTDampGain;
  TEdit *PTVoicingLevel;
  TEdit *PTVoicingF0;
  TEdit *PTVoicingWidth;
  TGroupBox *PTgroupVoicing;

  TStatic *PTTextDamp1, *PTTextDamp2,
          *PTTextFIR1, *PTTextFIR2,
          *PTTextOLA1, *PTTextOLA2, *PTTextOLA3, *PTTextOLA4,
          *PTTextADDVOICING, *PTTextADDVOICINGF0, *PTTextADDVOICINGW;
  int editMode, lastEditMode;

  TWEditManager(PTWindowsObject AParent, LPSTR name);
  ~TWEditManager();
  virtual void SetupWindow();
  virtual bool CanClose();
  virtual void EvClose();
  void IDOk(WPARAM code);
  void IDCancel(WPARAM code);
  void EVplay(WPARAM code);
  void EVcancelModif(WPARAM code);
  void EVremoveTrajOLA(WPARAM code);
  void EvLockHamonics(WPARAM code);
  void EvLockFormantLPC(WPARAM code);
  void EVapplyPatternOLA(WPARAM code);
  void EVapplySelectedOLA(WPARAM code);
  void EVforgetPatternOLA(WPARAM code);
  void EVreadPatternOLA(WPARAM code);
  void EVsavePatternOLA(WPARAM code);
  void EVapplyFIR(WPARAM code);
  void EVapplyDamping(WPARAM code);
  void IDscrollFIRatt(WPARAM);
  void IDscrollFIRorder(WPARAM);
  void EVChModFIR(WPARAM);
  void EVChModEdit(WPARAM);
  void EVChModStopOLA(WPARAM);
  void EVapplyNoise(WPARAM);
  void EVapplyAddvoicing(WPARAM);
  void EVforgetAddvoicing(WPARAM);
  void EVapplyGetSpeechLevel(WPARAM);
  
  void disableMode(int mode);
  void disableAddvoicing();
  void disableOLA();
  void disableFIR();
  void disableDamping();
  void disableNoise();
  float GetWidth();
  float GetGain();
  double GetSNRdB();
  double GetVoicingLevel();
  double GetVoicingF0();
  double GetVoicingWidth();
  float GetDampGain();
  void getCurrentPar(float *gain, float *width);
  void setCurrentPar(float gain, float width);
  // static width;   // width in Hz of the OLA filter
  // static gain;    // gain in dB of the OLA filter
 private:
  void startRecording(int duration);
  void stopRecording();
  double speechLeveldB;
  double voicingLevel;
  double voicingF0;
  double voicingWidth;
  DECLARE_RESPONSE_TABLE(TWEditManager);
};
extern TWEditManager *editManager;
extern bool yaUnEditManager;
extern float widthOLA, gainOLA;
extern bool isFilterFIR(), isFilterOLA(), isEditingDampRight(), isEditingDampMiddle(),
            isEditingDampLeft(), isEditingAddvoicing();

