/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier editwnd.cpp
//
#include "common.h"
#pragma hdrstop


// Constructor for a TEditWindow.  Initializes its data fields using
//	passed parameters and default values.  Constructs its child edit
//	control.
TEditWindow::TEditWindow(PTWindowsObject AParent, LPSTR ATitle,
								 TModule*)
				: TFrameWindow(AParent, ATitle)
{
  Editor = new TEdit(this, 0, NULL, 0, 0, 0, 0, 0, TRUE, GetModule());
  Editor->Attr.Style |= ES_NOHIDESEL;
}

DEFINE_RESPONSE_TABLE1(TEditWindow,TFrameWindow)
  EV_WM_SIZE,
  EV_WM_SETFOCUS,
END_RESPONSE_TABLE;

/* Responds to an incoming WM_SIZE message by resizing the child edit
  control according to the size of the TEditWindow's client area. */
void TEditWindow::EvSize(uint sizeType, TSize &size)
{ TFrameWindow::EvSize(sizeType, size);
  Editor->SetWindowPos( 0, -1, -1, size.cx+2,
	 size.cy+2, SWP_NOZORDER);
}

/* Responds to an incoming WM_SETFOCUS message by setting the focus to
	the child edit control. */
void TEditWindow::EvSetFocus(HWND)
{ Editor->SetFocus();
}

