/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier etiman.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>         
#include <math.h>

#include "notetiq.h"
#include "cnotetiq.h"
#include "snoori.h"
#include "outils.h"
#include "menu.h"
#include "getphoan.h"
#include "signal.h"
#include "format_f.h"
#include "files.h"
#include "add_files/htmlhelp.h"

////////////////////////////////////////////////
// fonctions de la souris
//
static int yaUnChangerTexteEtiq = false;
static int yaDesChangerTexteEtiq = false;
static int yaUnAjouterLimiteEtiq = false;
static int yaUnEffacerLimiteEtiq = false;
static int yaUnChangerLimiteEtiq = false;
int getPhoanDejaCree = false;
static TWgetphoan *phonAnnotator; 	// the dialog for phonetic annotating

static void AjouterLimiteEtiq(long echt)
{
  etiqs.add_mt(echt);

  yaUnAjouterLimiteEtiq=FAUX;
  Set_yaDesModifsEtiquetages();
  aff_etiqs();
  if (getPhoanDejaCree) phonAnnotator->UpdateCurrentSegment();
}

static void EffacerLimiteEtiq(long echt)
{ etiqs.detach(echt);
  yaUnEffacerLimiteEtiq=FAUX;
  Set_yaDesModifsEtiquetages();
  aff_etiqs();
  if (getPhoanDejaCree) phonAnnotator->UpdateCurrentSegment();
}

static void ChangerLimiteEtiq(long echt)
{ etiqs.shift(echt);
  Set_yaDesModifsEtiquetages();
  aff_etiqs();
  if (getPhoanDejaCree) phonAnnotator->UpdateCurrentSegment();
}

static void ChangerTexteEtiq(TPoint& point, long echt)
{ int i;
  int ph;

  i=etiqs.search(echt);
  if ((i>=0)&&(i<etiqs.nb-1)) {
    ph=GetPhonemeByMenu(point); 
    if (ph!=-128) {
      etiqs.e[i]->SetText(TextOfPhon(ph));
      aff_etiqs();
      if (getPhoanDejaCree) phonAnnotator->UpdateCurrentSegment();
    }
  }
  else
    MessageBox(PTWtop->HWindow
,ml(3801,"entre de phonme impossible ici\nvous n'tes pas entre deux limites")
,ml(3802,"warning"),MB_OK);

  yaUnChangerTexteEtiq=FAUX;
  Set_yaDesModifsEtiquetages();
}

static void ChangerTextesEtiq(TPoint& point, long echt)
{
  TWgetphoan *x;
  int numEtiq;

  if (!yaUnSignal) return;
  numEtiq = etiqs.search(echt);
  if ((numEtiq <0) || (numEtiq >= etiqs.nb))
 	::MessageBox(PTWtop->HWindow, "Il faut d'abord placer des limites de sons", "Warning", MB_OK);
  else if (!getPhoanDejaCree) {
    //TWgetphoan(PTWtop, "Wgetphoan", echt, 50, 50, 200, "Phonetic annotator").Execute();
    desactiveMenusSeuls(PPMENUAllStandard);
    active(MENUEcoute1Fois);
    ::DrawMenuBar(PTWtop->HWindow);
//    phonAnnotator = new TWgetphoan(PTWtop, "Phonetic annotations", echt, 50, 50, 200, "Phonetic annotator");
    phonAnnotator = new TWgetphoan(PTWtop, "Wgetphoan", echt, 50, 50, 200, "Phonetic annotator");
    phonAnnotator->Create();
    phonAnnotator->ShowWindow(SW_SHOW);

    getPhoanDejaCree = true;
    yaDesChangerTexteEtiq=FAUX;
    Set_yaDesModifsEtiquetages();
  }
}

//////////////////////////////////////////
// traitement de la souris
//
void drawDownEtiq(int event_x)
{ BOOL ctrl,maj;
  long echt;

  if (!yaUnSignal) return;
  if (!isEtiqModifiable)
  { affiche_warning(
ml(3803,"Modification impossible,\nVous \
n'avez pas le droit de toucher  ce fichier"));
    wetiquetage->LButtonDown=FALSE;
    return;
  }
  echt=wetiquetage->DXtoLX(event_x);
  ctrl=GetKeyState(VK_CONTROL)<0;
  maj=GetKeyState(VK_SHIFT)<0;
  yaUnEffacerLimiteEtiq=ctrl&&maj;
  yaUnAjouterLimiteEtiq=ctrl&&(!maj);
  yaUnChangerLimiteEtiq=(!ctrl)&&maj;
  ct.posBarre=-1;
  wsignal->wsig->MoveBarre(echt);
  SetCapture(wetiquetage->HWindow);
}
void drawDblclkEtiq(int event_x)
{ long echt;

  if (!yaUnSignal) return;
  if (!isEtiqModifiable) 
  { affiche_warning(
ml(3803,"Modification impossible,\nVous \
n'avez pas le droit de toucher  ce fichier"));
    wetiquetage->LButtonDown=FALSE;
    return;
  }
  echt=wetiquetage->DXtoLX(event_x);
  yaUnChangerTexteEtiq=TRUE;
  ct.posBarre=-1;
  wsignal->wsig->MoveBarre(echt);
  SetCapture(wetiquetage->HWindow);
}

void drawDblclkREtiq(int event_x)
{ long echt;

  if (!yaUnSignal) return;
  if (!isEtiqModifiable) {
	affiche_warning(
ml(3803,"Modification impossible,\nVous \
n'avez pas le droit de toucher  ce fichier"));
    wetiquetage->RButtonDown=FALSE;
    return;
  }
  echt=wetiquetage->DXtoLX(event_x);
  yaDesChangerTexteEtiq=TRUE;
  ct.posBarre=-1;
  wsignal->wsig->MoveBarre(echt);
  SetCapture(wetiquetage->HWindow);
}

void drawMotionEtiq(int event_x)
{ long echt;

  if (!yaUnSignal) return;
  if (!isEtiqModifiable) return;
  echt=wetiquetage->DXtoLX(event_x);
  if (yaUnChangerLimiteEtiq)
    ChangerLimiteEtiq(echt);
  wsignal->wsig->MoveBarre(echt);
}
void drawUpEtiq(TPoint& point)
{ long echt;

  if (!yaUnSignal) return;
  if (!isEtiqModifiable) return;
  echt=wetiquetage->DXtoLX(point.x);
  if (yaUnAjouterLimiteEtiq) AjouterLimiteEtiq(echt);
  if (yaUnEffacerLimiteEtiq) EffacerLimiteEtiq(echt);
  if (yaUnChangerLimiteEtiq) ChangerLimiteEtiq(echt);
  if (yaUnChangerTexteEtiq) ChangerTexteEtiq(point, echt);
  if (yaDesChangerTexteEtiq) ChangerTextesEtiq(point, echt);
  yaUnChangerLimiteEtiq = yaDesChangerTexteEtiq = FAUX;
  wsignal->wsig->MoveBarre(-1);
  ReleaseCapture();
}

///////////////////////////////////////////////
// fonctions du menu principal
//
typedef HWND WINAPI (*HtmlHelpFunc)( HWND hwndCaller, LPCSTR pszFile,UINT uCommand, DWORD dwData );

const char pszHelpOCXCtrl [] = "hhctrl.ocx";
void Wtop::CMHelpEtiq()
{
  HINSTANCE hHelpOCX = ::LoadLibrary(pszHelpOCXCtrl);
  if (!hHelpOCX) {
    ::MessageBox(HWindow, "Cannot use the html help!", "Error", MB_OK);
   return;
  }

   HtmlHelpFunc HTMLHelp = (HtmlHelpFunc)::GetProcAddress(hHelpOCX, ATOM_HTMLHELP_API_ANSI);

  // Now call HTMLHelp functions:

  HTMLHelp(HWindow, helpfile, HH_DISPLAY_TOPIC, (DWORD) "mousePhoneme.htm");
}

void Wtop::CMlectEtiq()
{ if (!yaUnSignal) return;
 
  if (get_format(this,en_cours)!=IDOK) return;
  etiqs.clear();
  if (en_cours.fmt_phon!=0)
  { souris(XC_watch);
    lireman(&etiqs, en_cours);
    isEtiqModifiable=droit_ecrire(en_cours.nom_man);
    //:: en_cours.isOpenPhon=TRUE;
    aff_etiqs();
    souris(XC_top_left_arrow);
  }
}

void Wtop::CMsauverEtiq()
{ if (!yaUnSignal) return; 
  
  if (get_format(this,en_cours)!=IDOK) return;
  if (en_cours.fmt_phon!=0)
  { souris(XC_watch);
    if ((isEtiqModifiable
	   =droit_ecrire_message(en_cours.nom_man)
          )==TRUE)
      sauvman(&etiqs, en_cours);
    souris(XC_top_left_arrow);
  }
}


