/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier evalue.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>

#include "format_f.h"

static long p_ca[TAIL_LOC];	/* pile des calculs (resultat
                                       dans p_ca[0]) */
static int top_ca;		/* sommet de la pile des calculs */

static void e_ca(long x)
{
  if (top_ca >= TAIL_LOC)
    affiche_erreur(ml(3901,"plus de place dans la pile des calculs"));
  p_ca[top_ca++] = x;
}

static long d_ca()
{
  if (!top_ca) affiche_erreur(ml(3902,"pile des calculs vide"));
  return(p_ca[--top_ca]);
}

long evalue(
	struct post_pile *expr,
	long *valeurs)
{
  int i;

  top_ca = 0;
  for (i = 0; i < expr->sommet; i++)
  { switch (expr->pile[i].t)
    { case 'n' : e_ca(expr->pile[i].x.val); break;
      case 'v' : {
		   if (valeurs == NULL)
		     affiche_erreur(
		       ml(3903,"valeur inconnue pour l'evaluation"));
		   e_ca(valeurs[expr->pile[i].x.var]);
         	 }
		 break;
      case 'c' : e_ca(valeurs[NBVAR]); break; /* constante SOF */
      case 'o' : switch (expr->pile[i].x.op)
                 { case PLUS : e_ca(d_ca()+d_ca()); break;
		   case MOINS : { long x = d_ca(), y = d_ca();
				  e_ca(y-x);
				}
				break;			
		   case FOIS : e_ca(d_ca()*d_ca()); break;
		   case DIVISE : { long x = d_ca(), y = d_ca();
				   e_ca(y/x);
				 }
				 break;
		 }
		 break;
      default : affiche_erreur(ml(3904,"expression incoherente"));
    }
  }
  return(p_ca[0]);
}
