/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier fftlpc.h
//

#ifndef _FFTLPC_H
#define _FFTLPC_H

#define ORDRE_LPC_MIN 4
#define ORDRE_LPC_MAX 60
#define ORDRE_LPC_STD 18
#define ORDRE_LPC_MIN_MS 0.2
#define ORDRE_LPC_MAX_MS 5.0
#define ORDRE_LPC_STD_MS 1.0

// dans le fichier blackman.cpp
extern void         initblack(	// initialisation d'une fenetre
			        //     de blackman
       FLOATbuf *h,
       long         nb_points);
extern void black_sf(	// fenetre de blackman SAMPLE -> float
       SAMPLEbuf& cnv,
       long cnv_debut,
       FLOATbuf& res,
       FLOATbuf *h,
       long         nb_points);
extern void black_ff(	// fenetre de blackman float -> float
       FLOATbuf& cnv,
       FLOATbuf& res,
       FLOATbuf *h,
       long         nb_points);
// dans le fichier hamming.cpp
extern void initham(	// initialisation d'une fenetre
       FLOATbuf *h,          //    de hamming
       long nb_points);
extern void initham_d(	// initialisation d'une fenetre
       double *h,          //    de hamming
       long nb_points);
extern void initham_(	// initialisation d'une fenetre
       float *h,          //    de hamming
       long nb_points);
extern void inithan(	// initialisation d'une fenetre
       FLOATbuf *h,          //    de hamming
       long nb_points);
extern void initHamDeriv(   // initialisation de la drive de la fenetre de hamming
       FLOATbuf *h,
       int nb_points);
extern void initHamTimeMul( // initialisation de la fenetre de hamming multiplie par le temps
       FLOATbuf *h,
       int nb_points);
extern void preaccentuation(
       SAMPLEbuf& cnv,
       long cnv_debut,
       float *res,
       long nb_points);
extern void applyWindow(   // Application d'une fentre d'analyse
       float *speech,
       float *result,
       FLOATbuf *window,
       long nb_points);
extern void ham_sf(	// fenetre de hamming SAMPLE -> float
       SAMPLEbuf& cnv,
       long cnv_debut,
       FLOATbuf& res,
       FLOATbuf *h,
       long nb_points);
extern void ham_sf_(	// fenetre de hamming SAMPLE -> float
       short *cnv,
       long cnv_debut,
       float *res,
       float *h,
       long nb_points);
extern void ham_sd_(	// fenetre de hamming SAMPLE -> double
       short *cnv,
       long cnv_debut,
       double *res,
       float *h,
       long nb_points);
extern void ham_ff(	// fenetre de hamming float -> float
       FLOATbuf& cnv,
       FLOATbuf& res,
       FLOATbuf *h,
       long nb_points);
extern void ham_ff_(	// fenetre de hamming float -> float
       float *cnv,
       float *res,
       float *h,
       long nb_points);
extern void ham_dd_(	// fenetre de hamming double -> double
       double *cnv,
       double *res,
       float *h,
       long nb_points);
extern void preac_f(	// preaccentuation SAMPLE -> float
       SAMPLEbuf& cnv,
       long cnv_debut,
       FLOATbuf& res,
       long nb_points);

extern void preac_f_(	// preaccentuation SAMPLE -> float
       short *cnv,
       long cnv_debut,
       float *res,
       long nb_points);
extern void preac_d_(	// preaccentuation SAMPLE -> double
       short *cnv,
       long cnv_debut,
       double *res,
       long nb_points);

// dans le fichier lpc.cpp
extern void autolpc (
	float *signal, 	// signal array
	float *r, 			// autoc
	float *a, 			//     lpc coeff. and air
	float *sf,			//         air (areas ??)
							//             of vocal tract
	float *e,       	// gain factor
	int n,      		// Nb elements in the array
   int p);          	//     and order of lpc
int ordre_lpc_std();
extern int ordre_lpc_msTOecht(float ordre_ms);

extern void halle(
  float res[],   /* spectre lisse cepstralement. */
  SAMPLE cnv[],  /* signal de parole  */
  int debut,       // first sample of the signal window
  int ordreFFT,
  int fenSignal,
  int n1, 
  int n2,	/* points caracteristiques du liftrage                */
  float alpha,  /* le coefficient accelerateur de convergence         */
  int nb_iter,	/* nombre d'iterations pour les calculs de la courbe  */
  bool preac);


// dans le fichier lesfft.cpp
// FFTc128
extern void init_fftc128();
extern void fftc128(FLOATbuf& data);
extern void free_fftc128();
// FFTc256
extern void init_fftc256();
extern void fftc256(FLOATbuf& data);
extern void free_fftc256();
// FFTi128
extern void init_fftic128();
extern void fftic128(FLOATbuf& data);
extern void free_fftic128();
// FFTi256
extern void init_fftic256();
extern void fftic256(FLOATbuf& data);
extern void free_fftic256();
// FFTr256
extern void init_fftr256();
extern void fftr256(FLOATbuf& data,int isign);
extern void free_fftr256();
// FFTr512
extern void init_fftr512();
extern void fftr512(FLOATbuf& data,int isign);
extern void free_fftr512();
// FFTc512
extern void init_fftc512();
extern void fftc512(FLOATbuf& data);
extern void free_fftc512();
// FFTic512
extern void init_fftic512();
extern void fftic512(FLOATbuf& data);
extern void free_fftic512();
// FFTr1024
extern void init_fftr1024();
extern void fftr1024(FLOATbuf& data,int isign);
extern void free_fftr1024();
// FFTc1024
extern void init_fftc1024();
extern void fftc1024(FLOATbuf& data);
extern void free_fftc1024();
// FFTic1024
extern void init_fftic1024();
extern void fftic1024(FLOATbuf& data);
extern void free_fftic1024();
// FFTr2048
extern void init_fftr2048();
extern void fftr2048(FLOATbuf& data,int isign);
extern void free_fftr2048();
// FFTc2048
extern void init_fftc2048();
extern void fftc2048(FLOATbuf& data);
extern void free_fftc2048();
// FFTic2048
extern void init_fftic2048();
extern void fftic2048(FLOATbuf& data);
extern void free_fftic2048();
// FFTr2048
extern void init_fftr4096();
extern void fftr4096(FLOATbuf& data,int isign);
extern void free_fftr4096();
// FFTc4096
extern void init_fftc4096();
extern void fftc4096(FLOATbuf& data);
extern void free_fftc4096();
// FFTic4096
extern void init_fftic4096();
extern void fftic4096(FLOATbuf& data);
extern void free_fftic4096();

#endif
