/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier filtre.h
//

#ifndef _FILTRE_H
#define _FILTRE_H
#define NMAX 		512

class profiltre
{ public:
    FLOATbuf *f;
    int ordre;		// ordre du filtre (peut etre modifie) 
    char type[MAX_LIGNE]; // type du filtre "bp","bs","lp","hp" 
    float fl    // frequence de coupure basse 
	 ,fh    // frequence de coupure haute
	 ,fc;	// frequence de coupure
	      // en type "lp" et "hp", on utilise fc
              // en type "bp" et "bs", on utilise fl et fh
    float att;		/* attenuation */

    profiltre();
    ~profiltre();
    void newsize(int ordre);
};
// mode d'emploi de profiltre
//
//   crer un objet profiltre
//       par exemple:  profiltre filt;
//   initialiser dans filt
//       ordre, type, fl, fh, fc, att
//          type: 4 choix possibles
//            "lp"  low pass
//            "hp"  high pass
//            "bp"  band pass
//            "bs"  band stop
//       on initialise toujours ordre, type, att
//       on initialise fc dans les cas "lp" et "hp"
//       on initialise fh et fl dans les cas "bp" et "bs" 
//   appeler desfir(&filt);
//       qui calcule les coefficients f
//       et modifie ventuellement ordre
//   pour filtrer utiliser
//       filtrer(BufferResultat,BufferData
//               ,DataDebut,DataFin,filt);
//
// - fc, fh, fl sont exprimes par rapport  la
//      frquence d'chantillonnage selon la
//      formule suivante:
//          fc = frquence_choisie
//               /frquence_d'chantillonnage

// dans le fichier desfil.cpp
extern void desfir(
	struct profiltre *filt);
// dans le fichier filtrer.cpp
extern void filtrer(	/* filtrage FIR d'un signal (SAMPLE) */
     SAMPLEbuf& resultat,
     SAMPLEbuf& data,
     long fs, long ls,  // premier et dernier echantillon
     profiltre& filt);

#endif
