/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// filtrer.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <math.h>

#include "filtre.h"

/*
 * Filtrage FIR d'un signal de short.
 * data: speech 
 * fs, ls: first and last sample in the data to be filtered
 * len : total length of data
 * filterod:  filter's order
 */
void filtrer( //resultat, data, fs, ls, coef, filterod)
     SAMPLEbuf& resultat,
     SAMPLEbuf& data,
     long fs,  // chantillons de dbut
     long ls,  //       et de fin
     profiltre& filt)
{
  int n, r,
      i,
      ecrete = 0;
  long il;
  long sample;
  float auxi;
  SAMPLEbuf ss(ls-fs+1,"ss in filtrer()");
  
  n = filt.ordre / 2;
  r = filt.ordre % 2;
  for (sample = fs + n;
       sample <= ls - n + 1 - r;
       sample++ )
  { auxi = 0.0;
    for (i = 0; i < filt.ordre;i++)
      auxi += data[sample - n + i] * (*filt.f)[i];
    if (fabs(auxi) > 31767.)
    { auxi = (auxi < 0.) ? -31766.9 : 31766.9;
      ecrete++;
    }
    ss[sample - fs] = (int) auxi;
  }
  for (il=fs; il<fs+n; il++) resultat[il] = 0;
  for (il=ls; il>ls-n+1-r; il--) resultat[il] = 0;
  for (il=fs+n; il<=ls-n+1; il++) resultat[il] = ss[il-fs];

  // if (ecrete) // cas non trait

  return;
}

