/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier fmaxspec.cpp
//

#include "common.h"
#pragma hdrstop

bool fmaxForAll = false;
double fMaxSpectro = 8000.;

class TWFmaxSpectro : public TDialog
{
  TButton *PTOk;
  TRadioButton *PTdefault;
  TRadioButton *PTonlyThisFile;
  TButton *PTCancel;
  TEdit *PTfmax;
  TGroupBox *PTgroup;
  TStatic *PTtext;

 public:
  TWFmaxSpectro(PTWindowsObject AParent, LPSTR name);
  ~TWFmaxSpectro();
  virtual void SetupWindow();
  virtual bool CanClose();

  void IDOk(WPARAM code);
  void IDCancel(WPARAM code);
 private:
  void startRecording(int duration);
  void stopRecording();
  DECLARE_RESPONSE_TABLE(TWFmaxSpectro);
};
DEFINE_RESPONSE_TABLE1(TWFmaxSpectro,TDialog)
  EV_CHILD_NOTIFY_ALL_CODES(IDOK,IDOk),
  EV_CHILD_NOTIFY_ALL_CODES(IDCANCEL,IDCancel),
  EV_WM_CLOSE,
END_RESPONSE_TABLE;


TWFmaxSpectro::TWFmaxSpectro(PTWindowsObject AParent, LPSTR name)
	:TDialog(AParent,name)
{
  PTdefault = new TRadioButton(this,IDC_RADIOBUTTON2,0);
  PTonlyThisFile = new TRadioButton(this,IDC_RADIOBUTTON3,0);
  PTOk = new TButton(this,IDOK);
  PTCancel = new TButton(this,IDCANCEL);
  PTfmax = new TEdit(this, IDC_EDIT4);
  PTgroup = new TGroupBox(this, IDC_GROUPBOX1);
  PTtext = new TStatic(this, IDC_STATICTEXT25);
}

bool TWFmaxSpectro::CanClose()
{
  STRING s;
  if (PTdefault->GetCheck()== BF_CHECKED) fmaxForAll = true;
  if (PTonlyThisFile->GetCheck()== BF_CHECKED) fmaxForAll = false;
  PTfmax->GetText(s,10);
  fMaxSpectro = atof(s);
  return true;
}


TWFmaxSpectro::~TWFmaxSpectro()
{
  delete PTOk;
  delete PTdefault;
  delete PTonlyThisFile;
  delete PTCancel;
  delete PTfmax;
  delete PTgroup;
  delete PTtext;
}

void TWFmaxSpectro::SetupWindow()
{
	STRING s;
   TDialog::SetupWindow();
   if (fmaxForAll) PTdefault->SetCheck(BF_CHECKED);
   else PTonlyThisFile->SetCheck(BF_CHECKED);
   sprintf(s,"%.0f", fMaxSpectro);
   PTfmax->SetText(s);
}

void TWFmaxSpectro::IDOk(WPARAM)
{
  TDialog::CmOk();
}

void TWFmaxSpectro::IDCancel(WPARAM)
{
 TDialog::CmCancel();
}

//////////////////////////////////////////////////
// commandes menu de la fentre principale
//
void Wtop::CMSpectroFmax()
// fonction d'activation de la fentre dialogue
{
  PTWtop->GetModule()->ExecDialog(new TWFmaxSpectro(PTWtop,"WFMaxSpectro"));
}
