/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier format_f.h
//

#ifndef _FORMAT_F_H
#define _FORMAT_F_H

#include "babel.h"
#include "postfixe.h"

///////////////////////////////////
// formats des fichiers son
//
#define		FREQ_STD	16000
#define 	NB_BITS_STD	16
struct format {
       struct entete *fmt;
       char nfmt[MAX_LIGNE]; // nom du format
};


///////////////////////////////////
// formats des fichiers phonmes
//
#define FMTPHON_CRIN 1
#define FMTPHON_NIST 2
#define FMTPHON_SAM 3
#define FMTPHON_ALIGN 4

struct format_phon { char *nom; };
extern struct format_phon Fmt_phon[];

///////////////////////////////////
// formats des fichiers mots
//
#define FMTTEXT_VECSYS 1
#define FMTTEXT_NIST 2
#define FMTTEXT_SAM 3
#define FMTTEXT_NOISEX 4
struct format_text { char *nom; };
extern struct format_text Fmt_text[];

// dans le fichier en_post.cpp
extern struct post_pile *en_post(char *s);
extern void imprime_pile(struct post_pile *expr);
// dans le fichier evalue.cpp
extern long evalue(
	struct post_pile *expr,
	long *valeurs);
// dans le fichier format_f.cpp
extern struct format *Fmt_par; /* le tableau des formats
                                    de lecture 	*/
extern void init_fmt();
extern int get_format(PTWindowsObject AParent,infoFile&); //int& f);
extern int getSpeechFormat(PTWindowsObject AParent,infoFile&); //int& f);
extern int get_format_son(PTWindowsObject AParent,int& f);
// dans le fichier lit_cont.cpp
extern char *trouve(
     struct champ *ch,
     int fic,
     long *valeurs);
extern void swap(char huge *t,long n);  /* echange des octets */
// dans le fichier lit_entete.cpp
extern struct entete *lire_entete(FILE *fic);

#endif
