/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier getphoan.h
//

#ifndef _GETPHOAN_H
#define _GETPHOAN_H

/*
 * Fenetre d'edition pour la lecture des symboles phonetiques
 */
class TWeditphoan : public TEdit
{
   public:
     bool backspace;
     bool leftArrow;
     bool rightArrow;
     bool endKey;
     TWeditphoan(TWindow *parent,
     				  int id,
                 const char *text,
                 int x, int y, int w, int h)
        :
        TEdit(parent, id, text, x, y, w, h, 100, false, 0)
		  {
        }
     void EvKeyDown(uint key, uint repeatCount, uint flags);
     void NotifyParent(int notification);
  	DECLARE_RESPONSE_TABLE(TWeditphoan);
};

/*
 * Panneau de lecture des etiquettes phonetiques.
 * Il est possible de cliquer les etiquettes ou de rentrer
 * le texte au clauvier.
 */
class TWgetphoan : public TDialog
{
   public:
     TWeditphoan *Teditpho;
     TStatic *st0,*st1,*capture;
     TButton *butPlay, *butCancel;
     TButton **butPhon;
     TCheckBox *CheckPlayer;
     int numEtiq;
     TWgetphoan (PTWindowsObject AParent,LPSTR name, int echt, int x,int y,int w, const char *afftext);
     ~TWgetphoan();
     void CmUpdate() {UpdateTextFields();} // Edit control notification.
     void forwards();
     void backwards();
     void detruitAnnexes();
     void retour();
     void executeAnnotation(char *text);
     void deleteLastAnnotation();
     void UpdateCurrentSegment();
     void HandleCheckPlayer();    // Handles notifications from ID_CHECKBOX
     // void CmCancel() {} ;
     // void CmButton() {UpdateTextFields();}  Button control notification.
     LRESULT TWgetphoan::EvCommand(UINT id, HWND, UINT);
     void TWgetphoan::EvCommandEnable(TCommandEnabler& ce);
     void SetupWindow();
     bool CanClose();
     void CmCancel(); 
     void CloseWindow();
     void EvClose();
   private:
     void  UpdateTextFields();             // updates from edit control

 	DECLARE_RESPONSE_TABLE(TWgetphoan);
};

#endif
