/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include <math.h>
#include <stdlib.h>
#include "fft_mayer.h"


void realGoertzel(
  double x[],
  double *real,
  double *imaginary, 
  int n, 
  float omega)
{
  double fr = 2. * M_PI * omega,
         cosa = cos(fr),
         sina = -sin(fr),
         cosb = cos(fr * (n - 1)),
         sinb = -sin(fr * (n - 1)),
         coeff = 2. * cosa,
         s_prev = 0,
         s_prev2 = 0,
	 tmp;
  int i;
  for (i = 0; i < n; i++) {
    double s = x[i] + coeff * s_prev - s_prev2;
    s_prev2 = s_prev;
    s_prev = s;
  }
  tmp = s_prev - cosa * s_prev2;
  *real = tmp * cosb + sina * sinb * s_prev2;
  *imaginary = tmp * sinb - sina * cosb * s_prev2; // diffrence de signe avec fft_mayer (oppose de la partie imaginaire)
}

main()
{
  int n = 32, i;
  double x[32], y[32], real, imag;
  for (i = 0; i < 32; i++) x[i] = y[i] = ((double) rand()) / ((double) RAND_MAX);
  realfft(32, y);
  realGoertzel(x, &real, &imag, 32, 1./32.);
  realGoertzel(x, &real, &imag, 32, 2./32.);
}

