/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

//fichier hanning.cpp
//

#include "common.h"
#pragma hdrstop

#include <iostream.h>
#include <math.h>
#include "hanning.h"

HANNING::HANNING()
{
   for(int i=0;i<NbMaxFenetresHanning;i++)
   	{
      	HAN[i] = NULL;
      }
   nbhan=0;
}


HANNING::~HANNING()
{
	int i=0;
	while (HAN[i]){
   	delete [] HAN[i];
      HAN[i]=NULL;
      i++;
   }

}

void HANNING::creation_fen(int taille)
{
	HAN[nbhan]= new float[taille+1];
   HAN[nbhan][0]= taille ;
	for(int i=0; i<taille ;i++) HAN [nbhan][i+1]=0.5*(1-cos(((2*M_PI*i)/taille)));
   nbhan+=1;
}

// copie une fenetre de hanning (dans le tableau) pre-calcule ou qu'elle calcule
void HANNING::fenetre(int taille, float * hanning)
{
	int i=0;
   while ((i!=nbhan) && (taille!= (int)HAN[i][0] )) i++;
   if (nbhan==NbMaxFenetresHanning) affiche_erreur("hanning.cpp : tableau des fenetres de hanning trop petit");
   if (i==nbhan) creation_fen(taille) ;
   for (int k=0; k < taille ; k++) hanning[k]=HAN[i][k+1];

} 

