/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier lireanno.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <string.h>

#include "notetiq.h"
#include "menu.h"
#include "outils.h"
#include "format_f.h"

// les tiquettes sont ignores au-del de 32000
//   environ par fichier

static void lireAnnotCrin(
	notetiqs *annot,
        infoFile& infofile) // fichier  lire
{
  STRING texte,ch;
  FILE *f = fopen(infofile.nomAnnot, "rt");
  int i, j; //, imuet;
  long l,tramDeb,tramFin;

  fscanf(f, "%d %s %d %s", &i, texte, &i, texte);

  for (i = 0; !feof(f); i++)
  { fgets(ch,78,f);
    suppcrnl(ch);
    suppDebut(ch,' ');
    if (*ch!=0) 
    switch (sscanf(ch, "%ld %ld %s"
		, &tramDeb, &tramFin, texte))
    { case 3: // cas normal
	     l=tramDeb*NBECHTTRAME;
             if ((j=annot->addS(l))>=0)
	     { if (annot->addS(tramFin*NBECHTTRAME)>=0)
	         annot->e[j]->SetText(texte);
	     }
	     break;
      default:affiche_erreur_LigneFichier(
		   ch,infofile.nomAnnot);
    }
  }

  fclose(f);
}

/*
 * Lecture de l'etiquetage ortographique d'un fichier SAM.
 */
static void lireAnnotSam( 
	notetiqs *annot,
        infoFile& infofile, // fichier  lire
	char *motCle)	// mot cle annoncant une
	          // annotation orthographique. 
{
  FILE *f = fopen(infofile.nomAnnot, "rt");
  int elf, i, numLigne, annot_i;

  for (i = 0, numLigne = 0, elf = 0;
       !feof(f) && !elf; 
       numLigne++)
  { char ligne[MAX_LIGNE], *debLigne, *p
        ,ligne0[MAX_LIGNE]; 
    int errorDetected = FAUX;
    fgets(ligne0, MAX_LIGNE, f);
    strcpy(ligne,ligne0);
    p=ligne0;
    debLigne = readAField(&p, ':');
    elf = (debLigne && !strcmp(debLigne, "ELF"));
    if (!elf) {
      if (!strcmp(debLigne, motCle)) {
	char *field;
	field = readAField(&p, ',');
	if (field)
	{ if ((annot_i=annot->addS(atol(field)))<0)
	    errorDetected=VRAI;
        }
	else errorDetected = VRAI;
	if (!errorDetected) {
	  field = readAField(&p, ',');
	  if (field)
	  { if (annot->addS(atol(field))<0)
	      errorDetected = VRAI;
          }
	  else errorDetected = VRAI;
	}
	if (!errorDetected) {
	  readAField(&p, ',');
	  readAField(&p, ',');
	  readAField(&p, ',');
	  suppcrnl(p);
	  suppDebut(p, ' ');
	  suppFin(p, ' ');
	  annot->e[annot_i]->SetText(p);
	}
	i++;
      }
      else if (!strcmp(debLigne, "EXT"))
      { // cas non trait
      }
      if (errorDetected)
      {	affiche_erreur_LigneFichier(ligne, infofile.nomAnnot);
	fclose(f);
	return;
      }
    }
  }

  fclose(f);
}

/*
 * Lecture de l'tiquetage orthographique d'un fichier SAM.
 */
static void lireAnnotNist( 
	notetiqs *annot,
        infoFile& infofile) // fichier  lire
{
  FILE *f = fopen(infofile.nomAnnot, "rt");
  int i,annot_i;

  i = 0;
  do {
    char ligne[MAX_LIGNE], *p;
    p = fgets(ligne, MAX_LIGNE, f);
    if (p)
    { if ((annot_i=annot->addS(atol(readAField(&p, ' '))))
          >=0)
      { if (annot->addS(atol(readAField(&p, ' ')))>=0)
        { suppcrnl(p);
          suppDebut(p, ' ');
          suppFin(p, ' ');
          annot->e[annot_i]->SetText(p);
	  i++;
        }
      }
    }
  }
  while (!feof(f)); 

  fclose(f);
}


void lireAnnotations( 
	notetiqs *annot,
        infoFile& infofile) // fichier  lire
{
  FILE *f;

  annot->clear();

  f = fopen(infofile.nomAnnot, "rt");
  if (!f)
  {  affiche_erreur(ml(4702,"Impossible d'ouvrir le fichier d'annotations"));
    return;
  }
  fclose(f);

  switch (infofile.fmt_word) {
  case FMTTEXT_SAM :
    lireAnnotSam(annot, infofile, "LBR");
    break;
  case FMTTEXT_NOISEX :
    lireAnnotSam(annot, infofile, "UTS");
    break;
  case FMTTEXT_NIST :
    lireAnnotNist(annot, infofile);
    break;
  case FMTTEXT_VECSYS :
  default :
    lireAnnotCrin(annot, infofile);
    break;
  }
}
