/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier lissage_.h
//

#ifndef _LISSAGE__H
#define _LISSAGE__H
static TYPEBUF travail_(ORDRE_MAX,"travail in lisser..()");
			// tableau de travail
void NOM(
	TYPEBUF& r_,  // tableau resultat
	TYPEBUF& t_,  // tableau a lisser
	int ordre, // nombre de points de la fenetre
                   //          de lissage	
	int n)	   // nombre d'elements du tableau	
{ float *travail=(float *)&travail_[0];
  float *r=(float *)&r_[0];
  float *t=(float *)&t_[0];
	double S;	// somme des elements du tableau
	                //     de travail	
	int i;		// indice dans le tableau resultat		
	int k;		// indice dans le tableau de travail		
	int j;
	int ordre_sur_deux;

	if (!(ordre % 2))
	{ affiche_erreur(
	    "bug in lisser_f() : l'ordre du lissage doit etre impair"); //  revoir
	   return;
	}
	if (ordre > ORDRE_MAX)
	{ affiche_erreur(
	    "bug in lisser_f() : ordre trop grand");
	   return;
	}

	for (i = 0, S = 0; i < ordre; i++)
	  S += (travail[i] = t[i]);
	

	/* lissage des elements de ordre/2 jusqu'a n-ordre/2 */
	ordre_sur_deux = ordre/2;
        for (k = 0, i = ordre/2; i < (n - ordre/2); i++) {
	    r[i] = (TYPE) (S / ordre);
	    S = S + t[i + 1 + ordre_sur_deux] - travail[k];
	    if (i + 1 + ordre_sur_deux != n)
	      travail[k] = t[i + 1 + ordre_sur_deux];
	    k = (k + 1) % ordre;
	}

	/* calcul des premiers elements du tableau */
	for (i = 0; i < ordre / 2; i++) {
	    for (j = 0, S = 0; j < 2 * i + 1; j++)
	      S += t[j];
	    r[i] = (TYPE) (S / (2 * i + 1));
	}

	/* calcul des derniers elements du tableau */
	for (i = 0; i < ordre / 2; i++) {
	    for (j = 0, S = 0; j < 2 * i + 1; j++)
	      S += t[n - 1 - j];
	    r[n - 1 - i] = (TYPE) (S / (2 * i + 1));
	}

	return;
}

#undef TYPE
#undef NOM

#endif

