/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include "common.h"
#include "polypoint.h"
#include "guiklat.h"

#include "listyl.h"

void Listyl::remove() {
  Item *p = list;

  while (p) {
    Item *tmp = p;
    p = p->next;
    delete tmp;
  }
  list = (Item *) 0;
}


void Listyl::append(TypeItem *val)
{
  Item *pt = new Item(val);

  if (list == 0) {
    list = pt;
    return;
  }
  else {
    Item *p = list;
	 while (p->next) p = p->next;
	 p->next = pt;
  }
}

void Listyl::insertSorted(TypeItem *x)
{
  Item *xx;

  if (!x) return;
  xx = new Item(x);
  if (list == 0) {
    list = xx;
    return;
  }
  else if (xx->val->avant(list->val)) {
    xx->next = list;
    list = xx;
    return;
  }
  else {
    Item *pt = list;
    while (pt->next && pt->next->val->avant(x)) pt = pt->next;
    if (!pt->next) pt->next = xx;
    else {
      xx->next = pt->next;
      pt->next = xx;
    }
    return;
  }
}

// Supression de tous les elements d'une liste
// verifiant une condition.

void Listyl::removeIfSelec()
{
  Item *x = list;
  while (x && x->val->estSelec()) {
    Item *p = x->next;
    x->next = (Item *) 0;
    delete x;
    x = p;
  }
  if (!x) list = (Item *) 0;
  else {
    Item *p1, *p2;
    for (p1 = x, p2 = x->next; p2;) {
      if (p2->val->estSelec()) {
	     p1->next = p2->next;
	     p2->next = (Item *) 0;
        delete p2;
	     p2 = p1->next;
      }
      else {
        p1 = p2;
	     p2 = p2->next;
      }
    }
    list = x;
  }
}