/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier lit_ente.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <string.h>

#include "format_f.h"

static char t[LCH];
static char ts[LCH];

static void affiche_erreur_format(char *message)
{ char ch[200];
  strcpy(ch,ml(5004,"lecture de fichier format\n"));
  strcat(ch,message);
  affiche_erreur(ch);
}

static char *lire_mot(char **s)
{
	char *q = *s + strlen(*s),
	     *p = *s,
	     *r = t,
	     *res = t;

	while (p < q && *p == ' ') p++;
	while (p < q && !SEP(*p) && *p != ' ')  *r++ = *p++;
	while (p < q && *p == ' ') p++;

	*r = '\000';
	*s = p;
	return(res);
}


static char *lire_sep(char **s)
// lire sparateur (1 caractre et les blancs qui suivent)
{
	char *p = ts,
	     *r = *s,
	     *q = *s + strlen(*s);
	*p++ = *r++;
	*p = '\000';
	while (r < q && *r == ' ') r++;
	*s = r;
	return(ts);
}


static struct champ *nvch()
{
	struct champ *x;

	x = NEW(struct champ);
	x->type = ' ';
	
	return(x);
}


/*
static struct champ_lu *lire_ch_fic(char *s,char *sepa)
// en principe, non utilis
{
	char *e = s;
	struct champ_lu *nv = NEW(struct champ_lu);
	char *sep = sepa,*mot;


	if (!strcmp(sep,","))
	{ // il y a un second terme dans
	  //   le membre de gauche 
	   char *m = lire_mot(&e);

	   if (!strcmp(m,"*")) {
	      nv->itere = VRAI;
	      sep = lire_sep(&e);
	   }
	   else affiche_erreur("premier membre incorrect");
	}
	else nv->itere = FAUX;

	if (strcmp(sep,"="))
	  affiche_erreur("il manque =");

	mot = lire_mot(&e);
	if (!strcmp(mot,"num")) nv->type_don = 'n';
	else if (!strcmp(mot,"car")) nv->type_don = 'c';
	else affiche_erreur("type du champ lu inconnu");
	if (strcmp(lire_sep(&e),","))
	  affiche_erreur("il manque une , apres le type");
	// printf("--> %s\n",lire_mot(&e));
	nv->adr = en_post(lire_mot(&e)); 
	if (strcmp(lire_sep(&e),","))
	  affiche_erreur("il manque une , apres l'adresse");
	// printf("--> %s\n",lire_mot(&e)); 
	nv->tail = en_post(lire_mot(&e));
	if (strcmp(lire_sep(&e),","))
	  affiche_erreur("il manque une , apres la \
	                      longueur du champ");
	mot = lire_mot(&e);
	if (nv->type_don == 'n')
	{ // conversion eventuelle des entiers 
	   if (!strcmp(mot,"swap")) nv->dd = ON_SWAP;
	   else if (!strcmp(mot,"normal")) nv->dd = ON_SWAP_PAS;
	   else affiche_erreur("type de decodage incorrect");
	}
	else { // conversion eventuelle des chaines de caracteres 
	   if (!strcmp(mot,"1/1")) nv->dd = ON_1S1;
	   else if (!strcmp(mot,"1/2")) nv->dd = ON_1S2;
	   else affiche_erreur("type de decodage \
	                        caracteres incorrect");
	}

// imprime_champ_lu(nv);
	return(nv);
}
*/
		
static struct champ *lire_champ(char *s)
{
	char *p = s; 
	struct champ *z = NEW(struct champ);
	if (debug==5)
	{ char ch[80];
	  sprintf(ch,"lire_champ(\"%s\")",s);
	  Wmsg->wr(ch);
	}
	while (*p && *p == ' ') p++;	/* on saute les blancs */
	if (!*p) affiche_erreur_format(ml(5001,"attention champ vide"));
	lire_sep(&p);
	if (*p == 'v')
	{ // expression numerique 
	   p++;
	   if (strcmp(lire_sep(&p),","))
	     affiche_erreur_format(ml(5002,"il manque une virgule"));
	   z->type = 'n';
		z->x.val = en_post(p);
	}
	else if (*p == '"')
	{ // chaine de caracteres 
	   char *t = (char *) malloc((unsigned int)MAX_LIGNE),*r;
	   
	   r = t;
	   p++;
	   while (*p)
	   { while (*p && *p != '"' && r < t + MAX_LIGNE-1) *r++ = *p++;
	     if (*p && *p == '"' && *p++ && *p == '"'
	         && r < t + MAX_LIGNE-1) *r++ = '"';
	   }
	   *r = '\000';
	   z->type = 'c';
	   z->x.libel = t;
	}
	/*
	else
	{ // cas d'un champ a lire dans le fichier 
	  z->type = 'l';
	  z->x.lu = lire_ch_fic(p,sep);
	}
        */
	
	return(z);

}

struct entete *lire_entete(FILE *fic)
{
  char ligne[LCH],*mot,*st;
  struct champ *frequence,*nb_bits//,*nb_phrase,*sexe,*age
		    ,*signal_swap,*debut,*longueur//,*titre
		    //,*date,*locuteur,*lg_bloc
		    ;
  struct entete *ent;

  frequence = nb_bits //= nb_phrase
            = debut = longueur
	    = signal_swap
	    //= lg_bloc = titre = date = locuteur
	    //= sexe = age
	    = (struct champ *)NULL;
  st = fgets(ligne,LCH-1,fic);
  while (!feof(fic))
  {
    mot = lire_mot(&st);
    if (!strcmp(mot,"frequence")) frequence = lire_champ(st);
    //else if (!strcmp(mot,"locuteur")) locuteur = lire_champ(st);
    else if (!strcmp(mot,"nb_bits")) nb_bits = lire_champ(st);
    else if (!strcmp(mot,"signal_swap")) signal_swap = lire_champ(st);
    //else if (!strcmp(mot,"nb_phrase")) nb_phrase = lire_champ(st);
    else if (!strcmp(mot,"debut")) debut = lire_champ(st);
    else if (!strcmp(mot,"longueur")) longueur = lire_champ(st);
    //else if (!strcmp(mot,"titre")) titre = lire_champ(st);
    //else if (!strcmp(mot,"date")) date = lire_champ(st);
    //else if (!strcmp(mot,"sexe")) sexe = lire_champ(st);
    //else if (!strcmp(mot,"age")) age = lire_champ(st);
    //else if (!strcmp(mot,"lg_bloc")) lg_bloc = lire_champ(st);
    else if (strcmp(mot,""))
	   affiche_erreur_format(
	     ml(5003,"champ inconnu"));
    st = fgets(ligne,LCH-1,fic);
  }

  ent = NEW(struct entete);
  ent->frequence = (frequence) ? frequence : nvch();
  ent->frequence->type_res = 'n';
  //ent->locuteur = (locuteur) ? locuteur : nvch();
  //ent->locuteur->type_res = 'c';
  ent->nb_bits = (nb_bits) ? nb_bits : nvch();
  ent->nb_bits->type_res = 'n';
  //ent->nb_phrase = (nb_phrase) ? nb_phrase : nvch();
  //ent->nb_phrase->type_res = 'n';
  ent->debut = (debut) ? debut : nvch(); 
  ent->debut->type_res = 'n';
  ent->longueur = (longueur) ? longueur : nvch();
  ent->longueur->type_res = 'n';
  //ent->titre = (titre) ? titre : nvch(); 
  //ent->titre->type_res = 'c';
  //ent->date = (date) ? date : nvch();
  //ent->date->type_res = 'c';
  //ent->sexe = (sexe) ? sexe : nvch();
  //ent->sexe->type_res = 'c';
  //ent->age = (age) ? age : nvch();
  //ent->age->type_res = 'n';
  //ent->lg_bloc = (lg_bloc) ? lg_bloc : nvch();
  //ent->lg_bloc->type_res = 'n';
  ent->signal_swap = (signal_swap) ? signal_swap : nvch();
  ent->signal_swap->type_res = 'c';
	
  return(ent);
}



