/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier menu.h
//
#ifndef _MENU_H
#define _MENU_H

// id pour les messages retour des menus phonmes
#define ID_PHON0 10000
extern void detruitMenusLangue();
extern void destroyPhonEntries();
extern void destroyPopupMenus();

class MenuSquel {
 public:
   struct menuItem *content;
   int nItem;
/*   int nbItem();
   struct menuItem *contents();   */
   MenuSquel();
   ~MenuSquel();
   void addMenuItem(uint flags, uint item, char *text, class MenuSquel *subm);
};

// structure permettant de stocker la structure du menu  sans le creer.
struct menuItem {
  uint flags;
  uint item;
  char *text;
  MenuSquel *subm;
};

struct phonEntry {
  uint item;
  char *text;
};

extern int nPhonEntry;
extern struct phonEntry *phonEntries;

extern bool init_langue();
extern char *TextOfPhon(int phon);
extern int phon_TextToi(char *text);
extern int GetPhonemeByMenu(TPoint& point);
extern void construitTablePhon(MenuSquel *squel);
extern TPopupMenu *construitMenu(MenuSquel *squel);
extern int GetPhonemeOrClassByMenu();
extern bool comp_phon(char *phon1, char *phon2);
extern void get_F1F2vowel(int i,int& phon,int& f1,int& f2);

/////////////////////////////////////////////////////
// macro de dfinition des menus par AddMenuItem()
//
//   menu___   macro utilise seulement ici
//
//   menu__   item normal
//   menu_E   dernier item de menu ou sous-menu
//   menuS_   sparateur
//   menuP_   popup menu
//   menuPE    la fois menuP_ et menu_E
//
#define menu___(option,id,text)  AddMenuItem(&menu,im,option,id,text)
#define menu__(text,id)  menu___(MF_STRING,id,text)
#define menu_E(text,id)  menu___(MF_STRING|MF_END,id,text)
#define menuS_()  menu___(MF_STRING,0,"")
#define menuP_(text)  menu___(MF_POPUP,0,text)
#define menuPE(text)  menu___(MF_POPUP|MF_END,0,text)
#endif /* _MENU_H */    
