/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier mire.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>

#include "spectro.h"


/************************************************************************/
/*									*/
/* procedure permettant d'afficher l'echelle de couleur utilisee	*/
/*									*/
/************************************************************************/


void mire(
	d_planche *fen,	// fenetre dans laquelle se passe
                        //           l'affichage	
	float silence,	// valeur en dB en dessous de laquelle on
                        //   affiche 'blanc'	
	float maxi)	// valeur en dB au del de laquelle on
                        //   affiche 'noir'	


{
  int i, n, cmapWidth,
      istep;   // one out of istep energy strings is displayed
  float x,db;
  char ch[MAX_LIGNE];
  float ix;
  float xmin,ymin,xmax,ymax;
  SIZE size;

  // sauver les coordonnes de la fentre
  snogetvcoor(&xmin,&ymin,&xmax,&ymax,fen);

  snovcoor(0.0, 0.0, 1.0, 1.0, fen);

  fen->SetPlancheFont(queryFont("arial", 7, 24, 0));

  // evaluate the extent of text
  sprintf(ch,"%.3f",maxi);
  GetTextExtentPoint(fen->hDCcomp,ch,strlen(ch),&size);
  cmapWidth = .8 * fen->largeur;
  n = cmapWidth / size.cx;
  istep = max(1, NB_COUL_SPEC / n );
  for(n = 1; n < istep; n = n << 1); // to get a power of 2 (NB_COUL_SPEC should be a power of 2)
  istep = n;

  for (i = 0; i <= NB_COUL_SPEC; i++) {
    db = (i / (NB_COUL_SPEC-1.)) * (maxi - silence)
	 + silence;
    MgiHue(Pcolors[i],fen);
    ix=0.8/NB_COUL_SPEC;
    x=0.1+ix*i;
    snorbox(x, 0.1, x+ix, 0.35, fen);
    { RECT rect;
      rect.left=fen->LXtoDX(x);
      rect.right=fen->LXtoDX(x+ix);
      rect.bottom=fen->LYtoDY(0.4);
      rect.top=fen->LYtoDY(0.65);
      affGris(fen,&rect,i);
    }
    MgiHue(NOIR, fen);
    sprintf(ch,"%.0f",db);
    if (!(i % istep)) snorgfs( x    ,0.8  ,ch,fen);
  }

  MgiHue(NOIR, fen);
  snorrect(0.1,0.1 
	  ,0.9,0.35,fen);
  snorrect(0.1,0.4 
	  ,0.9,0.65,fen);

  // restaurer les coordonnes de la fenetre
  snovcoor(xmin,ymin,xmax,ymax,fen);
}

void Wtop::CMafficheMire()
{ wspectro->wsona->clear_fenetre();
  mire(wspectro->wsona, SILENCE_SPECTRO, MAX_SPECTRO);
  ::InvalidateRect(wspectro->wsona->HWindow,NULL,TRUE);
  wspectro->wsona->spectro_consolider(0,INFINI_I);
}
