/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier notetiq.h
//

#ifndef _NOTETIQ_H
#define _NOTETIQ_H

// longueur trame, uniquement pour compatibilit
//   avec les anciens fichiers
#define NBECHTTRAME 128

class notetiq
{ public:
    char *text;  // texte de l'annotation
    long limite;

    notetiq();
    ~notetiq();
    char *Text();
    void SetText(char *text);
};

class notetiqs
{   int sp_add(int n,long echt);
  public:
    notetiq **e; //[NB_SEG+1]; // les segments etiquetes
    int nb;	// nombre d'etiquettes (de 0  nb-1)
    //

    notetiqs();
    ~notetiqs();
    void clear();
    int addX(long echt); // add eXclusive
                    // insertion d'une nouvelle limite
		    //   le segment insr est cre
		    //   avec un texte vide
		    // erreur si la limite existe dj
    int addS(long echt); // add and Search
		    // idem addX(), la valeur retourne
		    // tant diffrente si la limite
                    // existe dj (pas d'erreur ici)
    int add_mt(long echt); // idem add() avec Move du Texte
		    // vers le plus grand des deux segments
		    // crs  partir de l'ancien qui a t
		    // coup en deux  
    void detach(long echt);
    int search(long echt);
    int nearestLimit(long echt);
    void shift(long echt); // changer une limite
    void SetText(int i,char *texte);
    char *Text(int i);
    void edit_copy(long echtdebut,long echtfin,notetiqs& dst);
    void edit_cut(long echtdebut,long echtfin,notetiqs& dst);
    void edit_paste(long echt,long length,notetiqs& src);
    void edit_delete(long echtdebut,long echtfin);
};


// dans le fichier notetiq.cpp
extern notetiqs etiqs;
extern notetiqs notes;
extern bool isEtiqModifiable;
extern bool isNoteModifiable;
extern void aff_notes();
extern void aff_etiqs();
extern void readnotetiqs(char *soundName,notetiqs& ne
			 ,long depl,long longueur);

// dans le fichier lireanno.cpp
extern void lireAnnotations(
     notetiqs *annot,
     infoFile& infofile); // fichier (nom et format)
// dans le fichier lireman.cpp
extern void lireman(
     notetiqs *et,
     infoFile& infofile); // fichier (nom et format)
// dans le fichier sauvanno.cpp
extern void sauveAnnotations(
     notetiqs *annot,
     infoFile& infofile); // fichier (nom et format)
// dans le fichier sauvman.cpp
extern void sauvman(
     notetiqs *et,
     infoFile& infofile); // fichier (nom et format)

#endif
