/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include "common.h"
#include "optionsavespectro.h"


int currentWidthSpectro = 1024;
int currentHeightSpectro = 256;

DEFINE_RESPONSE_TABLE1(TWoptionSaveSpectro,TDialog)
  EV_CHILD_NOTIFY_ALL_CODES(IDOK,IDok),
  EV_CHILD_NOTIFY_ALL_CODES(IDCANCEL,IDcancel),
END_RESPONSE_TABLE;
TWoptionSaveSpectro::TWoptionSaveSpectro(PTWindowsObject AParent, LPSTR name)
	:TDialog(AParent,name)
{
  PTWidth = new TEdit(this, IDC_EDIT2);
  PTHeight = new TEdit(this, IDC_EDIT4);
  add = new TButton(this, IDOK);
  forget = new TButton(this, IDCANCEL);
}

TWoptionSaveSpectro::~TWoptionSaveSpectro()
{
  delete add;
  delete forget;
  delete PTWidth;
  delete PTHeight;
}

void TWoptionSaveSpectro::SetupWindow()
{
  STRING s;
  TDialog::SetupWindow();
  sprintf(s,"%d", currentWidthSpectro);
  PTWidth->SetText(s);
  sprintf(s,"%d", currentHeightSpectro);
  PTHeight->SetText(s);
}

bool TWoptionSaveSpectro::CanClose()
{
  STRING s;
  PTWidth->GetText(s,10);
  currentWidthSpectro = atoi(s);
  PTHeight->GetText(s,10);
  currentHeightSpectro = atoi(s);
  return(true);
}
void TWoptionSaveSpectro::IDok(WPARAM)
{
  CloseWindow(IDOK);
}

void TWoptionSaveSpectro::IDcancel(WPARAM)
{
  CloseWindow(IDCANCEL);
}
