/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#define PSOLA 		0
#define VOCODER 	1

class TWTimeF0 : public TDialog
{
  public:
  TRadioButton *PTpsola;
  TRadioButton *PTvocoder;
  TRadioButton *PTNocorrec;
  TRadioButton *PTPhaseLock;
  TButton *PTCancel;
  TButton *PTApply;
  TScrollBar *PTTimeFactor;
  TScrollBar *PTF0Factor;
  TStatic *PTTextTime;
  TStatic *PTTextF0;
  TGroupBox *PTgroupVocoder;

  TWTimeF0(PTWindowsObject AParent, LPSTR name);
  ~TWTimeF0();
  virtual void SetupWindow();
  virtual bool CanClose();
  void IDOk(WPARAM code);
  void IDscrollTime(WPARAM);
  void IDscrollF0(WPARAM);
  void EVChModSynt(WPARAM);
  void EVChModPhaseCorrec(WPARAM);
  void disableVocoder();
  void disablePsola();
 private:
  float F0Factor, timeFactor;
  int typeSynthese;
  bool withPhaseLocking;
  DECLARE_RESPONSE_TABLE(TWTimeF0);
};

extern void vocoderLaroche(float timeFactor, bool withPhaseLocking);
extern void pitchScaleMod(float F0Factor, float timeFactor);
