/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier outilbuf.h
//
//   outils divers sur buffers, temps et frquences
#ifndef _OUTILS_H
#define _OUTILS_H
// dans le fichier conver_t.cpp
extern int msToPix(long t);	/* Conversion millisecondes (int)
                                     en pixels */
extern long pixToMs(int x);	/* Conversion pixels en millisecondes */
extern int echtToPix(float x);	/* Conversion echantillons en pixels */
extern float pixToFreq(int y);	/* Conversion pixels en Hz */
extern float canToHz(float x);	/* Conversion numero de canal (coef FFT)
                                     en Hz */
extern float freqToEcr(float f);/* Conversion Hz --> canal */
extern int freqToPix(float f);	/* Conversion Hz --> pixels */
extern float can3ToHz(float x);	/* Conversion numero de canal
                                     interpole au 1/3 de canal -> Hz */
extern int hzToCan3(float x);	/* Conversion Hz --> canal
				     (interpole au 1/3 de canal) */
// dans le fichier outilbuf.cpp
extern long _i(long x);	// numero echantillon ds fichier
			//   -> numero echantillon memoire
extern float max_f(	/* recherche du maximum d'un
                                     tableau de float */
	FLOATbuf& t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
        int fin);
extern float min_f(	/* recherche du minimum d'un
                                     tableau de float */
	FLOATbuf& t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
        int fin);
extern float max_tf(
	float *t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
   int fin);

extern double max_td(
	double *t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
   int fin);

extern float min_tf(
	float *t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
   int fin);

extern double min_td(
	double *t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
   int fin);

extern float max_ti(
	int *t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
   int fin);

extern float min_ti(
	int *t,	/* tableau sur lequel porte la recherche */
	int debut,	/* indice de debut et fin de recherche	*/
   int fin);

extern int min_sl(	/* recherche et localise le
                               minimum d'un tableau de short */
	SAMPLEbuf& t,	/* tableau a examiner		    */
	long debut,	/* indices extremes de la recherche */
	long fin,
	long *ou);	/* emplacement du minimum 	    */
extern int max_sl(		/* recherche et localise le
                                     maximum d'un tableau de short */
	SAMPLEbuf& t,	/* tableau a examiner		    */
	long debut,	/* indices extremes de la recherche */
	long fin,
	long *ou);	/* emplacement du maximum 	    */
extern float max_fl(	// recherche et localise le
                        //   maximum d'un tableau de float 
	float *t,	// tableau a examiner
	int debut,	// indices extremes de la recherche 
	int fin,
	int *ou);	// emplacement du maximum 	    
extern double max_dl(	// recherche et localise le
                        //   maximum d'un tableau de float 
	double *t,	// tableau a examiner
	int debut,	// indices extremes de la recherche 
	int fin,
	int *ou);	// emplacement du maximum 	    
extern void blkcpy(	/* copie d'un bloc de caracteres */
     SAMPLEbuf& dest,
     long dest_debut,
     SAMPLEbuf& ori,
     long ori_debut,
     long n);
extern void swap(char huge *t,long n);  // echange des octets
extern long info_souris(  // Trouve la date et la frequence
                         //   d'un point de spectrogramme. 
     d_planche *fen_but,
     int x,		// position de la souris par rapport
     int y,             //           a la fenetre 
     float *frequence);	// frequence pointee par la souris 
extern char *suppFin(char *s,char c);
extern char *suppDebut(char *s,char c);
extern char *readAField(char **s,char separator);
extern char *suppcrnl(char *s);
extern char *suppblanc(char *s);
// dans le fichier temps.cpp
extern long enMilli(long x);	// Conversion echantillons (int)
                                //     en millisecondes 
extern long enEcht(long x);	// Conversion millisecondes (int)
                                //     en echantillons 
extern float enMillif(float x);	// Conversion echantillons (float)
                                //     en millisecondes 
extern float enEchtf(float x);	// Conversion millisecondes (float)
				//     en echantillons
#endif
