/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// paraCriticalBands.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "snoori.h"
#include "signal.h"
#include "outils.h"

#include "wcoupe.h"

// variables modifies par la fentre
//   (selon le paramtre d'appel p)
//   p->fen_fft
//   p->fen_signal
//   p->niv              
//   p->isPreac
//   p->nbBands

class TWparaCriticalBands : public TWparaCoupe
{   paramCoupeCriticalBands *param;

  public:
    TWparaCriticalBands(PTWindowsObject AParent,char *titre
		  ,float fen_signal_min,float fen_signal_max
		  ,paramCoupeCriticalBands *p);
	 // rponses aux vnements
	 /*
	 virtual void controle_fen_fft(RTMessage)=[WM_USER+2];
    virtual void controle_fen_signal(RTMessage)=[WM_USER+3];
	 */
	 LRESULT controle_fen_fft(WPARAM,LPARAM);
	 LRESULT controle_fen_signal(WPARAM,LPARAM);
	 DECLARE_RESPONSE_TABLE(TWparaCriticalBands);
};
DEFINE_RESPONSE_TABLE1(TWparaCriticalBands,TWparaCoupe)
  EV_MESSAGE(WM_USER+2,controle_fen_fft),
  EV_MESSAGE(WM_USER+3,controle_fen_signal),
END_RESPONSE_TABLE;

static choix choix_type[] = { {0," spectro like"}
                             ,{1," ASR like"}
			  ,{0,""} };

static choix choix_echelle[] = { {0," Bark (PLP like)"}
                             ,{1," Mel (MFCC like)"}
			  ,{0,""} };
static choix choix_cepstre[] = { {0," Without prior smoothing"}
                             ,{1," With cesptral smoothing"}
			  ,{0,""} };

static choix choix_liftering[] = { {0," Without liftering"}
                             ,{1," With liftering"}
			  ,{0,""} };

TWparaCriticalBands::TWparaCriticalBands(PTWindowsObject AParent,char *titre
		  ,float fen_signal_min,float fen_signal_max
		  ,paramCoupeCriticalBands *p)
	:TWparaCoupe(AParent,titre,p)
{ param=p;
  //
  // initialiser le contenu des contrles
  //   avec les variables correspondantes
  //
  // fenetre signal
  new TWfloat(this,3,xx,yy,ww
	      ,&param->fen_signal
	      ,ml(5912,"fenetre_signal=")
	      ,fen_signal_min,fen_signal_max
	      ,fen_signal_min,fen_signal_max
	      ,ticket);                yy+=HNUM;
  // fen_fft 
  new TWint(this,2,xx,yy,ww
	      ,&param->fen_fft
	      ,ml(5914,"fenetre_fft=")
	      ,4,13,4,13
	      ,ticket);                yy+=HNUM;
  new TWint(this,4,xx,yy,ww
	      ,&param->nbBands
	      ,ml(5916,"nombre de bandes=")
	      ,1,1 << (param->fen_fft - 1),1,1 << (param->fen_fft - 1)
	      ,ticket);                yy+=HNUM;
  new TWchoix(this,5,xx,yy,ww
	      ,&param->completionStrategy
	      ,ml(8553,"band distribution:")
	      ,choix_type
	      ,0);                		yy+=HNUM;
  new TWchoix(this,6,xx,yy,ww
	      ,&param->frequencyScale
	      ,ml(8554,"scale:")
	      ,choix_echelle
	      ,0);                		yy+=HNUM;
  new TWchoix(this,7,xx,yy,ww
	      ,&param->withCepstralSmoothing
	      ,ml(8555,"Before integration:")
	      ,choix_cepstre
	      ,0);                		yy+=HNUM;
  new TWchoix(this,8,xx,yy,ww
	      ,&param->withDctIdctLiftering
	      ,ml(8556,"Dct-idct liftering:")
	      ,choix_liftering
	      ,0);                		yy+=HNUM;
  new TWint(this,9,xx,yy,ww
	      ,&param->nbMelLiftering
	      ,ml(8557,"Liftering order=")
	      ,1,1 << (param->fen_fft - 1),1,1 << (param->fen_fft - 1)
	      ,ticket);                yy+=HNUM;
   FinirCreate();
}
LRESULT TWparaCriticalBands::controle_fen_signal(WPARAM,LPARAM)
{
  if ((1 << param->fen_fft) <enEchtf(param->fen_signal)) {
    param->fen_signal=enMillif(1 << param->fen_fft);
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}
LRESULT TWparaCriticalBands::controle_fen_fft(WPARAM,LPARAM)
{
  if ((1 << param->fen_fft)<enEchtf(param->fen_signal)) {
    while ((1 << param->fen_fft)<enEchtf(param->fen_signal))
		param->fen_fft++;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}

void Wcoupe::IDparaCriticalBands(WPARAM) //RTMessage)
{ if (pCriticalBands->isOpen) return;
  GetModule()->MakeWindow(
		new TWparaCriticalBands(this,ml(5915,"paramtres bandes critiques")
							 ,0.1,64.,pCriticalBands));
}


