/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// parafft.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "snoori.h"
#include "signal.h"
#include "outils.h"

#include "wcoupe.h"

// variables modifies par la fentre
//   (selon le paramtre d'appel p)
//   p->fen_fft
//   p->fen_signal
//   p->niv              
//   p->isPreac

class TWparaFFT : public TWparaCoupe
{   paramCoupeFFT *param;

  public:
    TWparaFFT(PTWindowsObject AParent,char *titre
		  ,float fen_signal_min,float fen_signal_max
		  ,paramCoupeFFT *p);
	 // rponses aux vnements
	 /*
	 virtual void controle_fen_fft(RTMessage)=[WM_USER+2];
    virtual void controle_fen_signal(RTMessage)=[WM_USER+3];
	 */
	 LRESULT controle_fen_fft(WPARAM,LPARAM);
	 LRESULT controle_fen_signal(WPARAM,LPARAM);
	 DECLARE_RESPONSE_TABLE(TWparaFFT);
};
DEFINE_RESPONSE_TABLE1(TWparaFFT,TWparaCoupe)
  EV_MESSAGE(WM_USER+2,controle_fen_fft),
  EV_MESSAGE(WM_USER+3,controle_fen_signal),
END_RESPONSE_TABLE;

TWparaFFT::TWparaFFT(PTWindowsObject AParent,char *titre
		  ,float fen_signal_min,float fen_signal_max
		  ,paramCoupeFFT *p)
	:TWparaCoupe(AParent,titre,p)
{ param=p;
  //
  // initialiser le contenu des contrles
  //   avec les variables correspondantes
  //
  // fenetre signal
  // praccentuation
  new TWchoix(this,0,xx,yy,ww
	      ,&param->moduleIsDisplayed
	      ,"Module/Phase: "
	      ,choix_YESNO 
	      ,ticket);                yy+=HNUM;
  new TWfloat(this,3,xx,yy,ww
	      ,&param->fen_signal
	      ,ml(5902,"fenetre_signal=")
	      ,fen_signal_min,fen_signal_max
	      ,fen_signal_min,fen_signal_max
	      ,ticket);                yy+=HNUM;
  // fen_fft 
  new TWint(this,2,xx,yy,ww
	      ,&param->fen_fft
	      ,ml(5904,"fenetre_fft=")
	      ,4,13,4,13
	      ,ticket);                yy+=HNUM;
  FinirCreate();
}
LRESULT TWparaFFT::controle_fen_signal(WPARAM,LPARAM)
{
  if ((1 << param->fen_fft) <enEchtf(param->fen_signal)) {
    param->fen_signal=enMillif(1 << param->fen_fft);
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}
LRESULT TWparaFFT::controle_fen_fft(WPARAM,LPARAM)
{
  if ((1 << param->fen_fft)<enEchtf(param->fen_signal)) {
    while ((1 << param->fen_fft)<enEchtf(param->fen_signal))
		param->fen_fft++;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}

void Wcoupe::IDparaFFT1(WPARAM) //RTMessage)
{ if (pFFT1->isOpen) return;
  GetModule()->MakeWindow(
		new TWparaFFT(this,ml(5905,"paramtres FFT1")
							 ,0.1,16.,pFFT1));
}

void Wcoupe::IDparaFFT2(WPARAM) //RTMessage)
{ if (pFFT2->isOpen) return;
  GetModule()->MakeWindow(
	   new TWparaFFT(this,ml(5906,"paramtres FFT2")
			   ,1.,128.,pFFT2));
}
