/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier paralpc.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>
#include "snoori.h"
#include "signal.h"
#include "fftlpc.h"
#include "outils.h"

#include "wcoupe.h"

// variables modifies par la fentre
//   (selon le paramtre d'appel p)
//   p->fen_signal
//   p->ordre_lpc
//   p->rayon           
//   p->niv
//   p->isPreac

class TWparaLPC : public TWparaCoupe
{   paramCoupeLPC *param;
    
  public:
    TWparaLPC(PTWindowsObject AParent,char *titre
		  ,paramCoupeLPC *p);
	 // rponses aux vnements
	 /*
	 virtual void controle_ordre_lpc(RTMessage)=[WM_USER+2];
	 virtual void controle_fen_signal(RTMessage)=[WM_USER+3];
	 */
	 LRESULT controle_ordre_lpc(WPARAM,LPARAM);
	 LRESULT controle_fen_signal(WPARAM,LPARAM);
	 DECLARE_RESPONSE_TABLE(TWparaLPC);
};
DEFINE_RESPONSE_TABLE1(TWparaLPC,TWparaCoupe)
  EV_MESSAGE(WM_USER+2,controle_ordre_lpc),
  EV_MESSAGE(WM_USER+3,controle_fen_signal),
END_RESPONSE_TABLE;

TWparaLPC::TWparaLPC(PTWindowsObject AParent,char *titre
		  ,paramCoupeLPC *p)
	:TWparaCoupe(AParent,titre,p)
{
  param=p;
  // initialiser le contenu des contrles
  //   avec les variables correspondantes
  // fenetre signal
  new TWfloat(this,3,xx,yy,ww
	      ,&param->fen_signal
	      ,ml(6102,"fenetre_signal=")
	      ,0.5,64.,0.5,64.
	      ,ticket);                 yy+=HNUM;
  // ordre_lpc 
  new TWfloat(this,2,xx,yy,ww
	      ,&param->ordre_lpc
	      ,ml(6104,"ordre_lpc=")
	      ,ORDRE_LPC_MIN_MS,ORDRE_LPC_MAX_MS
	      ,ORDRE_LPC_MIN_MS,ORDRE_LPC_MAX_MS
	      ,ticket);                 yy+=HNUM;
  // rayon
  new TWfloat(this,0,xx,yy,ww
	      ,&param->rayon
	      ,ml(6106,"rayon=")
	      ,0.1,2.0,0.1,2.0
	      ,ticket);                 yy+=HNUM;
  FinirCreate();
}
LRESULT TWparaLPC::controle_fen_signal(WPARAM,LPARAM)
{ if (param->ordre_lpc>param->fen_signal/2)
  { param->fen_signal=2*param->ordre_lpc;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}
LRESULT TWparaLPC::controle_ordre_lpc(WPARAM,LPARAM)
{ if (param->ordre_lpc>param->fen_signal/2)
  { param->ordre_lpc=param->fen_signal/2;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}

void Wcoupe::IDparaLPC(WPARAM) //RTMessage)
{ if (pLPC->isOpen) return;
  GetModule()->MakeWindow(
	   new TWparaLPC(this,ml(6107,"paramtres LPC"),pLPC));
}

