/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier paralpcs.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>
#include "snoori.h"
#include "signal.h"
#include "fftlpc.h"
#include "outils.h"

#include "wcoupe.h"

// variables modifies par la fentre
//   (selon le paramtre d'appel p)
//   p->fen_signal
//   p->ordre
//   p->fInf
//   p->fHaute           
//   p->niv
//   p->isPreac

class TWparaLPCsel : public TWparaCoupe
{   paramCoupeLPCsel *param;
    
  public:
    TWparaLPCsel(PTWindowsObject AParent,char *titre
		  ,paramCoupeLPCsel *p);
	 // rponses aux vnements
	 /*
	 virtual void controle_ordre_lpc(RTMessage)=[WM_USER+2];
    virtual void controle_fen_signal(RTMessage)=[WM_USER+3];
    virtual void controle_fInf(RTMessage)=[WM_USER+4];
	 virtual void controle_fHaute(RTMessage)=[WM_USER+5];
	 */
	 LRESULT controle_ordre_lpc(WPARAM,LPARAM);
	 LRESULT controle_fen_signal(WPARAM,LPARAM);
	 LRESULT controle_fInf(WPARAM,LPARAM);
	 LRESULT controle_fHaute(WPARAM,LPARAM);
	 DECLARE_RESPONSE_TABLE(TWparaLPCsel);
};
DEFINE_RESPONSE_TABLE1(TWparaLPCsel,TWparaCoupe)
  EV_MESSAGE(WM_USER+2,controle_ordre_lpc),
  EV_MESSAGE(WM_USER+3,controle_fen_signal),
  EV_MESSAGE(WM_USER+4,controle_fInf),
  EV_MESSAGE(WM_USER+5,controle_fHaute),
END_RESPONSE_TABLE;

TWparaLPCsel::TWparaLPCsel(PTWindowsObject AParent,char *titre
		  ,paramCoupeLPCsel *p)
	:TWparaCoupe(AParent,titre,p)
{
  param=p;
  // initialiser le contenu des contrles
  //   avec les variables correspondantes
  // fenetre signal
  new TWfloat(this,3,xx,yy,ww
	      ,&param->fen_signal
	      ,ml(6202,"fenetre_signal=")
	      ,0.5,64.,0.5,64.
	      ,ticket);                 yy+=HNUM;
  // ordre lpc
  new TWfloat(this,2,xx,yy,ww
	      ,&param->ordre_lpc
	      ,ml(6204,"ordre_lpc=")
	      ,ORDRE_LPC_MIN_MS,ORDRE_LPC_MAX_MS
	      ,ORDRE_LPC_MIN_MS,ORDRE_LPC_MAX_MS
	      ,ticket);                 yy+=HNUM;
  // contrle fInf et fHaute
  param->fInf=min(en_cours.frequence/2-500
                  ,max(0,param->fInf));
  param->fHaute=min(en_cours.frequence/2
		  ,max(param->fInf+500
		       ,param->fHaute));
  // fInf et fHaute
  myTStatic(ml(6205,"Frquences slectives (Hz)"));
  new TWint(this,4,xx,yy,ww
	      ,&param->fInf,ml(6206,"LowerFreq=")
	      ,0,en_cours.frequence/2
	      ,0,en_cours.frequence/2
	      ,ticket);                 yy+=HNUM;
  new TWint(this,5,xx,yy,ww
	      ,&param->fHaute,ml(6208,"UpperFreq=")
	      ,0,en_cours.frequence/2
	      ,0,en_cours.frequence/2
	      ,ticket);                 yy+=HNUM;
  FinirCreate();
}
LRESULT TWparaLPCsel::controle_fen_signal(WPARAM,LPARAM)
{ if (param->ordre_lpc>param->fen_signal/2)
  { param->fen_signal=2*param->ordre_lpc;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}
LRESULT TWparaLPCsel::controle_ordre_lpc(WPARAM,LPARAM)
{ if (param->ordre_lpc>param->fen_signal/2)
  { param->ordre_lpc=param->fen_signal/2;
    ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}
LRESULT TWparaLPCsel::controle_fInf(WPARAM,LPARAM)
{ if (param->fInf<0)
  { param->fInf=0;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  if (param->fInf>(param->fHaute-500))
  { param->fInf=param->fHaute-500;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}
LRESULT TWparaLPCsel::controle_fHaute(WPARAM,LPARAM)
{ if (param->fHaute<(param->fInf+500))
  { param->fHaute=param->fInf+500;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  if (param->fHaute>(en_cours.frequence/2))
  { param->fHaute=en_cours.frequence/2;
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
  return 0;
}

void Wcoupe::IDparaLPCsel(WPARAM) //RTMessage)
{ if (pLPCsel->isOpen) return;
  GetModule()->MakeWindow(
	   new TWparaLPCsel(this
		   ,ml(6209,"paramtres LPCsel"),pLPCsel));
}
