/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier "perso.cpp"
//
// ce fichier ralise un embryon de fonctions personnelles
//  un utilisateur-dveloppeur. Les fonctions sont:
//     - ouverture d'une fentre avec menu
//     - trac de gris dans la nouvelle fentre
//     - trac color dans la fentre des spectrogrammes
//     - trac de texte dans la fentre des spectrogrammes

#include "common.h"
#pragma hdrstop

#include "menu.h"

class Wmyfonction : public TFrameWindow
// objet fentre ouverte par myfonction1
{ public:
    char *menu;

    Wmyfonction();
    ~Wmyfonction();
    void BuildMenu();
    virtual void SetupWindow(); 
	 // rponses aux vnements
	 /*
	 virtual void WMSize(RTMessage Msg) = [WM_FIRST+WM_SIZE];
    virtual void CMtrythis1(RTMessage)=[CM_FIRST+1];
    virtual void CMtrythis2(RTMessage)=[CM_FIRST+2];
	 */
	 void EvSize(uint sizeType, TSize &size);
	 void CMtrythis1();
	 void CMtrythis2();
	 DECLARE_RESPONSE_TABLE(Wmyfonction);
};
DEFINE_RESPONSE_TABLE1(Wmyfonction,TFrameWindow)
  EV_WM_SIZE,
  EV_COMMAND(MENUTry1,CMtrythis1),
  EV_COMMAND(MENUTry2,CMtrythis2),
END_RESPONSE_TABLE;

// objet fentre fille de la fentre ci-dessus
d_planche *wmyfonction;

Wmyfonction::Wmyfonction()
    : TFrameWindow(PTWtop,ml(6250,"my fonction"))
{ // style pour une fentre popup avec titre
  Attr.Style|=WS_POPUPWINDOW|WS_CAPTION
		       |WS_THICKFRAME;
  // taille de la fentre
  Attr.X=300;
  Attr.Y=0;
  Attr.W=250;
  Attr.H=220;

  // cration du menu (vide)
  menu=(char *)malloc(1);

  // cration de la fentre fille
  wmyfonction=new d_planche(this);
}
Wmyfonction::~Wmyfonction()
{ // destruction du menu
  DestroyMenu(::GetMenu(HWindow));
  free(menu);

  // ractivation des menus de la fentre principale
  active(PPMENUAllStandard);
  active(MENUMyFonction1);
  ::DrawMenuBar(PTWtop->HWindow);
}
void Wmyfonction::SetupWindow()
{ //HMENU hmenu;
  TFrameWindow::SetupWindow();

  // construire et afficher le menu
//  BuildMenu();
//  hmenu = LoadMenuIndirect(menu);
//  ::SetMenu(HWindow, hmenu);
	this->AssignMenu("PERSO");
}
/*void Wmyfonction::BuildMenu()
// construction du menu
{ WORD *pw;
  int im; // indice sur le menu en construction

  // d'abord initialisation standard
  menu=(char *)realloc(menu,20);
  pw=(WORD *)(menu);
  *pw++=0; *pw++=0;
  im=4;

  // puis personnalisation du menu
//  menuPE(ml(POPTry,"try this"));
//  menu__(ml(MENUTry1,"try this 1"),1);
//  menu_E(ml(MENUTry2,"try this 2"),2);
} */
void Wmyfonction::EvSize(uint, TSize &)
// message de WINDOWS signalant que la
//   fentre change de taille
{ RECT rect;

  // changement de taille retouch pour donner
  //   un minimum de 100 pixels dans chaque sens
  //   (hauteur et largeur)
  Attr.H=max(100,Attr.H);
  Attr.W=max(100,Attr.W);

  // changer la taille de la fentre file
  ::GetClientRect(HWindow,&rect);
  ::MoveWindow(wmyfonction->HWindow,20,10
		 ,rect.right-30,rect.bottom-30,FALSE);

  // retracer l'ensemble
  ::InvalidateRect(HWindow,NULL,TRUE);
}
void Wmyfonction::CMtrythis1()
// trace des carrs de couleur dans la
//   fentre wspectro
{ static BOOL ind=TRUE;
  int v;

  ind=!ind;
  v=(ind) ? 40 : 80;

  // donner la couleur des tracs
  wspectro->wsona->SetForegroundColor(
	(ind) ? BLEUsombre : ROUGE);

  // tracer un rectangle de couleur
  wspectro->wsona->Dfillrect(v+20,v+20,v+100,v+100);

  // retracer la fentre wspectro
  ::InvalidateRect(wspectro->wsona->HWindow,NULL,TRUE);
}
void Wmyfonction::CMtrythis2()
// trace des carrs griss dans la
//   fentre myfonction
{ static int ngris=0;
  BOOL ind;
  RECT rect;

  // transforme le curseur souris en sablier
  souris(XC_watch);

  //
  grisSpectro(1.0); // dfinit les gris utiliss
  //
  ngris--;
  if (ngris<0) ngris=NB_COUL_SPEC-1;
  //
  ind= ((ngris&1)!=0) ;
  rect.left=(ind) ? 20 : 40;
  rect.right=(ind) ? 60 : 80;
  rect.top=(ind) ? 20 : 40;
  rect.bottom=(ind) ? 60 : 80;

  // trace le rectangle gris
  affGris(wmyfonction,&rect,ngris);

  // retracer la fentre 
  ::InvalidateRect(HWindow,NULL,TRUE);

  // redonne au curseur souris son aspect standard
  souris(XC_top_left_arrow);
}
void Wtop::CMMyFonction1()
// ouvre la fentre myfonction
{ // dsactive des commandes menu de la fentre
  //   principale, et en particulier celui qui
  //   active la fentre myfonction (pour qu'elle
  //   ne se retrouve pas ouverte deux fois)
  desactive(PPMENUAllStandard);
  desactive(MENUMyFonction1);
  ::DrawMenuBar(PTWtop->HWindow);

  // ouvre la fentre myfonction
  GetApplication()->MakeWindow(new Wmyfonction);
}
void Wtop::CMMyFonction2()
// crit un texte dans la fentre wspectro
{ // efface d'abord la fentre
  wspectro->wsona->clear_fenetre();

  // donne la couleur de trac, ici noir
  wspectro->wsona->SetForegroundColor(NOIR);

  // trace le texte
  wspectro->wsona->DTextOut(25,25,"WinSnoori");

  // demande le retrac de toute la fentre
  ::InvalidateRect(wspectro->wsona->HWindow,NULL,TRUE);
}
