/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _PHASE_UNWRAPPING_H
#define _PHASE_UNWRAPPING_H

#include <vector>
class RealPhaseUnwrapping {
  private:
    double unwrap(double a, double b, double phi_a, double phi_der_a, double phi_der_b, double realXb, double imagXb);
    int n;
    double dOmega;
    double *real, *imag, *realnxn, *imagnxn, *phaseDer;
    double *realCopy, *imagCopy, *realnxnCopy, *imagnxnCopy, *phaseDerBis, *phase;
    std::vector<double> phaseUnwrapped;
    std::vector<double> standardFreq;

    // remove the linear phase component (should equal zero for a real signal).
    // Phase should be an odd function.
    void removeLinearPhase();

    // extract n phase points from all the phase samples which have been calculated.
    void rearrange();

public:
    RealPhaseUnwrapping(double *xr, int nbPoints, int fftOrder);
    ~RealPhaseUnwrapping();
    double *get(double result[]);
};
#endif