/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier piquef0.h
//
#ifndef _PIQUEF0_H
#define _PIQUEF0_H
#include "class_sig.h"


typedef struct {
    long date;
    float freq;
} PiqF0Point;


//////////////////////////////////////////////
class POINTF0buf : public BUFbuf
{ public:
	POINTF0buf(long n,char *name)
        : BUFbuf(n,sizeof(double),name) {}
   PiqF0Point huge & operator[](long i)
        #ifdef BUFCONTROLS
	;
        #else
	{ return ((PiqF0Point *)p)[i]; }
       #endif
};

class PolyPointsF0
{ public:
    PolyPointsF0(POINTF0buf &pointF0, int nbPt);
    ~PolyPointsF0();
    bool selec;
    int nbPt;
    PiqF0Point *pts;
    PolyPointsF0 *reste;
};


class WPiqueF0 : public WSignal
{
  public:
	 bool syntheExists;
    int lastCommand;
    WPiqueF0();
    ~WPiqueF0();
    void EvSize(uint, TSize&);
    void CMReadPitchFile();
    void CMCurrentPitch();
    void CMSeeF0Contour();
    void CMModifF0Contour();
    void CMSaveF0Contour();
    void CMResynth();
    void CMRevoicingParam();
    void CMHelpProsody();
    void CMzoomIn();
    void CMzoomOut();
    void CMplay();
    virtual void SetupWindow();
    virtual bool CanClose();
	 DECLARE_RESPONSE_TABLE(WPiqueF0);
};

extern bool yaUneFenetrePiqueF0;
extern WPiqueF0 *wpiquef0;
extern bool yaF0Selected;

#define CAN2HZF0(X) (X * pm.F0Maxscale() / NB_CANAUX)
#define FREQ2ECRF0(X) (X * NB_CANAUX / pm.F0Maxscale())

#define INITF0CONT  { (PolyPointsF0 *) NULL, (PolyPointsF0 *) NULL }


PolyPointsF0 *f0contour[2] = INITF0CONT;
//    [0] is the actual F0-contour
//    [1] is a temporary F0-contour entered using the mouse.

void drawDownPiqF0(int, int );
void drawMotionPiqF0(int, int);
void drawUpPiqF0(int, int);

void drawDownPiqF0Pt(int, int );
void drawMotionPiqF0Pt(int, int );
void drawUpPiqF0Pt(int, int );
#endif
