/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

//fichier pitchmk.cpp
//

#include "common.h"
#pragma hdrstop

#include<math.h>
#include<iostream.h>
#include<stdio.h>
#include<malloc.h>

#include "snoori.h"
#include "spectro.h"
#include "pitchm.h"     
#include "signal.h"
#include "outils.h"  // pour la fonction enMilli et enEcht(temps.cpp)
#include "pitchmk.h"



#ifdef BUFCONTROLS
ProgDynVect & PROGDYNbuf::operator[](int i)
{ if ((i<0)||(i>=ni))
  { char ch1[80],ch2[80];

    strcpy(ch1,"range error : ");
    strcat(ch1,name);
    sprintf(ch2,"PROGDYNbuf[i] : i=%ld out of range",i);
    MessageBox(GetActiveWindow() //PTWtop->HWindow
              ,ch2,ch1,MB_OK);
    i=ni;
  }
  return ((ProgDynVect *)p)[i];
}
#endif

float dist (
	int pitch1, int pitch2,
	int date1, int date2,
	float bonus,
	float alpha,
	float beta,
	float gamma)

{
   float d;

   if (!date1 && !date2)
     d = 1. / EPSILON;
	else if (!(date1-date2)&& (pitch1!=0))
			d = beta * en_cours.frequence/(float)pitch1
					- gamma * bonus;
	else if ((pitch1!=0)&&(pitch2!=0))
		d = alpha * fabs( (en_cours.frequence/(float)pitch1
		-en_cours.frequence/(float)pitch2)/(float)(date1-date2) )
		+ beta * ( fabs( fabs( (float)(date1-date2) )
								-en_cours.frequence/(float)pitch1 ))
		- gamma * bonus;
   // This case should not happen but might happen if the position
   // where the pitch is evaluated is slightly shifted related to
   // the position where pitch has been actually calculated.
	else if ((pitch1 == 0 && pitch2 != 0) || (pitch2 == 0 && pitch1 != 0))
		d = beta * ( fabs( fabs( (float)(date1-date2) )
								-en_cours.frequence/(float)(pitch1 + pitch2)))
		   - gamma * bonus;
   else
      d = 1. / EPSILON;
	return(d);
}

//#define  CANDIDATSCONTIGUS
#ifdef CANDIDATSCONTIGUS
void candidats_i (
	PROGDYNbuf&  candid,
   SAMPLEbuf& speech,
   struct ctrl_temps ctloc,
   long echtDeb, echtFin,
	int precht, // date du premier echantillon de la fenetre de recherche
	int fenr, // taille de la fenetre de recherche
	int CandidNegatifs) // on prend les minima en compte
{
	int i,k,gar1, gar2;
	INTbuf tab(fenr, "tab"),
          compt(fenr, "compt");

   for ( i=0 ; (precht + i <= echtFin) && (i < fenr) ; i++) {
     tab[i]= speech[precht - ctloc.d_e + i];
     compt[i]=i;   // pour garder une trace de la date
   }
	for ( i=0 ; i<10; i++) {
			k=0;
			if (CandidNegatifs)
					while (k != (fenr-1 - i))
					{  if (tab[k] < tab[k+1])
						{	gar1=tab[k+1] ; gar2=compt[k+1] ;
							tab[k+1]=tab[k] ; compt[k+1]=compt[k] ;
							tab[k]=gar1 ; compt[k]=gar2 ;
						}
						k += 1 ;
					}
				else
					while (k != (fenr-1 - i))
					{  if (tab[k] > tab[k+1])
						{	gar1=tab[k+1] ; gar2=compt[k+1] ;
							tab[k+1]=tab[k] ; compt[k+1]=compt[k] ;
							tab[k]=gar1 ; compt[k]=gar2 ;
						}
						k += 1 ;
					}
			candid[0].c[i].dat = precht + compt[k]; // date "absolue"
			candid[0].c[i].pitch = pm.getf0(candid[0].c[i].dat);
			candid[0].c[i].bonus = (float) abs(tab[k]);
   }
	tab.newsize(0);
	compt.newsize(0);
}
#endif

void candidats_i (
	PROGDYNbuf&  candid,
   SAMPLEbuf& speech,
   struct ctrl_temps ctloc,
   long echtDeb,
   long echtFin,
	int precht, // date du premier echantillon de la fenetre de recherche
	int fenr, // taille de la fenetre de recherche
	int CandidNegatifs) // on prend les minima en compte
{
  int ech, nc,
      nbCandid = 0;

  for (ech = 0; precht + ech <= echtFin && ech < fenr;) {
    int k, echExtr;
    SAMPLE val;
    // going down while it is possible
    if (CandidNegatifs)
       while (precht + ech <= echtFin && ech < fenr
              && speech[precht + ech - ctloc.d_e] > speech[precht + ech - ctloc.d_e+ 1]) ech++;
    else
       while (precht + ech <= echtFin && ech < fenr
              && speech[precht + ech - ctloc.d_e] < speech[precht + ech - ctloc.d_e + 1]) ech++;


    // we have got an extremum
    // We ensure that the sample lies inside the speech array.
    if (!(precht + ech <= echtFin && ech < fenr))
      echExtr = precht + ech - 1;
    else
    	echExtr = precht + ech;
    val = abs(speech[echExtr - ctloc.d_e]);

    // We search where to insert it in the candidate array
    for (k = 0; k < 10 && k < nbCandid && val < candid[0].c[k].bonus; k++);
    // We shift to the right candidates less than the new one
    for (int l = min(10 - 1, nbCandid); l > k; l--)
      candid[0].c[l] = candid[0].c[l - 1];
    if (k < 10) {
      candid[0].c[k].dat = echExtr; // date "absolue"
      candid[0].c[k].pitch = pm.getf0(candid[0].c[k].dat);
      candid[0].c[k].bonus = (float) val;
      nbCandid = min(10, nbCandid + 1);
    }
    // now we are going up
    if (CandidNegatifs)
        while (precht + ech <= echtFin && ech < fenr
               && speech[precht + ech - ctloc.d_e] <= speech[precht + ech  - ctloc.d_e+ 1]) ech++;
    else
        while (precht + ech <= echtFin && ech < fenr
               && speech[precht + ech - ctloc.d_e] >= speech[precht + ech  - ctloc.d_e+ 1]) ech++;
  }
  for (nc = nbCandid; nc < 10; nc ++) {
    candid[0].c[nc].dat = 0;
    candid[0].c[nc].pitch = 0;
    candid[0].c[nc].bonus = -1. / EPSILON;
  }
}



void NeyPitch (
	PROGDYNbuf& tablis,
	int n, 	//longueur du tablis
	int mem, //nombre d'antecedent pour prog dyn
	float beta
	)
{
	int i;
	float alpha = 1., /*beta = 200.,*/ gamma = 0.5 ;
	for ( i=1 ; i<n ; i++ )
		{	int l;
			for ( l=0 ; l<10 ; l++ )
				{	float dMin = INFINI_F;
					int j,         // date du pitch d'ou l'on vient
						 jMin = -1, // coordonne du meilleur antcdent
						 kMin = -1;
					for ( j= max(0, i-mem) ; j<i ; j++ )
						{	int k;
							for ( k=0 ; k<10 ; k++ ) {
								float d;
                        d = dist(tablis[j].c[k].pitch, tablis[i].c[l].pitch,
                        	 		tablis[j].c[k].dat, tablis[i].c[l].dat,
                                 tablis[j].c[k].bonus, alpha, beta,gamma);

                        if ( tablis[j].c[k].dcum + d < dMin) {
										dMin = tablis[j].c[k].dcum + d;
                           	jMin = j;
                              kMin = k;
                           }
								}
						}
					tablis[i].c[l].antdatp = jMin;
					tablis[i].c[l].anttyp = kMin;
					tablis[i].c[l].dcum = dMin;
				}
		}
}

// The last extremum marked. In the case where speech is voiced
// this extremum is the first extremum in the next window.
static struct ProgDynPoint lastExtremumMarked;

struct ProgDynPoint MarkPitch (
	INTbuf& MPitch,	// tableau du chemin optimal de taille n
	int n,
	int mem,
	PROGDYNbuf& tablisM,
	PROGDYNbuf& tablism,
	int * option)  // 0: normal, 1:on prend le tabm, 2:on prend le tabM

{
	int i, k, j,
		 iMin = -1 , kMin = -1, //coord du meilleur resultat
		 iMinM = -1 , kMinM = -1,
		 iMinm = -1 , kMinm = -1;
	//float dMin = INFINI_F;
	float dMinM = INFINI_F;
	float dMinm = INFINI_F;

   // Searching for the best "last" minimum (from n-mem to n)
	for (i = n - 1; i >= max(0, n-mem); i--) {
     for ( k=0 ; k<10 ; k++) {
       if ( tablisM[i].c[k].dcum<dMinM ) {
         dMinM = tablisM[i].c[k].dcum ;
         iMinM = i;
         kMinM = k;
       }
     }
   }
   // Searching for the best "last" maximum (from n-mem to n)
	for (i = n - 1; i>= max(0, n-mem); i--) {
     for ( k=0 ; k<10 ; k++) {
       if ( tablism[i].c[k].dcum<dMinm ) {
         dMinm = tablism[i].c[k].dcum ;
         iMinm = i;
         kMinm = k;
       }
     }
   }


   // cas forc (pour raccord tous les 2 s avec les marques)
   // The choice of using minima or maxima is forced in order
   // to use the same type of extrema as the one used for
   // the segment processed before.
   if (*option==1)
     {dMinM=1; dMinm=0;}
   else if (*option==2)
     {dMinM=0; dMinm=1;}


	if (dMinM <= dMinm) {
     iMin=iMinM;
     kMin=kMinM;
     MPitch[0] = tablisM[iMin].c[kMin].dat ;
     lastExtremumMarked = tablisM[iMin].c[kMin];
     j = 1;
     for ( i = tablisM[iMin].c[kMin].antdatp, k = tablisM[iMin].c[kMin].anttyp ;
				i >= 0 ; ) {
       int ii;
       MPitch[j] = tablisM[i].c[k].dat ;
       ii = i;
       i = tablisM[ii].c[k].antdatp ;
       k = tablisM[ii].c[k].anttyp ;
       j += 1;
     }
     *option = 2;
   }
   else {
     iMin=iMinm;
     kMin=kMinm;
     MPitch[0] = tablism[iMin].c[kMin].dat ;
     lastExtremumMarked = tablism[iMin].c[kMin];
     j = 1;
     for ( i = tablism[iMin].c[kMin].antdatp, k = tablism[iMin].c[kMin].anttyp ;
				i >= 0 ; ) {
       int ii;
       MPitch[j] = tablism[i].c[k].dat ;
       ii = i;
       i = tablism[ii].c[k].antdatp ;
       k = tablism[ii].c[k].anttyp ;
       j += 1;
     }
     *option=1;
   }
   return lastExtremumMarked;
}


void log_pitch_mark(
	INTbuf& Pitch_Mark)

{ 	int i;
	STRING ch;
	int e;
	logs.open2();
	logs.wr1(">> pitch_mark");
	sprintf(ch,ml(6810,"file : %s"),en_cours.nom);
	logs.wr1(ch);
	logs.wr1("Time\tTime\tPitch");
	logs.wr1("[ms]\t[echt]\t[Hz]");
	i=0;
	while (Pitch_Mark[i] != 0)
		{ 	e=Pitch_Mark[i];
			sprintf(ch,"%ld\t%ld\t%d",enMilli((long)fabs(e)), e,pm.getf0(e));
			logs.wr1(ch);
			i++;
		}
	logs.close1();
}

// Pitch marking of speech. Mark instants are given in samples related to
// the beginning of the speech file.
struct ProgDynPoint *Pitch_Marqueur(
	INTbuf& Pitch_Mark,
   SAMPLEbuf& speech,		// signal de parole a marquer
   struct ctrl_temps ctloc,  // reperage temporel
   long echtDeb,   // Region a marquer definie par les echantillons de debut et de fin
   long echtFin,   // par rapport au debut de fichier.
	float beta,
	int pnonvoise, // ecart des marques dans le nonvois
   struct ProgDynPoint *premierPic,
	int * premier_pic_Maxmin) // 1:pics min , 2:pics max ,
									 // o:laisse le choix = debut du signal ou non vois
{
  int i,j,k,
		 debvois, debnonvois, // marque le dbut du vois, non-voise
		 c, cp,   //pour la segmentation des parties voiseees
		 minipitch, // dans la partie voisees
		 fenr, //taille de la fenetre de recherche
		 pitch, //(voir l'utilite de la variable)
		 ia, // indexation actuel de Pitch_Mark[]
		 transition ; // debut de la fenetre de 2ms (sauf debut du signal)
	int e ;

		// Il faut faire calculer une fois le pitch et pm est garde en memoire
	transition = (*premier_pic_Maxmin != 0);
	for ( debvois=0, debnonvois=0, ia=0 ; debvois < pm.nbPitch ;) {
			pitch=pm.getf0(pm.premEchtAbs + debvois*pm.depEcht + pm.fenPitch/2);

	      /* Recherche du debut d'une partie voisee*/

			if (pitch < 1) {
				 while((pitch < 1) && (debvois < pm.nbPitch)) {
					 debvois += 1 ;
                pitch = pm.getf0(pm.premEchtAbs + debvois*pm.depEcht + pm.fenPitch/2);
             }
				 /* Marquage de la partie non voisee */

				 if (debnonvois == 0) {// debut du signal
					 for ( e=pm.premEchtAbs + pm.fenPitch/2 ;
						  e < pm.premEchtAbs + (debvois)*pm.depEcht + pm.fenPitch/2;
						  e += pnonvoise, ia ++)
						Pitch_Mark[ia]= -e;       
             }
             else { // cas general
					 for ( e=(int)fabs(Pitch_Mark[ia-1]) + pnonvoise;
						  e < pm.premEchtAbs + debvois*pm.depEcht + pm.fenPitch/2;
						  e += pnonvoise, ia ++)
						 Pitch_Mark[ia]= -e;
             }
				transition=0;
         }	 // on vient de se placer au debut du voise

		   /*  Segmentation et marquage de la partie voisee */
			c=0;
			minipitch=0;
			pitch=pm.getf0(pm.premEchtAbs + (debvois*pm.depEcht) + pm.fenPitch/2);
			while( (pitch > 0 ) && ( (debvois+c) < pm.nbPitch ) ) {
						if(pitch > minipitch) minipitch = pitch;
						c += 1;
						pitch=pm.getf0(pm.premEchtAbs + ((debvois+c)*pm.depEcht)
						+ pm.fenPitch/2);
					}
					// c*pm.depEcht donne la taille du voise
					// minipitch(frequentiellement= maxi  pitch)

			if (debvois < pm.nbPitch) {
					minipitch = en_cours.frequence/minipitch; //periode ds tempo
					cp = max(1, c*pm.depEcht/minipitch); //segmentation
					PROGDYNbuf tablisM(cp, "tabLisM");
               PROGDYNbuf tablism(cp, "tablism");
					PROGDYNbuf candid(1, "candid");

					j=0;
               for ( k=0 ; k<10 ; k++ ) {
                 tablisM[0].c[k].pitch = tablism[0].c[k].pitch = 0;
                 tablisM[0].c[k].dat = tablism[0].c[k].dat = 0 ; //date"absolue"
                 tablisM[0].c[k].bonus = tablism[0].c[k].bonus = -1. / EPSILON;
                 tablisM[0].c[k].dcum=0; tablism[0].c[k].dcum=0;
                 tablisM[0].c[k].antdatp=-1; tablism[0].c[k].antdatp=-1;
                 tablisM[0].c[k].anttyp=-1; tablism[0].c[k].anttyp=-1;
               }
					if (transition) {
                  if (*premier_pic_Maxmin == 1) {
                    tablism[j].c[0].pitch = premierPic->pitch;
                    tablism[j].c[0].dat = premierPic->dat;
                    tablism[j].c[0].bonus = (float)((2 << 15) - 1);
                  }
                  else {
                    tablisM[j].c[0].pitch = premierPic->pitch;
                    tablisM[j].c[0].dat = premierPic->dat;
                    tablisM[j].c[0].bonus = (float)((2 << 15) - 1);
                  }
                  j = 1;
               }

					for (  ; j<cp ; j++) {
                 fenr=min(minipitch,c*pm.depEcht-j*minipitch);
																			// pour eviter pitch=0
                 // Searching for the maxima which can be candidates
                 candidats_i(candid, speech, ctloc, echtDeb, echtFin, pm.premEchtAbs+
									  debvois*pm.depEcht + j*minipitch + pm.fenPitch/2,
									  fenr, 0) ;

                 for ( k=0 ; k<10 ; k++ ) {
                   tablisM[j].c[k].pitch = candid[0].c[k].pitch;
                   tablisM[j].c[k].dat = candid[0].c[k].dat; // date"absolue"
                   tablisM[j].c[k].bonus = candid[0].c[k].bonus;
                 }

                 // Searching for the minima which can be candidates
                 candidats_i(candid, speech, ctloc, echtDeb, echtFin, pm.premEchtAbs+
									  debvois*pm.depEcht + j*minipitch + pm.fenPitch/2,
									  fenr, 1) ;

                 for ( k=0 ; k<10 ; k++ ) {
                   tablism[j].c[k].pitch = candid[0].c[k].pitch;
                   tablism[j].c[k].dat = candid[0].c[k].dat;//date "absolue"
                   tablism[j].c[k].bonus = candid[0].c[k].bonus;
                 }

               }
					candid.newsize(0);


					if ( cp > 1 ) {//pour eviter : un seul echantillon
                     int limGauche, k;
							NeyPitch ( tablisM, cp, 10, beta);
							NeyPitch ( tablism, cp, 10, beta);
							INTbuf MPitch(1,"chemin optim");
							MPitch.newsize(cp+1);//cas ou tout pris
							for (i=0 ; i<=cp ; i++) MPitch[i]=-1;
							if (transition == 0)  *premier_pic_Maxmin=0;

							MarkPitch ( MPitch, cp, 10, tablisM, tablism
												, premier_pic_Maxmin);

							int nm=0 ; //nombre de marques

							while ( MPitch[nm] != -1 ) nm+= 1;

                     // The new pitch mark is MPitch[nm - 1] (nm - 1 and not 0
                     // because of the backtrack in the dynamic programming.
                     // As some pitch periods at the beginning of the voiced
                     // segment may have been discarded during DP, we must
                     // add extra marks between the last unvoiced mark and the
                     // new pitch mark.
                     // limGauche is the last mark put in the signal.
                     limGauche = (ia) ? abs(Pitch_Mark[ia - 1]) : echtDeb + pm.fenPitch / 2;
                     Pitch_Mark[ia++] = MPitch[nm-1];

                     k = ia - 1;
                     while ( (pm.getf0(Pitch_Mark[k]) && pm.getf0(Pitch_Mark[k])< 1000)
                            && ( (int)(en_cours.frequence / pm.getf0(Pitch_Mark[k])) < abs(Pitch_Mark[k] - limGauche ) ) ) {
                            	// pour viter de placer une marque avant la dernire nonvoise.
                       int l;
                       ia++; // One mark is inserted, ia is incremented even if this
                       		  // does not appear at the end.
                       // Existing marks are shifted to the right to give place
                       // for the mark to be inserted.
                       for (l = ia; l > k; l--) Pitch_Mark[l] = Pitch_Mark[l - 1];
                       if (pm.getf0(Pitch_Mark[k + 1])> 0)
                       	 Pitch_Mark[k] = Pitch_Mark[k + 1] -
                       						  (int)(en_cours.frequence / pm.getf0(Pitch_Mark[k + 1]));
                       else Pitch_Mark[k] = Pitch_Mark[k + 1] - pnonvoise;
                     }

                     // Marks from DP are added
							for ( i = 1 ; i < nm ; i++)
								 Pitch_Mark[ia++]= MPitch[nm - 1 - i];

					  		/* traitement des marques manquantes apres le voise */
							while ( (pm.getf0(Pitch_Mark[ia-1])>0 && pm.getf0(Pitch_Mark[ia-1])< 1000)
									&& (pm.premEchtAbs + (debvois+c)*pm.depEcht
								       + pm.fenPitch/2 - Pitch_Mark[ia-1] >
								      (int)(en_cours.frequence/pm.getf0(Pitch_Mark[ia-1]))) ) {
							  Pitch_Mark[ia] = Pitch_Mark[ia-1] +
							 						 (int)(en_cours.frequence/pm.getf0(Pitch_Mark[ia-1]) );
							  ia ++;
							}
							if ( pm.getf0(Pitch_Mark[ia-1]) < 1
							  || pm.getf0(Pitch_Mark[ia-1]) > 1000 )
								Pitch_Mark[ia-1]= -(int)fabs(Pitch_Mark[ia-1]);

               }
               // Only one set of extrema has been found. Dynamic programming
         		// is thus not necessary.
               else {
                 // the unique point is forced by the transition with the previous
                 // speech window.
                 if (transition) {
                   if (*premier_pic_Maxmin == 1)
                        Pitch_Mark[ia++] = tablism[0].c[0].dat;
                   else if(*premier_pic_Maxmin == 2)
                        Pitch_Mark[ia++] = tablisM[0].c[0].dat;
                 }
                 // the largest extremum is accepted as the mark.
                 // This case should be an exception because that means
                 // that the voiced region is very short.
                 else {
                   int maxVal = -INFINI_I;
                   int km, kM;
                   for (k = 0; k < 10; k++) {
                     if (tablism[0].c[k].bonus > maxVal) {
                       km = k; kM = -1;
                       maxVal = abs(tablism[0].c[k].bonus);
                     }
                     if (tablisM[0].c[k].bonus > maxVal) {
                       kM = k;  km = -1;
                       maxVal = tablisM[0].c[k].bonus;
                     }
                   }
                   Pitch_Mark[ia++] = (km >= 0) ? tablism[0].c[km].dat
                      									 : tablisM[0].c[kM].dat;
                 }
               }

					tablisM.newsize(0); tablism.newsize(0);
				}
			debnonvois = debvois + c ; // on se replace apres le voise.
			debvois = debnonvois ;
			transition=0;//fin des options de transition
		}
	log_pitch_mark(Pitch_Mark);
   return((*premier_pic_Maxmin) ?  &lastExtremumMarked : (struct ProgDynPoint *) NULL);
}



   
