/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier pitchmk.h
//
#ifndef _PITCHMK_H
#define _PITCHMK_H
struct optProsodie {
  float timeFactor;
  float f0Factor;
};

struct ProgDynPoint {
	float dcum; /* distance cummulee en ce point */
	int antdatp; /* date du pitch du precedent point (en colonne j) */
	int anttyp; /* type du precedent point (en ligne k)*/
	int pitch; /* valeur du pitch en ce point (en Herz)*/
	int dat;   /* date du point */
	float bonus; /* bonus dans la Prog Dyna, ici l'amplitude du point */
};

struct ProgDynVect_ {
  struct ProgDynPoint c[10];
};

typedef struct ProgDynVect_ ProgDynVect;
//#define BUFCONTROLS
//////////////////////////////////////////////
class PROGDYNbuf : public BUFbuf
{ public:
    PROGDYNbuf(int n,char *name)
        : BUFbuf(n,sizeof(ProgDynVect),name) {}
    ProgDynVect & operator[](int i)
	#ifdef BUFCONTROLS
	;
        #else
	{ return ((ProgDynVect *)p)[i]; }
        #endif
};

extern struct ProgDynPoint *Pitch_Marqueur(
		INTbuf& Pitch_Mark,
      SAMPLEbuf& speech,
      struct ctrl_temps ctloc,
      long debut,
      long fin,
		float beta,
		int pnonvois,
      struct ProgDynPoint *premierPic,
		int * premier_pic_Maxmin);// 1:pics min , 2:pics max ,
								     // o:laisse le choix = debut du signal ou non vois


extern void affichage_marques(
		INTbuf& Pitch_Mark,	  /* marques sur le signal temporel       */
		long premEcht,	  /* echantillon de debut d'affichage 	    */
		long derEcht,	  /* echantillon de fin   d'affichage  	    */
		d_planche *fenetre); /* fenetre */

//extern void initScaleMod();
//extern void freeHanningWindows();

extern void  Scale_mod(
	INTbuf& Pitch_Mark,      /* marques sur le signal temporel       */
   SAMPLEbuf& speech,       /* original speech   */
   struct ctrl_temps ctloc,   /* location in the speech file */
	FLOATbuf& Space_mod,       /* space modifie */
	FLOATbuf& Som_Han,   /* somme des fenetres de Hanning */
	float coef_tempo,      /* coef de dilatation ou compression tempo */
	float coef_pitch,     /* coef de dilatation ou compression pitch */
	long * der_marque_virt, /* derniere marque virtuelle */
	long * der_marque_synt, /* derniere marque synthetisee */
   long * der_marque, /* derniere marque de pitch */
   int lastPitchValue,
   int *lastSample,
   bool continued); /* true if the previous window has been synthetized */

extern void ex_locuteur(); // dans pmmenu.cpp
extern void ex_locutrice(); // dans pmmenu.cpp
extern void ex_nimporte(); // dans pmmenu.cpp

extern struct optProsodie optProso;
#endif
