/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier pmmedian.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <malloc.h>

#include "spectro.h"
#include "pitchm.h"

/*
 * Prototype de la fonction mediane parametree par le type
 */
#define Mediane(NOM,TYPE,TYPEBUF) \
TYPE NOM( \
	TYPEBUF& t,             \
	int deb, int fin,     \
	TYPE vMin, TYPE vMax, \
	TYPE delta)	      \
{ \
  TYPE *effect; \
  int n, i, nClas, nbVal = 0; \
 \
  if (vMin >= vMax) { \
    affiche_bug("media_.(): erreur valeurs extremes\n"); \
  } \
  nClas = (vMax - vMin) / delta + 1; \
  effect = (TYPE *) malloc ((unsigned int) (((vMax - vMin) / delta + 1) * sizeof(TYPE))); \
  for (i = 0; i < nClas; i++) effect[i] = 0; \
  /* calcul des effectifs de chaque classe */ \
  for (i = deb; i <= fin; i++) if (dans(t[i], vMin, vMax)) { \
      nbVal++; \
      effect[(int)((t[i] - vMin) / delta)] += 1; \
    } \
 \
  /* recherche de la mediane */ \
  for (i = 0, n = 0; i < nClas && n < nbVal / 2; i++) \
    n += effect[i]; \
 \
  free((char *) effect); \
  return((TYPE)(vMin + (i - 0.5) * delta)); \
}


/*
 * Mediane d'un tableau de short
 */
//Mediane(media_s, short)

/*
 * Mediane d'un tableau de int
 */
Mediane(media_i, int, INTarray)

