/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier postfixe.h
//

#ifndef _POSTFIXE_H
#define _POSTFIXE_H

// taille de la pile locale
#define TAIL_LOC	20
// nombre de variables 
#define NBVAR		26

#define PLUS 	1
#define MOINS 	2
#define FOIS	3
#define DIVISE	4

#define OPERATEUR(c) ((c) == '+' || (c) == '-' \
                      || (c) == '*' || (c) == '/')

struct cell {
	char t;	/* 'o' : operateur, 'n' : nombre,
	           'v' : variable  'c' : constante */
	union {
		int op,var; /* operateur, variable */
		int val;    /* valeur numerique */
		long konst;  /* constante (SOF : taille du fichier) */
	} x;
};

struct post_pile{
	int sommet; 	    /* le nombre d'elements de la pile */
	char indic[NBVAR];  /* pour indiquer la presence   
				 d'une variable */
	struct cell *pile;  /* la pile correspondant a l'expression */
};

#endif
