/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier persov.cpp   (contient marque-pitch et modif tempo et frequencielle)
      
//

#include "common.h"
#pragma hdrstop

#include "menu.h"
#include "spectro.h"
#include "pitchm.h"
#include "signal.h"
#include "outils.h"     // pour la fonction enMilli et enEcht(temps.cpp)
#include "files.h"
#include "pitchmk.h"
#include <iostream.h>  // pour affichage et fichier
#include <fstream.h>   //
#include <stdio.h>     // Enregistrement
#include <stdlib.h>    //
#include <fcntl.h>     //
#include <io.h>        //

#define SEEK_END 2     //
#define SEEK_SET 0     //

//	 Modif apportee par ailleurs : perso.cpp
//											 div.h(logfiles::open2 et show2)
//                                francais.str
// 									  pour les menus : main.cpp,main.h,snoori.h
//                                francais.str


static INTbuf Pitch_Mark(1,"marques dans le signal tempo");
static FLOATbuf Space_mod(1," signal tempo modifie");
static FLOATbuf Som_Han(1," somme des fenetres de Hanning");
static float betaPitch =200. ;
static int pnonvois_ms = 10 ;

struct optProsodie optProso = {2., 1.};

void Wtop::CMDispMark()
// trace les marques de couleur dans la
//   fentre wsignal     (bleu = voise et vert=nonvoise)
{
	wsignal->aff();

	affichage_marques(Pitch_Mark, ct.d_es, ct.f_es, wsignal->wsig);
}

void Wtop::CMPitchMark()
// trace les marques de couleur dans la
//   fentre wsignal     (bleu = voise et vert=nonvoise)
{
 	int pnonvois, n, i;
	int premier_pic_Maxmin =0 ;

   souris(XC_watch);

   calculePitch(&n, space, ct, typeLoc);
   Pitch_Mark.newsize(ct.f_e-ct.d_e);
   for (i=0 ; i< ct.f_e-ct.d_e ; i++ ) Pitch_Mark[i]=0;
   pnonvois=enEcht(pnonvois_ms);
   Pitch_Marqueur(Pitch_Mark, space, ct, ct.d_e, ct.f_e, betaPitch,
   					pnonvois, (struct ProgDynPoint *) NULL, &premier_pic_Maxmin);
   i=0;
   while (Pitch_Mark[i]!=0) i++;
   Pitch_Mark.newsize(i);

   souris(XC_top_left_arrow);

   logs.open1();
   logs.wr1(ml(9014,"Pitch marks in samples <0 unvoiced >0 voiced"));
   for (int i = 0; i < Pitch_Mark.size(); i++) {
     STRING mes;
     sprintf(mes,"%d", Pitch_Mark[i]);
     logs.wr1(mes);
   }
   logs.close1();

	wsignal->aff();
	affichage_marques(Pitch_Mark, ct.d_es, ct.f_es, wsignal->wsig ); 
}

long logs_nc2; // nombre de caractres dj rentr  (pour open2)
void logfiles::open2()
	{ char ch[80];
	 strcat(strcpy(ch,tempdir),"resultsk.txt");
	fic1=fopen(ch,"wb");
	logs_nc2=0;
	}

void RawtoWav(
	char* fichierraw,
	char* fichierwav,
	float frequence)
{
 typedef struct{
	unsigned short formatTag;
	unsigned short channels;
	unsigned long samplesPerSec;
	unsigned long avgBytesPerSec;
	unsigned short blockAlign;
	unsigned short bitsPerSample;
 } PCMWAVFMT;

/* Calcul de la taille du fichier en caracteres. */

	int fich = open(fichierraw, O_RDONLY | O_BINARY );
	int l;

	l = (fich>0) ?  lseek(fich, (long)0, SEEK_END) : 0 ;
	close(fich);

/* conversion brut ---> .wav */

	short x;
	int l1 = l + 38, l2 = l + 2;
	FILE *f = fopen(fichierraw, "rb"),
		  *g = fopen(fichierwav, "wb");

	PCMWAVFMT std = {1, 1, frequence, 2*frequence, 2, 16};

	if (!f || !g ) fprintf(stderr, "Unable to open files\n"), fflush(stderr);

/* En-tete du fichier */
	fprintf(g, "RIFF");
	fwrite((char *) &l1, sizeof(long), 1, g);
	fprintf(g, "WAVEfmt \020%c%c%c", 0, 0, 0);

	fwrite( &std, sizeof(PCMWAVFMT), 1, g);
	fprintf( g, "data");
	fwrite((char *) &l2, sizeof(long), 1, g);

	while (!feof(f)) {
			fread((char * ) &x, sizeof(short), 1, f);
			fwrite((char *)&x, sizeof(short), 1, g);
   }

	fclose(f);
	fclose(g);
}


struct ProgDynPoint mark = {0.,0,0,0,0,0.};
//   Dilatation et compression temporelle et frequencielle
//
void pitchScaleMod(
  float F0Factor,
  float timeFactor)
{
	SAMPLEbuf speech(1, "speech signal for pitch-scale modifications");
   STRING resFile, resRawFile;
   int pnonvois;
   int premier_pic_Maxmin ;
   long der_marque_virt;
   long der_marque_synt;
   int lastPitchValue, lastSample;
   long der_marque;
   int i;
   int comp, debut;
   struct ctrl_temps ctloc, ct_;
   struct ProgDynPoint *lastImposedMark;
   bool continued = false;

   lastPitchValue = lastSample = 0;
   lastImposedMark = (struct ProgDynPoint *) NULL;
   ctloc = ct;
   strcpy(resFile,tempdir);
   strcat(resFile,"modif.wav");
   strcpy(resRawFile,tempdir);
   strcat(resRawFile,"modif");
   pm.fenPitch = (int) (en_cours.frequence * (float) FENPITCH / 1000.);
   // add pm.fenPitch in the case where the last window overlaps
   // the end of the speech file
   Space_mod.newsize((int)(timeFactor*ct.tf+pm.fenPitch));
   Som_Han.newsize((int) (timeFactor*ct.tf+pm.fenPitch));
   for ( i=0 ; i< (int) (timeFactor*ct.tf); i++ )
			{Space_mod[i]=0.;Som_Han[i]=0.;}

   comp = 0;
   pnonvois=enEcht(pnonvois_ms);
   premier_pic_Maxmin = 0;
   debut = 1; // debut du signal pour traitement
   ctloc.d_e = 0;
   ctloc.f_e = ctloc.d_e + (int)min(((int)MAXECHTECR-1),(ctloc.tf-ctloc.d_e-1));
   ctloc.d_es = ctloc.d_e;
   ctloc.f_es = ctloc.f_e;
   ctloc.d_a = ctloc.d_es;
   ctloc.f_a = ctloc.f_es;
   souris(XC_watch);

   ct_.d_es = 0;

   while (ctloc.d_es + (int)(pm.fenPitch*3) < ct.tf || ctloc.d_es == ct_.d_es) {
      struct ProgDynPoint *lastMark;
	   INTbuf Pitch_MarkBis(1,"Copies des marques dans le signal tempo");
      int nbValPitch;
      pm_space.newsize(ctloc.f_e-ctloc.d_e+1);
  	   speech.newsize(ctloc.f_e - ctloc.d_e + 1);
      lireSignal(en_cours, en_cours.depl + ctloc.d_e*sizeof(SAMPLE),
                 speech, 0, ctloc.f_e - ctloc.d_e + 1);
      calculePitch(&nbValPitch, speech, ctloc, typeLoc);

      /* calcul des marques */
      souris(XC_watch);
      Pitch_Mark.newsize(ctloc.f_es - ctloc.d_es + 1);
      for (i = 0 ; i < ctloc.f_es - ctloc.d_es + 1; i++ ) Pitch_Mark[i]=0;

      lastMark = Pitch_Marqueur(Pitch_Mark, speech, ctloc, ctloc.d_e, ctloc.f_e, betaPitch,
      								  pnonvois, lastImposedMark, &premier_pic_Maxmin);

      // The first mark must be the last mark found in the previous
      // pitch marking.
      if (continued && lastImposedMark) {
      //IL faut que les marques virtuelles et reelles soient dans un rapport 2
          // Nothing to do because the last mark is used to force the
          // pitch marking to begin with this mark.
        	 i=1;
        	 while (Pitch_Mark[i]!=0) i++;
          Pitch_Mark[0] = lastImposedMark->dat;
          // The last mark is discarded because it is not sufficiently reliable
          Pitch_Mark.newsize(i - 1);
      }
      else {
        i=0;
        while (Pitch_Mark[i]!=0) i++;
        // The last mark is discarded because it is not sufficiently reliable
        Pitch_Mark.newsize(i - 1);
      }

      if (debut) {
        	der_marque_virt = timeFactor * Pitch_Mark[0] ;
      	der_marque_synt = der_marque_virt;
      	debut = 0;
      }

      /* calcul de dilatation ou compression */
		Scale_mod(Pitch_Mark, speech, ctloc, Space_mod, Som_Han, timeFactor,
                F0Factor, &der_marque_virt, &der_marque_synt, &der_marque,
                lastPitchValue, &lastSample, continued);
      continued = true;

      if (Pitch_Mark[Pitch_Mark.size() - 1] > 0) {
        lastPitchValue = pm.getf0(Pitch_Mark[Pitch_Mark.size() - 1]);
        if (!lastPitchValue) {
           lastPitchValue = pm.getf0(Pitch_Mark[Pitch_Mark.size() - 1] - enEcht(4));
           if (!lastPitchValue)
             lastPitchValue = max(pm.getf0(Pitch_Mark[Pitch_Mark.size() - 1] + enEcht(4)),
             					       pm.getf0(Pitch_Mark[Pitch_Mark.size() - 1] - enEcht(8)));
        }
        if (!lastPitchValue)
          affiche_erreur("CMPitchScaleMod: pitch null sur marque voisee");
      }
      else lastPitchValue = 0;

      if (der_marque > 0) {
        lastImposedMark = &mark;
        lastImposedMark->dat = der_marque;
        premier_pic_Maxmin = (speech[der_marque - ctloc.d_e] > 0) ? 2 : 1;
      }
      else {
      	lastImposedMark = (struct ProgDynPoint *) NULL;
         premier_pic_Maxmin = 0;
      }
      ct_ = ctloc;
      ctloc.d_es = abs(der_marque) - pm.fenPitch/2 ;
      ctloc.f_es = ctloc.d_es + (int)min(((int)MAXECHTECR-1),(ctloc.tf-ctloc.d_es-1));
      ctloc.d_a = ctloc.d_es;
      ctloc.f_a = ctloc.d_es + (int)MAXECHTECR -1;
      ctloc.d_e = ctloc.d_es;
      ctloc.f_e = ctloc.f_es;
      comp++;
   }

	if (ctloc.d_es == ct_.d_es)
     affiche_erreur(ml(9015,"Impossible de traiter tout le fichier"));
 
   souris(XC_top_left_arrow);
   ofstream sortie (resRawFile, ios::out | ios::binary);
   int Space_mod_int;
   for ( int e=0; e < lastSample ; e++) {
     Space_mod[e]=(Som_Han[e]?(Space_mod[e]/Som_Han[e]):0.);
     Space_mod_int = (int) Space_mod[e];
     sortie.write((char *) &Space_mod_int, sizeof(SAMPLE) ) ;
   }
   sortie.close();
   Pitch_Mark.newsize(0);
   Space_mod.newsize(0);
   Som_Han.newsize(0);

   RawtoWav(resRawFile, resFile, en_cours.frequence);
   unlink(resRawFile);
	{
     STRING message, commande;
     CHARbuf buf(1,"");
     STARTUPINFO siStartInfo;
     PROCESS_INFORMATION piProcInfo;
     bool b;

     sprintf(message,"%s %s",ml(9012,"Le fichier synthtis est"),resFile);
     buf.cpy(message);
     sprintf(commande, "%s %s", SndRecorder, resFile);
     memset(&siStartInfo, 0, sizeof(STARTUPINFO));
     siStartInfo.cb = sizeof(STARTUPINFO);
     b = CreateProcess(NULL, commande, 0, 0, false, DETACHED_PROCESS, 0, 0, &siStartInfo, &piProcInfo);
     ::PlaySound(resFile, 0, SND_ASYNC | SND_NOWAIT | SND_FILENAME);
     ::MessageBox(PTWtop->HWindow,(char *)&buf[0],ml(9013,"Modification temps-F0 termines"),
     					MB_OK | MB_TASKMODAL );
   }
}


#ifdef UIY
void Wtop::CMChoixLocuteur()
{ char ch1[80];

  strcpy(ch1,My_itoa(loc));
  if ( MyInputDialog(
			  ml(9010,"Choix du locuteur")
			 ,ml(6262,"0=locuteur, 1=locutrice et 2=n'importe qui")
			 ,ch1,78 ) )
  loc=atof(ch1);
}


void Wtop::CMBeta()
// fonction d'activation de la fentre dialogue
{ char ch1[80];
  strcpy(ch1,My_ftoa(betaPitch));
  if ( MyInputDialog(
			  ml(9002,"Paramtre Bta")
			 ,ml(6260,"entrer Bta")
			 ,ch1,78 ) )
  betaPitch=atof(ch1);
}



void Wtop::CMShowLog2()
{ logs.show2();
}


void logfiles::show2()
{ char ch[80];
  strcat(strcpy(ch,tempdir),"resultsk.txt");
  if (isFile(ch)) ShowFileText(ch,"");
  else affiche_warning(ml(201,"pas de rsultats"));
}


void Wtop::CMEnregistreModif()
{char ch1[80]="modif.wav";
 char fichierraw[10]="modif";

 if ( MyInputDialog(
			  ml(6263,"Enregistrer modifications (format .wav)")
			 ,ml(6264,"Entrer le nom du fichier")
			 ,ch1,78 ) ) ;

 RawtoWav(fichierraw,ch1,en_cours.frequence);
}


/* Notes */
/* traitements des erreurs pour le choix du locuteur */
/* et pour le fichier d'enregistrement                */
/* (dans les boites de dialogue)                     */

#endif

