/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include "common.h"
#include "revoicingParam.h"

double revoicingLevel = 2.;
double revoicingNoiseCorrection = -25.;
double revoicingTimeAttenuation = -20;
double revoicingOther = 0.0;

DEFINE_RESPONSE_TABLE1(TWrevoicingParam,TDialog)
  EV_CHILD_NOTIFY_ALL_CODES(IDOK,IDok),
  EV_CHILD_NOTIFY_ALL_CODES(IDCANCEL,IDcancel),
END_RESPONSE_TABLE;
TWrevoicingParam::TWrevoicingParam(PTWindowsObject AParent, LPSTR name)
	:TDialog(AParent,name)
{
  PTVoicingLevel = new TEdit(this, IDC_EDIT28);
  PTNoiseCorrect = new TEdit(this, IDC_EDIT24);
  PTTimeAttenuation = new TEdit(this, IDC_EDIT29);
  PTOther = new TEdit(this, IDC_EDIT30);
  add = new TButton(this, IDOK);
  forget = new TButton(this, IDCANCEL);
}

TWrevoicingParam::~TWrevoicingParam()
{
  delete add;
  delete forget;
  delete PTVoicingLevel;
  delete PTNoiseCorrect;
  delete PTTimeAttenuation;
  delete PTOther;
}

void TWrevoicingParam::SetupWindow()
{
  STRING s;
  TDialog::SetupWindow();
  sprintf(s,"%lf", revoicingLevel);
  PTVoicingLevel->SetText(s);
  sprintf(s,"%lf", revoicingNoiseCorrection);
  PTNoiseCorrect->SetText(s);
  sprintf(s,"%lf", revoicingTimeAttenuation);
  PTTimeAttenuation->SetText(s);
  sprintf(s,"%lf", revoicingOther);
  PTOther->SetText(s);
}

bool TWrevoicingParam::CanClose()
{
  STRING s;
  PTVoicingLevel->GetText(s,10);
  revoicingLevel = atof(s);

  PTNoiseCorrect->GetText(s,10);
  revoicingNoiseCorrection = atof(s);

  PTTimeAttenuation->GetText(s,10);
  revoicingTimeAttenuation = atof(s);

  PTOther->GetText(s,10);
  revoicingOther = atof(s);
  return(true);
}
void TWrevoicingParam::IDok(WPARAM)
{
  CloseWindow(IDOK);
}

void TWrevoicingParam::IDcancel(WPARAM)
{
  CloseWindow(IDCANCEL);
}