/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier racine.cpp
//
#include "common.h"
#pragma hdrstop

/**********************************************************/ 
/*  parametres d'entrees :				  */
/*     a : les coefs Ai tq i de 0 a` P.			  */
/*     n : l'ordre de LPC, donc P.			  */	
/*     b : b(2i+1)+jb(2i) = reel + j imaginaire.	  */
/*         tq i de 0 a` n.				  */
/**********************************************************/ 
#include <math.h>   
#include <stdio.h>
#define sqr(x)  ((x) * (x))
void root(
	float *a,    /* tableau contenant les coefficients */
	int      n,    /* nb de element du tableau - 1 */
	float *b)    /* resultat. */
{
  int   m,i,ip,n2; 
  float seg,ss,sug,gpg,gp,gq,x,y,y1,dx,dy,u,v,w1,s1,v1,w2,u1,t,dd,dc,c;
  float p,qp,q,x1,s,rr,yy;

  if (n > 0) { 
          m = n; 
          n2 = n * 2; 
          n = n + 1;
          seg = 0.0; 
          ss = 0.0; 
          sug = 1.0; 
          gpg = 1.0; 
          rr = a[0]; 
          for (i = 1; i <= n; i++) b[i] = a[i - 1] / rr; 

 etiq100: gp = (float)fabs((double)b[m + 1]);
          if (gp > 1.0e-12) goto etiq102; 
          x = 0.0; 
          y = 0.0; 
          goto etiq83; 
 etiq102: gq = (float) exp(   ( log((double) gp) / (double) m)     ); 
          gp = gq; 
          gpg = gpg * gp; 
          for (i = 2; i <= (m + 1); i++) { 
            b[i] = b[i] / gq; 
            gq = gp * gq; 
	  }
          x = 0.0001; 
          x1 = x; 
          y = 0.2; 
          y1 = 0.2; 
          s = 10.0e+28; 
          dx = 1.0; 
  etiq50: u = b[1]; 
          v = 0.0; 
          for (i = 2; i <= (m + 1); i++) { 
            /* si w1 est trop grand,alors on saute sur 220 */
            /* c.a.d:dans le cas de f'(x)=0                */
	    if (   ((float) fabs((double)u) > 3.2e+6)
		   || ((float) fabs((double) v) > 3.2e+6)   )
	      goto etiq220; 
            w1 = u * x1 - v * y1 + b[i]; 
            v = u * y1 + v * x1; 
            u = w1; 
  	  }
	  if ( ((float) fabs((double) u) > 3.0e+7)
	       || ((float) fabs((double) v) > 3.0e+7) ) goto etiq220;
          s1 = sqr(u) + sqr(v); 
          if (s1 >= s) goto etiq220; 
          s = s1; 
          x = x1; 
          y = y1; 
          ss = 0.0; 
          if (s <= 1.0e-19) goto etiq80; 
          u1 = m * b[1]; 
          v1 = 0.0; 
          for (i = 2; i <= m; i++) { 
            w1 = u1 * x - v1 * y + b[i] * (m - i + 1); 
            v1 = u1 * y + v1 * x; 
            u1 = w1; 
          } 
          w2 = sqr(u1) + sqr(v1); 
          if (w2 <= 1.0e-19) goto etiq210; 
          dx = (u * u1 + v * v1) / w2; 
          dy = (u1 * v - v1 * u) / w2; 
          t = 1.0 + 4.0 / m; 
 etiq130: t = t / 1.67; 
          x1 = x - t * dx; 
	  y1 = y - t * dy;
	  /*  ici, 50.0 et 85.0 depondent la machine */
          if (m < 50.0) goto etiq132; 
          yy = sqr(x1) + sqr(y1); 
          yy = (float) sqrt((double)yy);
          if (yy >= exp( (85.0 / m) ) ) goto etiq130; 
 etiq132: if (t >= 1.0e-3) goto etiq50; 
          if (s <= 1.0e-18) goto etiq80; 
 etiq210: ss = 1.0; 
          dd = sqr(dx) + sqr(dy);
	  dd = (float)sqrt((double)dd);
          if (dd > 1.0) dd = 1.0; 
          dc = 6.28 / (m + 4.5); 
 etiq230: c = 0.0; 
 etiq220: if (ss != 1.0) goto etiq130; 
 etiq200: c = c + dc; 
          dx = (float)cos((double)c) * dd; 
          dy = (float)sin((double)c) * dd; 
          x1 = x + dx; 
          y1 = y + dy; 
          if (c <= 6.29) goto etiq50; 
          dd = dd / 1.67; 
          if (dd <= 0.1e-7) goto etiq80; 
          goto etiq230; 
  etiq80: if ((float)fabs((double) y) <= 1.0e-6) goto etiq83; 
          p = -2.0 * x; 
          q = x * x + y * y; 
          ip = 2 * m + 1; 
          b[ip] = x * gpg; 
          b[ip + 1] =  - y * gpg; 
          qp = q * gpg; 
          m = m - 1; 
          goto etiq81; 
  etiq83: qp = -x; 
          p =  - x; 
          y = 0.0; 
          q = 0.0; 
  etiq81: for (i = 1; i <= m; i++) { 
            b[i + 1] = b[i + 1] - b[i] * p; 
            b[i + 2] = b[i + 2] - b[i] * q; 
          }
          ip = 2 * m + 1; 
          b[ip] = x * gpg; 
          b[ip + 1] = y * gpg; 
          seg = seg + p * gpg; 
          sug = sug * qp * gpg; 
          m = m - 1; 
          if (m < 1) goto etiq110;
          else if (m == 1) goto etiq104;
               else goto etiq100; 
 etiq104: x =  - b[2] / b[1]; 
          goto etiq83; 
 etiq110: b[1] = seg * a[0]; 
          b[2] = sug * a[0]; 
   
          x = b[1]; 
          for (i = 2; i <= (n2 + 2); i++) b[i - 2] = b[i]; 
          b[n2 + 1] = x; 
   } 
   else { b[0] = 0.0; b[1] = 0.0; b[2] = 0.0; } 
}
