/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier scalemod.cpp
//

#include "common.h"
#pragma hdrstop

#include <math.h>
#include <iostream.h>
#include <stdio.h>
#include <malloc.h>
#include <fstream.h>

#include "snoori.h"
#include "spectro.h"
#include "pitchm.h"
#include "signal.h"
#include "outils.h" //pour la fonction enEcht(temps.cpp)
#include "pitchmk.h"
#include "hanning.h"


void  Scale_mod(
	INTbuf& Pitch_Mark,
   SAMPLEbuf& speech,
   struct ctrl_temps ctloc,
	FLOATbuf& Space_mod,
	FLOATbuf& Som_Han,
	float coef_tempo,
	float coef_pitch,
	long * der_marque_virt,
	long * der_marque_synt,
   long * der_marque,
   int lastPitchValue,
   int *lastSample,
   bool continued)

{
	int i, m, n, pitch,
		 ok, //pour l'arret de l'association des marques
		 reverse; // si pair (et nonvoise et egal au precedent) il y a inversement
	int nbm = Pitch_Mark.size();
	int nbms; //nbre de marques dans le signal modifie
	int mu_P,mu_PS;  // taille de la fenetre (depart, synt)
	int milieu, milieu_s ;   // milieu de la fenetre ( depart, synt)
	float * hanning;    // la fenetre de Hanning choisie
	float * hanning_s;    // la fenetre de Hanning finale
	int * space_fen; // morceau de signal de speech fenetr par Hanning

   /* marques virtuelles */
   int *Pitch_Mark_Virt = new int[nbm],
       *Pitch_Mark_Synt, *Mark_Asso;

	for ( i=0 ; i< nbm ; i++ ) Pitch_Mark_Virt[i]=0;

	Pitch_Mark_Virt[0]=*der_marque_virt;
	for (i=1; i<nbm ; i++) {
     Pitch_Mark_Virt[i] = IROUND(coef_tempo * abs(Pitch_Mark[i]));
// The following line comes directly from Moulines and Laroche but is
// dangerous with rounding errors
//    Pitch_Mark_Virt[i] = (int)fabs(Pitch_Mark_Virt[i-1]) +
//							  (int) (coef_tempo * ((int)fabs(Pitch_Mark[i])-(int)fabs(Pitch_Mark[i-1])));
     if (Pitch_Mark[i] < 0)
				Pitch_Mark_Virt[i] = -Pitch_Mark_Virt[i] ;
   }

   /* calcul des marques pour le signal synthetis */

	if (coef_tempo >= 1 || coef_pitch < 1)
		nbms = ((int)2*(coef_tempo+1))*nbm ; 		// entier superieur a coef_tempo
   else nbms = (int) (2 * nbm / coef_tempo);    // ATTENTION calcul a verifier

	Pitch_Mark_Synt = new int [nbms];
   Mark_Asso = new int [nbms];
	for (i=0; i < nbms; i++) Pitch_Mark_Synt[i]=0;
	for (i=0; i < nbms; i++) Mark_Asso[i]=-1;

	Pitch_Mark_Synt[0]=*der_marque_synt;

	if (abs(Pitch_Mark_Synt[0]) == abs(Pitch_Mark_Virt[0])) Mark_Asso[0] = 0;
   else {
     m=0;
     while (abs(Pitch_Mark_Synt[0]) > abs(Pitch_Mark_Virt[m]))m++;
     if ( (abs(Pitch_Mark_Virt[m]) - abs(Pitch_Mark_Synt[0])) <
          (abs(Pitch_Mark_Synt[0]) - abs(Pitch_Mark_Virt[m-1])) )
          Mark_Asso[0] = m;
     else Mark_Asso[0] = m -1; // m!=0 car P_M_S[0] > (int)fabs(P_M_V[0]) par construction
   }
	if  (Pitch_Mark_Virt[Mark_Asso[0]] < 0)
			Pitch_Mark_Synt[0] = - abs(Pitch_Mark_Synt[0]);

	i=0;
	ok=1;
	while ( ok )  {
     if (Pitch_Mark_Synt[i] < 0)
       pitch = enEcht(10);//a voir
     else {
       pitch = ( pm.getf0(Pitch_Mark[Mark_Asso[i]])?
                 pm.getf0(Pitch_Mark[Mark_Asso[i]])
                 :pm.getf0(Pitch_Mark[Mark_Asso[i]+1]) );
					// (Pour le cas de debut de voisement)
       if (!pitch) pitch = lastPitchValue;
       if (!pitch) {
//         affiche_erreur("Scale_mod: pitch is given a default value");  Mais il reste un bug car on arrive dans ce cas de temps en temps
         pitch = 100;      // 100 Hz
       }
       pitch = IROUND(en_cours.frequence / pitch);
     }

     if (i+1 > nbms - 1)
       affiche_erreur("erreur sur la taille du tableau de marques de synthese");
     Pitch_Mark_Synt[i+1]= abs(Pitch_Mark_Synt[i])
										+ IROUND(pitch * coef_pitch);

     /* Association */

     if (abs(Pitch_Mark_Synt[i+1]) > abs(Pitch_Mark_Virt[nbm-1]))
       ok = 0;     // si on depasse la fin
     if (ok) {
       m=0;
       if (i+1 > nbms - 1)
         affiche_erreur("erreur sur la taille du tableau de marques de synthese");
       while (Pitch_Mark_Synt[i+1] > abs(Pitch_Mark_Virt[Mark_Asso[i]+m])) m++;
       if ( ( abs(Pitch_Mark_Virt[Mark_Asso[i]+m])- Pitch_Mark_Synt[i+1] ) <
				  ( Pitch_Mark_Synt[i+1] - abs(Pitch_Mark_Virt[Mark_Asso[i]+m-1])) )
				Mark_Asso[i+1] = Mark_Asso[i] + m;
       else Mark_Asso[i+1] = Mark_Asso[i] + m -1;


       if  (Pitch_Mark_Virt[Mark_Asso[i+1]] < 0)
       Pitch_Mark_Synt[i+1] = - Pitch_Mark_Synt[i+1];

       i++;
     }

   }       //(on s'arrete a i mais i+1 est ecrit (sans marque associee)!)

  /* Reconstitution avec la fenetre de Hanning */

	mu_P = 2 * enEcht(10);     // initialisation avec les nonvoiss.
	mu_PS = mu_P;
	hanning = new float [5000]; // taille a voir mais resiste a 50 Hz a 44 kHz
	hanning_s = new float [5000];
	space_fen = new int [5000];
   HANNING tableau_fen_han;

	//Fenetre_hanning(HAN, &nb_HAN, hanning, mu_P);
   tableau_fen_han.fenetre(mu_P, hanning);

   // The synthesis begins with 1 to not resynthetize the mark synthetized in
   // the previous use of scalemod.
	i = (continued) ? 1 : 0;
	while (Mark_Asso[i] != -1 ) {
     if (Pitch_Mark[Mark_Asso[i]] < 0)
       pitch = enEcht(10);//a voir
     else {
        pitch = ( pm.getf0(Pitch_Mark[Mark_Asso[i]])?
							pm.getf0(Pitch_Mark[Mark_Asso[i]])
						  :pm.getf0(Pitch_Mark[Mark_Asso[i]+1]) );
        // (Pour le cas de debut de voisement)
        if (pitch > 0)  pitch = IROUND(en_cours.frequence / pitch);
        /* else ok=0; */
     }

     mu_P = (int) 2*pitch ;
     milieu = (mu_P - 1)/2;
     //Fenetre_hanning(HAN, &nb_HAN, hanning, mu_P);
     tableau_fen_han.fenetre(mu_P, hanning);
     mu_PS = IROUND(2*(pitch*coef_pitch)) ;          //  a voir
     /* mu_PS = mu_P; */                           //  fenetre modifiee ?
     milieu_s = (mu_PS-1)/2;
     //Fenetre_hanning(HAN, &nb_HAN, hanning_s, mu_PS);
     tableau_fen_han.fenetre(mu_PS, hanning_s);


     for (n = 0; n < mu_P ; n++) {
     	 if  ( abs(Pitch_Mark[Mark_Asso[i]])-ctloc.d_e + n - milieu < speech.size()
            && abs(Pitch_Mark[Mark_Asso[i]])-ctloc.d_e + n - milieu >= 0)
     	 	space_fen[n]= hanning[n] *
						 	speech[(int)(fabs(Pitch_Mark[Mark_Asso[i]]))-ctloc.d_e + n - milieu];
       else affiche_erreur("depassement dans space");
     }

     if ( (Pitch_Mark[Mark_Asso[i]] < 0 && i>0) &&
					(Mark_Asso[i-1] == Mark_Asso[i] && !(reverse % 2) ) )  {
       if ( Mark_Asso[i-1] == Mark_Asso[i] && Pitch_Mark[Mark_Asso[i-1]] < 0)
       for (n=0 ; n< mu_P ; n++) {
         int ind = abs(Pitch_Mark_Synt[i]) + n - milieu;
         if (ind >= 0) {
           Space_mod[ind] += space_fen[mu_P-1-n]; // inversion de la fenetre
           *lastSample = ind;
         }
       }
       for (n=0 ; n< mu_PS ; n++) {
         int ind =abs(Pitch_Mark_Synt[i]) + n - milieu_s;
       	if (ind >= 0) {
           Som_Han[ind] += hanning_s [mu_PS-1-n];
           *lastSample = ind;
         }
       }
       reverse++;
     }
     else {
       for (n=0 ; n< mu_P ; n++) {
         int ind = abs(Pitch_Mark_Synt[i]) + n - milieu;
         if (ind >= 0) {
           Space_mod[ind] += space_fen[n];
           *lastSample = ind;
         }
       }
       for (n=0 ; n< mu_PS ; n++) {
         int ind = abs(Pitch_Mark_Synt[i]) + n - milieu_s;
         if (ind > 0) {
         //  affiche_erreur("depassement dans som_han");
           Som_Han[ind] += hanning_s [n];
           *lastSample = ind;
         }
       }
       reverse=0;
     }

     i++;
   }
   *der_marque_synt = Pitch_Mark_Synt[i - 1];
   for (m = nbm - 1;
   	  m >=0 && abs(Pitch_Mark_Virt[m]) > abs(*der_marque_synt); m--);
   if (m >= 0) {
   	*der_marque_virt = Pitch_Mark_Virt[m];
      *der_marque = Pitch_Mark[m];
   }
   else affiche_erreur("erreur dans scalemod");

   delete [] Mark_Asso;
   delete [] Pitch_Mark_Virt;
   delete [] Pitch_Mark_Synt;
	delete [] hanning;
   delete [] space_fen;
   delete [] hanning_s;
}

