/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier selecteu.cpp
//

#include "common.h"
#pragma hdrstop
                             
#include <stdio.h>
#include <stdlib.h>
#include <sys\stat.h>
#include <io.h>
#include <dirent.h>

#include "files.h"

// revoir les utilisations des File Dialog
// la dfinition des OFN_ se trouve dans l'include <commdlg.h>

bool WindowsWAVfiles=true;

////////////////////////////////////////////
// get_nom_fichier_open()
//
int get_nom_fichier_open(PTWindowsObject Parent
			,char *file)
{ int ret;
  STRING ch;

  TFileOpenDialog::TData FileData
	 (OFN_FILEMUSTEXIST | OFN_SHOWHELP | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST
	  ,"*.*",0,"","");

  x_makepath(FileData.FileName,NULL,NULL,file,file);
  ret=TFileOpenDialog(Parent,FileData,0
			 ,ml(7921,"ouvrir un fichier")).DoExecute(); 
  if (ret==IDOK)
  { strcpy(file,FileData.FileName);
	 sprintf(ch,"get_nom_fichier_open() fileout=%s"
		 ,file);
	 Wmsg->wr(ch);
  }
  return ret;
}

////////////////////////////////////////////
// get_nom_fichier_save()
//
int get_nom_fichier_save(PTWindowsObject Parent
			,char *file)
{ int ret;
  STRING ch;

  TOpenSaveDialog::TData FileData
	 ( OFN_SHOWHELP | OFN_OVERWRITEPROMPT,
	  "*.*",0,"","");

  strcpy(FileData.FileName, file);
  //x_makepath(FileData.FileName,NULL,NULL,file,file);
  ret=TFileSaveDialog(Parent,FileData,0).DoExecute();
  //ret=TFileSaveDialog(Parent,FileData,0
  //			,ml(7922,"sauver un fichier")).DoExecute();
		//Parent->GetApplication(
		// )->ExecDialog(new TMyFileSaveDialog(
		//                     Parent,ch));
  if (ret==IDOK)
  { strcpy(file,FileData.FileName);
    sprintf(ch,"get_nom_fichier_save() fileout=%s"
	    ,file);
    Wmsg->wr(ch);
  }
  return ret;
}

////////////////////////////////////////////
// SelectFile()
//
int SelectFile(PTWindowsObject Parent
			,char *file)
{ int ret;
  STRING ch;
  TFileOpenDialog::TData FileData
  	 ( OFN_SHOWHELP | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST
    ,"*.*",0,"","");
  // TOpenSaveDialog::TData FileData(OFN_HIDEREADONLY| OFN_PATHMUSTEXIST,"*.*",0,"","");
  x_makepath(FileData.FileName,NULL,NULL,file,file);
  ret=TFileOpenDialog(Parent,FileData,0
			 ,ml(7923,"slectionner un fichier")).DoExecute();
  if (ret==IDOK)
  { strcpy(file,FileData.FileName);
	 sprintf(ch,"SelectFile() fileout=%s"
		 ,file);
	 Wmsg->wr(ch);
  }
  return ret;
}

////////////////////////////////////////////
// SelectDir()
//
int SelectDir(PTWindowsObject Parent
			,char *file)
{ int ret;
  STRING ch;
  TFileOpenDialog::TData FileData
	 (OFN_FILEMUSTEXIST | OFN_SHOWHELP | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST
	  ,"*.*",0,"","");

  x_makepath(FileData.FileName,NULL,NULL,file,file);
  ret=TFileOpenDialog(Parent,FileData,0
			 ,ml(7924,"slectionner un rpertoire")).DoExecute();
  if (ret==IDOK)
  { strcpy(file,FileData.FileName);
	 sprintf(ch,"SelectDir() fileout=%s"
		 ,file);
	 Wmsg->wr(ch);
  }
  return ret;
}


////////////////////////////////////////////////////
bool isFile(char *filename)
{ FILE *file;
  if ((file=fopen(filename,"r"))!=NULL)
  { fclose(file);
    return TRUE;
  }
  else return FALSE;
}

  char path[_MAX_PATH];
  char drive[_MAX_DRIVE];
  char dir[_MAX_DIR];
  char file[_MAX_FNAME];
  char ext[_MAX_EXT];
  char wavext[_MAX_EXT];


bool isWAV(char *filename)
{
  strcpy(path, filename);
  strcpy(wavext,".WA$\0");
  _splitpath(path,0,0,0,ext);
  if (!stricmp(ext,wavext)) return true;
  if (!WindowsWAVfiles) return false;
  // WSN est le format wav adapte a WinSnoori (avec des chunks specifiques
  // a Snoori)
  return (stricmp(ext,".WAV")==0 || stricmp(ext,".WSN")==0);
}

bool isExt(char *filename)
// renvoie TRUE s'il y a une extension
{ char ext[_MAX_EXT];

  _splitpath(filename,NULL,NULL,NULL,ext);
  return (strlen(ext)>1);
}

int is_readable(char *file)
// en retour 1  ok
//           0  not readable
{ // verifie si le fichier selectionne existe et est lisible

  struct stat s_buf;

  if (stat(file, &s_buf) == 1) {
	 affiche_erreur(ml(7901,"Fichier inexistant"));
	 return 0;
  }

  else if ((s_buf.st_mode & S_IFMT) == S_IFDIR) {
	 affiche_erreur(ml(7902,"Rpertoire"));
	 return 0;
  }
  return(1);
}


void x_makepath( 
// au lieu des drive,dir,fname,ext on peut
// donner un nom de chemin contenant
// la bonne information correspondante
                char *x_path
	       ,char *x_drive,char *x_dir
					,char *x_fname,char *x_ext)
{ char drive[_MAX_DRIVE];
  char dir[_MAX_DIR];
  char fname[_MAX_FNAME];
  char ext[_MAX_EXT];
  if (x_drive!=NULL) _splitpath(x_drive,drive,NULL,NULL,NULL);
  if (x_dir!=NULL) _splitpath(x_dir,NULL,dir,NULL,NULL);
  if (x_fname!=NULL) _splitpath(x_fname,NULL,NULL,fname,NULL);
  if (x_ext!=NULL) _splitpath(x_ext,NULL,NULL,NULL,ext);
  _makepath(x_path
	   ,(x_drive==NULL) ? NULL : drive
	   ,(x_dir==NULL) ? NULL : dir
	   ,(x_fname==NULL) ? NULL : fname
	   ,(x_ext==NULL) ? NULL : ext  );
}

void splitmakedir(char *chemin)
// transforme le chemin en directory
//   en supprimant le nom du fichier et son extension
{ int i;
  char lecteur[_MAX_DRIVE],rep[_MAX_DIR];

  _splitpath(chemin,lecteur,rep,NULL,NULL);
  _makepath(chemin,lecteur,rep,NULL,NULL);
  i=strlen(chemin);
  if ((i>0)&&(chemin[i-1]!='\\'))
    strcat(chemin,"\\");
}

void normdir(char *dir)
// normalise un nom de directory en mettant
//   un '\' en fin s'il manque
{ int i=strlen(dir);
  if (i>0)
    if (dir[i-1]!='\\')
      strcat(dir,"\\");
}

bool is_a_directory(char *chemin)
{ DIR *dir;

  if ((dir=opendir(chemin))==NULL) return FALSE;
  else closedir(dir);
  return TRUE;
}

