/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier signal_t.cpp
//

#include "common.h"
#pragma hdrstop
                                                   
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>

#include "snoori.h"
#include "signal.h"
#include "notetiq.h"
#include "files.h"
#include "audio.h"
#include "spectro.h"
#include "outils.h"
#include "fmaxspec.h"

/* tableau pour acquisition restitution */
SAMPLEbuf space(1 ,"space");

/* phrase en cours d'etude */
int yaUnSignal = NOSIGNAL;
struct infoFile en_cours;

/* reperage temporel de Snoori */
struct ctrl_temps ct;

void SetModeZoom(int mode)
{
  ct.modeMemoire = mode;
  { HMENU m=GetMenu(PTWtop->HWindow);
    WORD c=MF_CHECKED, u=MF_UNCHECKED;
    CheckMenuItem(m,MENUZoomin,(mode==ZOOM)?c:u);
    CheckMenuItem(m,MENUZoomout,(mode!=ZOOM)?c:u);
  }
}
/*
 * En fonction de la taille du fichier de parole,
 * selectionne la partie qui
 * doit etre affichee. ct.tf doit, bien sur, etre connu.
 */
void trouveQuoiAfficher()
{
  ct.d_a = 0;
  ct.f_a = MAXECHTECR -1;
  ct.d_e = 0;
  ct.f_e = min(ct.f_a,ct.tf-1);
  SetModeZoom(TOUT);
  space.newsize(ct.f_e+1);
  ct.d_es = ct.d_e;
  ct.f_es=min(ct.f_e,ct.f_a);
  if (!fmaxForAll) fMaxSpectro = en_cours.frequence / 2.;
}

void trouveQuoiAffBis(int premEchtAff, int derEchtAff)
{
  ct.d_a = premEchtAff;
  ct.f_a = derEchtAff;
  ct.d_e = 0;
  ct.f_e = min(ct.f_a, ct.tf - 1);
  SetModeZoom(TOUT);
  space.newsize(ct.f_e + 1);
  ct.d_es = ct.d_e;
  ct.f_es=min(ct.f_e, ct.f_a);
  if (!fmaxForAll) fMaxSpectro = en_cours.frequence / 2.;
}

static void lireEtAfficherSignal()
{ 
  SpectroDisplay display;
  display.type = WINDOW;
  display.ws = wspectro->wsona;
  notes.clear();
  etiqs.clear();
  trouveQuoiAfficher();
  lireSignal(en_cours
	    , en_cours.depl + ct.d_e*sizeof(SAMPLE)
	    , space, 0
	    , ct.f_e - ct.d_e + 1);
  if (isWAV(en_cours.nom))
  { // lecture annotations pour un fichier .wav
    readnotetiqs(en_cours.nom,notes
		  ,en_cours.notedepl
		  ,en_cours.notelongueur);
    readnotetiqs(en_cours.nom,etiqs
		  ,en_cours.etiqdepl
		  ,en_cours.etiqlongueur);
    isEtiqModifiable=
      isNoteModifiable=droit_ecrire(en_cours.nom);
  }
  else
  { isEtiqModifiable=TRUE;
    isNoteModifiable=TRUE;
    if (en_cours.fmt_phon!=0)
    { lireman(&etiqs, en_cours);
      isEtiqModifiable=droit_ecrire(en_cours.nom_man);
    }
    if (en_cours.fmt_word!=0)
    { lireAnnotations(&notes, en_cours);
      isNoteModifiable=droit_ecrire(en_cours.nomAnnot);
    }
    /* //::
    if (  (en_cours.fmt_phon!=0)
	||(en_cours.fmt_word!=0) )
    { if (MessageBox(PTWtop->HWindow
	  ,ml(8005,"ouvrir aussi les fichiers d'tiquetage ?")
	  ,ml(8006,"ouvrir fichier")
          ,MB_YESNO)==IDYES)
      { if (en_cours.fmt_phon!=0)
       { lireman(&etiqs, en_cours);
          isEtiqModifiable=droit_ecrire(en_cours.nom_man);
	  en_cours.isOpenPhon=TRUE;
        }
	if (en_cours.fmt_word!=0)
	{ lireAnnotations(&notes, en_cours);
	  isNoteModifiable=droit_ecrire(en_cours.nomAnnot);
	  en_cours.isOpenWord=TRUE;
	}
      }
    }
    */
  }

  SetScrollSpectroPosition(0);
  wsignal->aff();
  wsignal->paint();
  aff_etiqs();
  aff_notes();

  if (autospectro)
    spectrogram(wspectro->wsona->sig, display, ct.d_es, ct.f_es, ct, ON_NETTOIE );
  else {
    wspectro->wsona->clear_fenetre();
    wspectro->wsona->spectro_consolider(0,INFINI_I);
  }
  wspectro->paint();
  initEditSignal();
}

void lect_signal()
{ if (init_infoFile_read(&en_cours))
  { ct.tf=en_cours.longueur / sizeof(SAMPLE);
    yaUnSignal = ASIGNAL;
    //:: en_cours.isOpenPhon=false;
    //:: en_cours.isOpenWord=false;
    PTWtop->SetNomFichierParole(en_cours.nom);

    if (Licensed) active(PPMENUAllStandard);
    else {
      active(MENUEcoute1Fois);
 	   active(MENUEcoute);
	   active(MENUPlayFile);
	   active(MENUZoomin);
	   active(MENUZoomout);
      active(PPMENUSpectro);
      active(MENUOptionsSpec);
    }

    DrawMenuBar(PTWtop->HWindow);
    lireEtAfficherSignal();
  }
}

void Wtop::CMouAller()
// fonction d'activation de la fentre dialogue
{ char ch1[80];
  long echt;

  strcpy(ch1,"0");
  if ( MyInputDialog(
		ml(8001,"aller ")
	       ,ml(8002," quelle milliseconde ?")
               ,ch1,78 ) )
  { souris(XC_watch);
    echt=(atol(ch1)/1000.)*en_cours.frequence;
    SetScrollSpectroPosition(echt);
    allerA(echt);
    souris(XC_top_left_arrow);
  }
}

void Wtop::CMfreqEchantillonnage()
// fonction d'activation de la fentre dialogue
{
  char ch1[80];
  float freq = en_cours.frequence;

  strcpy(ch1,My_ftoa(en_cours.frequence));
  if ( MyInputDialog(
	        ml(8003,"frquence d'chantillonnage")
	       ,ml(8004,"entrer la frquence")
	       ,ch1,78 ) )
    en_cours.frequence=atof(ch1);
  // Premier controle autoritaire de la frequence
  en_cours.frequence = max(50., en_cours.frequence);
  if (yaUnSignal == ASIGNAL) {  // Sampling rate checking
   float freqApprox = (ct.f_e - ct.d_e) / DUREE_FEN;
   if (   freqApprox / en_cours.frequence > 3.
       || freqApprox / en_cours.frequence < 0.33)
      affiche_erreur(ml(8007,  "tes vous sur de cette frquence\n\
...qui peut causer des problmes de traitement du signal"));
  }
}

extern bool init_infoFile_read_WAV(struct infoFile *nv);
extern void trouveQuoiAffBis(int premEchtAff, int derEchtAff);
extern void RawtoWav(char* fichierraw,char* fichierwav,float frequence);
// Creates a constant signal (0)
bool cstRawFile(char *filename, int nbItem)
{
  ofstream outfp;
  unsigned char high = 0, low = 0;

  outfp.open(filename, ios::out|ios::binary|ios::trunc);
  if(!outfp) return false;
  for (int i = 0; i < nbItem; i++) outfp << high << low;
  outfp.close();
  return true;
}

//
// Init signal and spectrogram when no signal is available.
bool initShadow(
  int dateFin,   // date de fin du dernier polypoints en ms.
  bool force,    // if force is true the shadow file gets exactly the dateFin as
  					  // duration.
  int d_a,       // temporal window to be displayed in ms
  int f_a,
  int samplingRate)
{
  STRING shadowFile, shadowRawFile;
  bool status;
  int duration = (force) ? dateFin / 1000 : max(3, (dateFin + 500) / 1000);
  SpectroDisplay display;
  display.type = WINDOW;
  display.ws = wspectro->wsona;

  sprintf(shadowFile, "%s\\temp\\shadow.wav", WinSnooriDirectory);
  sprintf(shadowRawFile, "%s\\temp\\shadow.raw", WinSnooriDirectory);
  status = cstRawFile(shadowRawFile, (int) (samplingRate * duration));
  if (!status) return(false);
  RawtoWav(shadowRawFile, shadowFile, (double) samplingRate);
  unlink(shadowRawFile);
  strcpy(en_cours.nom, shadowFile);
  init_infoFile_read_WAV(&en_cours);
  ct.tf = en_cours.longueur / sizeof(SAMPLE);
  ::trouveQuoiAffBis(enEcht(d_a), enEcht(f_a));
  // cts.d_a = ct.d_a;
  // cts.f_a = ct.f_a;

  ::lireSignal(en_cours, en_cours.depl + ct.d_e * sizeof(SAMPLE), space, 0, ct.f_e - ct.d_e + 1);
  yaUnSignal = ASHADOW;
  ::SetScrollSpectroPosition(0);
  wsignal->aff();
  wsignal->paint();

  ::spectrogram(wspectro->wsona->sig, display, ct.d_es, ct.f_es, ct, ON_NETTOIE);
  wspectro->paint();

  initEditSignalSeul();
  return(true);
}

// get a sample in a mapped file
SAMPLE getSample(
  PBYTE pbFile,
  int isample)
{
 union {
   char c[2];
   int x;
 } b;

 if (en_cours.swap != SWAPINFILE) {
   b.c[1] = pbFile[sizeof(SAMPLE) * isample + en_cours.depl];
   b.c[0] = pbFile[sizeof(SAMPLE) * isample + en_cours.depl + 1];
 }
 else {
   b.c[0] = pbFile[sizeof(SAMPLE) * isample + en_cours.depl];
   b.c[1] = pbFile[sizeof(SAMPLE) * isample + en_cours.depl + 1];
 }
 return(b.x);
}
