/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier sof.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>

#include "files.h"

#define SEEK_END 2
#define SEEK_SET 0

/*
 * fonctions calculant la taille d'un fichier.
 */

int fsof(FILE *f)
{ int lg = (f) ? (int) lseek(fileno(f),(long)0,SEEK_END) : 0;
  if (f) lseek(fileno(f), (long) 0, SEEK_SET);
  return(lg);
}

long sof(int f)
// renvoie la taille en caractres du fichier f dj ouvert
//     f: identificateur numro du fichier f
{ long lg;

  lg= (f>0) ? lseek(f,(long)0,SEEK_END) : 0;
  return(lg);
}

long nsof(char *s)
// renvoie la longueur en caractres du fichier s non ouvert
//     s: nom du fichier en char *
{ int f;
  long l;

  f= open(s,O_RDONLY|O_BINARY);
  if (f>=0) { l=lseek(f,(long)0,SEEK_END); 
	      close(f);
	    }
  else l=0;
  return(l);
}
