/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier spectre.h
//

#ifndef _SPECTRE_H
#define _SPECTRE_H

// dans le fichier cepstre.cpp
extern int cepstre(
	FLOATbuf **res, 	// les resultats
	SAMPLE *cnv_,	// signal d'entree
	long cnv_debut,
	int nb_cepstre,	// nombre de cepstres a calculer
 	long decal, 	// decalage entre deux cepstres 
        int fen_signal_, // taille de la fenetre signal
	int fen_fft1, // 1re fenetre fft (avant liftrage)
        int fen_fft2, // 2me fenetre fft (aprs liftrage)
	int ninf,     // points caractristiques
	int nsup,     //     du filtrage
	int sens, 	// sens de remplissage
	int avecPreacc, // VRAI si preaccentuation
   int beforeLastSpectrum);
   
int cepstrePartiel(
	FLOATbuf **res,  // les resultats
	SAMPLEbuf& cnv_, // signal d'entree
	long cnv_debut,
	int nb_cepstre,	// nombre de cepstres a calculer
 	long decal, 	// decalage entre deux cepstres
        int fen_signal_, // taille de la fenetre signal
	int fen_fft1, // 1re fenetre fft (avant liftrage)
   int fen_fft2, // 2me fenetre fft (avant liftrage)
   int fen_fft3, // 3me fentre fft (aprs liftrage)
	int ninf,         // points caractristiques
	int nsup,         //     du filtrage
	int sens, 	// sens de remplissage
  	int avecPreacc,	// VRAI si preaccentuation
   int beforeLastSpectrum);

// dans le fichier cepstre2.cpp
extern int cepstre256(	/* Calcul de spectres lisses
                                     cepstralement sur 256 points */
	FLOATbuf **res, // les resultats
	SAMPLE *cnv,	// signal d'entree
	long cnv_debut, 
	int nb_cepstre,	// nombre de cepstres a calculer
 	long decal, 	// decalage entre deux cepstres (en nb d'echt) 
	int nb_cep_inf, // points caractristiques
	int nb_cep_sup, //     du filtrage
	int sens, 	// sens de remplissage
  	int avecPreacc);// VRAI si preaccentuation 
// dans le fichier cepstre5.cpp
extern int cepstre512(	/* Calcul de spectres lisses
                                     cepstralement sur 512 points */
	FLOATbuf **res, // les resultats
	SAMPLE *cnv,	// signal d'entree
	long cnv_debut,
	int nb_cepstre,	// nombre de cepstres a calculer 
        long decal, 	// decalage entre deux cepstres (en nb d'echt)
	int nb_cep_inf, // points caractristiques
	int nb_cep_sup, //     du filtrage
	int sens, 	// sens de remplissage
        int avecPreacc);// VRAI si preaccentuation 
// dans le fichier fband.cpp
extern void fband(
	int n,        // ordre de LPC */
	float *coef,  // les coefficients de LPC de 0 a` n */
	float fe,     // fe:freq d'echantillonnage, bmax:bande max */
	float bmax,
	float wa,     // les bornes wa=0, wb=fe/2 en cas normal. */
	float wb,
	float *freq,  // freqs et bandes, freq[0]=band[0]=nb
	float *band); //                   de formants
// dans le fichier fftgen.cpp
extern void fftGen(
	FLOATbuf& x, FLOATbuf& y,
	int ordre, int log2Ordre);
extern void initFftGen(
	int ordre,
	int log2Ordre,
	int isign,
	float ); //rayon) paramtre non utilis
// dans le fichier root.cpp
extern void root(
	float *a,    /* tableau contenant les coefficients */
	int n,       /* nb de element du tableau - 1 */
	float *b);   /* resultat. */
// dans le fichier seleclp.cpp
void seleclp(
	int np,        /* nombre de points d'entree */
	int ordp,      /* l'ordre de LPCSELEC */
	float wa,      /* frontiere d'analyse */
	float wb,
	float fech,    /* frequence d'echantionnage */
	float *sig_,   /* signal d'entree */
	float *err,    /* erreur de LPC */
	float *coefp_); /* les coefficients */
extern int ordre_lpcsel_msTOecht(float ordre_ms
			,unsigned int fmin
			,unsigned int fmax);
// dans le fichier specfft.cpp
extern void specFft(
	SAMPLEbuf& z,	   /* signal temporel brut */
	long z_debut, 
	FLOATbuf& spec,   /* spectre calcule		*/
	bool avecPreacc,  /* true if preemphasis */
   bool withLog);    /* true if the log of the decibel scale is applied. */
extern void initSpecFft(int fen_signal_
	,int fen_fft_);
extern void freeSpecFft();
#endif
