/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier speechNspeech.cpp
//

#include "common.h"
#pragma hdrstop

#include "outils.h"
#include "signal.h"
#include "spectre.h"
#include "ed_voca.h"
#include "energyClass.h"

void Wtop::CMgetSpeechStart()
{
  HANDLE hFile, hFileMapping;
  PBYTE pbFile;
  STRING s;
  TEDVoca startDetector;

  if (!yaUnSignal) return;
  hFile = CreateFile(en_cours.nom, GENERIC_READ, FILE_SHARE_READ, NULL,
                 				 OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
  if (hFile == INVALID_HANDLE_VALUE) return;

  hFileMapping = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
  CloseHandle(hFile);

  if (hFileMapping == NULL) return;
  
  pbFile = (PBYTE) MapViewOfFile(hFileMapping, FILE_MAP_READ, 0, 0, 0);
  
  {
    int ech;
    SAMPLEbuf fenetre(1, "fenetre de signal temporel pour l'energie");

    energy en;
    int stepMs = 4,
        fen_signalMs = 32,
        fen_signal = enEcht(fen_signalMs);
      //         MinSpeech, MaxSpeechSil, MaxSilSpeech, MaxSize, MinSize, MaxSil, MinNRJ, stepMs
    startDetector.Config(50, 40, 100, -1, 150, 1000, SILENCE_SPECTRO - 10., stepMs);
    startDetector.Init();
    fenetre.newsize(fen_signal + 1);
    en.init(0., 8000., fen_signalMs);

    for (int echt = fen_signal / 2 - 1; echt < ct.tf - fen_signal; echt += enEcht(stepMs)) {
      int n, i;
      float energie;
      char* buffer = (char *) fenetre.p;

      for (i = 0; i < (fen_signal + 1) * sizeof(SAMPLE); i++)
        buffer[i] = pbFile[sizeof(SAMPLE) * (echt - fen_signal / 2 + 1) + en_cours.depl + i];
      if (en_cours.swap != SWAPINFILE)
        swap((char huge *) buffer, (fen_signal + 1) * sizeof(SAMPLE));
      if ((n = NB_BITS - en_cours.nb_bits) > 0) // left shift
        for (i = 0; i < fen_signal + 1; i++)
          fenetre[i] = fenetre[i] << n;
      startDetector.TestAFrame(en.compute(fenetre, 0), enMilli(echt));
    }
  }
  UnmapViewOfFile(pbFile);
  CloseHandle(hFileMapping);
  sprintf(s, "Date de dbut et fin de parole %d ms, %d ms",
  	       startDetector.getStartDate(), startDetector.getEndDate());
  affiche_erreur(s);
}


