/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier suivipic.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>

#include "snoori.h"
#include "signal.h"
#include "pics.h"
#include "opt_for.h"
#include "outils.h"
#include "fftlpc.h"

static void trackCepstralPeaks(
  bool withTrueEnvelope)    // true if the true envelope calculation is used.
{
  int debut, fin, nbSpec = INFINI_L,
      depl;
  if ( (ct.debRegion >= ct.finRegion)
       || !dans(ct.debRegion, ct.d_e, ct.f_e)
       || !dans(ct.finRegion, ct.d_e, ct.f_e) ) {
    // pas de rgion dlimite, on fait tout l'cran
    debut=ct.d_es;
    fin=ct.f_es;
  }
  else {
    debut=ct.debRegion;
    fin=ct.finRegion;
  }

  souris(XC_watch);
  depl = max(enEcht(opt_for.deplacement),wspectro->wsona->DXtoLX(2) - wspectro->wsona->DXtoLX(0));
  // 216!!! really stupid because it depends from the order of the cepstrum analysis. Should be changed even
  // if there is no risk.
  suivrePicsCepstre(space, debut, fin, 7, 216, (int)enEchtf(opt_for.nb_cep[0]), (int)enEchtf(opt_for.nb_cep[1]),
		   				 0., depl /* enEcht(opt_for.deplacement)*/, nbSpec, withTrueEnvelope);
  affichePicsCepstre(nbSpec, depl, //enEcht(opt_for.deplacement)
							  7, debut, 0.5, wspectro->wsona);
  if (nbSpec) logPicsCepstre();
  freePicsCepstre();
  ::InvalidateRect(PTWtop->HWindow,NULL,TRUE);
  souris(XC_top_left_arrow);
}

void Wtop::CMsuivi_pics_trueEnv()
{
  trackCepstralPeaks(true);
}
void Wtop::CMsuivi_pics_cepstres()
{
  trackCepstralPeaks(false);
}

void Wtop::CMsuivi_racines_lpc()
{
  long debut,fin;

  if ( (ct.debRegion >= ct.finRegion)
       || !dans(ct.debRegion, ct.d_e, ct.f_e)
       || !dans(ct.finRegion, ct.d_e, ct.f_e) ) {
    // pas de rgion dlimite, on fait tout l'cran
    debut=ct.d_es;
    fin=ct.f_es;
  }
  else {
    debut=ct.debRegion;
    fin=ct.finRegion;
  }

  {
    int depl,
        nbSpec=INFINI_L;

    souris(XC_watch);
    depl=max(enEcht(opt_for.deplacement), wspectro->wsona->DXtoLX(2) - wspectro->wsona->DXtoLX(0));
    suivreRacLpc(space, debut, fin, ordre_lpc_msTOecht(opt_for.or_lpc), 700., 0., depl, nbSpec);
    affRacLpc(nbSpec, depl, 700., debut, wspectro->wsona);
    if (nbSpec) logRacLpc();
    freeRacLpc();
    ::InvalidateRect(HWindow,NULL,TRUE);
    souris(XC_top_left_arrow);
  }
}

