/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier temps.cpp
//

#include "common.h"
#pragma hdrstop

#include <math.h>
#include "signal.h"
#include "outils.h"


/* pour convertir des echantillons en millisecondes */
long enMilli(long x)
{
	return((fabs(en_cours.frequence) < EPSILON) 
		? 0
		: LROUND(x / (en_cours.frequence/1000.)));
}



/* Pour convertir des millisecondes en echantillons */
long enEcht(long x)
{
	return(LROUND(x * (en_cours.frequence/1000.)));
}

/* pour convertir des echantillons en milliseconde */
/* en partant d'une valeur d'echantillon reelle */
float enMillif(float x)
{
	return((fabs(en_cours.frequence) < EPSILON) 
		? 0
		: x / (en_cours.frequence/1000.) );
}

	
/* Pour convertir des millisecondes (donnees en reels)
	   en echantillons */
float enEchtf(float x)
{
	return(x * (en_cours.frequence/1000.) );
}

