/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier test.cpp
//
#include "common.h"
#pragma hdrstop

#include <sys/stat.h>

#include "test.h"
#include "notetiq.h"
#include "format_f.h"
#include "signal.h"
#include "files.h"
#include "audio.h"

void essai()
{
}
void testSAMPLEbuf()
{ int i;
  SAMPLEbuf b(2,"b in CMtestSAMPLEbuf");
  char ch[80];

  Wmsg->wr("test SAMPLEbuf b.size==2");
  for (i=-1;i<=3;i++)
  { b[i]=i;
    sprintf(ch,"... criture b[%d]=%d",i,i);
    Wmsg->wr(ch);
  }
  for (i=-1;i<=3;i++)
  { sprintf(ch,"... lecture b[%d]=%d",i,b[i]);
    Wmsg->wr(ch);
  }
  Wmsg->wr("... b.newsize(3)");
  b.newsize(3);
  for (i=-1;i<=3;i++)
  { sprintf(ch,"... criture b[%d]=%d",i,i);
    Wmsg->wr(ch);
    b[i]=i;
  }
  for (i=-1;i<=3;i++)
  { sprintf(ch,"... lecture b[%d]=%d",i,b[i]);
    Wmsg->wr(ch);
  }
}
void sp1(char *nom,struct champ *Pchamp)
{ int i;
  char ch[80];

  sprintf(ch,"%s type=%c type_res=%c"
	  ,nom,Pchamp->type,Pchamp->type_res);
  Wmsg->wr(ch);
  switch (Pchamp->type) 
  { case ' ':Wmsg->wr("... non dfini");
             break;
    case 'c':sprintf(ch,"... libel=%s",Pchamp->x.libel);
	     Wmsg->wr(ch);
	     break;
    case 'n':for (i=0;i<Pchamp->x.val->sommet;i++)
              { switch(Pchamp->x.val->pile[i].t)
		{ case 'o':sprintf(ch,"... expr[%d]  oprateur: %d"
		                   ,i,Pchamp->x.val->pile[i].x.op);
			   break;
		  case 'n':sprintf(ch,"... expr[%d]  nombre:    %d"
		                   ,i,Pchamp->x.val->pile[i].x.val);
			   break;
		  case 'v':sprintf(ch,"... expr[%d]  variable:  %d"
		                   ,i,Pchamp->x.val->pile[i].x.var);
			   break;
		  case 'c':sprintf(ch,"... expr[%d]  constante: %d"
				   ,i,Pchamp->x.val->pile[i].x.konst);
			   break;
	        }
		Wmsg->wr(ch);
	      }
              break;
    case 'l':Wmsg->wr("lu dans fichier ???"); break;
  }
}
void affformat()
{ int f;
  char ch[80];
  infoFile infofile;

  infofile.nom[0]=0;
  infofile.nom_man[0]=0;
  infofile.nomAnnot[0]=0;
  infofile.fmt_son=0;
  infofile.fmt_phon=0;
  infofile.fmt_word=0;
  if (get_format(PTWprologue,infofile)!=IDOK) return;
  f=infofile.fmt_son;

  sprintf(ch,"nom format: %s",Fmt_par[f].nfmt);
  Wmsg->wr(ch);
  sp1("frequence",Fmt_par[f].fmt->frequence);
  sp1("debut",Fmt_par[f].fmt->debut);
  sp1("longueur",Fmt_par[f].fmt->longueur);
  sp1("nb_bits",Fmt_par[f].fmt->nb_bits);
  sp1("signal_swap",Fmt_par[f].fmt->signal_swap);
}

void aff_format_fileWAV()
{ int i,ret=0;
  PCMWAVEFORMAT waveFormat;
  MMCKINFO ck;
  HMMIO hmmio;
  char proc[]="aff_format_fileWAV()";
  char fichin[80],filename[80];
  char ch[80];

  strcpy(filename,"*.wav");
  SelectFile(PTWprologue,filename);
  sprintf(ch,"aff. format file .WAV : %s",filename);
  Wmsg->wr(ch);
  if (!isWAV(filename))
  { Wmsg->wr("... ce n'est pas un fichier .WAV");
    return;
  }

  strcpy(fichin,filename); 
  if (erboxmmioOpen(1,proc,fichin
	,hmmio=mmioOpen(filename,NULL,MMIO_READ))
	!=0)
	{ Wmsg->wr("... fichier inexistant");
	  return ;
        }

  // chunk "RIFF"
  if (ret==0)
  { ck.fccType=mmioFOURCC('W','A','V','E');
    if (erboxmmioDescend(2,proc,fichin
	,mmioDescend(hmmio,&ck,NULL,MMIO_FINDRIFF))
	!=0)
	{ Wmsg->wr("... pas de chunk RIFF");
	  ret=1;
        }
  }

  // chunk "fmt "
  if ((ret==0)&&(mmioSeek(hmmio,12,SEEK_SET)==-1)) ret=1;
  if (ret==0)
  { ck.ckid=mmioFOURCC('f','m','t',' ');
    ck.fccType=0;
    if (erboxmmioDescend(3,proc,fichin
	,mmioDescend(hmmio,&ck,NULL,0)) 
	!=0)
	{ Wmsg->wr("... pad de chunk fmt"); 
	  ret=1;
	}
        else Wmsg->wr("... il y a un chunk fmt");
  }
  if (ret==0)
  { // lire les datas du chunk "fmt "
    if (erboxmmioRead(4,proc,fichin
	,mmioRead(hmmio,(HPSTR)&waveFormat,16))
        !=0) ret=1;
  }
  if (ret==0)
  { // afficher le chunk "fmt "
    sprintf(ch,"...... wFormatTag=%d",waveFormat.wf.wFormatTag);
    Wmsg->wr(ch);
    sprintf(ch,"...... nChannels=%d",waveFormat.wf.nChannels);
    Wmsg->wr(ch);
    sprintf(ch,"...... nSamplesPerSec=%ld",waveFormat.wf.nSamplesPerSec);
    Wmsg->wr(ch);
    sprintf(ch,"...... nAvgBytesPerSec=%ld",waveFormat.wf.nAvgBytesPerSec);
    Wmsg->wr(ch);
    sprintf(ch,"...... nBlockAlign=%d",waveFormat.wf.nBlockAlign);
    Wmsg->wr(ch);
    sprintf(ch,"...... wBitsPerSample=%d",waveFormat.wBitsPerSample);
    Wmsg->wr(ch);
  }

  // chunk "data"
  if ((ret==0)&&(mmioSeek(hmmio,12,SEEK_SET)==-1)) ret=1;
  if (ret==0)
  { ck.ckid=mmioFOURCC('d','a','t','a');
    if ((i=erboxmmioDescend(6,proc,fichin
	  ,mmioDescend(hmmio,&ck,NULL,MMIO_FINDCHUNK)))
	  !=0) ret=1;
    if (i!=0) Wmsg->wr("... pas de chunk data");
    else Wmsg->wr("... il y a un chunk data");
  }

  // chunk "text"
  if ((ret==0)&&(mmioSeek(hmmio,12,SEEK_SET)==-1)) ret=1;
  if (ret==0)
  {  ck.ckid=mmioFOURCC('t','e','x','t');
    i=mmioDescend(hmmio,&ck,NULL,MMIO_FINDCHUNK);
    if (i!=0) Wmsg->wr("... pas de chunk text");
    else Wmsg->wr("... il y a un chunk text");
  }

  // chunk "phon"
  if ((ret==0)&&(mmioSeek(hmmio,12,SEEK_SET)==-1)) ret=1;
  if (ret==0)
  { ck.ckid=mmioFOURCC('p','h','o','n');
    i=mmioDescend(hmmio,&ck,NULL,MMIO_FINDCHUNK);
    if (i!=0) Wmsg->wr("... pas de chunk phon");
    else Wmsg->wr("... il y a un chunk phon");
  }

  //
  erboxmmioClose(7,proc,fichin
		    ,mmioClose(hmmio,0));

  return ; 
}
void test_aff_ct()
{ char ch[80];

  sprintf(ch,"ct.modeMemoire=%d"
	    ,ct.modeMemoire); Wmsg->wr(ch);
  sprintf(ch,"ct.tf=%ld",ct.tf); Wmsg->wr(ch);
  sprintf(ch,"ct.d_e=%ld ct.f_e=%ld",ct.d_e,ct.f_e); Wmsg->wr(ch);
  sprintf(ch,"ct.d_a=%ld ct.f_a=%ld",ct.d_a,ct.f_a); Wmsg->wr(ch);
  sprintf(ch,"ct.d_es=%ld ct.f_es=%ld",ct.d_es,ct.f_es); Wmsg->wr(ch);
}
void test_aff_en_cours()
{ char ch[80];

  sprintf(ch,"en_cours.nom=%s",en_cours.nom); Wmsg->wr(ch);
  sprintf(ch,"en_cours.nom_man=%s",en_cours.nom_man); Wmsg->wr(ch);
  sprintf(ch,"en_cours.nomAnnot=%s",en_cours.nomAnnot); Wmsg->wr(ch);
  sprintf(ch,"en_cours.depl=%ld",en_cours.depl); Wmsg->wr(ch);
  sprintf(ch,"en_cours.longueur=%ld",en_cours.longueur); Wmsg->wr(ch);
  sprintf(ch,"en_cours.etiqdepl=%ld",en_cours.etiqdepl); Wmsg->wr(ch);
  sprintf(ch,"en_cours.etiqlongueur=%ld",en_cours.etiqlongueur); Wmsg->wr(ch);
  sprintf(ch,"en_cours.notedepl=%ld",en_cours.notedepl); Wmsg->wr(ch);
  sprintf(ch,"en_cours.notelongueur=%ld",en_cours.notelongueur); Wmsg->wr(ch);
  sprintf(ch,"en_cours.nb_bits=%d",en_cours.nb_bits); Wmsg->wr(ch);
  sprintf(ch,"en_cours.frequence=%f",(float)en_cours.frequence); Wmsg->wr(ch);
  sprintf(ch,"en_cours.swap=%d",en_cours.swap); Wmsg->wr(ch);
  sprintf(ch,"en_cours.mode=%d",en_cours.mode); Wmsg->wr(ch);
}

void dump_presse_papier()
{ unsigned int i,j,k,n;
  long size;
  HANDLE h;
  unsigned char *p;
  char ch[80];

  Wmsg->wr("dbut dump_presse_papier");
  OpenClipboard(GetActiveWindow());
  for (k=0; (k=EnumClipboardFormats(k))!=0; )
  { wsprintf(ch,"format: %04x",k);
    Wmsg->wr(ch);
    h=GetClipboardData(k);
    if (h==NULL) Wmsg->wr("erreur: handle NULL");
    else
    { size=GlobalSize(h);
      wsprintf(ch,"size: %lx",size);
      Wmsg->wr(ch);
      p=(unsigned char *)GlobalLock(h);
      for (i=0,n=0; (i<0x100)&&(i<size); i+=0x10)
      { wsprintf(ch,"%03x  ",i);
	for (j=0; (j<0x10)&&((i+j)<size); j++,n++)
	  wsprintf(&ch[lstrlen(ch)],"%02x",p[i+j]);
        Wmsg->wr(ch);
      }
      if (n<size) Wmsg->wr("...");
      GlobalUnlock(h);
    }
  }
  CloseClipboard();
  Wmsg->wr("fin dump_presse_papier");
}

struct { int index;
	 char *name;
       } DevCaps[]
= { { DRIVERVERSION,"DRIVERVERSION" },
    { TECHNOLOGY,"TECHNOLOGY"       },
    { HORZSIZE,"HORZSIZE"           },
    { VERTSIZE,"VERTSIZE"           },
    { HORZRES,"HORZRES"             },
    { VERTRES,"VERTRES"             },
    { LOGPIXELSX,"LOGPIXELSX"       },
    { LOGPIXELSY,"LOGPIXELSY"       },
    { BITSPIXEL,"BITSPIXEL"         },
    { PLANES,"PLANES"               },
    { NUMBRUSHES,"NUMBRUSHES"       },
    { NUMPENS,"NUMPENS"             },
    { NUMFONTS,"NUMFONTS"           },
    { NUMCOLORS,"NUMCOLORS"         },
    { ASPECTX,"ASPECTX"             },
    { ASPECTY,"ASPECTY"             },
    { ASPECTXY,"ASPECTXY"           },
    { PDEVICESIZE,"PDEVICESIZE"     },
    { CLIPCAPS,"CLIPCAPS"           },
    { SIZEPALETTE,"SIZEPALETTE"     },
    { NUMRESERVED,"NUMRESERVED"     },
    { COLORRES,"COLORRES"           },
    { RASTERCAPS,"RASTERCAPS"       },
    { CURVECAPS,"CURVECAPS"         },
    { LINECAPS,"LINECAPS"           },
    { POLYGONALCAPS,"POLYGONALCAPS" },
    { TEXTCAPS,"TEXTCAPS"           },
    { 0,"" }
  };
 
void aff_DeviceCaps()
{ int i;
  char ch[80];
  HDC hDC;
  HWND hWnd;

  hDC=GetDC(hWnd=GetActiveWindow());
  for (i=0;DevCaps[i].name[0]!=0;i++)
  { sprintf(ch,"%s=0x%04x"
      ,                  DevCaps[i].name
      ,GetDeviceCaps(hDC,DevCaps[i].index));
    Wmsg->wr(ch);
  }
  ReleaseDC(hWnd,hDC);
}

#define PALMAX 30
void test_aff_system_palette()
{ int i,n;
  char ch[80];
  PALETTEENTRY palette[PALMAX];
  HDC hDC;
  HWND hWnd;

  hDC=GetDC(hWnd=GetActiveWindow());

  Wmsg->wr("// system palette");
  sprintf(ch,"SIZEPALETTE=%d"
	  ,GetDeviceCaps(hDC,SIZEPALETTE));
  Wmsg->wr(ch);

  n=GetSystemPaletteEntries(hDC,0
	    ,PALMAX, palette);
  for (i=0;i<n;i++)
  { sprintf(ch,"%d  red=%02x green=%02x blue=%02x flags=%02x"
		,i,palette[i].peRed,palette[i].peGreen
		  ,palette[i].peBlue,palette[i].peFlags);
    Wmsg->wr(ch);
  }

  ReleaseDC(hWnd,hDC);
}

void test_aff_default_palette()
{ char ch[80];
  int i,j;
  HPALETTE h;
  PALETTEENTRY pe[PALMAX];
  HDC hDC;
  HWND hWnd;

  hDC=GetDC(hWnd=GetActiveWindow());

  Wmsg->wr("// default palette");

  h=(HPALETTE)GetStockObject(DEFAULT_PALETTE);
  if (h==NULL)
  { sprintf(ch,"GetStockObject(DEFAULT_PALETTE)==NULL");
    Wmsg->wr(ch);
  }
  else
  { j=GetPaletteEntries(h,0,PALMAX,pe);
    sprintf(ch,"NumEntries=%d",j);
    Wmsg->wr(ch);
    for (i=0;i<min(j,PALMAX);i++)
    { sprintf(ch,"%03d  blue=%02x green=%02x red=%02x flags=%02x"
              ,i
              ,pe[i].peBlue,pe[i].peGreen
	      ,pe[i].peRed,pe[i].peFlags);
      Wmsg->wr(ch);
    }
  }

  ReleaseDC(hWnd,hDC);
}
void test_aff_notes()
{ int i;
  char ch[80];
  sprintf(ch,"// test_aff_notes() nb=%d",notes.nb);
  Wmsg->wr(ch);
  for (i=0;i<notes.nb;i++)
  { sprintf(ch,"%d  limite=%ld  texte=\"%s\"  size=%ld"
	      ,i,notes.e[i]->limite,notes.e[i]->Text()
	      ,sizeof(notes.e[i]->text));
    Wmsg->wr(ch);
  }  
}
void test_aff_etiqs()
{ char ch[80];
  sprintf(ch,"// test_aff_etiqs() nb=%d",etiqs.nb);
  Wmsg->wr(ch);
  Wmsg->wr(" crire");
}
void aff_GetFreeSpace()
{ char ch[80];
  sprintf(ch,"GetFreeSpace(0)=%ld",GetFreeSpace(0));
  Wmsg->wr(ch);
}
void test_select_dir()
{ char filename[80];
  char ch[80];

  strcpy(filename,tempdir);
  strcat(filename,"aze.tmp");
  if (SelectDir(PTWprologue,filename)==IDOK)
  { sprintf(ch,"test_select_dir() : filename=%s"
	      ,filename);
    Wmsg->wr(ch);
  }
}

//////////////////////////////////////
// test police
//
// revoir la "modalit"
// revoir les scroll des largeur et hauteur
// revoir quand on modifie le TWtext
class TWtest_police : public TFrameWindow
{ char text[40];
  d_planche *wplanche;
  int largeur, hauteur;   
  public:
    TWtest_police(PTWindowsObject AParent);
	 virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC hdc,PAINTSTRUCT&);
	 // rponses aux vnements
	 /*
	 virtual void paint(RTMessage) = [WM_USER+1];
	 */
	 LRESULT paint(WPARAM,LPARAM);
	 DECLARE_RESPONSE_TABLE(TWtest_police);
};
DEFINE_RESPONSE_TABLE1(TWtest_police,TFrameWindow)
  EV_MESSAGE(WM_USER+1,paint),
END_RESPONSE_TABLE;

TWtest_police::TWtest_police(PTWindowsObject AParent)
	:TFrameWindow(AParent,"test police")
{ int xx,yy,ww;  // coordonnes courantes dans la fentre
  int ticket=0;
  
  DisableAutoCreate();
  Attr.Style = WS_VISIBLE | DS_MODALFRAME
	       | WS_CAPTION | WS_SYSMENU;
  Attr.X = 100;
  Attr.Y = 100;
  Attr.W = 500;
  Attr.H = 300;

  largeur=7,hauteur=11;
  strcpy(text,"02468abcdpgw=ABCD-13579.:;,");

  xx=2; yy=2; 
  ww=Attr.W-6;
  new TWint(this,1,xx,yy,ww
	      ,&hauteur,"hauteur"
	      ,4,30,4,30
	      ,ticket); yy+=HNUM;
  new TWint(this,1,xx,yy,ww
	      ,&largeur,"largeur"
	      ,3,20,3,20
	      ,ticket); yy+=HNUM;
  new TWtext(this,1,xx,yy,ww,text,"texte"
              ,30,ticket); yy+=HNUM;
  wplanche=new d_planche(this);

}
void TWtest_police::Paint(TDC&, bool, TRect&) //HDC,PAINTSTRUCT&)
{
  ::MoveWindow(wplanche->HWindow,2,100,Attr.W-6,100,TRUE);
  wplanche->clear_fenetre();
  MgiHue(NOIR,wplanche);
  aff_str(wplanche,5,20,text);
  wplanche->paint();
}
LRESULT TWtest_police::paint(WPARAM,LPARAM)
{
  wplanche->SetPlancheFont(queryFont("arial", largeur, hauteur, 0));
  ::InvalidateRect(HWindow, NULL, TRUE);
  return 0;
}

void test_police()
{ PTWprologue->GetApplication(
       )->MakeWindow(new TWtest_police(PTWprologue));
}
void test_droit_ecrire()
{ char filename[80];
  strcpy(filename,"*.*");
  if (MyInputDialog("test droit criture"
		   ,"nom de fichier",filename,78))
  { struct stat buf;
    char ch[80];
    int i;
    Wmsg->wr("test_droit_ecrire");
    sprintf(ch,"... file: %s",filename);
    Wmsg->wr(ch);
    i=stat(filename,&buf);
    sprintf(ch,"...... stat()=%d st_mode=%x",i,buf.st_mode);
    Wmsg->wr(ch);
    strcpy(ch,"... fullpath: ");
    _fullpath(ch+strlen(ch),filename,60);
    Wmsg->wr(ch);
    Wmsg->wr((droit_ecrire(filename)!=0)
	     ? "... criture autorise"
             : "... criture refuse" );
  }
}

struct { void (*proc)();
	 char *text;
       } tabtest[]
= { { essai,"essai" },
    { test_droit_ecrire, "droit d'criture fichier" },
    { test_police, "test police" },
    { aff_format_fileWAV, "aff. format fileWAV" },
    { test_aff_ct, "aff. ct" },
    { test_aff_en_cours, "aff. en_cours" },
    { affformat,"aff. format" },
    { testSAMPLEbuf,"test SAMPLEbuf" },
    { aff_DeviceCaps,"aff. DeviceCaps" },
    { dump_presse_papier,"dump presse-papier" },
    { test_aff_system_palette,"aff. system_palette" },
    { test_aff_default_palette,"aff. default_palette" },
    { test_aff_notes,"aff. notes" },
    { test_aff_etiqs,"aff. etiqs" },
    { affstack,"affstack()" },
    { aff_GetFreeSpace,"GetFreeSpace(0)" },
    { test_select_dir,"test select directory" },
    { NULL,"" }
  };

////////////////////////////////////
// fentre Wseltest
//
// variables de la fentre
//     num_format
//
// les textes sont en anglais en dur
static int num_test=0;

class TWseltest : public TDialog
{   TListBox *PTlist;
  public:
	 TWseltest(PTWindowsObject AParent, LPSTR name);
    virtual bool CanClose();
    virtual void SetupWindow();
	 // rponses aux vnements
	 /*
	 virtual void HandleList(RTMessage)
          = [ID_FIRST + 101];
	 */
	 void HandleList(WPARAM code);
	 DECLARE_RESPONSE_TABLE(TWseltest);
};
DEFINE_RESPONSE_TABLE1(TWseltest,TDialog)
  EV_CHILD_NOTIFY_ALL_CODES(101,HandleList),
END_RESPONSE_TABLE;

TWseltest::TWseltest(PTWindowsObject AParent, LPSTR name)
	:TDialog(AParent,name)
{ // initialiser le contenu des contrles
  //   avec les variables correspondantes
  PTlist=new TListBox(this,101);
}
void TWseltest::SetupWindow()
{ int i;

  TDialog::SetupWindow();
  for (i=0;tabtest[i].text[0]!=0;i++)
    PTlist->AddString(tabtest[i].text);
  PTlist->SetSelIndex(num_test);
}

bool TWseltest::CanClose()
{ BOOL Valid;
  // mettre  jour les variables en extrayant
  //   leur valeur des contrles,
  //   et aprs avoir ventuellement vrifi
  //   leur validit (variable Valid)
  num_test=PTlist->GetSelIndex();
  Valid=TRUE;
  { if (num_test<0)
    { affiche_erreur("pas de test slectionn");
      Valid=FALSE;
    }
  }
  return Valid;
}
void TWseltest::HandleList(WPARAM code)
{ switch (code) //HIWORD(Msg.LParam))
  { case LBN_DBLCLK:
           CloseWindow(IDOK);
           break;
  }
}

void test()
{ PTWprologue->GetApplication(
       )->ExecDialog(new TWseltest(PTWprologue,"Wseltest"));

 (*tabtest[num_test].proc)();
}
