/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include <stdlib.h>
#include <math.h>
#include "fft_mayer.h"

#define SQR(X)  ((X) * (X))
#define fftOrder 16
main()
{
  double *original = new double[fftOrder],
			*real = new double[fftOrder],
         *real1 = new double[fftOrder],
         *imag1 = new double[fftOrder],
         *spectrum1 = new double[fftOrder],
			*spectrum = new double[fftOrder];
  float sa = 0., e = 1., s = 0.;

  for (int i = 0; i < fftOrder; i++) {
    original[i] = real1[i] = real[i] = rand() / ((float) RAND_MAX);
    imag1[i] = 0.;
  }

  for(int i = 0; i < fftOrder; i++, e *= -1) {
    sa = sa + e * real[i];
    s += real[i];
  }
  
  realfft(fftOrder, real);
  realifft(fftOrder, real);

  fft(fftOrder, real1, imag1);
  ifft(fftOrder, real1, imag1);
  for(int i = 0; i < fftOrder; i++) {
    real1[i] /= fftOrder;
    real[i] /= fftOrder;
  }
  // magnitude spectrum calculation
  spectrum[0] = 10. * log10(SQR(real[0]) + 1.e-06);
  spectrum[fftOrder / 2] = 10. * log10(SQR(real[fftOrder / 2]) + 1.e-06);
  for (int k = 1; k < fftOrder / 2; k++)
      spectrum[k] = 10. * log10(SQR(real[k]) + SQR(real[fftOrder - k]) + 1e-06);
  for (int k =  fftOrder / 2 + 1; k < fftOrder; k++)        // copy the first half onto the second half
      spectrum[k] = spectrum[fftOrder - k];
  for (int k = 0; k < fftOrder; k++)
      spectrum1[k] = 10. * log10(SQR(real1[k]) + SQR(imag1[k]) + 1e-06);
}


