/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */


// fichier toolsformants
//
#include "common.h"
#include "guiklat.h"
#include "toolsformants.h"

#define CACHE 0		/* les PP de ce formant ne sont pas visibles. */
#define LIGNE 1		/* les PP sont visibles mais on ne peut pas les selectionner. */
#define ACTIF 2		/* les PP sont visibles (y compris les points) et selectionnables. */

extern klatt_frame_t defaultFrame;
extern char *nomParamKlatt[];
int yaUneFenetreSetParam=0;

extern int etatParam[NBMAJEURS];
extern char *nomParMajeursKlatt[NBMAJEURS];
static ParametrageColor ptr[NBMAJEURS];

DEFINE_RESPONSE_TABLE1(TCourbeColor, TFrameWindow)
	EV_WM_PAINT,
END_RESPONSE_TABLE;


TCourbeColor::TCourbeColor (PTWindowsObject AParent,
		int X, int Y, int W, int H,
      ParametrageColor *p_color): TFrameWindow(AParent,"") {
	this->p_color=p_color;
   Attr.X=X;
   Attr.Y=Y;
   Attr.W=W;
   Attr.H=H;
   Attr.Style=WS_VISIBLE | WS_BORDER | WS_CHILD;
   hDCcomp=CreateCompatibleDC(NULL);
}

void TCourbeColor::Paint(TDC& dc, bool, TRect&) {
  PaintButton( *p_color);
}

void TCourbeColor::PaintButton( ParametrageColor & p){
  TBrush brush(p_color->FormantColor);
  TBrush Blackbrush(TColor::Black);
  TRect rect;
  HDC hDC=GetDC(HWindow);

  mbrush.lbStyle=BS_SOLID;
  ::GetClientRect(HWindow,&rect);

  if (etatParam[p_color->num]==CACHE) {
    mbrush.lbColor=BLANC;
    mhbrush=CreateBrushIndirect(&mbrush);
    FillRect(hDC,&rect,mhbrush);
    rect.left++;
	 rect.top++;
	 rect.right--;
	 rect.bottom--;
    mbrush.lbColor=p_color->FormantColor;
    mhbrush=CreateBrushIndirect(&mbrush);
	 FrameRect(hDC, &rect, mhbrush);
  }
  else if (etatParam[p_color->num]==LIGNE){
    mbrush.lbColor=BLANC;
    mhbrush=CreateBrushIndirect(&mbrush);
    FillRect(hDC,&rect,mhbrush);
    rect.top=rect.top+6;
    rect.bottom=rect.bottom-6;
    mbrush.lbColor=p_color->FormantColor;
    mhbrush=CreateBrushIndirect(&mbrush);
    FillRect(hDC,&rect,mhbrush);
  }
  else if (etatParam[p_color->num]==ACTIF)  {
    mbrush.lbColor=p_color->FormantColor;
    mhbrush=CreateBrushIndirect(&mbrush);
    rect.right++;
	 rect.bottom++;
    FillRect(hDC,&rect,mhbrush);
  }
  ReleaseDC(HWindow, hDC);
}

void TCourbeColor::LButDown() {
   if (etatParam[p_color->num]==0) {
      etatParam[p_color->num]= LIGNE;
      PaintButton( *p_color);
   }
   else if (etatParam[p_color->num]==1) {
      etatParam[p_color->num]= ACTIF;
      PaintButton( *p_color);
   }
   else if (etatParam[p_color->num]==2) {
      etatParam[p_color->num]= CACHE;
      PaintButton( *p_color);
   }
}

static void initParamColor() {
  for(int i = 0; i < NBMAJEURS; i++) {
   ptr[i].num = i;
   ptr[i].FormantColor= couleurParam(i);
  }
}


//////////////////////////////////////////////////
// fentre WToolsFormants
DEFINE_RESPONSE_TABLE1(WToolsFormants, TFrameWindow)
	EV_WM_LBUTTONDOWN,
   EV_CHILD_NOTIFY_ALL_CODES(1101,IDBut1),
   EV_CHILD_NOTIFY_ALL_CODES(1102,IDBut2),
   EV_CHILD_NOTIFY_ALL_CODES(1103,IDBut3),
   EV_CHILD_NOTIFY_ALL_CODES(1104,IDBut4),
   EV_CHILD_NOTIFY_ALL_CODES(1105,IDBut5),
   EV_CHILD_NOTIFY_ALL_CODES(1106,IDBut6),
   EV_CHILD_NOTIFY_ALL_CODES(1107,IDBut7),
   EV_CHILD_NOTIFY_ALL_CODES(1108,IDBut8),
   EV_CHILD_NOTIFY_ALL_CODES(1109,IDBut9),
   EV_CHILD_NOTIFY_ALL_CODES(1110,IDBut10),
   EV_CHILD_NOTIFY_ALL_CODES(1111,IDBut11),
   EV_CHILD_NOTIFY_ALL_CODES(1112,IDBut12),
   EV_CHILD_NOTIFY_ALL_CODES(1113,IDBut13),
   EV_CHILD_NOTIFY_ALL_CODES(1114,IDBut14),
   EV_CHILD_NOTIFY_ALL_CODES(1115,IDBut15),
   EV_CHILD_NOTIFY_ALL_CODES(1116,IDBut16),
   EV_CHILD_NOTIFY_ALL_CODES(1117,IDBut17),
   EV_CHILD_NOTIFY_ALL_CODES(1118,IDBut18),
   EV_CHILD_NOTIFY_ALL_CODES(1119,IDBut19),
   EV_CHILD_NOTIFY_ALL_CODES(1120,IDBut20),
   EV_CHILD_NOTIFY_ALL_CODES(1121,IDBut21),
   EV_CHILD_NOTIFY_ALL_CODES(1122,IDBut22),
   EV_CHILD_NOTIFY_ALL_CODES(1123,IDBut23),
   EV_CHILD_NOTIFY_ALL_CODES(1130,IDButUpFast),
   EV_CHILD_NOTIFY_ALL_CODES(1131,IDButUp),
   EV_CHILD_NOTIFY_ALL_CODES(1132,IDButDown),
   EV_CHILD_NOTIFY_ALL_CODES(1133,IDButDownFast),
END_RESPONSE_TABLE;

void *WToolsFormants::operator new(size_t Type_size)
{
//  if (WPF->yaUneFenetreToolsFormants) return (void *) NULL; else
  return ::operator new(Type_size); 

}

void WToolsFormants::operator delete(void *p)
{
//  if (!WPF->yaUneFenetreToolsFormants) return; else
  ::operator delete(p);
}


WToolsFormants::WToolsFormants(TWindow* window, Wpiquefor *wpique) : TFrameWindow(window, "")
{
  int x,y,w,h,dy,hd;
  int xb,wb;
  char ch[80];
  static ind=0;

  this->WPF = wpique;
  WPF->tools = this;
  if (ind==0) { initParamColor(); ind=1; }

  x=3; y=3; w=129; h=17; dy=20, hd=17+5;
  wb=w-h-1; // largeur des boutons spectres
  xb=x+wb+1; // abscisse des boutons couleurs

  iconified = true;
  wsprintf(ch,"%s",ml(1100,"Formants Tools"));
  Title=strdup(ch);

  Attr.Style=WS_VISIBLE|WS_POPUPWINDOW|WS_CAPTION
		       |WS_THICKFRAME
		       |WS_MINIMIZEBOX
		       |WS_MAXIMIZEBOX;
  Attr.X=700;
  Attr.Y=0;
  Attr.W=w+h;
  Attr.H=y+dy*(ptr[NBMAJEURS-1].num+6.25+1)+40;
  this->SetIcon(GetApplication(), IDI_ICON1);
  for (int i = 0; i < NBMAJEURS; i++) {
  		pBut[i] = &ptr[i];
      TB[i]= new TButton(this,1101 + i, nomParMajeursKlatt[i],
		       			    x, y + dy * pBut[i]->num, wb, h,FALSE);
  }

  TGB = new TGroupBox(this, 1140, "Move Formants", x, y+dy*(pBut[NBMAJEURS - 1]->num + 1.25),
  				wb+h+3, (hd*4)+(2*dy), 0);

  glyph1 = new TGlyphButton(this, 1130,""
		       ,x+(h/2),y+dy*(pBut[NBMAJEURS-1]->num+2.5),wb,hd,FALSE);
  glyph1->SetGlyph(IDB_BITMAPUF);
  glyph2 = new TGlyphButton(this,1131,""
		       ,x+(h/2),y+dy*(pBut[NBMAJEURS-1]->num+3.75),wb,hd,FALSE);
  glyph2->SetGlyph(IDB_BITMAPU);
  glyph3 = new TGlyphButton(this,1132,""
		       ,x+(h/2),y+dy*(pBut[NBMAJEURS-1]->num+5),wb,hd,FALSE);
  glyph3->SetGlyph(IDB_BITMAPD);
  glyph4 = new TGlyphButton(this,1133,""
		       ,x+(h/2),y+dy*(pBut[NBMAJEURS-1]->num+6.25),wb,hd,FALSE);
  glyph4->SetGlyph(IDB_BITMAPDF);

  for (int i = 0; i < NBMAJEURS; i++)
    TC[i] = new TCourbeColor(this, xb, y + dy * pBut[i]->num, h, h, pBut[i]);
}

WToolsFormants::~WToolsFormants()
{
   for (int i=0; i<NBMAJEURS; i++){
		delete TC[i];
		delete TB[i];
	}
   delete TGB;
   delete glyph1;
	delete glyph2;
   delete glyph3;
   delete glyph4;
   WPF->tools = (WToolsFormants *) NULL;
}

bool WToolsFormants::CanClose()
{
  active(PPMENUAllStandard);
  return true;
}

void WToolsFormants::IDBut1(WPARAM code) {
	TC[0]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut2(WPARAM code) {
	TC[1]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut3(WPARAM code) {
	TC[2]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut4(WPARAM code) {
	TC[3]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut5(WPARAM code) {
	TC[4]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut6(WPARAM code) {
	TC[5]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut7(WPARAM code) {
	TC[6]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut8(WPARAM code) {
	TC[7]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut9(WPARAM code) {
	TC[8]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut10(WPARAM code) {
	TC[9]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut11(WPARAM code) {
	TC[10]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut12(WPARAM code) {
	TC[11]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut13(WPARAM code) {
	TC[12]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut14(WPARAM code) {
	TC[13]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut15(WPARAM code) {
	TC[14]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut16(WPARAM code) {
	TC[15]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut17(WPARAM code) {
	TC[16]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut18(WPARAM code) {
	TC[17]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut19(WPARAM code) {
	TC[18]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut20(WPARAM code) {
	TC[19]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut21(WPARAM code) {
	TC[20]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut22(WPARAM code) {
	TC[21]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDBut23(WPARAM code) {
	TC[22]->LButDown();
   WPF->affPPoints();
}
void WToolsFormants::IDButUpFast(WPARAM code) {
	translatePPselectionne(10);
   WPF->affPPoints();
}
void WToolsFormants::IDButUp(WPARAM code) {
	translatePPselectionne(1);
   WPF->affPPoints();
}
void WToolsFormants::IDButDown(WPARAM code) {
	translatePPselectionne(-1);
   WPF->affPPoints();
}
void WToolsFormants::IDButDownFast(WPARAM code) {
	translatePPselectionne(-10);
   WPF->affPPoints();
}



TWParamDef::TWParamDef(PTWindowsObject AParent, LPSTR name): TDialog(AParent, name){
	yaUneFenetreSetParam=1;
   Text[0]=new TStatic (this, IDC_TEXT1);
   Text[1]=new TStatic (this, IDC_TEXT2);
   Text[2]=new TStatic (this, IDC_TEXT3);
   Text[3]=new TStatic (this, IDC_TEXT4);
   Text[4]=new TStatic (this, IDC_TEXT5);
   Text[5]=new TStatic (this, IDC_TEXT6);
   Text[6]=new TStatic (this, IDC_TEXT7);
   Text[7]=new TStatic (this, IDC_TEXT8);
   Text[8]=new TStatic (this, IDC_TEXT9);
   Text[9]=new TStatic (this, IDC_TEXT10);
   Text[10]=new TStatic (this, IDC_TEXT11);
   Text[11]=new TStatic (this, IDC_TEXT12);
   Text[12]=new TStatic (this, IDC_TEXT13);
   Text[13]=new TStatic (this, IDC_TEXT14);
   Text[14]=new TStatic (this, IDC_TEXT15);
   Text[15]=new TStatic (this, IDC_TEXT16);
   Text[16]=new TStatic (this, IDC_TEXT17);
   Text[17]=new TStatic (this, IDC_TEXT18);
   Text[18]=new TStatic (this, IDC_TEXT19);

   TextEdit[0]=new TEdit(this, IDC_EDIT1);
   TextEdit[1]=new TEdit(this, IDC_EDIT2);
   TextEdit[2]=new TEdit(this, IDC_EDIT3);
   TextEdit[3]=new TEdit(this, IDC_EDIT4);
   TextEdit[4]=new TEdit(this, IDC_EDIT5);
   TextEdit[5]=new TEdit(this, IDC_EDIT6);
   TextEdit[6]=new TEdit(this, IDC_EDIT7);
   TextEdit[7]=new TEdit(this, IDC_EDIT8);
   TextEdit[8]=new TEdit(this, IDC_EDIT9);
   TextEdit[9]=new TEdit(this, IDC_EDIT10);
   TextEdit[10]=new TEdit(this, IDC_EDIT11);
   TextEdit[11]=new TEdit(this, IDC_EDIT12);
   TextEdit[12]=new TEdit(this, IDC_EDIT13);
   TextEdit[13]=new TEdit(this, IDC_EDIT14);
   TextEdit[14]=new TEdit(this, IDC_EDIT15);
   TextEdit[15]=new TEdit(this, IDC_EDIT16);
   TextEdit[16]=new TEdit(this, IDC_EDIT17);
   TextEdit[17]=new TEdit(this, IDC_EDIT18);
   TextEdit[18]=new TEdit(this, IDC_EDIT19);
}

TWParamDef::~TWParamDef()
{
  for (int i = 0; i < NBPAR_KLATT_DEFAULT; i++) {
    delete Text[i];
    delete TextEdit[i];
  }
}

DEFINE_RESPONSE_TABLE1(TWParamDef,TDialog)
   EV_CHILD_NOTIFY_ALL_CODES(IDOK,IDok),
   EV_CHILD_NOTIFY_ALL_CODES(IDCANCEL,IDcancel),
   EV_WM_CLOSE,
END_RESPONSE_TABLE;

void TWParamDef::SetupWindow(){
   char _tempo_[10]="";
   TDialog::SetupWindow();

   Text[0]->SetText(nomParamKlatt[F0hz10_]);
   itoa(defaultFrame.F0hz10, _tempo_, 10);
   TextEdit[0]->SetText(_tempo_);

   Text[1]->SetText(nomParamKlatt[AVdb_]);
   itoa(defaultFrame.AVdb, _tempo_, 10);
   TextEdit[1]->SetText(_tempo_);

   Text[2]->SetText(nomParamKlatt[FNZhz_]);
   itoa(defaultFrame.FNZhz, _tempo_, 10);
   TextEdit[2]->SetText(_tempo_);

   Text[3]->SetText(nomParamKlatt[BNZhz_]);
   itoa(defaultFrame.BNZhz, _tempo_, 10);
   TextEdit[3]->SetText(_tempo_);

   Text[4]->SetText(nomParamKlatt[FNPhz_]);
   itoa(defaultFrame.FNPhz, _tempo_, 10);
   TextEdit[4]->SetText(_tempo_);

   Text[5]->SetText(nomParamKlatt[BNPhz_]);
   itoa(defaultFrame.BNPhz, _tempo_, 10);
   TextEdit[5]->SetText(_tempo_);

   Text[6]->SetText(nomParamKlatt[ASP_]);
   itoa(defaultFrame.ASP, _tempo_, 10);
   TextEdit[6]->SetText(_tempo_);

   Text[7]->SetText(nomParamKlatt[Kopen_]);
   itoa(defaultFrame.Kopen, _tempo_, 10);
   TextEdit[7]->SetText(_tempo_);

   Text[8]->SetText(nomParamKlatt[Aturb_]);
   itoa(defaultFrame.Aturb, _tempo_, 10);
   TextEdit[8]->SetText(_tempo_);

   Text[9]->SetText(nomParamKlatt[TLTdb_]);
   itoa(defaultFrame.TLTdb, _tempo_, 10);
   TextEdit[9]->SetText(_tempo_);

   Text[10]->SetText(nomParamKlatt[AF_]);
   itoa(defaultFrame.AF, _tempo_, 10);
   TextEdit[10]->SetText(_tempo_);

   Text[11]->SetText(nomParamKlatt[Kskew_]);
   itoa(defaultFrame.Kskew, _tempo_, 10);
   TextEdit[11]->SetText(_tempo_);

   Text[12]->SetText(nomParamKlatt[ANP_]);
   itoa(defaultFrame.ANP, _tempo_, 10);
   TextEdit[12]->SetText(_tempo_);

   Text[13]->SetText(nomParamKlatt[AB_]);
   itoa(defaultFrame.AB, _tempo_, 10);
   TextEdit[13]->SetText(_tempo_);

   Text[14]->SetText(nomParamKlatt[AVpdb_]);
   itoa(defaultFrame.AVpdb, _tempo_, 10);
   TextEdit[14]->SetText(_tempo_);

   Text[15]->SetText(nomParamKlatt[Gain0_]);
   itoa(defaultFrame.Gain0, _tempo_, 10);
   TextEdit[15]->SetText(_tempo_);

   Text[16]->SetText(nomParamKlatt[Ra_]);
   itoa(defaultFrame.Ra, _tempo_, 10);
   TextEdit[16]->SetText(_tempo_);

   Text[17]->SetText(nomParamKlatt[Rk_]);
   itoa(defaultFrame.Rk, _tempo_, 10);
   TextEdit[17]->SetText(_tempo_);

   Text[18]->SetText(nomParamKlatt[Rg_]);
   itoa(defaultFrame.Rg, _tempo_, 10);
   TextEdit[18]->SetText(_tempo_);
}

void TWParamDef::IDok(WPARAM){
   defaultFrame.F0hz10=VerifVal(TextEdit[0],0, 1000, defaultFrame.F0hz10);
   defaultFrame.AVdb=VerifVal(TextEdit[1], 0, 70, defaultFrame.AVdb);
   defaultFrame.FNZhz=VerifVal(TextEdit[2], 248, 528, defaultFrame.FNZhz);
   defaultFrame.BNZhz=VerifVal(TextEdit[3], 40, 1000, defaultFrame.BNZhz);
   defaultFrame.FNPhz=VerifVal(TextEdit[4], 100, 528, defaultFrame.FNPhz);
   defaultFrame.BNPhz=VerifVal(TextEdit[5], 40, 1000, defaultFrame.BNPhz);
   defaultFrame.ASP=VerifVal(TextEdit[6], 0, 70, defaultFrame.ASP);
   defaultFrame.Kopen=VerifVal(TextEdit[7], 0, 60, defaultFrame.Kopen);
   defaultFrame.Aturb=VerifVal(TextEdit[8], 0, 80, defaultFrame.Aturb);
   defaultFrame.TLTdb=VerifVal(TextEdit[9], 0, 24, defaultFrame.TLTdb);
   defaultFrame.AF=VerifVal(TextEdit[10], 0, 80, defaultFrame.AF);
   defaultFrame.Kskew=VerifVal(TextEdit[11], 0, 40, defaultFrame.Kskew);
   defaultFrame.ANP=VerifVal(TextEdit[12], 0, 100, defaultFrame.ANP);
   defaultFrame.AB=VerifVal(TextEdit[13], 0, 80, defaultFrame.AB);
   defaultFrame.AVpdb=VerifVal(TextEdit[14], 0, 70, defaultFrame.AVpdb);
   defaultFrame.Gain0=VerifVal(TextEdit[15], 0, 80, defaultFrame.Gain0);
   defaultFrame.Ra=VerifVal(TextEdit[16], 0, 20, defaultFrame.Ra);
   defaultFrame.Rk=VerifVal(TextEdit[17], 0, 70, defaultFrame.Rk);
   defaultFrame.Rg=VerifVal(TextEdit[18], 50, 200, defaultFrame.Rg);

	CloseWindow();
}

void TWParamDef::IDcancel(WPARAM){
   CloseWindow();
}

bool TWParamDef::CanClose(){
   yaUneFenetreSetParam=0;
   active(PPMENUAllStandard);
  	return true;
}


void TWParamDef::CloseWindow() {
   TDialog::CloseWindow();
}

void TWParamDef::EvClose() {
   yaUneFenetreSetParam=0;
   active(PPMENUAllStandard);
   TDialog::EvClose();
}



int TWParamDef::VerifVal(TEdit* TextTest,int ValMin, int ValMax, int ValDef) {
 	int a;
   char StrTemp[10]="";

   TextTest->GetText(StrTemp,10);
   a=atoi(StrTemp);
   if ((a<ValMin)||(a>ValMax)) {
      itoa(ValDef, StrTemp, 10);
		TextTest->SetText(StrTemp);
   	a=ValDef;
      }
   return (a);
}

