/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier toolsformants.h
//

#ifndef _TOOLSFORMANTS_H
#define _TOOLSFORMANTS_H
#include <owl\glyphbtn.h>

//define des images sur les boutons
#define IDB_BITMAPUF 1145
#define IDB_BITMAPU 1146
#define IDB_BITMAPD 1147
#define IDB_BITMAPDF 1148

extern int yaUneFenetreSetParam;

struct ParametrageColor {
  /*	int etat; // invisible =0, non modifiable =1, modifiable =2*/
	int num;  // numro d'emplacement
	COLORREF FormantColor; // couleur de la courbe
};

class TCourbeColor: TFrameWindow {
public:
	ParametrageColor *p_color;
   HDC hDCcomp;
   LOGBRUSH mbrush;
   HBRUSH mhbrush;
   TCourbeColor (PTWindowsObject AParent, int X, int Y, int W, int H,
   					ParametrageColor *p_color);
   virtual void Paint(TDC& dc, bool erase, TRect& rect);
   void PaintButton( ParametrageColor & p);
   void LButDown();
	DECLARE_RESPONSE_TABLE(TCourbeColor);
};

//////////////////////////////////////////////////
// fentre WToolsFormants

class WToolsFormants : public TFrameWindow {
public:
    ParametrageColor *pBut[NBMAJEURS];
    TCourbeColor *TC[NBMAJEURS];
    TGlyphButton* glyph1, *glyph2, *glyph3, *glyph4;
    TGroupBox *TGB;
    TButton *TB[NBMAJEURS];
    int iconified;
    class Wpiquefor* WPF;

	 WToolsFormants(TWindow *WPF, Wpiquefor *wpique);
	 ~WToolsFormants();
    void * operator new(size_t Type_size);
    void operator delete(void *p);
	 virtual bool CanClose();
    void IDBut1(WPARAM code);     
    void IDBut2(WPARAM code);
    void IDBut3(WPARAM code);
    void IDBut4(WPARAM code);
    void IDBut5(WPARAM code);
    void IDBut6(WPARAM code);
    void IDBut7(WPARAM code);
    void IDBut8(WPARAM code);
    void IDBut9(WPARAM code);
    void IDBut10(WPARAM code);
    void IDBut11(WPARAM code);
    void IDBut12(WPARAM code);
    void IDBut13(WPARAM code);
    void IDBut14(WPARAM code);
    void IDBut15(WPARAM code);
    void IDBut16(WPARAM code);
    void IDBut17(WPARAM code);
    void IDBut18(WPARAM code);
    void IDBut19(WPARAM code);
    void IDBut20(WPARAM code);
    void IDBut21(WPARAM code);
    void IDBut22(WPARAM code);
    void IDBut23(WPARAM code);
    void IDButUpFast(WPARAM code);
    void IDButUp(WPARAM code);
    void IDButDown(WPARAM code);
    void IDButDownFast(WPARAM code);
    DECLARE_RESPONSE_TABLE(WToolsFormants);
};

#define NBPAR_KLATT_DEFAULT 19
class TWParamDef:public TDialog{
	TStatic* Text[NBPAR_KLATT_DEFAULT];
   TEdit* TextEdit[NBPAR_KLATT_DEFAULT];

	public :
   TWParamDef(PTWindowsObject AParent,LPSTR name);
   ~TWParamDef();
   virtual void SetupWindow();
   virtual bool CanClose();

   int VerifVal(TEdit* TextTest,int ValMin, int ValMax, int ValDef);
   void IDok(WPARAM);
   void IDcancel(WPARAM);
   virtual void CloseWindow();
   virtual void EvClose();
   DECLARE_RESPONSE_TABLE(TWParamDef);
};

#endif
