/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier trad_x.cpp
//

#include "common.h"
#pragma hdrstop

#include <stdio.h>
#include <string.h>

// ce fichier contient les anciennes versions de
//   l'interface graphique pour crire dans les
//   fentres d_planche. Sauf exception, prfrer
//   la nouvelle fonction membre correspondante
//   de d_planche, et donc ne plus utiliser les
//   fonctions de ce fichier.

static int der_x,der_y;
static int line_thick_width=1;

void snovcoor(float x_min, float y_min,
              float x_max, float y_max,
              d_planche *d)
     /* fixer les coordonnees d'une fenetre
        (point en bas a gauche, et point en
	haut a droite) */
{ d->xmin = x_min;
  d->ymin = y_min;
  d->xmax = x_max;
  d->ymax = y_max;
  d->xecart = x_max-x_min;
  d->yecart = y_max-y_min;
}
void snovcoorx(float x_min,
              float x_max, 
              d_planche *d)
     /* fixer les coordonnees d'une fenetre
        (point en bas a gauche, et point en
	haut a droite) */
{ d->xmin = x_min;
  d->xmax = x_max;
  d->xecart = x_max-x_min;
}
void snovcoory(float y_min,
              float y_max,
              d_planche *d)
     /* fixer les coordonnees d'une fenetre
        (point en bas a gauche, et point en
	haut a droite) */
{ d->ymin = y_min;
  d->ymax = y_max;
  d->yecart = y_max-y_min;
}

void snop(float x, float y, d_planche *d)
     /* dessiner un point dans la fenetre d */
{ int xx,yy;

  xx=(int)((x-d->xmin)/d->xecart*d->largeur+0.5);
  yy=(int)((y-d->ymin)/d->yecart*d->hauteur+0.5);
  yy = d->hauteur - yy -1;
  SetPixel(d->hDCcomp, xx, yy, d->couleurpixel);
  der_x = xx;
  der_y = yy;
}

void snol1(float x, float y, d_planche *d)
	/* dessine une ligne depuis le dernier point
                atteint par le dessin */
{

  int xx,yy;
  xx=(int)((x-d->xmin)/d->xecart*d->largeur+0.5);
  yy=(int)((y-d->ymin)/d->yecart*d->hauteur+0.5);
  yy = d->hauteur - yy -1;
  MoveToEx(d->hDCcomp,der_x,der_y, (POINT *) NULL);
  LineTo(d->hDCcomp,xx,yy);
  SetPixel(d->hDCcomp,xx,yy,d->couleurpixel);
  der_x = xx;
  der_y = yy;
}


void MgiHue(COLORREF col, d_planche *d)
	/* choisir la couleur */
{
  d->SetForegroundColor(col);
}


void snogetvcoor(float *xmin, float *ymin,
                 float *xmax, float *ymax,
                 d_planche *d) 
     /* recupere le systeme de coordonnees indiquees
				      par l'utilisateur */
{
  *xmin = d->xmin;
  *ymin = d->ymin;
  *xmax = d->xmax;
  *ymax = d->ymax;
}
void snoil(int x1, int y1, int x2, int y2,
	   d_planche *d)
{ int xx1,xx2,yy1,yy2;

  xx1=x1;
  yy1=y1; 
  xx2=x2;
  yy2=y2; 
  MoveToEx(d->hDCcomp,xx1,yy1, (POINT *) NULL);
  LineTo(d->hDCcomp,xx2,yy2);
  SetPixel(d->hDCcomp,xx2,yy2,d->couleurpixel);
  der_x = x2;
  der_y = y2; 
}

void snol(float x1, float y1, float x2, float y2,
          d_planche *d)
	/* dessiner une ligne donnee par ses 2 points */
{
  int xx1,yy1,xx2,yy2;
  xx1=(int)((x1-d->xmin)/d->xecart*d->largeur+0.5);
  yy1=(int)((y1-d->ymin)/d->yecart*d->hauteur+0.5);
  xx2=(int)((x2-d->xmin)/d->xecart*d->largeur+0.5);
  yy2=(int)((y2-d->ymin)/d->yecart*d->hauteur+0.5);
  yy1 = d->hauteur - yy1 -1;
  yy2 = d->hauteur - yy2 -1;
  MoveToEx(d->hDCcomp,xx1,yy1, (POINT *) NULL);
  LineTo(d->hDCcomp,xx2,yy2);
  SetPixel(d->hDCcomp,xx2,yy2,d->couleurpixel);
  der_x=xx2;
  der_y=yy2;
}

void snoibox(int x1, int y1, int x2, int y2,
             d_planche *d)
{ int temp;
  
  if (x1>x2) {temp=x1;x1=x2;x2=temp;}
  if (y1>y2) {temp=y1;y1=y2;y2=temp;}
  YFillRectangle(d->hDCcomp, x1, y1,
                 (unsigned int) (x2 - x1 + 1),
		 (unsigned int) (y2 - y1 + 2),
		 d->hMyBrush);
  der_x = x1;
  der_y = y1;
}

void snorbox(float x1, float y1, float x2, float y2,
             d_planche *d)
{ int xx1,yy1,xx2,yy2;
  int temp;
  
  xx1=(int)((x1-d->xmin)/d->xecart*d->largeur+0.5);
  yy1=(int)((y1-d->ymin)/d->yecart*d->hauteur+0.5);
  xx2=(int)((x2-d->xmin)/d->xecart*d->largeur+0.5);
  yy2=(int)((y2-d->ymin)/d->yecart*d->hauteur+0.5);
  if (xx1>xx2) {temp=xx1;xx1=xx2;xx2=temp;}
  yy1 = d->hauteur - yy1 -1;
  yy2 = d->hauteur - yy2 -1;
  if (yy1>yy2) {temp=yy1;yy1=yy2;yy2=temp;}
  YFillRectangle(d->hDCcomp, xx1, yy1,
                 (unsigned int) (xx2 - xx1 + 1),
		 (unsigned int) (yy2 - yy1 + 1),
		 d->hMyBrush);
  der_x=xx1;
  der_y=yy1;
}

void snorrect(float x1, float y1, float x2, float y2,
              d_planche *d)
{
  int xx1,yy1,xx2,yy2;
  int temp;
  
  xx1=(int)((x1-d->xmin)/d->xecart*d->largeur+0.5);
  yy1=(int)((y1-d->ymin)/d->yecart*d->hauteur+0.5);
  xx2=(int)((x2-d->xmin)/d->xecart*d->largeur+0.5);
  yy2=(int)((y2-d->ymin)/d->yecart*d->hauteur+0.5);
  if (xx1>xx2) {temp=xx1;xx1=xx2;xx2=temp;}
  yy1 = d->hauteur - yy1 -1;
  yy2 = d->hauteur - yy2 -1;
  if (yy1>yy2) {temp=yy1;yy1=yy2;yy2=temp;}
  YDrawRectangle(d->hDCcomp, xx1, yy1,
                 (unsigned int) (xx2 - xx1 + 1),
		 (unsigned int) (yy2 - yy1 + 1),
		 d->hMyBrush);
  der_x=xx1;
  der_y=yy1;
}

void snorgfs(float x, float y,
             char *blockn,
             d_planche *d)
	 /* afficher une chaine de caracteres
			    a un point donne en coord reelles */
{
  int xx,yy;
  xx=(int)((x-d->xmin)/d->xecart*d->largeur+0.5);
  yy=(int)((y-d->ymin)/d->yecart*d->hauteur+0.5);
  yy = d->hauteur - yy - 1;
  aff_str(d, xx, yy, blockn);
}

void snoigfs(int x, int y,
             char *blockn,
             d_planche *d)
	/* afficher une chaine de caracteres
			      a un point donne en coord entieres */
{
  aff_str(d , x, y, blockn);
}



int snoscalex(d_planche *d, float x)
{
  return((int)((x - d->xmin) / d->xecart * d->largeur + 0.5));
}

int snoscaley(d_planche *d, float y)
	/* transforme une coordonnee reelle en
		       une coordonnee entiere  */
{
  return(d->hauteur
         -(int)((y-d->ymin)/d->yecart*d->hauteur+0.5) );
}

void snoiunscalexy(int x, int y,
		   float *xr, float *yr,
    		   d_planche *d)
     /* pour transformer des coordonnees entieres
        en coordonnees reelles */
{
  if(x<=0) *xr = d->xmin;
  else if (x >= d->largeur) *xr = d->xmax;
  else *xr = x*d->xecart/d->largeur+d->xmin;
  if(y <= 0) *yr = d->ymax;
  else if (y >= d->hauteur) *yr = d->ymin;
  else *yr = (d->hauteur - y - 1.)
             / ((float) d->hauteur) * d->yecart + d->ymin;
}

void snorfc(float x, float y, float rx, float ry,
            d_planche *d)
     /* dessiner une ellipse pleine
        (donnee par le centre et les rayons) */
{
  int xx, yy, rxx, ryy;
  xx = (int)((x - d->xmin - rx / 2.)/d->xecart*d->largeur+0.5);
  yy = (int)((y - d->ymin + ry / 2.)/d->yecart*d->hauteur+0.5);
  yy = d->hauteur - yy -1;
  rxx = (int) (rx / d->xecart * d->largeur + 0.5);  
  ryy = (int) (ry / d->yecart * d->hauteur + 0.5);

  Ellipse(d->hDCcomp,xx-rxx,yy-ryy,xx+rxx,yy+ryy);

  der_x = xx;
  der_y = yy;
}

snortl( // dessin d'une ligne epaisse donne
        //   par ses deux points
     float x1,float y1,float x2,float y2,
     d_planche *d)
{
  d->SetPenWidth(line_thick_width);
  MoveToEx(d->hDCcomp,d->LXtoDX(x1),d->LYtoDY(y1),(POINT *) NULL);
  LineTo(d->hDCcomp,der_x=d->LXtoDX(x2),der_y=d->LYtoDY(y2));
  d->SetPenWidth(0);
  return 0;
}

void snoiwidth(int width)
// pour fixer la largeur d'une ligne 
{ line_thick_width = width;
}



void snorp(float x, float y, d_planche *d)
	 /* dessiner un point */
{
  int xx,yy;
  xx=(int)((x-d->xmin)/ d->xecart * d->largeur + 0.5);
  yy=(int)((y-d->ymin)/d->yecart*d->hauteur+0.5);
  yy = d->hauteur - yy -1;
  SetPixel(d->hDCcomp,xx,yy,d->couleurpixel);
  der_x=xx;
  der_y=yy;
}

void snorl1(float x, float y, d_planche *d)
	/* dessiner une ligne depuis le dernier
		   point atteint par le dessin */
{ int xx,yy;
  xx=(int)((x-d->xmin)/d->xecart*d->largeur+0.5);
  yy=(int)((y-d->ymin)/d->yecart*d->hauteur+0.5);
  yy = d->hauteur - yy -1;
  MoveToEx(d->hDCcomp,der_x,der_y, (POINT *) NULL);
  LineTo(d->hDCcomp,xx,yy);
  SetPixel(d->hDCcomp,xx,yy,d->couleurpixel);
  der_x=xx;
  der_y=yy;
}
