/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier util_x.cpp
//

#include "common.h"

#pragma hdrstop

#include <stdio.h>
#include <fcntl.h>
//#include <varargs.h>
#include <stdio.h>

#include "signal.h"
#include "files.h"
#include "notetiq.h"


void aff_str(d_planche *d, // procedure permettant l'affichage
                      //   d'une chaine de caracteres
     int x, int y,
     char *mess)
{
  if(mess)
    TextOut(d->hDCcomp, x, y, mess, strlen(mess));
}

///////////////////////////////////////////////
// d_planche
//
DEFINE_RESPONSE_TABLE1(d_planche,TFrameWindow)
  EV_WM_SIZE,
END_RESPONSE_TABLE;

d_planche::d_planche(PTWindowsObject AParent)
       : TFrameWindow (AParent,"")
{
  Attr.Style = WS_VISIBLE | WS_CHILD | WS_BORDER;

  Attr.X=0;
  Attr.Y=0;
  Attr.W=2;
  Attr.H=2;
  //
  LButtonDown=FALSE;

  //
  largeur=0;
  hauteur=0;

  snovcoor(0,0,1,1,this);
  
  hDCcomp = CreateCompatibleDC(NULL);
  ctp = (struct ctrl_temps *) NULL;
}

d_planche::~d_planche()
{
  freebitmap();
  // librer pen, brush
  SelectObject(hDCcomp, holdpen);
  DeleteObject(hMyPen);
  SelectObject(hDCcomp, holdbrush);
  DeleteObject(hMyBrush);
  // No desctruction of the font because fonts are stored to avoid memory garbage
  SelectObject(hDCcomp, holdfont);
  DeleteDC(hDCcomp);
}

void d_planche::SetupWindow()
{
  HDC hDC;
  RECT rect;

  hDC = GetDC(HWindow);
  ::GetClientRect(HWindow,&rect);
  SelectPalette(hDC,hpalGris,FALSE);
  RealizePalette(hDC);
  ReleaseDC(HWindow, hDC);

  SelectPalette(hDCcomp,hpalGris,FALSE);
  RealizePalette(hDCcomp);
  //
  // initialiser pixel, pen, brush
  couleurpixel = NOIR;
  // GetObject(GetStockObject(BLACK_PEN),sizeof(LOGPEN),&MyPen);
  MyPen.lopnWidth.x = 1;
  MyPen.lopnStyle = PS_SOLID;
  MyPen.lopnColor = NOIR;
  penoldwidth=  MyPen.lopnWidth.x;
  hMyPen = CreatePenIndirect(&MyPen);
  holdpen =(HPEN) SelectObject(hDCcomp, hMyPen);

  MyBrush.lbStyle = BS_SOLID;
  MyBrush.lbColor = NOIR;
  hMyBrush = CreateBrushIndirect(&MyBrush);
  holdbrush = (HBRUSH) SelectObject(hDCcomp, hMyBrush);

  hMyFont = queryFont("arial", 7, 13, 0);
  holdfont = (HFONT) SelectObject(hDCcomp, hMyFont);
}

void d_planche::paint()
{
  CopyArea_Dbw(this,0,0,largeur,hauteur,0,0,GXcopy);
}

void d_planche::Paint(TDC&, bool, TRect&) //HDC,PAINTSTRUCT&)
{
  paint();
}

void d_planche::allocbitmap()
{
  RECT rect;
  HDC hDC;

  ::GetClientRect(HWindow,&rect);
  hDC = GetDC(HWindow);
  largeur = rect.right+1;
  hauteur = rect.bottom+1;
  if ((largeur>1)&&(hauteur>1)) {
    hbitmap = CreateCompatibleBitmap(hDC,largeur,hauteur);
    holdbitmap = (HBITMAP)SelectObject(hDCcomp, hbitmap);
  }
  ReleaseDC(HWindow,hDC);
}

void d_planche::freebitmap()
{
  if ((largeur>1)&&(hauteur>1)) {
    SelectObject(hDCcomp, holdbitmap);
    DeleteObject(hbitmap);
  }
}

void d_planche::EvSize(uint, TSize&) //WMSize(RTMessage)
{
  unsigned int prevlargeur, prevhauteur;
  HBITMAP prevhbitmap, holdbitmap2;
  HDC hDCcomp2;

  if ((largeur > 1) && (hauteur > 1)) SelectObject(hDCcomp, holdbitmap);
  prevlargeur = largeur;
  prevhauteur = hauteur;
  prevhbitmap = hbitmap;

  SetForegroundColor(NOIR);
  allocbitmap();
  clear_fenetre();
  if ((prevlargeur>1)&&(prevhauteur>1)) {
    if (yaUnSignal) {
      hDCcomp2=CreateCompatibleDC(hDCcomp);
      holdbitmap2=(HBITMAP)SelectObject(hDCcomp2,prevhbitmap);
      StretchBlt(hDCcomp,0,0,largeur,hauteur
	        ,hDCcomp2,0,0,prevlargeur,prevhauteur
	        ,SRCCOPY);
      SelectObject(hDCcomp2, holdbitmap2);
      DeleteDC(hDCcomp2);
    }
    DeleteObject(prevhbitmap);
  }
  //
  SetBkMode(hDCcomp,TRANSPARENT);
  SetTextAlign(hDCcomp,TA_LEFT&TA_TOP);
  //
}

void d_planche::clear_fenetre()
{
  BitBlt(hDCcomp,0,0,largeur,hauteur,NULL,0,0,WHITENESS);
}

void d_planche::SetForegroundColor(COLORREF color)
{
  HPEN hpen;
  couleurpixel = color;
  MyPen.lopnColor = color;
  MyBrush.lbColor = color;
  //
  hpen = (HPEN) SelectObject(hDCcomp, holdpen);  // on met l'ancien pen
  DeleteObject(hMyPen);           // on detruit le pen qui vient de servir
  hMyPen = CreatePenIndirect(&MyPen);
  SelectObject(hDCcomp, hMyPen);    // on remet le nouveau pen mis a jour
  //
  SelectObject(hDCcomp, holdbrush);
  DeleteObject(hMyBrush);
  hMyBrush=CreateBrushIndirect(&MyBrush);
  SelectObject(hDCcomp,hMyBrush);
  //
  SetTextColor(hDCcomp,color);
}

void d_planche::SetPlancheFont(HFONT hf)
{
  SelectObject(hDCcomp, hf);
}

void d_planche::SetPenWidth(int width)
{
  MyPen.lopnWidth.x = width;
  //
  SelectObject(hDCcomp, holdpen);
  DeleteObject(hMyPen);
  hMyPen = CreatePenIndirect(&MyPen);
  SelectObject(hDCcomp, hMyPen);
}

void d_planche::ResetPenWidth()
{
  SetPenWidth(penoldwidth);
}

/////////////////////////////////////////
// fonctions graphiques de d_planche
//
// les coordonnes sont donnes
//   en pixel (in() pour les fonctions D***
//       0 des y en haut
//   en logique (float) pour les fonctions L***
//       0 des y dduit de Lcoory()
//       en gnral y croissant vers le haut
//
void d_planche::Lpoint(float x,float y) //snop() snorp()
{
  int xx=LXtoDX(x),yy=LYtoDY(y);
  SetPixel(hDCcomp,xx,yy,couleurpixel);
  der_x=xx; der_y=yy;
}

void d_planche::Lline1(float x, float y) //snol1() snorl1()
// dessiner une ligne donne par un point (la destination)
//     depuis le dernier point atteint par le dessin
{ int xx=LXtoDX(x),yy=LYtoDY(y);
  MoveToEx(hDCcomp,der_x,der_y, (POINT *) NULL);
  LineTo(hDCcomp,xx,yy);
  SetPixel(hDCcomp,xx,yy,couleurpixel);
  der_x=xx; der_y=yy;
}

void d_planche::Dline2(int x1,int y1
                      ,int x2,int y2) //snoil()
// dessiner une ligne donne par ses 2 points
{ MoveToEx(hDCcomp,x1,y1,(POINT *) NULL);
  LineTo(hDCcomp,x2,y2);
  SetPixel(hDCcomp,x2,y2,couleurpixel);
  der_x=x2; der_y=y2;
}

void d_planche::Lline2(float x1,float y1
                      ,float x2,float y2) //snol()
// dessiner une ligne donnee par ses 2 points 
{
  Dline2(LXtoDX(x1),LYtoDY(y1)
        ,LXtoDX(x2),LYtoDY(y2));
}

void d_planche::Dfillrect(int x1, int y1
                         ,int x2, int y2) //snoibox()
{ int temp;
  if (x1>x2) {temp=x1;x1=x2;x2=temp;}
  if (y1>y2) {temp=y1;y1=y2;y2=temp;}
  YFillRectangle(hDCcomp, x1, y1,
                 (unsigned int) (x2 - x1 + 1),
		 (unsigned int) (y2 - y1 + 2),
		 hMyBrush);
  der_x = x1; der_y = y1;
}

void d_planche::Lfillrect(float x1, float y1
                         ,float x2, float y2) //snorbox
{
  Dfillrect(LXtoDX(x1),LYtoDY(y1)
           ,LXtoDX(x2),LYtoDY(y2));
}

void d_planche::Lrect(float x1, float y1
                     ,float x2, float y2) //snorrect()
{
  int xx1=LXtoDX(x1),yy1=LYtoDY(y1)
     ,xx2=LXtoDX(x2),yy2=LYtoDY(y2);
  int temp;
  if (xx1>xx2) {temp=xx1;xx1=xx2;xx2=temp;}
  if (yy1>yy2) {temp=yy1;yy1=yy2;yy2=temp;}
  YDrawRectangle(hDCcomp, xx1, yy1,
                 (unsigned int) (xx2 - xx1 + 1),
		 (unsigned int) (yy2 - yy1 + 1),
		 hMyBrush);
  der_x=xx1; der_y=yy1;
}

void d_planche::DTextOut(
  int x,
  int y,
  char *ch)
//aff_str() snoigfs()
// afficher une chaine de caracteres
//     a un point donne en coord entieres 
{
  if (ch) TextOut(hDCcomp, x, y, ch, strlen(ch));
}

void d_planche::LTextOut(float x, float y
                        ,char *ch) //snorgfs()
// afficher une chaine de caracteres
//     a un point donne en coord reelles 
{
  DTextOut(LXtoDX(x), LYtoDY(y), ch);
}

void d_planche::Lellipse(float x, float y
                        ,float rx, float ry) //snorfc()
// dessiner une ellipse pleine
//     (donnee par le centre et les rayons)
{ int x1=LXtoDX(x-rx), y1=LYtoDY(y-ry);
  int x2=LXtoDX(x+rx), y2=LYtoDY(y+ry);
  Ellipse(hDCcomp,min(x1,x2),min(y1,y2)
                 ,max(x1,x2),max(y1,y2));
}
//
// correspondance entre espaces physique et logique
//
//   soit d dfini par: d_planche *d;
//   on a:
//     d->xmin logique correspond  0 physique
//     d->xmax logique correspond  d->largeur physique
//     d->ymin logique correspond  d->hauteur-1 physique
//     d->ymax logique correspond  -1 physique
// de plus, si rect est le rectangle obtenu
//   par GetClientRect(), on a:
//     d->largeur==rect.right+1
//     d->hauteur==rect.bottom+1
// et les points visibles  l'cran sont:
//   en x physique, de 0  largeur-1
//   en y physique, de 0  hauteur-1
//
//
////////////////////////////////////////////////
// LcoorxD() et LcooryD() servent  donner les
// coordonnes logiques L de deux points 1 et 2 de 
// la fentre dont on donne aussi les coordonnes
// physiques D 
//
void d_planche::setLXcoorD(float LX1, float LX2, int DX1, int DX2)
// le point d'abscisse logique LX1 a pour abscisse physique DX1
// idem pour LX2 et DX2
// DX1 doit tre diffrent de DX2
//   ce cas est cependant trait pour viter les plantages,
//   mais ne correspond pas  une utilisabilit relle
// quations de base
//   (LX2-xmin)/(LX2-LX1)=DX2/(DX2-DX1)
//   (xmax-LX1)/(LX2-LX1)=(largeur-DX1)/(DX2-DX1) 
{ int d=DX2-DX1;
  if (d==0) d=1; 
  RECT rect;
  ::GetClientRect(HWindow,&rect);
  xmin=(LX1*DX2-LX2*DX1)/d;
  xmax=(LX1*DX2-LX2*DX1+(LX2-LX1)*(rect.right+1))/d;
  xecart=xmax-xmin;
}
void d_planche::setLYcoorD(float LY1, float LY2, int DY1, int DY2)
// le point de coordonne logique LY1 a pour coordonne physique DY1
// idem pour LY2 et DY2
// DY1 doit tre diffrent de DY2
//   ce cas est cependant trait pour viter les plantages,
//   mais ne correspond pas  une utilisabilit relle
// quations de base
//   (LY2-ymin)/(LY2-LY1)=(DY2-(hauteur-1))/(DY2-DY1)
//   (ymax-LY1)/(LY2-LY1)=(-1-DY1)/(DY2-DY1)
{ int d=DY2-DY1;
  if (d==0) d=1; 
  RECT rect;
  ::GetClientRect(HWindow,&rect);
  ymax=(LY1*DY2-LY2*DY1+LY1-LY2)/d;
  ymin=(LY1*DY2-LY2*DY1+(LY2-LY1)*rect.bottom)/d;
  yecart=ymax-ymin;
}

///////////////////////////////////////////////////
// classe d_plancheTmp
//
d_plancheTmp::d_plancheTmp(d_planche *d)
{ this->d=d;
  hDCcomp=CreateCompatibleDC(NULL); 
  if (!hDCcomp)
    affiche_bug("d_plancheTmp() hDCcomp==NULL");
  //
  allocbitmap();
}
d_plancheTmp::~d_plancheTmp()
{ freebitmap();
  DeleteDC(hDCcomp);
}
void d_plancheTmp::allocbitmap()
{ largeur=d->largeur;
  hauteur=d->hauteur;
  if ((largeur>1)&&(hauteur>1))
  { hbitmap=CreateCompatibleBitmap(d->hDCcomp
		,largeur,hauteur);
    holdbitmap=(HBITMAP)SelectObject(hDCcomp,hbitmap);
  }
}
void d_plancheTmp::freebitmap()
{ if ((largeur>1)&&(hauteur>1))
  { SelectObject(hDCcomp,holdbitmap);
    DeleteObject(hbitmap);
  }
}
void d_plancheTmp::WMSize()
{ unsigned int prevlargeur,prevhauteur;
  HBITMAP prevhbitmap,holdbitmap2;
  HDC hDCcomp2;

  if ((largeur>1)&&(hauteur>1))
    SelectObject(hDCcomp,holdbitmap);
  prevlargeur=largeur;
  prevhauteur=hauteur;
  prevhbitmap=hbitmap;

  allocbitmap();
  clear_fenetre();
  if ((prevlargeur>1)&&(prevhauteur>1))
  { if (yaUnSignal)
    { hDCcomp2=CreateCompatibleDC(hDCcomp);
      holdbitmap2=(HBITMAP)SelectObject(hDCcomp2,prevhbitmap);
      StretchBlt(hDCcomp,0,0,largeur,hauteur
	        ,hDCcomp2,0,0,prevlargeur,prevhauteur
	        ,SRCCOPY);
      SelectObject(hDCcomp2,holdbitmap2);
      DeleteDC(hDCcomp2);
    }
    DeleteObject(prevhbitmap);
  }
}

void d_plancheTmp::clear_fenetre()
{ BitBlt(hDCcomp,0,0,largeur,hauteur,NULL,0,0,WHITENESS);
}
////////////// fin classe d_plancheTmp

void SetScrollSpectroPosition(long echt)
// cas particulier :
//   si !yaUnSignal remet  zro le slider
{
  int loval,hival,ipos;
  long lpos;

  scroll_spectro->GetRange(loval,hival);

  if (!yaUnSignal)
  { scroll_spectro->SetPosition(loval);
    return;
  }

  lpos=loval + LROUND( (echt/(float)ct.tf)
		       *(hival-(float)loval) );
  ipos=(int)max(loval,min(hival,lpos));
  scroll_spectro->SetPosition(ipos);
  //
  // amplitudes de dfilement
  //   petite : 1/10me d'cran
  //   grande : un demi cran
  scroll_spectro->LineMagnitude
    =max(1,(int)min(6000,
       (hival-(float)loval)*((ct.f_a-ct.d_a)/10.)
       /ct.tf ));
  scroll_spectro->PageMagnitude
    =max(1,(int)min(32000,
       (hival-(float)loval)*((ct.f_a-ct.d_a)/2.)
       /ct.tf ));
}


void desactiveMenusSeuls(int id)
{
  if (id>0)
    // menuitem
    EnableMenuItem(GetMenu(PTWtop->HWindow)
		 ,(UINT) id, (UINT) MF_GRAYED);
  else
    // popup
    switch (id){
        case PPMENUFile:
				 desactiveMenusSeuls(MENUNew);
				 desactiveMenusSeuls(MENUOpen);
				 desactiveMenusSeuls(MENUSave);
		       desactiveMenusSeuls(MENUSaveAs);
		       desactiveMenusSeuls(MENUCopyToFile);
		       desactiveMenusSeuls(MENUPasteFromFile);
             desactiveMenusSeuls(MENURemoveDC);
			  break;
      case PPMENUEdit: desactiveMenusSeuls(MENUUndo);
		       desactiveMenusSeuls(MENUCut);
		       desactiveMenusSeuls(MENUCopy);
		       desactiveMenusSeuls(MENUPaste);
		       desactiveMenusSeuls(MENUDelete);
		       desactiveMenusSeuls(MENUAmortirGauche);
		       desactiveMenusSeuls(MENUAmortirCentre);
		       desactiveMenusSeuls(MENUAmortirDroite);
//		       desactiveMenusSeuls(MENUFiltreSignal);
				 desactiveMenusSeuls(MENUEditingTools);
				 desactiveMenusSeuls(MENUResampling);
		       desactiveMenusSeuls(MENUEcoute);
		       desactiveMenusSeuls(MENUEcoute1Fois);   
             desactiveMenusSeuls(MENUPlayFile);
             desactiveMenusSeuls(MENUGetSpeechStart);
		       desactiveMenusSeuls(MENUFreqEchant);
		       desactiveMenusSeuls(MENUZoomin);        
		       desactiveMenusSeuls(MENUAllerA);
		       desactiveMenusSeuls(MENUZoomout);
                          break;
      case PPMENUSpectro:
		       desactiveMenusSeuls(MENUspFFTL        );
		       desactiveMenusSeuls(MENUspFFTE        );
		       desactiveMenusSeuls(MENUspREASS       );
		       desactiveMenusSeuls(MENUspLPC         );
		       desactiveMenusSeuls(MENUspCEP         );
		       desactiveMenusSeuls(MENUspGROLIS      );
		       desactiveMenusSeuls(MENUspGRONONLIS   );
             desactiveMenusSeuls(MENUClearSpectro  );
             desactiveMenusSeuls(MENUSaveSpectrogram  );
             desactiveMenusSeuls(MENUspCRITICALBANDS);
			  break;
      case PPMENULabels:
		       desactiveMenusSeuls(MENUEtiqLire         );
		       desactiveMenusSeuls(MENUEtiqAff          );
		       desactiveMenusSeuls(MENUEtiqSauver       );
		       desactiveMenusSeuls(MENUEtiqChercher     );
			  break;
      case PPMENUNotes:
		       desactiveMenusSeuls(MENUNoteLire         );
		       desactiveMenusSeuls(MENUNoteSauver       );
		       desactiveMenusSeuls(MENUNoteChercher     );
			  break;
      case PPMENUFormants:
			desactiveMenusSeuls(MENUAffFormants);
			desactiveMenusSeuls(MENUSuiviPicsCep);
         desactiveMenusSeuls(MENUSuiviPicsTrueEnv);
			desactiveMenusSeuls(MENUSuiviRacinesLPC);
			desactiveMenusSeuls(MENUAffCoupe);
			// desactiveMenusSeuls(MENUEditFormants);
			  break;
      case PPMENUProsody:
      	desactiveMenusSeuls(MENUTypeOfSpeaker);
         desactiveMenusSeuls(MENUChOptProso);
			desactiveMenusSeuls(MENUF0Screen);
         desactiveMenusSeuls(MENUItereF0);
         desactiveMenusSeuls(MENUPitchmEchelle);
         desactiveMenusSeuls(MENUOpenPitchFile);
         desactiveMenusSeuls(MENUDispPitchValues);
         desactiveMenusSeuls(MENUF0Modifications);
         desactiveMenusSeuls(MENUPitchScaleMod);
         desactiveMenusSeuls(MENUPitchMarker);
         desactiveMenusSeuls(MENUDispMarks);
         desactiveMenusSeuls(MENUEnergy);
           break;
      case PPMENUDivers:
			  // desactiveMenusSeuls(MENUMire);
           // desactiveMenusSeuls(MENUOptions);
           break;
      case PPMENUAllStandard:
      	desactiveMenusSeuls(PPMENUEdit);
         desactiveMenusSeuls(PPMENUFormants);
         desactiveMenusSeuls(PPMENUProsody);
         desactiveMenusSeuls(PPMENULabels);
         desactiveMenusSeuls(PPMENUNotes);
         desactiveMenusSeuls(PPMENUSpectro);
         desactiveMenusSeuls(PPMENUDivers);
		   desactiveMenusSeuls(PPMENUFile);
		   break;
    }
}

void desactiveVraimentTout()
{
  desactiveMenusSeuls(MENUNew);
  desactiveMenusSeuls(MENUOpen);
  desactiveMenusSeuls(MENUSave);
  desactiveMenusSeuls(MENUSaveAs);
  desactiveMenusSeuls(MENUCopyToFile);
  desactiveMenusSeuls(MENUPasteFromFile);
  desactiveMenusSeuls(MENURemoveDC);
  desactiveMenusSeuls(MENUCopyPostscipt);
  desactiveMenusSeuls(MENUExit);
  desactiveMenusSeuls(MENUUndo);
  desactiveMenusSeuls(MENUCut);
  desactiveMenusSeuls(MENUCopy);
  desactiveMenusSeuls(MENUPaste);
  desactiveMenusSeuls(MENUDelete);
  desactiveMenusSeuls(MENUAmortirGauche);
  desactiveMenusSeuls(MENUAmortirCentre);
  desactiveMenusSeuls(MENUAmortirDroite);
//  desactiveMenusSeuls(MENUFiltreSignal);
  desactiveMenusSeuls(MENUEditingTools);
  desactiveMenusSeuls(MENUResampling);
  desactiveMenusSeuls(MENUEcoute);
  desactiveMenusSeuls(MENUEcoute1Fois);
  desactiveMenusSeuls(MENUPlayFile);
  desactiveMenusSeuls(MENUGetSpeechStart);
  desactiveMenusSeuls(MENUFreqEchant);
  desactiveMenusSeuls(MENUZoomin);
  desactiveMenusSeuls(MENUAllerA);
  desactiveMenusSeuls(MENUZoomout);
  desactiveMenusSeuls(MENUspFFTL);
  desactiveMenusSeuls(MENUspREASS);
  desactiveMenusSeuls(MENUSaveSpectrogram);
  desactiveMenusSeuls(MENUspCRITICALBANDS);
  desactiveMenusSeuls(MENUspLPC);
  desactiveMenusSeuls(MENUspCEP);
  desactiveMenusSeuls(MENUspGROLIS);
  desactiveMenusSeuls(MENUspGRONONLIS);
  desactiveMenusSeuls(MENUClearSpectro);
  desactiveMenusSeuls(MENUconsDECO);
  desactiveMenusSeuls(MENUsuppDECO);
  desactiveMenusSeuls(MENUEtiqLire);
  desactiveMenusSeuls(MENUEtiqAff);
  desactiveMenusSeuls(MENUEtiqSauver);
  desactiveMenusSeuls(MENUEtiqHelp);
  desactiveMenusSeuls(MENUEtiqChangerTexte);
  desactiveMenusSeuls(MENUEtiqAjouterLimite);
  desactiveMenusSeuls(MENUEtiqEffacerLimite);
  desactiveMenusSeuls(MENUEtiqChangerLimite);
  desactiveMenusSeuls(MENUEtiqChercher);
  desactiveMenusSeuls(MENUEtiqExploreCorpus);
  desactiveMenusSeuls(MENUNoteLire);
  desactiveMenusSeuls(MENUNoteSauver);
  desactiveMenusSeuls(MENUNoteHelp);
  desactiveMenusSeuls(MENUNoteChangerTexte);
  desactiveMenusSeuls(MENUNoteAjouterLimite);
  desactiveMenusSeuls(MENUNoteEffacerLimite);
  desactiveMenusSeuls(MENUNoteChangerLimite);
  desactiveMenusSeuls(MENUNoteChercher);
  desactiveMenusSeuls(MENUNoteExploreCorpus);
  desactiveMenusSeuls(MENUAffFormants);
  desactiveMenusSeuls(MENUSuiviPicsCep);
  desactiveMenusSeuls(MENUSuiviPicsTrueEnv);
  desactiveMenusSeuls(MENUSuiviRacinesLPC);
  desactiveMenusSeuls(MENUChangeParamAnaSpec);
  desactiveMenusSeuls(MENUAffCoupe);
  desactiveMenusSeuls(MENUEditFormants);
  desactiveMenusSeuls(MENUPitchmEchelle);
  desactiveMenusSeuls(MENUF0Modifications);
  desactiveMenusSeuls(MENUReadPitchFile);
  desactiveMenusSeuls(MENUSeeF0Contour);
  desactiveMenusSeuls(MENUModifF0Contour);
  desactiveMenusSeuls(MENUCurrentPitch);
  desactiveMenusSeuls(MENUSaveF0Contour);
  desactiveMenusSeuls(MENUResynth);
  desactiveMenusSeuls(MENUDetails);
  desactiveMenusSeuls(MENUMire);
  desactiveMenusSeuls(MENUOptions);
  desactiveMenusSeuls(MENUAppendLog1ToLog);
  desactiveMenusSeuls(MENUShowLog);
  desactiveMenusSeuls(MENUShowLog1);
  desactiveMenusSeuls(MENUHelp);
  desactiveMenusSeuls(MENUHelpOnHelp);
  desactiveMenusSeuls(MENUsauveFor);
  desactiveMenusSeuls(IDM_MENU2);
  desactiveMenusSeuls(MENUTry2);
  desactiveMenusSeuls(MENUTry1);
  desactiveMenusSeuls(IDM_MENU1);
  desactiveMenusSeuls(MENUAideSouris);
  desactiveMenusSeuls(MENUlireFor);
  desactiveMenusSeuls(MENUdetruireFor);
  desactiveMenusSeuls(MENUrecalForLISCEP);
  desactiveMenusSeuls(MENUrecalForRACLPC);
  desactiveMenusSeuls(MENUlisseFor);
  desactiveMenusSeuls(MENUselectF6);
  desactiveMenusSeuls(MENUselectF5);
  desactiveMenusSeuls(MENUselectF4);
  desactiveMenusSeuls(MENUselectF3);
  desactiveMenusSeuls(MENUselectF2);
  desactiveMenusSeuls(MENUselectF1);
  desactiveMenusSeuls(MENUselectTous);
  desactiveMenusSeuls(MENUselectAucun);
  desactiveMenusSeuls(MENUhelpMouse);
  desactiveMenusSeuls(MENUpas16ms);
  desactiveMenusSeuls(MENUpas8ms);
  desactiveMenusSeuls(MENUpas4ms);
  desactiveMenusSeuls(MENUSaveF0Contour);
  desactiveMenusSeuls(MENUProsodyHelp);
  //desactiveMenusSeuls(MENUItereEnergie);
  desactiveMenusSeuls(MENUEnergy);
  desactiveMenusSeuls(MENUFOModifs);
  //desactiveMenusSeuls(MENUOptionsEnergie);
  //desactiveMenusSeuls(MENUAfficheEner);
  desactiveMenusSeuls(MENUChOptProso);
  desactiveMenusSeuls(MENUOpenPitchFile);
  desactiveMenusSeuls(MENUPitchScaleMod);
  desactiveMenusSeuls(MENUDispMarks);
  desactiveMenusSeuls(MENUDispPitchValues);
  desactiveMenusSeuls(MENUTypeOfSpeaker);
  desactiveMenusSeuls(MENUPitchMarker);
  desactiveMenusSeuls(MENUItereF0);
  desactiveMenusSeuls(MENUCorpusF0);
  desactiveMenusSeuls(MENUTimeModif);
  desactiveMenusSeuls(MENUMarks);
  desactiveMenusSeuls(MENUF0Screen);
  desactiveMenusSeuls(MENUFOModifs);
  desactiveMenusSeuls(MENUOptionsSpec);
  desactiveMenusSeuls(MENUFunctions);
}


void desactive(int id)
{
  desactiveMenusSeuls(id);
  if (id == PPMENUAllStandard) {
    isEtiqModifiable=FALSE;
    isNoteModifiable=FALSE;
  }
}

void active(int id)
{ if (id>0)
    // menuitem
    EnableMenuItem(GetMenu(PTWtop->HWindow)
		 ,(UINT) id, (UINT) MF_ENABLED);
  else
    // popup
    switch (id)
    { case PPMENUFile:
				 active(MENUNew);
				 active(MENUOpen);
				 active(MENUSave);
		       active(MENUSaveAs);
		       active(MENUCopyToFile);
		       active(MENUPasteFromFile);
             active(MENURemoveDC);
			  break;
      case PPMENUEdit: active(MENUUndo);
		       active(MENUCut);
		       active(MENUCopy);
		       active(MENUPaste);
		       active(MENUDelete);
		       active(MENUAmortirGauche);
		       active(MENUAmortirCentre);
		       active(MENUAmortirDroite);
//		       active(MENUFiltreSignal);
				 active(MENUEditingTools);
				 active(MENUResampling);
		       active(MENUEcoute);
		       active(MENUEcoute1Fois);
             active(MENUPlayFile);
             active(MENUGetSpeechStart);
		       active(MENUFreqEchant);
		       active(MENUZoomin);
		       active(MENUAllerA);
		       active(MENUZoomout);
                          break;
      case PPMENUSpectro:
		       active(MENUspFFTL        );
		       active(MENUspFFTE        );
		       active(MENUspREASS       );
		       active(MENUspLPC         );
		       active(MENUspCEP         );
		       active(MENUspGROLIS      );
		       active(MENUspGRONONLIS   );
             active(MENUClearSpectro  );
             active(MENUconsDECO);
             active(MENUsuppDECO);
             active(MENUSaveSpectrogram);
             active(MENUspCRITICALBANDS);
			  break;
      case PPMENULabels:
		       active(MENUEtiqLire         );
		       active(MENUEtiqAff          );
		       active(MENUEtiqSauver       );
		       active(MENUEtiqChercher     );
             active(MENUEtiqExploreCorpus);
			  break;
      case PPMENUNotes:
		       active(MENUNoteLire         );
		       active(MENUNoteSauver       );
		       active(MENUNoteChercher     );
             active(MENUNoteExploreCorpus);
			  break;
      case PPMENUFormants:
		       active(MENUAffFormants);
		       active(MENUSuiviPicsCep);
             active(MENUSuiviPicsTrueEnv);
		       active(MENUSuiviRacinesLPC);
		       active(MENUAffCoupe);
		       active(MENUEditFormants);
           break;
      case PPMENUProsody:
      		 active(MENUTypeOfSpeaker);
             active(MENUChOptProso);
             active(MENUF0Screen);
             active(MENUItereF0);
             active(MENUCorpusF0);
             active(MENUOpenPitchFile);
             active(MENUPitchmEchelle);
             active(MENUDispPitchValues);
             active(MENUPitchScaleMod);
  				 active(MENUF0Modifications);
             active(MENUFOModifs);
				 active(MENUReadPitchFile);
  				 active(MENUCurrentPitch);
  				 active(MENUSeeF0Contour);
             active(MENUModifF0Contour);
             active(MENUTimeModif);
         	 active(MENUPitchMarker);
         	 active(MENUDispMarks);
             active(MENUMarks);
             active(MENUEnergy);
           break;
      case PPMENUDivers:
             active(MENUDetails);
			    active(MENUMire);
             active(MENUOptions);
             active(MENUShowLog1);
             active(MENUAppendLog1ToLog);
             active(MENUShowLog);
             active(MENUFunctions);
           break;
      case PPMENUHelp:
             active(MENUHelp);
  				 active(MENUHelpOnHelp);
  				 active(MENUAbout);
           break;
      case PPMENUTJSACTIFS:
             active(PPMENUDivers);
             active(PPMENUHelp);
             active(MENUNoteExploreCorpus);
             active(MENUNoteHelp);
             active(MENUEtiqExploreCorpus);
             active(MENUCorpusF0);
             active(MENUEtiqHelp);
             active(MENUOptionsSpec);
             active(MENUChangeParamAnaSpec);
           break;
      case PPMENUAllStandard:
                   active(PPMENUEdit);
                   active(PPMENUFormants);
                   active(PPMENUProsody);
                   active(PPMENULabels);
                   active(PPMENUNotes);
                   active(PPMENUSpectro);
                   active(PPMENUFile);
		             isEtiqModifiable=TRUE;;
                   isNoteModifiable=TRUE;

	       if (!droit_ecrire(en_cours.nom)) {
            desactive(MENUSave);
		      desactive(MENUPasteFromFile);
            desactive(MENUUndo);
		      desactive(MENUCut);
		      desactive(MENUPaste);
		      desactive(MENUDelete);
		      desactive(MENUAmortirGauche);
		      desactive(MENUAmortirCentre);
		      desactive(MENUAmortirDroite);
//		      desactive(MENUFiltreSignal);
	       }
	       if (isWAV(en_cours.nom) && !droit_ecrire(en_cours.nom)) {
            desactive(MENUEtiqLire);
		      desactive(MENUNoteLire);
		      isEtiqModifiable=FALSE;
            isNoteModifiable=FALSE;
	       }

               break;
    }
}


void CopyArea_Dbw(d_planche *d // copie de d->hbitmap
                               //     vers d->w
                  ,int xsrc, int ysrc
		  ,int width, int height
		  ,int xdest, int ydest
		  ,DWORD dwRop)
{
 HDC hDC;

  hDC=GetDC(d->HWindow);
  SelectPalette(hDC,hpalGris,FALSE);
  RealizePalette(hDC);
  BitBlt(hDC,xdest,ydest,width,height
	 ,d->hDCcomp,xsrc,ysrc,dwRop);
  ReleaseDC(d->HWindow,hDC);
}
void InvertArea(HWND hWnd,int x,int y,int dx,int dy)
{ HDC hDC;

  hDC=GetDC(hWnd);
  BitBlt(hDC,x,y,dx,dy,NULL,0,0,DSTINVERT);
  ReleaseDC(hWnd,hDC);
}

void YFillRectangle(HDC hDC, int x, int y,
		    int width,int height,HBRUSH hbrush)
{ RECT rect;

  rect.left=x; rect.top=y;
  rect.right=x+width; rect.bottom=y+height;
  FillRect(hDC,&rect,hbrush);
}
void YDrawRectangle(HDC hDC, int x, int y,
		    int width,int height,HBRUSH hbrush)
{ RECT rect;

  rect.left=x; rect.top=y;
  rect.right=x+width; rect.bottom=y+height;
  FrameRect(hDC,&rect,hbrush);
}

void souris(const char *type)
// Make the target cursor
//   and may hide the Wactpourcent window
{ SetCursor(LoadCursor(NULL,type));
  if (type==XC_top_left_arrow)
    Wact->hidepourcent();
}
int textheight(HDC hDC, char *text)
{
	SIZE size;
	GetTextExtentPoint(hDC,text,strlen(text),&size);
	return((int) size.cy);
}

int textwidth(HDC hDC, char *text)
{
	SIZE size;
	GetTextExtentPoint(hDC,text,strlen(text), &size);
   return((int) size.cx);
}
