/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier wi.h
//
#ifndef _WI_H
#define _WI_H

// formes du curseur de la souris
#define XC_pirate IDC_CROSS
#define XC_top_left_arrow IDC_ARROW
#define XC_hand1 IDC_UPARROW
#define XC_watch IDC_WAIT

// raster operation pour les CopyArea
#define GXcopy SRCCOPY
#define GXxor SRCINVERT
#define GXarevoir SRCCOPY

////////////////////////////////////////////////
// variables
//
// fichier util_x.cpp
extern HBRUSH hSBrush; // brosse pour mise en surbrillance

class d_planche : public TFrameWindow
{ public:
    HDC hDCcomp;
    COLORREF couleurpixel;
    HBITMAP hbitmap,holdbitmap;
    LOGPEN MyPen;
	 HPEN hMyPen,holdpen;
    int penoldwidth;

    LOGBRUSH MyBrush;
	 HBRUSH hMyBrush,holdbrush;

    HFONT hMyFont, holdfont;

	 unsigned int //Dimension
	       largeur, hauteur ;
	 float       xmin, ymin, xmax, ymax
	      , xecart, yecart;
    int der_x,der_y;
    bool LButtonDown;  // bouton gauche
    bool RButtonDown;  // bouton droit
    bool shift,ctrl;
    struct ctrl_temps *ctp; // pointeur vers le reperage eventuel
    d_planche(PTWindowsObject AParent);
    ~d_planche();
    virtual void SetupWindow();
	 void paint();
	 virtual void Paint(TDC& dc, bool, TRect&); //HDC,PAINTSTRUCT&);
	 //
	 void allocbitmap();
    void freebitmap();
    void clear_fenetre();
    void SetForegroundColor(COLORREF color);
    void SetPenWidth(int width);
    void ResetPenWidth();
    void SetPlancheFont(HFONT hf);
    void setLXcoor(float left,float right)
                        { xmin=left; xmax=right;
			  xecart=right-left;
			} 
    void setLYcoor(float bottom,float top)
                        { ymin=bottom; ymax=top;
			  yecart=top-bottom;
			} 
    void setLXcoorD(float LX1, float LX2, int DX1, int DX2);
    void setLYcoorD(float LY1, float LY2, int DY1, int DY2);
    void getLXcoor(float& LX1, float& LX2)
		{ LX1=xmin; LX2=xmax; }
    void getLYcoor(float& LY1, float& LY2)
		{ LY1=ymin; LY2=ymax; }
    // conversion d'une coordonnee en pixel vers une coordonnee reelle.  
	 float DXtoLX(int x) { return (x<=0) ? xmin
			    : ( (x>=largeur) ?  xmax
			      : x*xecart/largeur+xmin );
                        }
	 float DXpixtoLXre(int x) {
    	return (x*xecart/largeur);
                        }
    float DYtoLY(int y) { return (y<=0) ? ymax
			    : ( (y>=hauteur) ? ymin
                              : (hauteur-y-1.)
			        /((float)hauteur)*yecart
				+ymin );
                        }
    int LXtoDX(float x) { return
			   (int)((x-xmin)/xecart*largeur
			         +0.5); }
    int LYDtoDY(float y) { return
			   (int)(y / yecart * hauteur
			         +0.5); }
    int LYtoDY(float y) { return hauteur-1
			  -(int)((y-ymin)/yecart*hauteur
				 +0.5); }
    void Lpoint(float x,float y);
    void Lline1(float x, float y);
    void Dline2(int x1,int y1,int x2,int y2);
	 void Lline2(float x1, float y1,float x2, float y2);
    void Dfillrect(int x1,int y1,int x2,int y2);
	 void Lfillrect(float x1,float y1,float x2,float y2);
    void Lrect(float x1,float y1,float x2,float y2);
	 void DTextOut(int x,int y,char *ch);
	 void LTextOut(float x,float y,char *ch);
	 void Lellipse(float x,float y,float rx,float ry);
	 //
	 // rponses aux vnements
	 //virtual void WMSize(RTMessage) = [WM_FIRST+WM_SIZE];
	 void EvSize(uint sizeType, TSize &size);
	 DECLARE_RESPONSE_TABLE(d_planche);
};

class d_planche_dblclk : public d_planche
{ public:
	 bool LButtonDblClk; // bouton gauche double-click

	 d_planche_dblclk(PTWindowsObject AParent)
	: d_planche(AParent) { LButtonDblClk=FALSE; }
	 virtual LPSTR GetClassName()
		  { return "d_planche_dblclk"; }
	 virtual void GetWindowClass(WNDCLASS _FAR & AWndClass)
	{ TFrameWindow::GetWindowClass(AWndClass);
	  AWndClass.style |= CS_DBLCLKS;
		  }
};

class d_plancheTmp
// contient un bitmap compatible avec celui
//   d'une fentre d_planche
// pas de resize, l'objet d_plancheTmp est
//   destin  tre utilis de manire
//   temporaire;
{ public:
	 d_planche *d;
	 int largeur,hauteur;  // de la fentre
	 HDC hDCcomp;
	 HBITMAP hbitmap,holdbitmap;

	 d_plancheTmp(d_planche *d);
	 ~d_plancheTmp();
	 void WMSize();
	 void allocbitmap();
	 void freebitmap();
	 void clear_fenetre();
};


/////////////////////////////////////////
// fonctions
//
// dans le fichier trad_x.cpp
extern void snovcoor(float x_min, float y_min,
				  float x_max, float y_max,
				  d_planche *d);
	  /* fixer les coordonnees d'une fenetre
		  (point en bas a gauche, et point en
	haut a droite) */
extern void snovcoorx(float x_min,
				  float x_max,
				  d_planche *d);
extern void snovcoory(float y_min,
				  float y_max,
				  d_planche *d);
extern void snop(float x, float y, d_planche *d);
	  /* dessiner un point dans la fenetre d */
extern void snorl(float x1, float y1, float x2, float y2,
			  d_planche *d);
	  /* dessiner une ligne donnee par ses 2 points */
extern void snol1(float x, float y, d_planche *d);
	/* dessine une ligne depuis le dernier point
					 atteint par le dessin */
extern void MgiHue(COLORREF col, d_planche *d);
	/* choisir la couleur */
extern void snogetvcoor(float *xmin, float *ymin,
                 float *xmax, float *ymax,
                 d_planche *d); 
     /* recupere le systeme de coordonnees indiquees
				      par l'utilisateur */
extern void snoil(int x1, int y1, int x2, int y2,
      d_planche *d); 
extern void snol(float x1, float y1, float x2, float y2,
          d_planche *d);
	/* dessiner une ligne donnee par ses 2 points */
extern void snoipoly(int n, short tx[], short ty[], int mode,
              d_planche *d);
extern void snoibox(int x1, int y1, int x2, int y2,
             d_planche *d);
extern void snoiboxw(int x1, int y1, int x2, int y2,
              d_planche *d);
extern void snorbox(float x1, float y1, float x2, float y2,
             d_planche *d);
extern void snorrect(float x1, float y1, float x2, float y2,
              d_planche *d);
extern void snorgfs(float x, float y,
             char *blockn,
             d_planche *d);
	 /* afficher une chaine de caracteres
			    a un point donne en coord reelles */
extern void snoigfs(int x, int y,
             char *blockn,
             d_planche *d);
	/* afficher une chaine de caracteres
			      a un point donne en coord entieres */
extern int snoscalex(d_planche *d, float x);
extern int snoscaley(d_planche *d, float y);
extern void snoclearpln(int plane_mask, int col,
                 d_planche *fenetre);
     /* efface des plans image (-1 pour effacer tous les plans) */
extern void snoclearplnw(int plane_mask, int col,
		  d_planche *fenetre);
     /* efface des plans image (-1 pour effacer tous les plans) */
extern void snoiunscalexy(int x, int y,
		   float *xr, float *yr,
    		   d_planche *d);
     /* pour transformer des coordonnees entieres
        en coordonnees reelles */
extern void snorfc(float x, float y, float rx, float ry,
            d_planche *d);
     /* dessiner une ellipse pleine
        (donnee par le centre et les rayons) */
extern snortl( // dessin d'une ligne epaisse donnee par ses deux points
     float x1,float y1,float x2,float y2,
     d_planche *d);
extern void snoitl(int x1, int y1, int x2, int y2,
            d_planche *d);
	/* dessin d'une ligne epaisse */
extern void snoiwidth(int width);
	/* pour fixer la largeur d'une ligne */
extern void snorp(float x, float y, d_planche *d);
	 /* dessiner un point */
extern void snorl1(float x, float y, d_planche *d);
	/* dessiner une ligne depuis le dernier
		   point atteint par le dessin */
extern void chargeFont(d_planche *fenetre, char *font_name);

// dans le fichier util_x.cpp
extern void initwi();
extern void aff_str(d_planche *d, // procedure permettant l'affichage
                      //   d'une chaine de caracteres 
     int x, int y,
     char *mess);

extern void initialiser(d_planche *);  /* definit le context graphique
                                 des fenetres  */
extern void replacer_slider();
extern void SetScrollSpectroPosition(long e);
extern void desactive(int menu);
extern void desactiveMenusSeuls(int menu);
extern void desactiveVraimentTout();
extern void active(int menu);
extern void label_printf();
extern void popdown();       /*  affiche un fenetre X */
extern void CopyArea_Dbw(d_planche *d // copie de d->hbitmap
                                //     vers d->w
                  ,int xsrc, int ysrc
		  ,int width, int height
		  ,int xdest, int ydest
		  ,DWORD dwRop);
extern void InvertArea(HWND hWnd  // inverse une zone de fentre
		,int x,int y,int nWidth,int nHeigth);
extern void YFillRectangle(HDC hDC, int x,int y  
		   ,int width,int height  
		   ,HBRUSH hbrush);       
extern void YDrawRectangle(HDC hDC, int x,int y  
		   ,int width,int height
		   ,HBRUSH hbrush);
extern void souris(const char *type); 
extern int textheight(HDC, char *text);
extern int textwidth(HDC, char *text);
#endif
