/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#include "wopensav.h"



static int isRelocatedAtTime;

LRESULT CALLBACK truc(HWND hdlg,	uint msg, WPARAM wParam,  LPARAM lParam)
{
  switch(msg) {
      case WM_NOTIFY:
        LPOFNOTIFY lpon = (LPOFNOTIFY) lParam;
        switch (lpon->hdr.code) {
        case  CDN_INITDONE:
          CheckRadioButton(hdlg,  IDC_KEEPLOCATE, IDC_RELOCATE, IDC_KEEPLOCATE);
          SetDlgItemText(hdlg, IDC_EDIT3, "0");
          break;
        case CDN_FILEOK:
          bool isRelocated = (IsDlgButtonChecked(hdlg, IDC_RELOCATE) == BST_CHECKED);
          if (isRelocated) {
            char s[80];
            GetDlgItemText(hdlg, IDC_EDIT3, s, 80 - 1);
            isRelocatedAtTime = atoi(s);
          }
          else isRelocatedAtTime = 0;
          break;
        }
        break;
  }
  return(TDialog::StdDlgProc(hdlg, msg, wParam, lParam));
}


WOpenSaveDialog::WOpenSaveDialog(TWindow* parent, int& isRelocatedAt, TData& data, TResId templateId)
     : isRelocatedAt_(isRelocatedAt), TOpenSaveDialog(parent, data, templateId)  {
}



int WOpenSaveDialog::DoExecute()
{
   ofn.lpfnHook = LPOFNHOOKPROC(truc);
   int ret = ::GetOpenFileName(&ofn);
   if (ret) {
    Data.Flags = ofn.Flags;
    Data.FilterIndex = (int)ofn.nFilterIndex;
    Data.Error = 0;
    isRelocatedAt_ = isRelocatedAtTime;
   }
  else {
    Data.Error = ::CommDlgExtendedError();
  }

  return ret ? IDOK : IDCANCEL;
}

