/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

#ifdef BUILDER
#include <condefs.h>

                
USEUNIT("..\licence\calculcle.cpp");
USEUNIT("licence.cpp");
USEUNIT("hanning.cpp");
USEUNIT("piquef0.cpp");
USEUNIT("energies.cpp");                                      
USEUNIT("optproso.cpp");
USEUNIT("scalemod.cpp");
USEUNIT("lesfft.cpp");
USEUNIT("affichmk.cpp");
USEUNIT("prosodie.cpp");
USEUNIT("pitchmk.cpp");
USEUNIT("fft_mayer.cpp");
USEUNIT("sof.cpp");
USEUNIT("trad_x.cpp");
USEUNIT("test.cpp");
USEUNIT("temps.cpp");
USEUNIT("suivipic.cpp");
USEUNIT("spline.cpp");
USEUNIT("spectrop.cpp");
USEUNIT("spectrog.cpp");
USEUNIT("spectrof.cpp");
USEUNIT("spectrap.cpp");
USEUNIT("specfft.cpp");
USEUNIT("util_x.cpp");
USEUNIT("pmenervo.cpp");
USEUNIT("selecteu.cpp");
USEUNIT("seleclp.cpp");
USEUNIT("sauvman.cpp");
USEUNIT("sauvanno.cpp");
USEUNIT("root.cpp");
USEUNIT("regres6.cpp");
USEUNIT("regres4.cpp");
USEUNIT("recher_c.cpp");
USEUNIT("recher_a.cpp");
USEUNIT("pmvoisem.cpp");
USEUNIT("pmpitchm.cpp");
USEUNIT("pmpics.cpp");
USEUNIT("pmpeigne.cpp");
USEUNIT("pmmenu.cpp");
USEUNIT("pmmedian.cpp");
USEUNIT("pmlispit.cpp");
USEUNIT("signal_t.cpp");
USEUNIT("lissage.cpp");
USEUNIT("pics_spe.cpp");
USEUNIT("perso.cpp");
USEUNIT("paralpcs.cpp");
USEUNIT("paralpc.cpp");
USEUNIT("parafft.cpp");
USEUNIT("paraceps.cpp");
USEUNIT("outilbuf.cpp");
USEUNIT("opt_for.cpp");
USEUNIT("notetiq.cpp");
USEUNIT("mire.cpp");
USEUNIT("menu.cpp");
USEUNIT("mccandle.cpp");
USEUNIT("lpc.cpp");
USEUNIT("lit_ente.cpp");
USEUNIT("lit_cont.cpp");
USEUNIT("lireanno.cpp");
USEUNIT("hamming.cpp");
USEUNIT("getphoan.cpp");
USEUNIT("gerefilt.cpp");
USEUNIT("format_f.cpp");
USEUNIT("formants.cpp");
USEUNIT("filtrer.cpp");
USEUNIT("lireman.cpp");
USEUNIT("div.cpp");
USEUNIT("fftgen.cpp");
USEUNIT("fband.cpp");
USEUNIT("evalue.cpp");
USEUNIT("etiman.cpp");
USEUNIT("en_post.cpp");
USEUNIT("editwnd.cpp");
USEUNIT("edit.cpp");
USEUNIT("droit_ec.cpp");
USEUNIT("drawbutton.cpp");
USEUNIT("affichag.cpp");
USEUNIT("delimite.cpp");
USEUNIT("delimit2.cpp");
USEUNIT("coupe.cpp");
USEUNIT("couleur.cpp");
USEUNIT("conver_t.cpp");
USEUNIT("choix_fi.cpp");
USEUNIT("cherchee.cpp");
USEUNIT("cherchan.cpp");
USEUNIT("cepstre.cpp");
USEUNIT("blackman.cpp");
USEUNIT("axes.cpp");
USEUNIT("audio.cpp");
USEUNIT("annoter.cpp");
USEUNIT("affv.cpp");
USEUNIT("affuneco.cpp");
USEUNIT("desfil.cpp");
USERES("snoorieng.RES");
USERC("snoorieng.rc");
USEUNIT("guiklat.cpp");
USEUNIT("tabpoints.cpp");
USEUNIT("PolyPoint.cpp");
USEUNIT("toolsformants.cpp");
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
#include "common.h"
#pragma hdrstop


#include <dir.h>

#include "notetiq.h"
#include "cnotetiq.h"
#include "wcoupe.h"
#include "signal.h"
#include "spectro.h"
#include "format_f.h"
#include "gerefilt.h"
#include "pitchm.h"
#include "piquef0.h"
#include "energies.h"
#include "files.h"
#include "menu.h"
#include "opt_for.h"
#include "axes.h"
#include "test.h"
#include "div.h"
#include "audio.h"
#include "fmaxspec.h"
#include "editmngmt.h"
#include "polypoint.h"
#include "filterOLA.h"
#include "guiklat.h"
#include "criticalbands.h"
#include "add_files/htmlhelp.h"

Wtop *PTWtop;
TFrameWindow *MainWin;
extern Wpiquefor *wpiquefor;  // formant editor window

#define WIDTH_VSCALE 	68
// revoir,  mettre dans la classe Wtop
static int yannot,hannot;
static int yspectro,hspectro;
static int yetiq,hetiq;
static int ysignal,hsignal;
static int yscroll,hscroll;

WPlancheSpectroMain    	*wspectro;
WPlancheSig      			*wsignal;
Wdonnees_annotations 	*wannotations;
Wdonnees_etiquetage  	*wetiquetage;
TScrollBar 					*scroll_spectro;


extern void initfpattern();

void initvariables()
{
  initfpattern();
  ct.modeMemoire=0;
  ct.tf=0;
  ct.d_e=0; ct.f_e=0;
  ct.d_a=0; ct.f_a=0;
  ct.d_es=0; ct.f_es=0;
  yaUnSignal = NOSIGNAL;
  *en_cours.nom='\0';
  *en_cours.nom_man='\0';
  *en_cours.nomAnnot='\0';
  en_cours.fmt_son=0;
  en_cours.fmt_phon=0;
  en_cours.fmt_word=0;
}

/////////////////////////////////////////
// Echelle verticale
DEFINE_RESPONSE_TABLE1(WVScale, d_planche)
  EV_WM_SIZE,
END_RESPONSE_TABLE;
WVScale::WVScale(PTWindowsObject AParent) :d_planche(AParent)
{
}

void WVScale::EvSize(uint sizeType, TSize &size)
{
  d_planche::EvSize(sizeType, size);
}

void WVScale::affichage(float vmin, float vmax, float incr, char *texte)
{
  clear_fenetre();
  setLXcoor(0., 1.);
  setLYcoor((float) 0., (float) NB_CANAUX);
  axe_y(0., (float) NB_CANAUX, vmin, vmax,
	     1., NOIR, incr, true, true, (texte) ? 36 : 0, (fabs((incr - ((int) incr))) < 0.001) ? "%2.0f" : "%3.1f", 12, 5, this);
  if (texte) {
    TSize size;
  	 MgiHue (ROUGE, this);
    SetPlancheFont(queryFont("arial", 7, 13, 0));
    GetTextExtentPoint32(hDCcomp, texte, strlen(texte), &size);
    if (size.cx > WIDTH_VSCALE) {
      SetPlancheFont(queryFont("arial", 5, 12, 0));
      GetTextExtentPoint32(hDCcomp, texte, strlen(texte), &size);
    }
    DTextOut((WIDTH_VSCALE - 3) / 2 + size.cx / 2, 24, texte);
  }

  ::InvalidateRect(HWindow, NULL, true);
}

/////////////////////////////////////////
// Echelle temporelle
DEFINE_RESPONSE_TABLE1(WScale, d_planche)
  EV_WM_SIZE,
END_RESPONSE_TABLE;
WScale::WScale(PTWindowsObject AParent) :d_planche(AParent)
{
}

void WScale::EvSize(uint sizeType, TSize &size)
{
  d_planche::EvSize(sizeType, size);
  if (yaUnSignal) affichage(ct.d_a, ct.f_a);
}

/////////////////////////////////////////
// Planche Signal + echelle temporelle
DEFINE_RESPONSE_TABLE1(WPlancheSig, TFrameWindow)
  EV_WM_SIZE,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_WM_MOUSEMOVE,
END_RESPONSE_TABLE;
WPlancheSig::WPlancheSig(PTWindowsObject AParent, struct ctrl_temps *ctpp)
{
   wsig = new Wdonnees_signal(AParent, ctpp);
   wscale = new WScale(AParent);
   wvscale = new WVScale(AParent);
}

bool WPlancheSig::MoveWindow(int x, int y, int w, int h, bool repaint) {
  int yy;
  wsig->MoveWindow(x + WIDTH_VSCALE, y, max(w - WIDTH_VSCALE, 0), 64, repaint);
  wscale->MoveWindow(x + WIDTH_VSCALE,  y + 64, max(w - WIDTH_VSCALE, 0), max(min(h - 64, 24), 0), repaint);
  wvscale->MoveWindow(x,  y, WIDTH_VSCALE, 64, repaint);
}

void WPlancheSig::EvSize(uint sizeType, TSize &size) {
  wsig->EvSize(sizeType, size);
  wscale->EvSize(sizeType, size);
};

void WPlancheSig::aff()
{
  float vmax;
  vmax = wsig->affichage(space, ct.d_es, ct.f_es, ct.d_a, ct.f_a,-2, (ct.modeMemoire==ZOOM));
  wscale->affichage(ct.d_a, ct.f_a);
  wvscale->affichage(-vmax, vmax, vmax, (char *) NULL);
}

void WPlancheSig::Paint(TDC& dc, bool erase, TRect& rect)
{
  wsig->Paint(dc,erase,rect);
  affRegion(this->wsig, &ct);
}

void WPlancheSig::drawMotion(int event_x, int transmet) {
  if (!yaUnSignal) return;
  else wsig->drawMotion(event_x, transmet);
};

/////////////////////////////////////////
// fentre donnees_signal
//
DEFINE_RESPONSE_TABLE1(Wdonnees_signal,d_planche)
  EV_WM_SIZE,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_WM_MOUSEMOVE,
END_RESPONSE_TABLE;
Wdonnees_signal::Wdonnees_signal(PTWindowsObject AParent, struct ctrl_temps *ctpp)
	 : d_planche(AParent)
{
   ctp = ctpp;
   wspectrAssoc = (Wdonnees_spectro *) NULL;
}

void Wdonnees_signal::Paint(TDC& dc, bool erase, TRect& rect)
{
  d_planche::Paint(dc,erase,rect);
  if (yaUnSignal) affRegion(this, &ct);
}
void Wdonnees_signal::EvSize(uint sizeType, TSize &size)
{
  d_planche::EvSize(sizeType, size);
  if (!yaUnSignal) {
    clear_fenetre();
	 aff_str(this,2,0,ml(101,"parole"));
	 return;
  }
  affichage(space, ct.d_es, ct.f_es, ct.d_a, ct.f_a,-2, (ct.modeMemoire==ZOOM));
}

void Wdonnees_signal::EvLButtonDown(uint, TPoint& point)
{ if (LButtonDown) return;
  LButtonDown=TRUE;
  SetCapture();
  if (yaUneFenetreCoupe) wspectrAssoc->drawDownCoupe(point.x);
  else drawDown(point.x, 1);
}
void Wdonnees_signal::EvMouseMove(uint, TPoint& point)
{ if (!LButtonDown) return;
  if (yaUneFenetreCoupe) wspectrAssoc->drawMotionCoupe(point.x);
  else drawMotion(point.x, 1);
}
void Wdonnees_signal::EvLButtonUp(uint, TPoint& point)
{ ReleaseCapture();
  if (!LButtonDown) return;
  LButtonDown=FALSE;
  if (yaUneFenetreCoupe) wspectrAssoc->drawUpCoupe(point.x);
  else drawUp(point.x, 1);
}

/*
 * Pour mettre en evidence un segment de parole lors de l'etiquetage.
 */
void Wdonnees_signal::BlueSegment(                      
  int echtDeb, int echtFin)
{
  int xx1 = LXtoDX((float)echtDeb),xx2=LXtoDX((float)echtFin);
  MgiHue(BLEU, this);
  YFillRectangle(hDCcomp, xx1, 0,
                 (unsigned int) (xx2 - xx1 + 1),
		 (unsigned int) 4,
		 hMyBrush);
  der_x=xx1; der_y=0;
}


//////////////////////////////////////////////////////////////////////
// Planche Spectrogramme + echelle verticale (frquentielle en gnral)
DEFINE_RESPONSE_TABLE1(WPlancheSpectro, TFrameWindow)
  EV_WM_SIZE,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_WM_MOUSEMOVE,
END_RESPONSE_TABLE;
WPlancheSpectro::WPlancheSpectro(PTWindowsObject AParent, struct ctrl_temps *ctpp, SAMPLEbuf *speech)
{
   wsona = new Wdonnees_spectro(AParent, ctpp, speech);
   wvscale = new WVScale(AParent);
}

bool WPlancheSpectro::MoveWindow(int x, int y, int w, int h, bool repaint) {
  int mute;
  wsona->MoveWindow(x + WIDTH_VSCALE, y, max(w - WIDTH_VSCALE, 0), h, repaint);
  wvscale->MoveWindow(x,  y, WIDTH_VSCALE, h, repaint);
  if (yaUnSignal) {
    wsona->incr = max(1000, niceVertIncr(0., fMaxSpectro, 12, &mute, wsona));
    wvscale->affichage(0., fMaxSpectro, wsona->incr, "Hz");
  }
  if (wpiquefor) wpiquefor->affPPoints();
  if (yaUnEditManager && editManager->editMode == OLA) affTrajOLA();
}

void WPlancheSpectro::EvSize(uint sizeType, TSize &size) {
  int mute;
  wsona->EvSize(sizeType, size);
  wvscale->EvSize(sizeType, size);
  if (yaUnSignal) {
    wsona->incr = max(1000, niceVertIncr(0., fMaxSpectro, 12, &mute, wsona));
    wvscale->affichage(0., fMaxSpectro, wsona->incr, "Hz");
  }
};

void WPlancheSpectro::Paint(TDC& dc, bool erase, TRect& rect)
{
  wsona->Paint(dc,erase,rect);
  if (yaUnSignal) wvscale->affichage(0., fMaxSpectro, wsona->incr, "Hz");
  if (wpiquefor) wpiquefor->affPPoints();
  if (yaUnEditManager && editManager->editMode == OLA) affTrajOLA();
}

void WPlancheSpectro::drawMotion(int event_x, int transmet) {
  if (!yaUnSignal) return;
  else wsona->drawMotion(event_x, transmet);
};

void WPlancheSpectro::paint()  {
  int mute;
  wsona->incr = max(1000, niceVertIncr(0., fMaxSpectro, 12, &mute, wsona));
  wsona->paint();
  if (yaUnSignal) wvscale->affichage(0., fMaxSpectro, wsona->incr, "Hz");
};

/////////////////////////////////////////
// fentre wspectro
//
DEFINE_RESPONSE_TABLE1(Wdonnees_spectro,d_planche_dblclk)
  EV_WM_SIZE,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_WM_LBUTTONDBLCLK,
  EV_WM_MOUSEMOVE,
END_RESPONSE_TABLE;

Wdonnees_spectro::Wdonnees_spectro(PTWindowsObject AParent, struct ctrl_temps *ctpp, SAMPLEbuf *speech)
	 : d_planche_dblclk(AParent)
{
  ctp = ctpp;
  sig = speech;
  bis = new d_plancheTmp(this);
  wsigAssoc = (Wdonnees_signal *) NULL;
  incr = 0.;
  isMain = false;
}


void Wdonnees_spectro::Paint(TDC& dc, bool erase, TRect& rect)
{
  d_planche_dblclk::Paint(dc,erase,rect);
  if (!yaUnSignal) return;

  { HDC hDC=GetDC(HWindow);
    int mute;
	 // affichage des axes
	 float f;
	 RECT rect;
    HPEN hCPen;
    float highestFreq;

    hCPen=CreatePen(PS_SOLID, 1, NOIR);
    SelectObject(hDC, hCPen);
 	 ::GetClientRect(HWindow, &rect);

    if (en_cours.mode == FFT_CRITICALBANDS && psp_CRITICALBANDS.nonLinearDisplay) {
      if (psp_CRITICALBANDS.frequencyScale) { // Mel scale
        highestFreq = hertz2mel(en_cours.frequence / 2.);
        incr = max(1000, niceVertIncr(0., highestFreq, 12, &mute, wspectro->wsona));
      }
      else { // Bark scale
        highestFreq = hertz2bark(en_cours.frequence / 2.);
        incr = max(10, niceVertIncr(0., highestFreq, 12, &mute, wspectro->wsona));
      }
    }
    else {
       highestFreq =  fMaxSpectro;
       incr = max(1000, niceVertIncr(0., fMaxSpectro, 12, &mute, this));
    }

   if (en_cours.mode == FFT_CRITICALBANDS && psp_CRITICALBANDS.nonLinearDisplay) spectro_SetMode(FFT_L);

	 for (f = 0.; f <= highestFreq ; f += incr) {
	   float ht = f * NB_CANAUX / highestFreq;
		int yy = LYtoDY(ht);
		MoveToEx(hDC, 0, yy, (POINT *) NULL);
		LineTo(hDC, rect.right + 1, yy);
	 }

    DeleteObject(hCPen);
	 ReleaseDC(HWindow,hDC);
    if (pm.yaUneEchelle) pm.dispScale();
    if (psp_ener.yaUneEchelle) dispEnergyScale();
  }
  affRegion(this, ctp);
}

void Wdonnees_spectro::aff()
{
  SpectroDisplay display;
  display.type = WINDOW;
  display.ws = this;

 if (autospectro)
   spectrogram(this->sig, display, ctp->d_es, ctp->f_es, *ctp, ON_NETTOIE);
 else {
   clear_fenetre();
   spectro_consolider(0,INFINI_I);
 }
}

/////////////////////////////////////////
// fentre wspectroMain
//
DEFINE_RESPONSE_TABLE1(WPlancheSpectroMain, WPlancheSpectro)
  EV_WM_SIZE,
END_RESPONSE_TABLE;

void WPlancheSpectroMain::EvSize(uint sizeType, TSize &size)
{
  WPlancheSpectro::EvSize(sizeType, size);
  // Displays the F0 contour if the window for F0 contour modifications
  // does exist.
  if (yaUneFenetrePiqueF0) {
    switch (wpiquef0->lastCommand) {
    case MENUSeeF0Contour:
       wpiquef0->CMSeeF0Contour();
       break;
    case MENUModifF0Contour:
       wpiquef0->CMModifF0Contour();
       break;
    }
  }
}

void Wdonnees_spectro::EvSize(uint sizeType, TSize &size)
{
  // Resizing only if non-zero size (otherwise that means that
  // the window has been minimized.
   if (size.cx && size.cy) {
     d_planche_dblclk::EvSize(sizeType, size);
     this->bis->WMSize();
     if (largeur && hauteur && yaUnSignal) aff();
     else {
       clear_fenetre();
	    aff_str(this,2,0,ml(102,"spectro"));
	    spectro_consolider(0,INFINI_I);
     }
   }
}



void Wdonnees_spectro::EvLButtonDown(uint, TPoint& point)
{ if (LButtonDown) return;
  if (LButtonDblClk) return;
  LButtonDown=TRUE;
  SetCapture();
  shift=GetKeyState(VK_SHIFT)<0;
  ctrl=GetKeyState(VK_CONTROL)<0;
  if (yaUnFiltrage) drawDownDomaine(point.x,point.y);
  else if (yaUneFenetrePiquefor&&shift) wpiquefor->drawDown(point.x,point.y);
  else if (yaUneFenetrePiquefor&&ctrl) wpiquefor->drawDownPiqPt(point.x,point.y);
  else if (yaUneFenetreCoupe) drawDownCoupe(point.x);
  else if (yaUnEditManager && isFilterOLA() && ctrl) drawDownEditPiqTraj(point.x,point.y);
  else if (yaUnEditManager && isFilterOLA()) drawDownEdit(point.x,point.y);
  else if (yaUnEditManager && isFilterFIR()) drawDownDomaine(point.x,point.y);
  else if (yaF0Selected&&shift) drawDownPiqF0(point.x,point.y);
  else if (yaF0Selected&&ctrl) drawDownPiqF0Pt(point.x,point.y);
  else drawDown(point.x, 1);
}
void Wdonnees_spectro::EvLButtonDblClk(uint, TPoint&)
{ if (LButtonDown) return;
  if (LButtonDblClk) return;
  LButtonDblClk=TRUE;
  SetCapture();
}
void Wdonnees_spectro::EvMouseMove(uint, TPoint& point)
{ if (LButtonDown)
  { if (yaUnFiltrage) drawMotionDomaine(point.x,point.y);
	 else if (yaUneFenetrePiquefor&&shift) wpiquefor->drawMotion(point.x,point.y);
	 else if (yaUneFenetrePiquefor&&ctrl) wpiquefor->drawMotionPiqPt(point.x,point.y);
	 else if (yaUneFenetreCoupe) drawMotionCoupe(point.x);
    else if (yaUnEditManager && isFilterOLA() && ctrl) drawMotionEditPiqTraj(point.x,point.y);
    else if (yaUnEditManager && isFilterOLA()) drawMotionEdit(point.x,point.y);
    else if (yaUnEditManager && isFilterFIR()) drawMotionDomaine(point.x,point.y);
    else if (yaF0Selected&&shift) drawMotionPiqF0(point.x,point.y);
    else if (yaF0Selected&&ctrl) drawMotionPiqF0Pt(point.x,point.y);
	 else drawMotion(point.x, 1);
  }
  affichePositionSpectro(point.x, point.y, isMain);
}

void Wdonnees_spectro::EvLButtonUp(uint, TPoint& point)
{ ReleaseCapture();
  if (LButtonDown)
  { LButtonDown=FALSE;
	 if (yaUnFiltrage) drawUpDomaine(point.x,point.y);
	 else if (yaUneFenetrePiquefor&&shift) wpiquefor->drawUp(point.x,point.y);
	 else if (yaUneFenetrePiquefor&&ctrl) wpiquefor->drawUpPiqPt(point.x,point.y);
	 else if (yaUneFenetreCoupe) drawUpCoupe(point.x);
    else if (yaUnEditManager && isFilterOLA() &&ctrl) drawUpEditPiqTraj(point.x,point.y);
    else if (yaUnEditManager && isFilterOLA()) drawUpEdit(point.x,point.y);
    else if (yaUnEditManager && isFilterFIR()) drawUpDomaine(point.x,point.y);
    else if (yaF0Selected&&shift) drawUpPiqF0(point.x,point.y);
    else if (yaF0Selected&&ctrl) drawUpPiqF0Pt(point.x,point.y);
	 else drawUp(point.x, 1);
  }
  if (LButtonDblClk)
  { LButtonDblClk=FALSE;
	//XM if (yaUneFenetrePiquefor&&ctrl) drawUpPiqSelect(point.x,point.y);
  }
}

/////////////////////////////////////////
// fentre donnees_etiquetage
//
DEFINE_RESPONSE_TABLE1(Wdonnees_etiquetage,d_planche_dblclk)
  EV_WM_SIZE,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_WM_LBUTTONDBLCLK,
  EV_WM_RBUTTONUP,
  EV_WM_RBUTTONDBLCLK,
  EV_WM_MOUSEMOVE,
  EV_WM_DRAWITEM,
  EV_WM_MEASUREITEM,
END_RESPONSE_TABLE;

void Wdonnees_etiquetage::EvMeasureItem(uint ctrlId, MEASUREITEMSTRUCT far& measureInfo)
{
  if (measureInfo.CtlType == ODT_MENU) {
    TScreenDC dc;
    TSize s = dc.GetTextExtent(((char *)measureInfo.itemData), strlen((char *)measureInfo.itemData));
    measureInfo.itemWidth = s.cx;
    measureInfo.itemHeight = s.cy;
  }
}


/*
 * Drawing an item in the phonetic menu.
 * The drawItem event must be caught at this level because it
 * is not trnasmited to the menu.
 */
void Wdonnees_etiquetage::EvDrawItem(uint /*ctrlId*/, DRAWITEMSTRUCT far & drawInfo)
{
  if (drawInfo.CtlType == ODT_MENU) {
    switch (drawInfo.itemAction) {
      case ODA_DRAWENTIRE:
        ODADrawEntire(drawInfo);
      break;

      case ODA_FOCUS:
        ODAFocus(drawInfo);
      break;

      case ODA_SELECT:
        ODASelect(drawInfo);
      break;
    }
  }
}

Wdonnees_etiquetage::Wdonnees_etiquetage(PTWindowsObject AParent)
	 : d_planche_dblclk(AParent)
{
	extern MenuSquel *squelMenuPhoneme, *squelMenuClasses;
   if (init_langue()) {
     PopupMenu = construitMenu(squelMenuPhoneme);
     construitTablePhon(squelMenuPhoneme);
     PopupMenuClasses = construitMenu(squelMenuClasses);
   }
   else fatal_error("inconsistent description of phonemes and phonetic classes");
}

void Wdonnees_etiquetage::SetupWindow()
{
  TFrameWindow::SetupWindow();
  d_planche_dblclk::SetupWindow();
}

//
// EvCommandEnable  pour les items des menus phonetiques
//
void Wdonnees_etiquetage::EvCommandEnable(TCommandEnabler& ce)
{
  if (ID_PHON0 <= ce.Id && ce.Id < ID_PHON0 + 1000) {
    ce.Enable(true);
  }
  else
    TWindow::EvCommandEnable(ce);
}

void Wdonnees_etiquetage::EvSize(uint sizeType, TSize &size)
{ d_planche::EvSize(sizeType, size);
  if (!yaUnSignal)
  { clear_fenetre();
	 aff_str(this,2,0,ml(103,"phonmes"));
	 return;
  }
  aff_etiqs();
}
void Wdonnees_etiquetage::EvLButtonDown(uint, TPoint& point)
{ if (LButtonDown) return;
  LButtonDown=TRUE;
  drawDownEtiq(point.x);
}
void Wdonnees_etiquetage::EvLButtonDblClk(uint, TPoint& point)
{ if (LButtonDown) return;
  LButtonDown=TRUE;
  drawDblclkEtiq(point.x);
}
void Wdonnees_etiquetage::EvRButtonDblClk(uint, TPoint& point)
{ if (RButtonDown) return;
  RButtonDown=TRUE;
  drawDblclkREtiq(point.x);
}
void Wdonnees_etiquetage::EvRButtonUp(uint, TPoint& point)
{ if (!RButtonDown) return;
  RButtonDown=FALSE;
  drawUpEtiq(point);
}
void Wdonnees_etiquetage::EvMouseMove(uint, TPoint& point)
{ if (!LButtonDown) return;
  drawMotionEtiq(point.x);
}
void Wdonnees_etiquetage::EvLButtonUp(uint, TPoint& point)
{ if (!LButtonDown) return;
  LButtonDown=FALSE;
  drawUpEtiq(point);
}

LRESULT Wdonnees_etiquetage::EvCommand(UINT id, HWND, UINT)
{
  if (  (id>=ID_PHON0-128)
		&&(id<=ID_PHON0+127) )
  { num_phon=id-ID_PHON0;
	 //::PostMessage(HWindow,WM_CLOSE,0,0);
  }
  return 0;
}

/////////////////////////////////////////
// fentre donnees_annotations
//
DEFINE_RESPONSE_TABLE1(Wdonnees_annotations,d_planche_dblclk)
  EV_WM_SIZE,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_WM_LBUTTONDBLCLK,
  EV_WM_MOUSEMOVE,
END_RESPONSE_TABLE;
Wdonnees_annotations::Wdonnees_annotations(PTWindowsObject AParent)
	 : d_planche_dblclk(AParent)
{
}
void Wdonnees_annotations::EvSize(uint sizeType, TSize &size)
{ d_planche::EvSize(sizeType, size);
  if (!yaUnSignal)
  { clear_fenetre();
	 aff_str(this,2,0,ml(104,"mots"));
	 return;
  }
  aff_notes();
}
void Wdonnees_annotations::EvLButtonDown(uint, TPoint& point)
{ if (LButtonDown) return;
  LButtonDown=TRUE;
  drawDownAnnot(point.x);
}
void Wdonnees_annotations::EvLButtonDblClk(uint, TPoint& point)
{ if (debug==6) Wmsg->wr("Wdonnees_annotations::EvLButtonDblClk()");
  if (LButtonDown) return;
  LButtonDown=TRUE;
  drawDblclkAnnot(point.x);
}
void Wdonnees_annotations::EvMouseMove(uint, TPoint& point)
{ if (!LButtonDown) return;
  drawMotionAnnot(point.x);
}
void Wdonnees_annotations::EvLButtonUp(uint, TPoint& point)
{ if (!LButtonDown) return;
  LButtonDown=FALSE;
  drawUpAnnot(point.x);
}


DEFINE_RESPONSE_TABLE1(Wtop,TFrameWindow)
  EV_WM_SIZE,
  EV_WM_CLOSE,
  EV_CHILD_NOTIFY_ALL_CODES(101,IDscrollbar),
	 // sous-menu fichier
	 EV_COMMAND(MENUNew,CMnouveau),
	 EV_COMMAND(MENUZero,CMzeroFile),
	 EV_COMMAND(MENUOpen,CMlecture_fichier),
	 EV_COMMAND(MENUSave,CMsauver),
	 EV_COMMAND(MENUSaveAs,CMsauverSous),
    EV_COMMAND(MENURecord,CMrecord),
	 EV_COMMAND(MENUCopyToFile,CMsauverUneRegion),
	 EV_COMMAND(MENUPasteFromFile,CMfinserer),
	 EV_COMMAND(MENURemoveDC,CMremoveDC),
	 EV_COMMAND(MENURegister,CMRegisterUser),
    EV_COMMAND(MENUsignalToClipboard,CMsignalToClipboard),
	 EV_COMMAND(MENUExit,CMquitter),

	 // sous-menu edition
	 EV_COMMAND(MENUUndo,CMfannuler),
	 EV_COMMAND(MENUCut,CMfcouper),
	 EV_COMMAND(MENUCopy,CMfcopier),
	 EV_COMMAND(MENUPaste,CMfcoller),
	 EV_COMMAND(MENUDelete,CMfeffacer),
    EV_COMMAND(MENUEditingTools, CMEditingTools),
    EV_COMMAND(MENUResampling, CMResampling),
//	 EV_COMMAND(MENUAmortirGauche,CMamortirGauche),  transfered in editing tools
//	 EV_COMMAND(MENUAmortirCentre,CMamortirCentre),
//	 EV_COMMAND(MENUAmortirDroite,CMamortirDroite),
//	 EV_COMMAND(MENUFiltreSignal,CMfiltreSignal),
	 EV_COMMAND(MENUEcoute,CMnbecoute),
	 EV_COMMAND(MENUEcoute1Fois,CMecoute1Fois),
    EV_COMMAND(MENUPlayFile,CMplayFile),
	 EV_COMMAND(MENUFreqEchant,CMfreqEchantillonnage),
	 EV_COMMAND(MENUGetSpeechStart,CMgetSpeechStart),
	 EV_COMMAND(MENUAllerA,CMouAller),
	 EV_COMMAND(MENUZoomin,CMzoom_tempo),
	 EV_COMMAND(MENUZoomout,CMsupprimeZoom_tempo),
	 // sous-menu spectrogramme
	 EV_COMMAND(MENUspFFTL,CMspectro_fft_large),
	 EV_COMMAND(MENUspFFTE,CMspectro_fft_etroit),
	 EV_COMMAND(MENUspLPC,CMspectro_lpc),
	 EV_COMMAND(MENUspCRITICALBANDS,CMspectro_criticalBands),
	 EV_COMMAND(MENUspCEP,CMspectro_cepstre),
	 EV_COMMAND(MENUspREASS,CMspectro_reass),
    EV_COMMAND(MENUSaveSpectrogram,CMsave_spectrogramme),
	 EV_COMMAND(MENUClearSpectro,CMclearSpectro),
	 EV_COMMAND(MENUconsDECO,CMdecoreSpectro),
    EV_COMMAND(MENUsuppDECO,CMnettoieSpectro),
    EV_COMMAND(MENUspectroToClipboard, CMspectroToClipboard),
    EV_COMMAND(MENUFMaxSpectro,CMSpectroFmax),
	 EV_COMMAND(MENUspOptFFTL,CMspectro_opt_fft_large),
	 EV_COMMAND(MENUspOptFFTE,CMspectro_opt_fft_etroit),
	 EV_COMMAND(MENUspOptCRITICALBANDS,CMspectro_opt_criticalBands),
	 EV_COMMAND(MENUspOptREASS,CMspectro_opt_fft_reass),
	 EV_COMMAND(MENUspOptLPC,CMspectro_opt_lpc),
	 EV_COMMAND(MENUspOptCEP,CMspectro_opt_cepstre),
	 EV_COMMAND(MENUspOptDefauts,CMspectro_opt_defauts),
	 EV_COMMAND(MENUoptionSaveSpectro,CMoptionSaveSpectro),
	 // sous-menu tiquetage
	 EV_COMMAND(MENUEtiqLire,CMlectEtiq),
	 EV_COMMAND(MENUEtiqSauver,CMsauverEtiq),
	 EV_COMMAND(MENUEtiqHelp,CMHelpEtiq),
	 EV_COMMAND(MENUEtiqChercher,CMchercheEtiq),
	 EV_COMMAND(MENUEtiqExploreCorpus,CMexploreCorpusEtiq),
	 // sous-menu annotations
	 EV_COMMAND(MENUNoteLire,CMlectFichAnnot),
	 EV_COMMAND(MENUNoteSauver,CMsauverFichAnnot),
	 EV_COMMAND(MENUNoteHelp,CMHelpAnnot),
	 EV_COMMAND(MENUNoteChercher,CMchercheAnnot),
	 EV_COMMAND(MENUNoteExploreCorpus,CMexploreCorpusAnnot),
	 // sous-menu formants
	 EV_COMMAND(MENUAffFormants,CMaffFormants),
	 EV_COMMAND(MENUSuiviPicsCep,CMsuivi_pics_cepstres),
    EV_COMMAND(MENUSuiviPicsTrueEnv,CMsuivi_pics_trueEnv),
	 EV_COMMAND(MENUSuiviRacinesLPC,CMsuivi_racines_lpc),
    EV_COMMAND(MENUAfficheEner,CMAfficheEner),
    EV_COMMAND(MENUItereEnergie,CMItereEnergie),
    EV_COMMAND(MENUOptionsEnergie,CMOptionsEnergie),
    EV_COMMAND(MENUEnergieEchelle,CMEnergieEchelle),
	 EV_COMMAND(MENUChangeParamAnaSpec,CMchangeParamAnaSpec),
	 EV_COMMAND(MENUAffCoupe,CMaffCoupe),
	 EV_COMMAND(MENUEditFormants,CMpiquefor),
    // sous-menu prosody
    EV_COMMAND(MENUTypeOfSpeaker,CMTypeOfSpeaker),
    EV_COMMAND(MENUF0Screen,CMF0Screen),
    // EV_COMMAND(MENUChOptProso,CMChOptProso),
    EV_COMMAND(MENUCorpusF0, CMCorpusF0),
    EV_COMMAND(MENUItereF0,CMItereF0),
    EV_COMMAND(MENUPitchmEchelle, CMPitchmEchelle),
    EV_COMMAND(MENUOpenPitchFile,CMOpenPitchFile),
    EV_COMMAND(MENUDispPitchValues,CMDispPitchValues),
    EV_COMMAND(MENUF0Modifications,CMF0Modifications),
    EV_COMMAND(MENUPitchScaleMod,CMPitchScaleMod),
	 EV_COMMAND(MENUPitchMarker,CMPitchMark),
	 EV_COMMAND(MENUDispMarks,CMDispMark),
	 EV_COMMAND(MENUGlottalClosureInstants,CMGlottalClosureInstants),
    // divers
	 EV_COMMAND(MENUDetails,CMdetails),
	 EV_COMMAND(MENUMire,CMafficheMire),
	 EV_COMMAND(MENUOptions,CMoptions),
	 EV_COMMAND(MENUAppendLog1ToLog,CMAppendLog1ToLog),
	 EV_COMMAND(MENUShowLog,CMShowLog),
	 EV_COMMAND(MENUShowLog1,CMShowLog1),
	 EV_COMMAND(MENUMyFonction1,CMMyFonction1),
	 EV_COMMAND(MENUMyFonction2,CMMyFonction2),
	 // sous-menu aides
	 EV_COMMAND(MENUHelp,CMhelp),
	 EV_COMMAND(MENUHelpOnHelp,CMhelponhelp),
	 EV_COMMAND(MENUAbout,CMabout),

END_RESPONSE_TABLE;


Wtop::Wtop(PTWindowsObject AParent, char *speech)
	 : TFrameWindow(AParent, ml(105,"noname"))
{
  char ch[80];

  speechFile = (speech) ? strdup(speech) : (char *) NULL;
  PTWtop=this;
  Attr.Style=WS_VISIBLE | WS_POPUPWINDOW|WS_CAPTION|WS_THICKFRAME
  				 |WS_MAXIMIZEBOX|WS_MINIMIZEBOX		;
  Attr.X=60;
  Attr.Y=40;
  Attr.W=900;
  Attr.H=550;
  Attr.AccelTable = IDA_COMMANDE;
  this->AssignMenu("COMMANDE");
  this->SetIcon(GetApplication(), IDI_ICON1);
  // various initialisations
  initvariables();
  initedit();
  init_opt_for();
  init_choix_YESNO();

  // initialisation des fentres graphiques
  wspectro = new WPlancheSpectroMain(this, &ct, &space);
  wspectro->wsona->isMain = true;
  wsignal = new WPlancheSig(this, &ct);
  // Association des fenetres signal et spectrogramme
  wsignal->wsig->wspectrAssoc = wspectro->wsona;
  wspectro->wsona->wsigAssoc = wsignal->wsig;
  wannotations = new Wdonnees_annotations(this);
  wetiquetage = new Wdonnees_etiquetage(this);
  scroll_spectro = new TScrollBar(this, 101, 0, 0, 100, 16, true);

  sprintf(ch, "GetFreeSpace(0)=%ld", GetFreeSpace(0));
  Wmsg->wr(ch);
}

void Wtop::SetupWindow()
{
  TFrameWindow::SetupWindow();


  scroll_spectro->SetRange(0, 32000);
  spectro_SetMode(FFT_L);
#ifdef LICENCE
  STRING lpVolumeNameBuffer, lpFileSystemNameBuffer, drive, dir, name, ext;
  unsigned long nFileSystemNameSize, lpVolumeSerialNumber,
       lpMaximumComponentLength, lpFileSystemFlags;
  struct date currentDate, beforeDate;
  getdate(&currentDate);

  _splitpath(WinSnooriDirectory, drive, dir, name, ext);
  strcat(drive,"\\");
  GetVolumeInformation(drive, lpVolumeNameBuffer, MAX_LIGNE, &lpVolumeSerialNumber,
     &lpMaximumComponentLength, &lpFileSystemFlags, lpFileSystemNameBuffer, MAX_LIGNE);

  extern bool verLicMach(const char *organization, const char *cleMach,
  								 unsigned long sn);

  // Rcupration de la date limite si le nom de l'organisation commence par "date".
  if (Organization[0] >= '0' && Organization[0] <= '9') {
    STRING x;
    strncpy(x, Organization, 2); x[2] = 0;
    beforeDate.da_day = atoi(x);
    strncpy(x, Organization+2, 2); x[2] = 0;
    beforeDate.da_mon = atoi(x);
    strncpy(x, Organization+4, 4); x[4] = 0;
    beforeDate.da_year = atoi(x);
  }
  else {
    beforeDate.da_day = 32;
    beforeDate.da_mon = 13;
    beforeDate.da_year = 2099;
  }

  // Le dernier controle porte sur la date de validit.
  if (!Organization || !strlen(Organization) || !Password || !strlen(Password)
      || !verLicMach(Organization, Password, lpVolumeSerialNumber)
      || !(   currentDate.da_year < beforeDate.da_year
      	  || (currentDate.da_year == beforeDate.da_year && currentDate.da_mon < beforeDate.da_mon)
           || (currentDate.da_year == beforeDate.da_year && currentDate.da_mon == beforeDate.da_mon
           		&& currentDate.da_day <= beforeDate.da_day))) {
    desactiveVraimentTout();
    active(MENUOpen);
    active(MENUExit);
    active(MENURegister);
    active(MENUExit);
	 active(MENUHelp);
	 active(MENUHelpOnHelp);
    active(MENUNew);
    active(MENUOpen);
  }
  else
#endif
       {
    Licensed = true;
#ifdef SMALLWSNO
    desactiveVraimentTout();
    desactive(MENURegister);
    active(MENUExit);
	 active(MENUHelp);
	 active(MENUHelpOnHelp);
#else
    desactive(PPMENUAllStandard);
#endif
    active(MENUNew);
    active(MENUOpen);
    // active(PPMENUFormants);
  }
  ::DrawMenuBar(HWindow);
  if (speechFile) lecture_fichier(speechFile);
}

bool Wtop::CanClose()
{
  if (UpdateCurrentFileBox() == IDABORT) return FALSE;
  //::WinHelp(HWindow,helpfile,HELP_QUIT,0L);
  //::WinHelp(HWindow,"winhelp.hlp",HELP_QUIT,0L);
  ::PostMessage(Parent->HWindow,WM_CLOSE,0,0);

  return TRUE;
}

Wtop::~Wtop()
{
  if (yaUneFenetrePiquefor) delete wpiquefor;
  etiqs.clear();
  notes.clear();
  pm.clear();
  detruitMenusLangue();
  destroyPhonEntries();
  delete wetiquetage;
}

void Wtop::IDscrollbar(WPARAM)
{
  int loval, hival, oldpos;
  long echt;

  souris(XC_watch);
  scroll_spectro->GetRange(loval, hival);
  oldpos = scroll_spectro->GetPosition();
  echt = (ct.tf - 1) * ( (oldpos - (float)loval) / (hival - (float)loval) );
  if (echt > ct.tf - (ct.f_a - ct.d_a + 1) && yaUnSignal == ASHADOW) {
    wpiquefor->lengthenShadow();
  }
  allerA(echt);
  if (yaUneFenetrePiquefor) wpiquefor->aff();
  if (yaUnEditManager && editManager->editMode == OLA) affTrajOLA();
  souris(XC_top_left_arrow);
}

//
void Wtop::EvSize(uint, TSize &)
{ int w;
  RECT rect;

  ::GetClientRect(HWindow,&rect);
  w=rect.right;
  //
  agencer_fenetre_principale();
  ::MoveWindow(wannotations->HWindow, WIDTH_VSCALE, yannot, w - WIDTH_VSCALE, hannot, true);
  wspectro->MoveWindow(0, yspectro, w, hspectro, true);
  wsignal->MoveWindow(0, ysignal, w, hsignal, true);
  ::MoveWindow(wetiquetage->HWindow, WIDTH_VSCALE, yetiq, w - WIDTH_VSCALE, hetiq, true);
  ::MoveWindow(scroll_spectro->HWindow, WIDTH_VSCALE, yscroll, w - WIDTH_VSCALE, hscroll, true);
  ::InvalidateRect(HWindow,NULL,true);
}

void Wtop::forcedResizeSpectro(int hspectro_)
{
  int height, w, y, h;
  RECT rect;

  ::GetClientRect(HWindow,&rect);
  w = rect.right;
  height = 2 * (MyTextHeight+2) + 88 + 16 + hspectro_;
  hspectro = hspectro_;
  yannot = 0;
  hannot=MyTextHeight+2;

  rect.bottom = rect.top + height;
  
  //
  y = height;
  //
  yscroll=(y-=(h=16)-1);
  hscroll=h;
  //
  ysignal=(y-=(h=88));
  hsignal=h;
  //
  yetiq=(y-=(h=MyTextHeight+2));
  hetiq=h;
  //
  yspectro = yannot+hannot;
  hspectro = yetiq-yspectro;
  SetWindowPos(HWindow, rect, SWP_NOMOVE | SWP_NOREDRAW | SWP_NOZORDER| SWP_NOACTIVATE);
  ::GetClientRect(wspectro->wsona->HWindow,&rect);
}

void Wtop::agencer_fenetre_principale()
{
  int y,h;
  RECT rect;

  ::GetClientRect(HWindow,&rect);
  //
  yannot=0;
  hannot=MyTextHeight+2;
  //
  y=rect.bottom;
  //
  yscroll=(y-=(h=16)-1);
  hscroll=h;
  //
  ysignal=(y-=(h=88));
  hsignal=h;
  //
  yetiq=(y-=(h=MyTextHeight+2));
  hetiq=h;
  //
  yspectro=yannot+hannot;
  hspectro=yetiq-yspectro;
}
void Wtop::SetNomFichierParole(char *ch)
// affiche la barre de titre (caption)
{ SetCaption(ch);
}
void Wtop::CMdetails()
{ CHARbuf buf(1,"");
  char ch[80];

  if (en_cours.nom[0]==0)
    buf.cat(ml(70,"no file opened"));
  else
  { buf.cat(ml(71,"Speech filename: "));
    buf.cat(mls(en_cours.nom));
    if (!isWAV(en_cours.nom))
    { buf.cat(ml(72,"\nSpeech file format: "));
      buf.cat(Fmt_par[en_cours.fmt_son].nfmt);
      if (en_cours.fmt_phon==0)
        buf.cat(ml(73,"\nno phoneme file"));
      else
      { buf.cat(ml(74,"\nPhoneme filename: "));
        buf.cat(en_cours.nom_man);
        buf.cat(ml(75,"\nPhoneme file format: "));
        buf.cat(Fmt_phon[en_cours.fmt_phon].nom);
      }
      if (en_cours.fmt_word==0)
        buf.cat(ml(76,"\nno word file"));
      else
      { buf.cat(ml(77,"\nWord filename: "));
        buf.cat(en_cours.nomAnnot);
        buf.cat(ml(78,"\nWord file format: "));
        buf.cat(Fmt_text[en_cours.fmt_word].nom);
      }
    }
    buf.cat("\n");
    sprintf(ch,ml(79,"\nFrequency (Hz) : %ld"),(long)en_cours.frequence);
    buf.cat(ch);
    buf.cat("\n");
    sprintf(ch,ml(80,"\nSamples in file : from 0 to %ld"),ct.tf-1);
    buf.cat(ch);
    sprintf(ch,ml(81,"\nSamples on screen : from %ld to %ld"),ct.d_a,ct.f_a);
    buf.cat(ch);
    sprintf(ch,ml(82,"\nSamples in memory : from %ld to %ld"),ct.d_e,ct.f_e);
    buf.cat(ch);
    sprintf(ch,ml(83,"\nSamples in file+memory : from 0 to %ld")
                ,repercute_tf());
    buf.cat(ch);
  }
  MessageBox((char *)&buf[0],ml(84,"Details"));
}
void Wtop::CMAppendLog1ToLog()
{ souris(XC_watch);
  logs.appendLog1toLog();
  Wact->wrlog(FALSE);
  souris(XC_top_left_arrow);
}
void Wtop::CMShowLog()
{ logs.show();
}
void Wtop::CMShowLog1()
{ logs.show1();
}
void Wtop::CMquitter()
{
 CloseWindow();
}


void Wtop::EvClose()
{
 CloseWindow();
}

typedef HWND WINAPI (*HtmlHelpFunc)( HWND hwndCaller, LPCSTR pszFile,UINT uCommand, DWORD dwData );

const char pszHelpOCXCtrl [] = "hhctrl.ocx";


void Wtop::CMhelp()
{
  //::WinHelp(HWindow,helpfile,HELP_INDEX,0L);
  HINSTANCE hHelpOCX = ::LoadLibrary(pszHelpOCXCtrl);
  if (!hHelpOCX) {
    ::MessageBox(HWindow, "Cannot use the html help!", "Error", MB_OK);
   return;
  }

   HtmlHelpFunc HTMLHelp = (HtmlHelpFunc)::GetProcAddress(hHelpOCX, ATOM_HTMLHELP_API_ANSI);

  // Now call HTMLHelp functions:

  HTMLHelp(HWindow, helpfile, HH_DISPLAY_TOPIC, 0);
}

void Wtop::CMspectroToClipboard() //RTMessage)
{
	::OpenClipboard(wspectro->wsona->HWindow);
	::EmptyClipboard();
	::SetClipboardData(CF_BITMAP, wspectro->wsona->hbitmap);
	::CloseClipboard();
}

void Wtop::CMsignalToClipboard() //RTMessage)
{
	::OpenClipboard(wsignal->wsig->HWindow);
	::EmptyClipboard();
	::SetClipboardData(CF_BITMAP, wsignal->wsig->hbitmap);
	::CloseClipboard();
}

void Wtop::CMhelponhelp()
{
  //::WinHelp(HWindow,"winhelp.hlp",HELP_INDEX,0L);

  HINSTANCE hHelpOCX = ::LoadLibrary(pszHelpOCXCtrl);
  if (!hHelpOCX) {
    ::MessageBox(HWindow, "Cannot use the html help!", "Error", MB_OK);
   return;
  }

   HtmlHelpFunc HTMLHelp = (HtmlHelpFunc)::GetProcAddress(hHelpOCX, ATOM_HTMLHELP_API_ANSI);

  // Now call HTMLHelp functions:

  HTMLHelp(HWindow, "htmlhelp.chm", HH_DISPLAY_TOPIC, 0);
}

void Wtop::CMabout()
{ ::MessageBox(HWindow
	 ,"WinSnoori 1.34\n\
Documentation: \n\
    C:\\Program Files\\Wsno\\WinSno.chm \n\
    C:\\Program Files\\Wsno\\Klatt\\klatt.html \n\
Copyright 2002-2006    LORIA"
			 ,ml(106,"About"),MB_OK);
}

/////////////////////////////////////////////
// fenetre prologue
//
class Wprologue : public TFrameWindow
{
    char *speechFile;
    TButton *PTButtonOk;
	 TButton *PTButtonTest;
	 BOOL indOk;
  public:
	 Wprologue(PTWindowsObject AParent, char *speech);
	 ~Wprologue();
    void setCommandKey();
	 virtual void SetupWindow();
	 void InitOnPrologue();
	 virtual void Paint(TDC& dc, bool erase, TRect& rect);

	 // rponses aux vnements
	 /*
	 virtual void exec_ok (RTMessage)
		  = [ID_FIRST+101];
	 virtual void exec_test (RTMessage)
		  = [ID_FIRST+102];
	 */
    void suite();
	 //void exec_ok(WPARAM code);
	 void exec_test(WPARAM code);
	 DECLARE_RESPONSE_TABLE(Wprologue);
};
DEFINE_RESPONSE_TABLE1(Wprologue,TFrameWindow)
//  EV_CHILD_NOTIFY_ALL_CODES(101,exec_ok),
  EV_CHILD_NOTIFY_ALL_CODES(102,exec_test),
END_RESPONSE_TABLE;


TFrameWindow *PTWprologue;
Wprologue::Wprologue(PTWindowsObject AParent, char *speech)
		: TFrameWindow(AParent,"WinSnoori")
{
  PTWprologue=this;

  speechFile = (speech) ? strdup(speech) : (char *) NULL;
  Attr.Style=WS_OVERLAPPEDWINDOW;

  Attr.X=0;
  Attr.Y=0;
  Attr.W=400;
  Attr.H=350;
  //
  //PTButtonOk=new TButton(this,101,"Ok",3,60,150,24,FALSE);  Supprime
  //PTButtonTest=new TButton(this,102,"Test",0,0,50,24,FALSE);
  //PTButtonTest->Attr.Style&=~WS_VISIBLE;
  indOk=FALSE;
}
Wprologue::~Wprologue()
{
  closecoul();
}

//
// Set the command key to launch WinSnoori from an html file.
// Cannot be done successfully from installshield !
#include <string.h>
void Wprologue::setCommandKey()
{
  HKEY hk;

  if (RegCreateKey(HKEY_CLASSES_ROOT, "wsnfile\\shell\\open\\command",&hk) == ERROR_SUCCESS) {
    DWORD dwData, size;
    char szBuf[80];

    sprintf(szBuf, "%s\\wsno.exe \"\%1\"", WinSnooriDirectory);
    /* Add the value to the subkey. */
    RegSetValueEx(hk,             /* subkey handle         */
        NULL,       /* value name            */
        0,                        /* must be zero          */
        REG_EXPAND_SZ,            /* value type            */
        (LPBYTE) szBuf,           /* address of value data */
        strlen(szBuf) + 1);       /* length of value data  */
    RegCloseKey(hk);
  }
}

bool GetSnooriDirectory()
{
  DWORD  dwDataSize = 1;
  HKEY   hKey;
  STRING value;

  if (RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\LORIA\\Wsno", &hKey) == ERROR_SUCCESS){   // with the inno installation
      // Get the size of the value data.
      if (RegQueryValueEx(hKey, "WsnoDirectory", NULL,
      	NULL, NULL, &dwDataSize) == ERROR_SUCCESS) {
         // Get the value data.
      	if (RegQueryValueEx(hKey, "WsnoDirectory", NULL, NULL, value,
                          &dwDataSize) == ERROR_SUCCESS)
           strcpy(WinSnooriDirectory, value);
         else {
           fatal_error("HKEY_LOCAL_MACHINE\\SOFTWARE\\Wsno key  not found");
           return(false);
         }
     }
     RegCloseKey(hKey);
     return(true);
  }
  else if (RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Wsno", &hKey) == ERROR_SUCCESS){   // with the old installation procedure
      // Get the size of the value data.
      if (RegQueryValueEx(hKey, "WsnoDirectory", NULL,
      	NULL, NULL, &dwDataSize) == ERROR_SUCCESS) {
         // Get the value data.
      	if (RegQueryValueEx(hKey, "WsnoDirectory", NULL, NULL, value,
                          &dwDataSize) == ERROR_SUCCESS)
           strcpy(WinSnooriDirectory, value);
         else {
           fatal_error("HKEY_LOCAL_MACHINE\\SOFTWARE\\Wsno key  not found");
           return(false);
         }
     }
     RegCloseKey(hKey);
     return(true);
  }
  else {
    fatal_error("HKEY_LOCAL_MACHINE\\SOFTWARE\\Wsno key  not found");
    return(false);
  }
}


void Wprologue::InitOnPrologue()
{ int ret=0;
  static ind=0; // indicateur de 1re fois

  if (ind!=0) return;
  ind=1;
  // lire le fichier wsno.ini
  if (ret==0) {
    STRING ch;
	 if (GetSnooriDirectory()){
      strcpy(ch, WinSnooriDirectory);
      normdir(ch);
		strcat(strcpy(helpfile,ch),"format\\wsno.chm");
		strcat(strcpy(formatdir,ch),"format\\");
		strcat(strcpy(tempdir,ch),"temp\\");
      if (!is_a_directory(tempdir)) {
        STRING s;
        sprintf(s, "Temporary directory (%s) does not exist", tempdir);
        fatal_error(s);
        sprintf(s, "Format directory (%s) does not exist", formatdir);
        fatal_error(s);
      }
	 }
  }
  if (ret==0) {
    int ret1, ret2;
    ret1 = GetPrivateProfileString("WinSnoori", "Organization", "",Organization,
        78,"wsno.ini");
    ret2 = GetPrivateProfileString("WinSnoori", "Password", "",Password,
        78,"wsno.ini");
    ret = 0;
  }
  if (ret==0) {
    if (GetPrivateProfileString("WinSnoori", "CountryFile", "",CountryFile,
  	                             78,"wsno.ini") ==0)
	 { ret=1;
		fatal_error("CountryFile not found in file wsno.ini");
	 }
    //if (!strcmp(CountryFile, "francais.str")) strcpy(helpfile,"wsno.hlp");
	 if (GetPrivateProfileString("WinSnoori"
			  ,"LanguageFile"
		,"",LanguageFile,78,"wsno.ini")
	==0)
	 { ret=1;
		fatal_error("LanguageFile not found in file wsno.ini");
	 }
  }
  if (ret==0)
  GetPrivateProfileString("WinSnoori",
                           "PhoneticFont" ,"",PhoneticFont,78,"wsno.ini");

  if (ret==0)
  GetPrivateProfileString("WinSnoori",
                           "SndRecorder" ,"",SndRecorder,78,"wsno.ini");
  setCommandKey();
  strcpy(logfile,tempdir);
  strcat(logfile,"log.txt");
  {
    FILE *f = fopen(logfile, "r");
    if (f) {
      fclose(f);
      remove(logfile);
    }
  }

}

void Wprologue::SetupWindow()
{
  TFrameWindow::SetupWindow();
  init_grafix(this);
}

void Wprologue::Paint(TDC& dc, bool, TRect&)
{
  char ch[80];

  InitOnPrologue();

  if (!indOk)
  { strcpy(ch,"WinSnoori : Snoori for Windows");
	 dc.TextOut(2,2,ch,strlen(ch));
    suite();
  }
  else Wact->paint();
}
//void Wprologue::exec_ok(WPARAM)
void Wprologue::suite()
{
  indOk=TRUE;
  ::InvalidateRect(HWindow,NULL,TRUE);

  if (GetKeyState(VK_SHIFT)<0) indtest=TRUE;

  initWmessage(this);
  if (indtest) Wmsg->show();
  initWact(this);
  opencoul();

#ifdef AVECBOUTONOK
  PTButtonOk->Show(SW_HIDE);
  if (indtest)
  { PTButtonTest->Show(SW_SHOW);
	 ::InvalidateRect(HWindow,NULL,TRUE);
  }
#endif
  if (!ml_init()) return ;

  GetApplication()->MakeWindow(new Wtop(this, speechFile));
}

void Wprologue::exec_test(WPARAM)
{ test();
}


////////////////////////////////////////////////////
// thread de machin: description non available yet
extern int UpdateCurrentFileBox();
extern Wpiquefor *PTWpiquefor;
extern void resetDefaultSaveName();

// pour ne pas afficher les warnings
bool show_warnings=true;



extern void pics_spe____done_free_buffers();

/////////////////////////////////////////////
// classe application

class TopApp : public TApplication
{ public:
    char *fichier;
	 TopApp(char *paramFichier) : TApplication()
    {
       if (paramFichier)  fichier = strdup(paramFichier);
       else fichier = (char *) NULL;
    }
    virtual ~TopApp()
    {
    	pics_spe____done_free_buffers();
    	delete GetMainWindow();
      SetMainWindow(NULL);
    }

    void InitMainWindow()
	 {
    	SetMainWindow(new Wprologue(NULL, fichier));
      GetMainWindow()->SetIcon(this, IDI_ICON1);
      MainWin = GetMainWindow();
    }
};

int OwlMain(int argc, char* argv [])
{
  TopApp * this_app= new TopApp(NULL);
  return this_app->Run();
}


#define WinMain
#define WinMain
#define WinMain
