/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

// fichier wsno.h
//
#ifndef _WSNO_H
#define _WSNO_H

extern TScrollBar *scroll_spectro;


class Wtop : public TFrameWindow
{ public:
    // fichier de parole au lancement de Snoori
    char *speechFile;
    // hauteur des lments de la fentre client
    //     la somme des hauteurs de tous les lments
	 //     est gale  la hauteur de la fentre client
	 // pour l'instant, les hauteurs sont fixes,
    //     sauf pour la fenetre spectrogramme
    /*
	 hscrollbar;
	 hsignal;
    hetiquetage;
    hspectro;
    hannotations;
    */


    Wtop(PTWindowsObject AParent, char *speech);
    ~Wtop();
    void agencer_fenetre_principale();
    void forcedResizeSpectro(int hspectro_);
    void SetNomFichierParole(char nom[]);
    void ChangerModeSouris(int mode);
    virtual void SetupWindow();
    virtual bool CanClose();
    virtual void EvClose();
    // rponses aux vnements commande menu
    // sous-menu fichier
	 void CMnouveau();
	 void CMzeroFile();
	 void CMlecture_fichier();
	 void CMsauver();
	 void CMsauverSous();
    void CMrecord();
	 void CMsauverUneRegion();
	 void CMfinserer();
    void CMremoveDC();
	 void CMquitter();
    void CMRegisterUser();
	 // sous-menu edition
	 void CMfannuler();
	 void CMfcouper();
	 void CMfcopier();
	 void CMfcoller();
	 void CMfeffacer();
    void CMEditingTools();
	 void CMamortirGauche();
	 void CMamortirCentre();
	 void CMamortirDroite();
	 void CMfiltreSignal();
	 void CMnbecoute();
    void CMgetSpeechStart();
    void CMResampling();
    void CMRemoveDC();
	 void CMecoute1Fois();
    void CMplayFile();
	 void CMfreqEchantillonnage();
	 void CMzoom_tempo();
	 void CMsupprimeZoom_tempo();
	 void CMouAller();
    void CMsignalToClipboard();
	 // sous-menu spectrogramme
	 void CMspectro_fft_large();
	 void CMspectro_fft_etroit();
	 void CMspectro_criticalBands();
	 void CMspectro_reass();
    void CMspectro_lpc();
	 void CMspectro_cepstre();
	 void CMclearSpectro();
	 void CMdecoreSpectro();
	 void CMnettoieSpectro();
    void CMSpectroFmax();
	 void CMspectro_opt_fft_large();
	 void CMspectro_opt_fft_etroit();
	 void CMspectro_opt_criticalBands();
	 void CMspectro_opt_fft_reass();
	 void CMspectro_opt_lpc();
	 void CMspectro_opt_cepstre();
	 void CMspectro_opt_defauts();
    void CMspectroToClipboard();
    void CMsave_spectrogramme();
    void CMoptionSaveSpectro();
	 // sous-menu tiquetage
	 void CMlectEtiq();
	 void CMsauverEtiq();
	 void CMHelpEtiq();
	 void CMchercheEtiq();
	 void CMexploreCorpusEtiq();
	 // sous-menu annotations
	 void CMlectFichAnnot();
	 void CMsauverFichAnnot();
	 void CMHelpAnnot();
	 void CMchercheAnnot();
	 void CMexploreCorpusAnnot();
	 // sous-menu formants
	 void CMaffFormants();
	 void CMsuivi_pics_cepstres();
    void CMsuivi_pics_trueEnv();
	 void CMsuivi_racines_lpc();
	 void CMchangeParamAnaSpec();
    void CMAfficheEner();
    void CMItereEnergie();
    void CMOptionsEnergie();
    void CMEnergieEchelle();
	 void CMaffCoupe();
	 void CMpiquefor();
    void CMpiquef0();
    void CMOpenPitchFile();
    void CMDispPitchValues();
    void CMTypeOfSpeaker();
    void CMItereF0();
    void CMCorpusF0();
    void CMChOptProso();
    void CMPitchmEchelle();
    void CMPitchMark();
    void CMDispMark();
    void CMPitchScaleMod();
    void CMGlottalClosureInstants();
    // sous-menu prosody
//    void CMItereF0();
    void CMF0Screen();
    void CMReadPitchFile();
    void CMSaveF0Contour();
    void CMSeeF0Contour();
    void CMF0Modifications();
    void CMModifF0Contour();
    void CMCurrentPitch();
    void CMResynth();
    void CMRevoicinParam();
    void CMHelpProsody();
	 // divers
         void CMdetails();
	 void CMafficheMire();
	 void CMoptions();
	 void CMAppendLog1ToLog();
	 void CMShowLog();
	 void CMShowLog1();
	 void CMMyFonction1();
	 void CMMyFonction2();
	 // sous-menu aides
	 void CMhelp();
	 void CMhelponhelp();
	 void CMabout();

	 // rponses aux vnements
	 /*
	 virtual void WMSize(RTMessage) = [WM_FIRST+WM_SIZE];
	 virtual void CMscrollbar(RTMessage Msg)
				  = [ID_FIRST + 101];
	 */
	 void lecture_fichier(char *fichier);
    void EvSize(uint sizeType, TSize &size);
	 void EvCommandEnable(TCommandEnabler &c) {  }
	 void IDscrollbar(WPARAM code);
	 DECLARE_RESPONSE_TABLE(Wtop);
};

class Wdonnees_spectro : public d_planche_dblclk
{ public:
	 Wdonnees_spectro(PTWindowsObject AParent, struct ctrl_temps *ctpp, SAMPLEbuf *speech);
	 virtual void Paint(TDC& dc, bool erase, TRect& rect); //HDC hDC,PAINTSTRUCT&);
    class Wdonnees_signal *wsigAssoc;
    d_plancheTmp *bis;
    SAMPLEbuf *sig;
	 int fen_signal;
	 int depl;
    bool isMain;		 // true if this spectrogram is the main window spectrogram
    float incr;       // vertical increment for the vertical scale.

	 // rponses aux vnements
	 /*
	 virtual void WMSize(RTMessage) = [WM_FIRST+WM_SIZE];
	 virtual void WMLButtonDown(RTMessage)
					= [WM_FIRST + WM_LBUTTONDOWN];
	 virtual void WMLButtonUp(RTMessage)
					= [WM_FIRST + WM_LBUTTONUP];
	 virtual void WMLButtonDblclk(RTMessage)
					= [WM_FIRST + WM_LBUTTONDBLCLK];
	 virtual void WMMouseMove(RTMessage)
					= [WM_FIRST + WM_MOUSEMOVE];
	 */
    void spectro_consolider(int xinf, int xsup);
    void spectro_nettoyer(int xinf, int xsup);
    void aff();
    void affichePositionSpectro(int event_x, int event_y, int withPitch);

    void drawMotion(int event_x, int transmet);
    void drawDown(int event_x, int transmet);
    void drawUp(int event_x, int transmet);
    void drawDownCoupe(int event_x);
    void drawMotionCoupe(int event_x);
    void drawUpCoupe(int event_x);
    void MoveBarre(long echt);
	 void EvSize(uint sizeType, TSize &size);
	 void EvLButtonDown(uint Modkeys, TPoint& point);
	 void EvLButtonUp(uint Modkeys, TPoint& point);
	 void EvLButtonDblClk(uint Modkeys, TPoint& point);
	 void EvMouseMove(uint Modkeys, TPoint& point);
	 DECLARE_RESPONSE_TABLE(Wdonnees_spectro);
};

class WPlancheSpectro : public TFrameWindow {
  public:
    class Wdonnees_spectro *wsona;
    class WVScale *wvscale;

	 WPlancheSpectro(PTWindowsObject AParent, struct ctrl_temps *ctp, SAMPLEbuf *speech);
	 virtual void Paint(TDC& dc, bool erase, TRect& rect);
    void drawMotion(int event_x, int transmet);
    void drawDown(int event_x, int transmet)
      {wsona->drawDown(event_x, transmet);};
    void drawUp(int event_x, int transmet)
      {wsona->drawUp(event_x, transmet);};
	 void EvSize(uint sizeType, TSize &size);
	 void EvLButtonDown(uint Modkeys, TPoint& point)
      {wsona->EvLButtonDown(Modkeys, point);};
	 void EvLButtonUp(uint Modkeys, TPoint& point)
      {wsona->EvLButtonUp(Modkeys, point);};
	 void EvMouseMove(uint Modkeys, TPoint& point)
      {wsona->EvMouseMove(Modkeys, point);};
    bool WPlancheSpectro::MoveWindow(int x, int y, int w, int h, bool repaint);
    void paint();
	 DECLARE_RESPONSE_TABLE(WPlancheSpectro);
};

class WPlancheSpectroMain : public WPlancheSpectro
{
  public:
  WPlancheSpectroMain(PTWindowsObject AParent, struct ctrl_temps *ctpp, SAMPLEbuf *speech)
   : WPlancheSpectro(AParent, ctpp, speech) {}
  void EvSize(uint sizeType, TSize &size);
  DECLARE_RESPONSE_TABLE(WPlancheSpectroMain);
};

typedef struct {
  STRING filename;
  int width;
  int height;
} SpectrogramFile;

#define WINDOW 		 1
#define IMAGEFILE     2
typedef struct {
  int type;
  Wdonnees_spectro *ws;
  SpectrogramFile sf;
} SpectroDisplay;


class WScale : public d_planche
{
  public:
    WScale(PTWindowsObject AParent);
    void EvSize(uint sizeType, TSize &size);
    void affichage(long premEchtFen, long derEchtFen);
  DECLARE_RESPONSE_TABLE(WScale);
};

class WVScale : public d_planche
{
  public:
    WVScale(PTWindowsObject AParent);
    void EvSize(uint sizeType, TSize &size);
    void affichage(float vmin, float vmax, float incr, char *texte);
  DECLARE_RESPONSE_TABLE(WVScale);
};

class Wdonnees_signal : public d_planche
{
  public:
	 Wdonnees_signal(PTWindowsObject AParent, struct ctrl_temps *ctp);
    Wdonnees_spectro *wspectrAssoc;
	 void aff();
	 virtual void Paint(TDC& dc, bool erase, TRect& rect);

    void drawMotion(int event_x, int transmet);
    void drawDown(int event_x, int transmet);
    void drawUp(int event_x, int transmet);
	 void EvSize(uint sizeType, TSize &size);
	 void EvLButtonDown(uint Modkeys, TPoint& point);
	 void EvLButtonUp(uint Modkeys, TPoint& point);
	 void EvMouseMove(uint Modkeys, TPoint& point);
    void BlueSegment(int echtDeb, int echtFin);
    void MoveBarre(long echt);
    float affichage(SAMPLEbuf& cnv, long premEcht, long derEcht, long premEchtFen,
     					 long derEchtFen, int valIncrement, bool normalize);
	 DECLARE_RESPONSE_TABLE(Wdonnees_signal);
};

class WPlancheSig : public TFrameWindow {
  public:
	 WPlancheSig(PTWindowsObject AParent, struct ctrl_temps *ctp);
	 void aff();
	 virtual void Paint(TDC& dc, bool erase, TRect& rect);
    void drawMotion(int event_x, int transmet);
    void drawDown(int event_x, int transmet)
      {wsig->drawDown(event_x, transmet);};
    void drawUp(int event_x, int transmet)
      {wsig->drawUp(event_x, transmet);};
	 void EvSize(uint sizeType, TSize &size);
	 void EvLButtonDown(uint Modkeys, TPoint& point)
      {wsig->EvLButtonDown(Modkeys, point);};
	 void EvLButtonUp(uint Modkeys, TPoint& point)
      {wsig->EvLButtonUp(Modkeys, point);};
	 void EvMouseMove(uint Modkeys, TPoint& point)
      {wsig->EvMouseMove(Modkeys, point);};
    void BlueSegment(int echtDeb, int echtFin)
      {wsig->BlueSegment(echtDeb, echtFin);};
    bool MoveWindow(int x, int y, int w, int h, bool repaint);
    void paint()  {wsig->paint();};
    WScale *wscale;
    WVScale *wvscale;
    Wdonnees_signal *wsig;
	 DECLARE_RESPONSE_TABLE(WPlancheSig);
};


class Wdonnees_annotations : public d_planche_dblclk
{ public:
	 Wdonnees_annotations(PTWindowsObject AParent);

	 // rponses aux vnements
	 /*
	 virtual void WMSize(RTMessage) = [WM_FIRST+WM_SIZE];
	 virtual void WMLButtonDown(RTMessage)
					= [WM_FIRST + WM_LBUTTONDOWN];
	 virtual void WMLButtonUp(RTMessage)
					= [WM_FIRST + WM_LBUTTONUP];
	 virtual void WMLButtonDblclk(RTMessage)
					= [WM_FIRST + WM_LBUTTONDBLCLK];
	 virtual void WMLMouseMove(RTMessage)
					= [WM_FIRST + WM_MOUSEMOVE];
	 */
	 void EvSize(uint sizeType, TSize &size);
	 void EvLButtonDown(uint Modkeys, TPoint& point);
	 void EvLButtonUp(uint Modkeys, TPoint& point);
	 void EvLButtonDblClk(uint Modkeys, TPoint& point);
	 void EvMouseMove(uint Modkeys, TPoint& point);
	 DECLARE_RESPONSE_TABLE(Wdonnees_annotations);
};

class Wdonnees_etiquetage : public d_planche_dblclk
{

 public:
    int num_phon;
    TPopupMenu *PopupMenu;
    TPopupMenu *PopupMenuClasses;
	 Wdonnees_etiquetage(PTWindowsObject AParent);
    ~Wdonnees_etiquetage() {
		 delete PopupMenu;
       delete PopupMenuClasses;
    }
    virtual void SetupWindow();

	 // rponses aux vnements
	 /*
	 virtual void WMSize(RTMessage) = [WM_FIRST+WM_SIZE];
	 virtual void WMLButtonDown(RTMessage)
					= [WM_FIRST + WM_LBUTTONDOWN];
	 virtual void WMLButtonUp(RTMessage)
					= [WM_FIRST + WM_LBUTTONUP];
	 virtual void WMLButtonDblclk(RTMessage)
					= [WM_FIRST + WM_LBUTTONDBLCLK];
	 virtual void WMLMouseMove(RTMessage)
					= [WM_FIRST + WM_MOUSEMOVE];
	 */
	 void EvDrawItem(uint /*ctrlId*/, DRAWITEMSTRUCT far& drawItem);
    void EvMeasureItem(uint ctrlId, MEASUREITEMSTRUCT far& measureInfo);
    void EvSize(uint sizeType, TSize &size);
	 void EvLButtonDown(uint Modkeys, TPoint& point);
	 void EvLButtonUp(uint Modkeys, TPoint& point);
	 void EvLButtonDblClk(uint Modkeys, TPoint& point);
	 void EvRButtonUp(uint Modkeys, TPoint& point);
	 void EvRButtonDblClk(uint Modkeys, TPoint& point);
	 void EvMouseMove(uint Modkeys, TPoint& point);
    void EvCommandEnable(TCommandEnabler& ce);
	 void ODADrawEntire(DRAWITEMSTRUCT far& drawInfo);
    void ODAFocus(DRAWITEMSTRUCT far& drawInfo);
    void ODASelect(DRAWITEMSTRUCT far& drawInfo);
    virtual LRESULT EvCommand(UINT id, HWND hWndCtl, UINT notifyCode);
	 DECLARE_RESPONSE_TABLE(Wdonnees_etiquetage);
};

extern Wtop *PTWtop;
extern WPlancheSpectroMain  *wspectro;
extern WPlancheSig		    *wsignal;
extern Wdonnees_annotations *wannotations;
extern Wdonnees_etiquetage  *wetiquetage;


extern d_plancheTmp *wspectroBis;

extern TFrameWindow *PTWprologue;
#endif
