/* This file is part of WinSnoori.

 WinSnoori is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 3 of the License.

WinSnoori is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with WinSnoori.  If not, see <http://www.gnu.org/licenses/>. */

                             // fichier zeroFile.cpp
//

#include "common.h"
#include "signal.h"
#include "zeroFile.h"
#pragma hdrstop

DEFINE_RESPONSE_TABLE1(TWzeroFile,TDialog)
  EV_CHILD_NOTIFY_ALL_CODES(IDOK,IDOk),
  EV_CHILD_NOTIFY_ALL_CODES(IDCANCEL,IDCancel),
//  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON2,EVChSamp),
//  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON3,EVChSamp),
//  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON4,EVChSamp),
//  EV_CHILD_NOTIFY_ALL_CODES(IDC_RADIOBUTTON5,EVChSamp),
  EV_WM_CLOSE,
END_RESPONSE_TABLE;

TWzeroFile::TWzeroFile(PTWindowsObject AParent, LPSTR name)
	:TDialog(AParent,name)
{
  PT8000 = new TRadioButton(this, IDC_RADIOBUTTON2, 0);
  PT11025 = new TRadioButton(this, IDC_RADIOBUTTON3, 0);
  PT16000 = new TRadioButton(this, IDC_RADIOBUTTON4, 0);
  PT22050 = new TRadioButton(this, IDC_RADIOBUTTON5, 0);
  PTDuration = new TEdit(this, IDC_EDIT7);
  PTCancel = new TButton(this,IDCANCEL);
  PTOk = new TButton(this,IDOK);
}

void TWzeroFile::SetupWindow()
{
  STRING s;
  TDialog::SetupWindow();

  SetCaption("Zero file");
  PT22050->SetCheck(BF_CHECKED);
}


bool TWzeroFile::CanClose()
{
  STRING s;
  if (PT8000->GetCheck() == BF_CHECKED) samplingRate = 8000;
  else if (PT11025->GetCheck() == BF_CHECKED) samplingRate = 11025;
  else if (PT16000->GetCheck() == BF_CHECKED) samplingRate = 16000;
  else if (PT22050->GetCheck() == BF_CHECKED) samplingRate = 22050;
  PTDuration->GetText(s,10);
  duration = atoi(s);
  return(true);
}

TWzeroFile::~TWzeroFile()
{
  delete PT8000;
  delete PT11025;
  delete PT16000;
  delete PT22050;
  delete PTDuration;
  delete PTCancel;
  delete PTOk;
}

void TWzeroFile::IDOk(WPARAM)
{
  TDialog::CmOk();
  if (yaUnSignal && UpdateCurrentFileBox() == IDABORT) return;
  reinitSignalAndScreen();
  initShadow(4000, false, 0, max(duration, 1000), samplingRate);
  active(PPMENUAllStandard);
  initEditSignal();
}

void TWzeroFile::IDCancel(WPARAM)
{
 TDialog::CmCancel();
}

void Wtop::CMzeroFile()
// fonction d'activation de la fentre dialogue
{
  TWzeroFile *x = new TWzeroFile(PTWtop, "WzeroFile");
  x->Create();
  x->ShowWindow(SW_SHOW);
}

